{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_graph_config_hierarchie;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses Dialogs,
{$IFNDEF FPC}
  u_objet_TGraphArbre, u_objet_graph_TViewer, Windows,
  ExtJvXPCheckCtrls, JvXPButtons,
{$ELSE}
  LCLIntf, ExtJvXPCheckCtrls, JvXPButtons,
{$ENDIF}
  U_FormAdapt,
  StdCtrls, U_ExtColorCombos,
  u_buttons_flat,ExtCtrls,
  Controls,Classes,Graphics,
  Forms,
  u_ancestroviewer, u_ancestrotree,
  u_framework_components,
  Menus, ComCtrls, u_objet_TState;

type

  { TFGraphConfigHierarchie }

  TFGraphConfigHierarchie=class(TF_FormAdapt)
    btnExport: TFBExport;
    btnFont: TJvXPButton;
    btnImport: TFBImport;
    cAvecActe: TJvXPCheckbox;
    cAvecLieu: TJvXPCheckbox;
    cbShowSosas: TJvXPCheckbox;
    cDeces: TJvXPCheckbox;
    cMariage: TJvXPCheckbox;
    cNaissance: TJvXPCheckbox;
    cNom: TJvXPCheckbox;
    cOptimiseLargeur: TJvXPCheckbox;
    cPaintFondRecFemme: TJvXPCheckbox;
    cPaintFondRecHomme: TJvXPCheckbox;
    cPosterite: TJvXPCheckbox;
    cPrenom: TJvXPCheckbox;
    cProf: TJvXPCheckbox;
    edColorTexteFemme: TExtColorCombo;
    edColorTexteHomme: TExtColorCombo;
    edCouleurFondFemme: TExtColorCombo;
    edCouleurFondRectHomme: TExtColorCombo;
    edCouleurLiens: TExtColorCombo;
    edCouleurRectFemme: TExtColorCombo;
    edCouleurRectHomme: TExtColorCombo;
    edEspaceEntreGenerations: TFWSpinEdit;
    edEspaceEntreIndis: TFWSpinEdit;
    edHeightIndi: TFWSpinEdit;
    edLineHeight: TFWSpinEdit;
    edMargeLeft: TFWSpinEdit;
    edMargeTop: TFWSpinEdit;
    edRecouvrementImpression: TFWSpinEdit;
    edWidthIndi: TFWSpinEdit;
    FontDialog:TFontDialog;
    Label1: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lCompositionLieu: TLabel;
    Notebook: TPageControl;
    page1: TTabSheet;
    page2: TTabSheet;
    page3: TTabSheet;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel12: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel2: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    Panel3: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel32: TPanel;
    Panel33: TPanel;
    Panel34: TPanel;
    Panel35: TPanel;
    Panel36: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    panExempleFont: TPanel;
    pBorder:TPanel;
    Panel11:TPanel;
    Panel14:TPanel;
    Panel13:TPanel;
    Panel6:TPanel;
    page4:TTabSheet;
    page5:TTabSheet;
    page6:TTabSheet;
    page7:TTabSheet;
    page8:TTabSheet;
    page9:TTabSheet;
    mLieu: TPopupMenu;
    mAvecSubd: TMenuItem;
    mAvecVille: TMenuItem;
    mAvecDept: TMenuItem;
    mAvecRegion: TMenuItem;
    mAvecPays: TMenuItem;
    mAvecCodeDept: TMenuItem;
    mAvecNomDept: TMenuItem;
    OpenDialog:TOpenDialog;
    SaveDialog:TSaveDialog;
    procedure SuperFormDestroy(Sender:TObject);
    procedure btnFontClick(Sender:TObject);
    procedure SuperFormShowFirstTime(Sender:TObject);
    procedure SuperFormKeyDown(Sender:TObject;var Key:Word;
      Shift:TShiftState);
    procedure onTabControl1Change(Sender: TObject);
    procedure onTabControl1DrawEx(AControl: TCustomTabControl;
      ATab: TTabSheet; Font: TFont);
    procedure ApplyChanges(Sender:TObject);
    procedure cMariageClick(Sender: TObject);
    procedure lCompositionLieuClick(Sender: TObject);
    procedure cAvecLieuClick(Sender: TObject);
    procedure menuChange(Sender: TObject);
    procedure lCompositionLieuMouseEnter(Sender: TObject);
    procedure lCompositionLieuMouseLeave(Sender: TObject);
    procedure cAvecActeMouseEnter(Sender: TObject);
    procedure cAvecActeMouseLeave(Sender: TObject);
    procedure cbShowSosasClick(Sender: TObject);
    procedure btnImportClick(Sender:TObject);
    procedure btnExportClick(Sender:TObject);
  private
    RectMonitor:TRect;
    fFill:TState;
    fOngletID:integer;
    FGraphTree  : TGraphTree;
    FRefresh: TJVXPButton;
    NomFich:string;

    procedure doActiveOnglet(onglet:integer); virtual;
    procedure RefreshIni;
  public
    constructor Create(Sender:TComponent);override;
    procedure InitView ( const AGraph : TGraphTree; const ARefresh: TJVXPButton ); virtual;
  end;

implementation

uses u_common_resources,
     u_common_functions,
     fonctions_dialogs,
     fonctions_init,
     u_printreport,
     IniFiles,
     u_ancestro_strings,
     u_genealogy_context;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFGraphConfigHierarchie.RefreshIni;
begin
  with FGraphTree do
  try
    ReadSectionIni;
    edMargeLeft.Value:=MargeLeft;
    edMargeTop.Value:=MargeTop;

    edWidthIndi.Value:=BoxWidth;
    edHeightIndi.Value:=BoxHeight;
    edEspaceEntreGenerations.Value:=SpaceGeneration;
    edEspaceEntreIndis.Value:=SpacePerson;
    edRecouvrementImpression.Value:=gci_context.ArbreRecouvrement;

    panExempleFont.Font.Assign(Font);
    edColorTexteHomme.Value:=ColorTextMan;
    edColorTexteFemme.Value:=ColorTextWoman;

    cNom.checked:=ttLastName in ShowText;
    cPrenom.checked:=ttName in ShowText;
    cProf.checked:=ttJob in ShowText;
    cNaissance.checked:=ttBirthDay in ShowText;
    cDeces.checked:=ttDeathDay in ShowText;
    cMariage.checked:=ttMarriage in ShowText;
    cPosterite.checked:=toWellKnown in Options;
    cbShowSosas.checked:=ttSOSA in ShowText;
    cAvecActe.checked:=toAct in Options;
    cOptimiseLargeur.checked:=toOptimiseWidth in Options;
    cAvecLieu.checked:=toCities in Options;
    mAvecSubd.checked:=toSubd in Options;
    mAvecVille.checked:=toCities in Options;
    mAvecCodeDept.checked:=toCodeDept in Options;
    mAvecNomDept.checked:= toNameDept in Options;
    mAvecRegion.checked:=toRegion in Options;
    mAvecPays.checked:=toCountry in Options;
    lCompositionLieu.Visible:=toCities in Options;

    edLineHeight.Value:=LineHeight;

    edCouleurLiens.Value:=ColorLink;
    edCouleurRectHomme.Value:=ColorRectMan;
    cPaintFondRecHomme.checked:= teBackMan in ShowBack;
    edCouleurFondRectHomme.Value:=ColorBackMan;
    edCouleurRectFemme.Value:=ColorRectWoman;
    cPaintFondRecFemme.checked:=teBackWoman in ShowBack;
    edCouleurFondFemme.Value:=ColorBackWoman;
  finally
    fFill.Value:=false;
  end;

end;

procedure TFGraphConfigHierarchie.InitView ( const AGraph : TGraphTree; const ARefresh: TJVXPButton );
begin

  Color:=gci_context.ColorLight;
{  btnFont.ColorShadow:=gci_context.ColorLight;
  btnFont.ColorBorder:=gci_context.ColorLight;
  btnFont.ColorDown:=gci_context.ColorLight;
  btnFont.ColorFocused:=gci_context.ColorLight;
  btnFont.ColorHighlight:=gci_context.ColorLight;}
  panExempleFont.Color:=gci_context.ColorDark;

  DefaultCloseAction:=caHide;

  fOngletID:=0;
  OpenDialog.InitialDir:=gci_context.PathDocs;
  SaveDialog.InitialDir:=gci_context.PathDocs;
  NomFich:='';

  fFill.Value:=true;
  FGraphTree := AGraph;
  FRefresh := ARefresh;
  RectMonitor:=(AGraph.Owner as TCustomForm).Monitor.WorkareaRect;
  RefreshIni;
end;

procedure TFGraphConfigHierarchie.SuperFormDestroy(Sender:TObject);
begin
  fFill.Destroy;
end;

constructor TFGraphConfigHierarchie.Create(Sender:TComponent);
begin
  fFill:=TState.create(false);
  FGraphTree := nil;
  Inherited;
end;

procedure TFGraphConfigHierarchie.btnFontClick(Sender:TObject);
begin
  FontDialog.Font.Assign(panExempleFont.Font);

  if FontDialog.execute then
  begin
    panExempleFont.Font.Assign(FontDialog.Font);
    ApplyChanges(Sender);
  end;
end;

procedure TFGraphConfigHierarchie.ApplyChanges(Sender:TObject);
begin
  if (fFill.Value=false)
  and Assigned(FGraphTree) then
  with FGraphTree do
  begin
    gci_context.ShouldSave:=true;
    ColorBackMan  :=edCouleurFondRectHomme.Value;
    ColorBackWoman:=edCouleurFondFemme.Value;
    ColorBox      :=clBlack;
    ColorRectMan  :=edCouleurRectHomme.Value;
    ColorRectWoman:=edCouleurRectFemme.Value;
    ColorTextMan  :=ColorTextMan;
    ColorTextWoman:=ColorTextWoman;

    MargeLeft:=edMargeLeft.Value;
    MargeTop:=edMargeTop.Value;

    BoxWidth:=edWidthIndi.Value;
    BoxHeight:=edHeightIndi.Value;
    SpaceGeneration:=edEspaceEntreGenerations.Value;
    SpacePerson:=edEspaceEntreIndis.Value;
    gci_context.ArbreRecouvrement:=edRecouvrementImpression.Value;
    graph_RecouvrementImpression:=edRecouvrementImpression.Value;

    Font.Assign(panExempleFont.Font);
    ColorTextMan:=edColorTexteHomme.Value;
    ColorTextWoman:=edColorTexteFemme.Value;

    SetCheckShow ( ttLastName,cNom.Checked );
    SetCheckShow ( ttName,cPrenom.Checked);
    SetCheckShow ( ttJob,cProf.Checked);
    SetCheckShow ( ttBirthDay,cNaissance.Checked);
    SetCheckShow ( ttDeathDay,cDeces.Checked);

    SetCheckOption(toOptimiseWidth,cOptimiseLargeur.checked);

    LineHeight:=edLineHeight.Value;

    SetCheckOption(toAct,cAvecActe.checked);
    SetCheckOption(toWellKnown,cPosterite.checked);

    SetCheckElement ( teBackMan,cPaintFondRecHomme.Checked);
    SetCheckElement ( teBackWoman,cPaintFondRecFemme.Checked);

    ColorLink:=edCouleurLiens.Value;
    ColorRectMan:=edCouleurRectHomme.Value;
    ColorBackMan:=edCouleurFondRectHomme.Value;
    ColorRectWoman:=edCouleurRectFemme.Value;
    ColorBackWoman:=edCouleurFondFemme.Value;

    WriteSectionIni;
    //on rafraichit le graph
    FRefresh.Enabled:=True;
  end;
end;

procedure TFGraphConfigHierarchie.SuperFormShowFirstTime(Sender:TObject);
begin
  //Positionnement de la fenêtre en bas à droite du moniteur de l'arbre
  Top:=RectMonitor.Bottom-Height;
  Left:=RectMonitor.Right-Width;
  Caption:=rs_Caption_Set_the_tree;
  doActiveOnglet(0);
end;

procedure TFGraphConfigHierarchie.doActiveOnglet(onglet:integer);
begin
  fOngletID:=onglet;
  Notebook.PageIndex:=onglet;
end;

procedure TFGraphConfigHierarchie.SuperFormKeyDown(Sender:TObject;
  var Key:Word;Shift:TShiftState);
begin
  case Key of
    _KEY_HELP:p_ShowHelp(_ID_PRINT_ARBRE);
  end;
end;

procedure TFGraphConfigHierarchie.onTabControl1Change(Sender: TObject);
begin
  doActiveOnglet((sender as TPanel).TabOrder);
end;

procedure TFGraphConfigHierarchie.onTabControl1DrawEx(
  AControl: TCustomTabControl; ATab: TTabSheet; Font: TFont);
begin
  Font.Color:= gci_context.ColorTexteOnglets;
  if ATab = ATab.PageControl.ActivePage then
    ATab.Color:=gci_context.ColorLight
  else
    ATab.Color:=gci_context.ColorDark;
end;

procedure TFGraphConfigHierarchie.cMariageClick(Sender: TObject);
begin
  if fFill.Value=false then
  with FGraphTree do
  begin
    (Owner as IFormIniPaint).EnableBtnRefresh;
    gci_context.ShouldSave:=true;
    SetCheckShow ( ttMarriage,cMariage.checked);
  end;
end;

procedure TFGraphConfigHierarchie.lCompositionLieuClick(Sender: TObject);
var
  p:TPoint;
begin
  p:=lCompositionLieu.ClientToScreen(Point(0,lCompositionLieu.Height));
  mLieu.Popup(p.X,p.Y);
end;

procedure TFGraphConfigHierarchie.cAvecLieuClick(Sender: TObject);
begin
  if fFill.Value=false then
  with FGraphTree do
  begin
    (Owner as IFormIniPaint).EnableBtnRefresh;
    SetCheckOption(toCities,cAvecLieu.checked);
    lCompositionLieu.Visible:=cAvecLieu.checked;
  end;
end;

procedure TFGraphConfigHierarchie.menuChange(Sender: TObject);
begin
  if fFill.Value=false then
  with FGraphTree do
  begin
    (Sender as TMenuItem).Checked:=not (Sender as TMenuItem).Checked;
    if (Sender as TMenuItem).Checked then
    begin
      if sender=mAvecCodeDept then
        mAvecNomDept.Checked:=false;
      if sender=mAvecNomDept then
        mAvecCodeDept.Checked:=false;
    end;
    SetCheckOption ( toSubd,mAvecSubd.checked );
    SetCheckOption ( toCities,mAvecVille.Checked);
    SetCheckOption ( toCodeDept,mAvecCodeDept.checked);
    SetCheckOption ( toNameDept,mAvecNomDept.checked);
    SetCheckOption ( toRegion,mAvecRegion.checked);
    SetCheckOption ( toCountry,mAvecPays.checked);
    (Owner as IFormIniPaint).EnableBtnRefresh;
    lCompositionLieu.Font.Style:=lCompositionLieu.Font.Style-[fsUnderline];
    lCompositionLieu.Cursor:=crDefault;
  end;
end;

procedure TFGraphConfigHierarchie.lCompositionLieuMouseEnter(
  Sender: TObject);
begin
  lCompositionLieu.Font.Style:=lCompositionLieu.Font.Style+[fsUnderline];
  lCompositionLieu.Cursor:=_CURPOPUP;
end;

procedure TFGraphConfigHierarchie.lCompositionLieuMouseLeave(
  Sender: TObject);
begin
  lCompositionLieu.Font.Style:=lCompositionLieu.Font.Style-[fsUnderline];
  lCompositionLieu.Cursor:=crDefault;
end;

procedure TFGraphConfigHierarchie.cAvecActeMouseEnter(Sender: TObject);
begin
  cAvecActe.ShowHint:=true;//met le hint devant la fiche si celle-ci est en mode fsStayOnTop
end;

procedure TFGraphConfigHierarchie.cAvecActeMouseLeave(Sender: TObject);
begin
  cAvecActe.ShowHint:=false;
end;

procedure TFGraphConfigHierarchie.cbShowSosasClick(Sender: TObject);
begin
  if fFill.Value=false then
  FGraphTree.SetCheckShow(ttSOSA,cbShowSosas.Checked);
end;

procedure TFGraphConfigHierarchie.btnImportClick(Sender:TObject);
begin
  if NomFich<>'' then
    OpenDialog.FileName:=NomFich;
  if OpenDialog.Execute then
  begin
    NomFich:=OpenDialog.FileName;
    try
      with FGraphTree do
      try
        fFill.Value:=true;
        try
          Inifile := nil; // GraphTree.Inifile is just global Finifile
          Inifile:=TIniFile.Create(NomFich);
          RefreshIni;

          (Owner as IFormIniPaint).EnableBtnRefresh;
          with FGraphTree.Viewer do
           Begin
            with PrintGraph,rp.PrinterMetrics do
             Begin
              PageWidth:=round(PhysicalWidth-MarginLeft-MarginRight-edRecouvrementImpression.Value);
              PageHeight:=round(PhysicalHeight-MarginTop-MarginBottom-edRecouvrementImpression.Value);
              BuildZonesImpression;
              BuildMiniature;
  //            Graph.Prepare;
              PrepareGraph;
             end;
            Refresh;
            RefreshMiniature;
           end;
        finally
          fFill.Value:=false;
        end;

      finally
        Inifile.Free;
        IniFile := nil;
      end;
    except
      MyMessageDlg(rs_Error_This_File_is_not_a_tree_config_file
        ,mmtError, [mmbCancel],Self)
    end;
  end;
end;

procedure TFGraphConfigHierarchie.btnExportClick(Sender:TObject);
begin
  if NomFich<>'' then
    SaveDialog.FileName:=NomFich;
  if SaveDialog.Execute then
  begin
    NomFich:=SaveDialog.FileName;
    with FGraphTree do
    try
      Inifile := nil; // GraphTree.Inifile is just global Finifile
      Inifile := TIniFile.Create(NomFich);
      WriteSectionIni;
    finally
      Inifile.Free;
      Inifile:=nil;
    end;
  end;
end;
end.

