{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_graph_TPlot;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

type
  TPlot=class
  private
    fYV:integer;
    fXV:integer;
    fYC:single;
    fXC:single;
    fYM:integer;
    fXM:integer;
    fYI:single;
    fXI:single;

  public
    //coordonnées dans le chantier
    property XC:single read fXC write fXC;
    property YC:single read fYC write fYC;

    //coordonnées dans le viewer
    property XV:integer read fXV write fXV;
    property YV:integer read fYV write fYV;

    //coordonnées dans la miniature
    property XM:integer read fXM write fXM;
    property YM:integer read fYM write fYM;

    //coordonnées pour l'impression (pour la roue)
    property XI:single read fXI write fXI;
    property YI:single read fYI write fYI;

    procedure CoordChantier_2_CoordViewer(coef:single);
    procedure CoordChantier_2_CoordMiniature(coef:single);
  end;

implementation

{ TPlot }

procedure TPlot.CoordChantier_2_CoordMiniature(coef:single);
begin
  fXM:=round(coef*fXC);
  fYM:=round(coef*fYC);
end;

procedure TPlot.CoordChantier_2_CoordViewer(coef:single);
begin
  fXV:=round(coef*fXC);
  fYV:=round(coef*fYC);
end;

end.

