unit RunLabel;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright Andr? Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestro 2013 GPL)           }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


//28.01.2001 by Peric

interface

uses
  {$IFDEF FPC}
  LCLType,
  {$ELSE}
  Windows,
  {$ENDIF} Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,EXtCtrls;

{$IFNDEF FPC}
{$R RunLabel.res}
{$ENDIF}

type
  TRunLabel = class(TCustomLabel)
   private


    FRunenabled:boolean;
    FRunspeed:integer;
    Timer:TTimer;
    FCop,FCaptionRun,FCaptionRRun: string;
    function GetCop: string;
    procedure SetCop(const Value: string);
    procedure SetCaptionRun(ACaptionRun: string);
    procedure Run;
    
  protected


    procedure SetRunenabled(ARunenabled:boolean);
    procedure SetRunspeed(ARunspeed:integer);
    procedure OnTimer(Sedner:Tobject);virtual;

  public


    constructor Create(Aowner:Tcomponent);override;

  published


    property RunEnabled:boolean
    read Frunenabled write Setrunenabled default True;
    property RunSpeed:integer
    read  FRunspeed write SetRunspeed default 20;
    property Copyright: string read GetCop write SetCop;
    property CaptionRun: string read FCaptionRun write SetCaptionRun ;
    property Align;
    property Alignment;
    property AutoSize;
    property Color;
    property Enabled;
    property DragCursor;
    property DragMode;
    property FocusControl;
    property Font;
    property ParentColor;
    property ParentShowHint;
    property ParentFont;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;


  end;

procedure Register;

implementation
 var x:integer;

procedure Register;
begin
  RegisterComponents('Perso', [TRunLabel]);
end;


constructor TRunLabel.Create(AOwner:TComponent);

begin
inherited;
Frunenabled:=True;
FRunspeed:=20;
Timer:=TTimer.Create(Self);
Timer.Interval:= FRunspeed;
Timer.OnTimer:=OnTimer;
FCop:='Copyright ? 2001 by Peric';
FCaptionRun:='RunLabel';
Caption:= FCaptionRun;
 end;

 function TRunLabel.GetCop: string;
begin
  Result:=FCop;
end;

procedure TRunLabel.SetCop(const Value: string);
begin
  FCop:=FCop;
end;


procedure TRunLabel.SetCaptionRun(ACaptionRun: string);
begin
  FCaptionRun:=ACaptionRun;
  Caption:=FcaptionRun;
 FCaptionRRun:='                        '+FCaptionRun;

end;
                          

 procedure TRunLabel.Setrunenabled(Arunenabled:boolean);

 begin
 Frunenabled:=Arunenabled;
 if csDesigning in ComponentState then
 Exit;
 Timer.Enabled:=Frunenabled;

 end;

 procedure TRunLabel.SetRunspeed(ARunspeed:integer);

 begin
 FRunspeed:=ARunspeed;
 Timer.interval:=ARunspeed;
 end;

 procedure TRunLabel.OnTimer(Sedner:Tobject);

 begin
 if csDesigning in ComponentState then begin
 Timer.Enabled:=False;
 Exit;
 end;
 Run;
 end;

 procedure TRunLabel.Run;
begin
X:=X+1;
Caption := Copy(FCaptionRRun,X, 30);
if x >= Length(FCaptionRRun) then
x := 0;
end;


end.
