unit u_common_tree;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$mode delphi}

interface
{$i ../extends.inc}

uses
  {$IFDEF VIRTUALTREES}
  VirtualTrees;
  {$ELSE}
  ComCtrls;
  {$ENDIF}

type
  TIndivTree=record
    cle:integer;
    Niveau:Smallint;
    Sosa:Int64;
    Implexe:Integer;
    Enfants:Integer;
    Ordre:Integer;
    Sexe : Integer;
    {$IFDEF VIRTUALTREES}libelle : String;{$ENDIF}
  end;
  PIndivTree=^TIndivTree;



procedure p_FindNodeWithKey ( const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const acle : Integer ; var FoundNode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF} );

implementation

{$IFNDEF VIRTUALTREES}
procedure ValidateNode ( ANode : TTreeNode );
var NodeIndiv : PIndivTree;
Begin
  New(NodeIndiv);
  with ANode do
   Begin
    Data:=NodeIndiv;
   end;
end;
{$ENDIF}

procedure p_FindNodeWithKey ( const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const acle : Integer ; var FoundNode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF} );
var AData : PIndivTree;
Begin
  with ATree,{$IFDEF VIRTUALTREES}ANode^{$ELSE}ANode{$ENDIF} do
   Begin
    if {$IFDEF VIRTUALTREES}ANode <> RootNode{$ELSE}ANode.Parent<>nil{$ENDIF} Then
      Begin
       AData:={$IFDEF VIRTUALTREES}GetNodeData(ANode){$ELSE}ANode.Data{$ENDIF};
       if AData^.cle = acle Then
         FoundNode:=ANode;
       if FoundNode   <> nil Then Exit;
       if {$IFDEF VIRTUALTREES}NextSibling{$ELSE}GetNextSibling{$ENDIF} <> nil Then p_FindNodeWithKey(ATree,{$IFDEF VIRTUALTREES}NextSibling{$ELSE}GetNextSibling{$ENDIF},acle,FoundNode);
      end;
    if FoundNode   <> nil Then Exit;
    if {$IFDEF VIRTUALTREES}FirstChild{$ELSE}GetFirstChild{$ENDIF}  <> nil Then p_FindNodeWithKey(ATree,{$IFDEF VIRTUALTREES}FirstChild{$ELSE}GetFirstChild{$ENDIF} ,acle,FoundNode);
   end;
End;


end.

