{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_arbre;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$i ../extends.inc}


interface

uses
{$IFNDEF FPC}
  Windows, ExtJvXPCheckCtrls,
{$ELSE}
  ExtJvXPCheckCtrls,
{$ENDIF}
  PrintersDlgs,U_FormAdapt,
{$IFDEF VIRTUALTREES}
  VirtualTrees,
{$ELSE}
  ComCtrls,
{$ENDIF}
  Menus,
  CompSuperForm,
  StdCtrls,Classes,ExtCtrls,Graphics,
  u_framework_components, U_OnFormInfoIni,IBSQL;

type
  TMyPopupMenu=class(TPopupMenu)

  public
    property PopupPoint;
  end;

  TIndividu=packed record
    Nom,
    Prenom,
    Deces,
    Naissance,
    SOSA,
    Implexe:string;
    Sexe,
    CleFiche,
    Level:integer;
  End;
  PIndividu=^TIndividu;

  { TFArbre }

  TFArbre=class(TF_FormAdapt)
    cbDescendance: TJvXPCheckbox;
    dxsGenerations: TFWSpinEdit;
    frbHorizontal: TRadioButton;
    frbVertical: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label8: TLabel;
    lHint: TLabel;
    lNom: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    IBSTree: TIBSQL;
    {$IFDEF VIRTUALTREES}
    oc:TVirtualStringTree;
    {$ELSE}
    oc:TTreeView;
    {$ENDIF}
    OnFormInfoIni: TOnFormInfoIni;
    Panel6: TPanel;
    pmArbre:TPopupMenu;
    Panel10:TPanel;
    Panel1:TPanel;
    dxComponentPrinter1:TPrinterSetupDialog;
    option_OpenFiche:TMenuItem;
    option_OpenFicheInBox:TMenuItem;
    IBQEnfants:TIBSQL;
    sp_fontsize: TFWSpinEdit;
    procedure sp_fontsizeChange(Sender: TObject);
    procedure ocGetPopupMenu(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}{$IFDEF VIRTUALTREES} ;Node: PVirtualNode;
      Column: TColumnIndex; const P: TPoint; var AskParent: Boolean;
      var PopupMenu: TPopupMenu{$ENDIF});
    procedure ocGetImageIndex(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}
      {$IFDEF VIRTUALTREES};Kind: TVTImageKind; Column: TColumnIndex; var Ghosted: Boolean;var ImageIndex: Integer{$ENDIF});
    {$IFDEF VIRTUALTREES}
    procedure ocPaintText(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
      const TargetCanvas: TCanvas; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; Column: TColumnIndex;
      TextType: TVSTTextType);
    {$ENDIF}
    procedure ocGetText({$IFDEF VIRTUALTREES}Sender: TBaseVirtualTree;{$ENDIF}Node: {$IFDEF VIRTUALTREES}PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var Text: String{$ELSE}TTreeNode{$ENDIF});
    procedure frbHorizontalClick(Sender:TObject);
    procedure cbZoomClick(Sender:TObject);
    procedure dxsGenerationsChange(Sender:TObject);
    procedure frbVerticalClick(Sender:TObject);
    procedure option_OpenFicheClick(Sender:TObject);
    procedure option_OpenFicheInBoxClick(Sender:TObject);
    procedure option_PrintClick(Sender:TObject);
    procedure cbDescendanceClick(Sender:TObject);
    procedure ocMouseMove(Sender:TObject;Shift:TShiftState;X,
      Y:Integer);

  private
    fStartIndividu:PIndividu;
    FGenerations : Integer;
    FDescendance : Boolean;
    fAll:TList;
    fCleIndiDepart:integer;
    GFormIndividu : TSuperForm;

    procedure GetPere(const Clef:integer; Anode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; var AnodeFound : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF});

    procedure doAscendance;
    procedure doDescendance;
    procedure Show_Arbre;
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure DoShowFirstTime; override;
    procedure Loaded; override;
    procedure DoShow; override;
    destructor Destroy; override;
    procedure DoRefreshControls; override;
    property CleIndiDepart:integer read fCleIndiDepart write fCleIndiDepart;
    procedure Init_Arbre;
    procedure Refresh_Arbre;

  end;

implementation

uses u_dm,u_form_individu,u_common_functions,u_common_ancestro,u_common_const,
{$IFDEF FPC}
     LCLProc,
{$ENDIF}
     u_genealogy_context,u_Form_Main,
     fonctions_ini,
     Controls,
     u_common_ancestro_functions, lazutf8,
     u_common_resources;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

{$IFNDEF VIRTUALTREES}
procedure ValidateNode ( ANode : TTreeNode );
var NodeEve : PIndividu;
Begin
  New(NodeEve);
  with ANode do
   Begin
    Data:=NodeEve;
   end;
end;
{$ENDIF}

procedure TFArbre.Init_Arbre;
begin
  f_GetMemIniFile();
  {$IFDEF VIRTUALTREES}
  oc.NodeDataSize := Sizeof(TIndividu)+1;
  {$ENDIF}
  if GFormIndividu=nil then
  begin
    fCleIndiDepart:=dm.individu_clef;
  end
  else
  begin
    fCleIndiDepart:=TFIndividu(GFormIndividu).CleFiche;
  end;

  dxsGenerations.Value:=gci_context.ArbreReduit;//AL mis là et une seule fois pour remplacer les 4 autres
End;

procedure TFArbre.Refresh_Arbre;
begin
  if     ( cbDescendance  .Checked  = FDescendance )
      and assigned ( fStartIndividu )
      and ( fStartIndividu^.CleFiche = fCleIndiDepart )
      and ( FGenerations=dxsGenerations.Value)
   Then
    Begin
      Exit;
    end;

  Show_Arbre;

end;
procedure TFArbre.Show_Arbre;
begin
  if not Visible
   Then Exit;

  FGenerations := dxsGenerations.Value;
  FDescendance := cbDescendance.Checked;

  oc.{$IFNDEF VIRTUALTREES}Items.{$ENDIF}Clear;
  fAll.Clear;

  //On charge les individus
  dm.IBTrans_Courte.StartTransaction;

  try
    if cbDescendance.Checked then
      doDescendance
    else
      doAscendance;
  finally
    IBSTree.Close;
    dm.IBTrans_Courte.Commit;
  end;
  if GFormIndividu=nil then
    lNom.Caption:=CoupeChaine(AssembleString([fStartIndividu.Nom,fStartIndividu.Prenom]),lNom);

  oc.FullExpand;

end;

procedure TFArbre.doAscendance;
var
  Alevel,ACleFiche:integer;
  descendant:integer;
  indi,
  indiParent:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  //On charge les individus
  with IBSTree do
  Begin
    SQL.Text :='SELECT t.tq_niveau'
      +',t.tq_cle_fiche'
      +',i.NOM'
      +',i.PRENOM'
      +',i.SEXE'
      +',i.DATE_NAISSANCE'
      +',i.DATE_DECES'
      +',t.IMPLEXE'
      +',t.tq_descendant'
      +',t.tq_sosa'
      +' FROM PROC_TQ_ASCENDANCE(:I_CLEF,:I_NIVEAU,0,1) t'
      +' inner join individu i on i.cle_fiche=t.tq_cle_fiche'
      +' ORDER BY t.tq_niveau,t.tq_sosa';
    ParamByName( IBQ_I_CLEF ).asInteger:=fCleIndiDepart;
    ParamByName( IBQ_I_NIVEAU ).asInteger:=FGenerations-1;
    ExecQuery;

    with oc{$IFNDEF VIRTUALTREES},Items{$ENDIF} do
    while not Eof do
    begin
      ALevel:=FieldByName('tq_niveau').AsInteger;
      ACleFiche:=FieldByName('tq_cle_fiche').AsInteger;
      descendant:=FieldByName('tq_descendant').AsInteger;
      if Alevel=0 then
      begin
        //celui de départ
        indi := AddChild(nil,{$IFDEF VIRTUALTREES}nil{$ELSE}''{$ENDIF});
        ValidateNode ( indi{$IFDEF VIRTUALTREES},False{$ENDIF} );
        fStartIndividu:=PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF});
        indiParent:=nil;
      end
      else
      begin
        indiParent:=nil;
        GetPere(descendant,{$IFDEF VIRTUALTREES}RootNode.FirstChild{$ELSE}GetFirstNode{$ENDIF},indiParent);//AL2009
        indi := AddChild(indiParent,{$IFDEF VIRTUALTREES}nil{$ELSE}''{$ENDIF});
        ValidateNode ( indi{$IFDEF VIRTUALTREES},False{$ENDIF} );
      end;
      fAll.Add({$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF});

      with PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF})^ do
       Begin
        Sexe:=FieldByName('SEXE').AsInteger;
        CleFiche:=ACleFiche;
        level:=Alevel;
        Nom:=FieldByName('NOM').AsString;
        Prenom:=FieldByName('PRENOM').AsString;
        Naissance:=FieldByName('DATE_NAISSANCE').AsString;
        Deces:=FieldByName('DATE_DECES').AsString;
        SOSA:=FieldByName('TQ_SOSA').AsString;
        Implexe:=FieldByName('IMPLEXE').AsString;
       end;

      {$IFNDEF VIRTUALTREES}
      ocGetText (indi);
      {$ENDIF}
      next;
    end;

  end;

  //on s'assure que les hommes sont à droite, et les femmes à gauche
  //fStartIndividu.OrdreHommeFemme;//pas nécessaire fait par order by sosa

end;



procedure TFArbre.DoShow;
begin
  inherited;
  Init_Arbre;
  Show_Arbre;
  sp_fontsize.Value := oc.Font.Size;
end;

procedure TFArbre.Loaded;
begin
  oc:= {$IFDEF VIRTUALTREES}TVirtualStringTree{$ELSE}TTreeview{$ENDIF}.Create(self);
  with oc do
   Begin
    Parent:=Self;
    {$IFNDEF VIRTUALTREES}
    ReadOnly:=True;
    {$ENDIF}
    Left := 0;
    Height := 468;
    Hint := rs_Tree;
    Top := 40;
    Width := 547;
    Align := alClient;
    {$IFDEF VIRTUALTREES}
    DefaultNodeHeight := 15;
    Font.Color := clBlack;
    Font.Height := -12;
    Font.Name := 'Tahoma';
    Font.Style := [fsBold];
    Header.AutoSizeIndex := 0;
    with Header.Columns.add do
      Begin
        Position := 0;
        Width := 545;
      end;
    Header.DefaultHeight := 17;
    Header.Height := 17;
    Header.Options := [hoAutoResize, hoDrag, hoShowSortGlyphs];
    TreeOptions.AutoOptions := [toAutoDropExpand, toAutoScroll, toAutoScrollOnExpand, toAutoSort, toAutoTristateTracking, toAutoDeleteMovedNodes];
    TreeOptions.MiscOptions := [toFullRepaintOnResize, toInitOnSave, toToggleOnDblClick, toWheelPanning, toEditOnClick];
    OnPaintText := ocPaintText;
    OnGetText := ocGetText;
    OnGetPopupMenu := ocGetPopupMenu;
    {$ELSE}
    OnMenuPopupHandler := ocGetPopupMenu;
    {$ENDIF}
    Images := dm.ImgCouple;
    ParentColor := True;
    ParentFont := False;
    ParentShowHint := False;
    PopupMenu := pmArbre;
    ShowHint := True;
    TabOrder := 0;
    OnDblClick := option_OpenFicheClick;
    OnGetImageIndex := ocGetImageIndex;
    OnMouseMove := ocMouseMove;
  end;

  f_GetMemIniFile();
  GFormIndividu:=owner as TSuperForm;

  fStartIndividu := nil ;

  fCleIndiDepart:=-1;
  FGenerations := 0;
  FDescendance := False;

{ Matthieu ?
  if gci_context.ArbreHorizontal then
  begin
    frbHorizontal.Checked:=true;
    oc.TreeOptions:=True;
  end
  else
  begin
    frbVertical.Checked:=true;
    oc.Rotated:=False;
  end;}
  lNom.PopupMenu:=TFIndividu(GFormIndividu).pmNom;
  lNom.OnMouseEnter:=TFIndividu(GFormIndividu).lNomMouseEnter;
  lNom.OnMouseLeave:=TFIndividu(GFormIndividu).lNomMouseLeave;
  lNom.OnMouseMove:=TFIndividu(GFormIndividu).lNomMouseMove;
  lNom.OnClick:=TFIndividu(GFormIndividu).lNomClick;
  fAll:=TList.create;
  Panel10.Color:=gci_context.ColorLight;
  inherited;

end;

procedure TFArbre.sp_fontsizeChange(Sender: TObject);
begin
  if oc.Font.Size <> sp_fontsize.Value Then
   Begin
    oc.Font.Size := sp_fontsize.Value;
    {$IFDEF VIRTUALTREES}
    oc.DefaultNodeHeight:=oc.Canvas.TextHeight('W')+2;
    {$ENDIF}
    Refresh_Arbre;
   end;
end;

procedure TFArbre.ocGetImageIndex(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}
      {$IFDEF VIRTUALTREES};Kind: TVTImageKind; Column: TColumnIndex; var Ghosted: Boolean;var ImageIndex: Integer{$ENDIF});
begin
  {$IFNDEF VIRTUALTREES}
  with Node do
  {$ENDIF}
    ImageIndex:=PIndividu({$IFDEF VIRTUALTREES}oc.GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^.Sexe;
end;

procedure TFArbre.ocGetPopupMenu(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}{$IFDEF VIRTUALTREES} ;Node: PVirtualNode;
      Column: TColumnIndex; const P: TPoint; var AskParent: Boolean;
      var PopupMenu: TPopupMenu{$ENDIF});
var
  indi:TIndividu;
  NewItem:TMenuItem;
  {$IFNDEF VIRTUALTREES}
  Node:TTreeNode;
  {$ENDIF}

begin
  pmArbre.Items.Clear;

  NewItem:=TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name:='option_Print';
  NewItem.Caption:=rs_Caption_Print_this_tree;
  NewItem.ImageIndex:=6;
  NewItem.Onclick:=option_PrintClick;

  NewItem:=TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name:='option_OpenFicheInBox';
  NewItem.Caption:=rs_Caption_Look_at_person_s_file;
  NewItem.ImageIndex:=1;
  NewItem.Onclick:=option_OpenFicheInBoxClick;

  NewItem:=TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Caption:='-';

  NewItem:=TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name:='option_OpenFiche';
  NewItem.Caption:=rs_Caption_Open_the_person_s_file;
  NewItem.ImageIndex:=86;
  NewItem.Onclick:=option_OpenFicheClick;

  NewItem:=TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Caption:='-';

  option_OpenFiche.visible:=false;
  option_OpenFicheInBox.visible:=false;
  with oc do
   Begin
    with Mouse.CursorPos do
     Node:=GetNodeAt(x,y);

    if Node<>nil then
      begin
        indi:=PIndividu({$IFDEF VIRTUALTREES}GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^;

        option_OpenFiche.Tag:=indi.CleFiche;
        option_OpenFicheInBox.Tag:=indi.CleFiche;
        option_OpenFiche.visible:=indi.CleFiche<>fCleIndiDepart;
        option_OpenFicheInBox.visible:=true;

        dm.IBTrans_Courte.StartTransaction;
        try
          with IBQEnfants do
          begin
            SQL.Clear;
            SQL.Add('select i.cle_fiche,i.nom,i.prenom,i.sexe from individu i'
              +' left join evenements_ind n on n.ev_ind_kle_fiche=i.cle_fiche and n.ev_ind_type=''BIRT''');
            if indi.Sexe=1 then
            begin
              SQL.Add('where i.cle_pere=:clef');
            end
            else
            begin
              SQL.Add('where i.cle_mere=:clef');
            end;
            SQL.Add('order by i.annee_naissance,n.ev_ind_date_mois,n.ev_ind_date');
            Params[0].AsInteger:=indi.CleFiche;
            ExecQuery;
            if not Eof then
            begin
              NewItem:=TMenuItem.create(self);
              pmArbre.Items.Add(NewItem);
              NewItem.Caption:='-';
              while not Eof do
              begin
                NewItem:=TMenuItem.create(self);
                pmArbre.Items.Add(NewItem);
                NewItem.Tag:=FieldByName('CLE_FICHE').AsInteger;
                NewItem.Caption:=AssembleString([FieldByName('NOM').AsString,FieldByName('PRENOM').AsString]);
                NewItem.Onclick:=option_OpenFicheClick;
                if FieldByName('SEXE').AsInteger=1 then
                  NewItem.ImageIndex:=39
                else if FieldByName('SEXE').AsInteger=2 then
                  NewItem.ImageIndex:=38
                else
                  NewItem.ImageIndex:=36;
                next;
              end;
            end;
          end;
        finally
          IBQEnfants.Close;
          dm.IBTrans_Courte.Commit;
        end;
      end;

   end;

end;


procedure TFArbre.ocGetText({$IFDEF VIRTUALTREES}Sender: TBaseVirtualTree;{$ENDIF} Node: {$IFDEF VIRTUALTREES}PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var Text: String{$ELSE}TTreeNode{$ENDIF});
begin
  with {$IFNDEF VIRTUALTREES}Node,{$ENDIF}PIndividu ( {$IFDEF VIRTUALTREES}Sender.GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^ do
    Begin
      if SOSA>''
       then Text:='['+SOSA+'] '
       Else Text:='';
      Text := Text+Nom;
      Text := Text + ' ' + Prenom;
      if Length(Text)>0 then
      begin
        if UTF8Length(Text)>30 then
          Text:=UTF8Copy(Text,1,30)+CST_THREE_POINTS;
      end;
      if Naissance>'' then
        Text:=Text+'°'+Naissance;

      if Deces>'' then
        Text:=Text+'†'+Deces;
    end;
end;

{$IFDEF VIRTUALTREES}
procedure TFArbre.ocPaintText(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
  const TargetCanvas: TCanvas; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  y:integer;
  s:String;
begin
  f_GetMemIniFile();
  with oc do
  if {$IFDEF VIRTUALTREES}GetNodeData( Node ){$ELSE}Node.Data{$ENDIF}<>nil then
  with PIndividu({$IFDEF VIRTUALTREES}GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^,TargetCanvas, Font do
  begin
    if Implexe>''
     then Style:=[fsItalic,fsBold]
     else Style:=[fsBold];

   // Brush.Style:=bsClear;

   // Brush.Color:=Color;
   // if Implexe='' then
   //    TargetCanvas.FillRect(ItemRect);

    if Sexe=1 then
      Color:=gci_context.ColorHomme //$00F6CA92//
    else
      Color:=gci_context.ColorFemme; // $00B5A7F2

  end;

end;
{$ENDIF}
destructor TFArbre.Destroy;
begin
  inherited;
  fAll.free;
end;

{procedure TIndividu.OrdreHommeFemme;
var
  n:integer;
begin
  case Childs.count of
    2:
      begin
        if TIndividu(Childs[0]).Sexe=2 then //homme
        begin
            //invertion
          Childs.Exchange(0,1);
        end;
      end;
  end;

  //on ordonne les suivants
  for n:=0 to Childs.count-1 do
    TIndividu(Childs[n]).OrdreHommeFemme;
end;}

procedure TFArbre.GetPere(const Clef:integer; Anode : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; var AnodeFound : {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF});
var
  n:integer;
begin
  with oc do
  while Assigned(ANode) do
  begin
    GetPere(Clef,Anode.{$IFDEF VIRTUALTREES}FirstChild{$ELSE}GetFirstChild{$ENDIF},AnodeFound);;
    if AnodeFound <> nil Then Exit;

    if PIndividu({$IFDEF VIRTUALTREES}GetNodeData( Anode ){$ELSE}ANode.Data{$ENDIF})^.CleFiche=Clef then
    begin
      AnodeFound:=ANode;
      break;
    end;

    if AnodeFound <> nil Then Exit;

    ANode:=ANode.{$IFDEF VIRTUALTREES}NextSibling{$ELSE}GetNextSibling{$ENDIF};
  end;
end;
procedure TFArbre.frbHorizontalClick(Sender:TObject);
begin
{  oc.Rotated:=True;
  gci_context.ShouldSave:=true;
  gci_context.ArbreHorizontal:=true;}
end;

procedure TFArbre.cbZoomClick(Sender:TObject);
begin
//  Oc.Zoom:=not cbZoom.Checked;
end;

procedure TFArbre.DoShowFirstTime;
begin
  inherited;
  {$IFDEF VIRTUALTREES}
  with oc do
  if GFormIndividu=nil
   then TreeOptions.SelectionOptions:=TreeOptions.SelectionOptions- [toExtendedFocus]
   else TreeOptions.SelectionOptions:=TreeOptions.SelectionOptions+ [toExtendedFocus];
  {$ENDIF}
  doRefreshControls;
end;

procedure TFArbre.dxsGenerationsChange(Sender:TObject);
begin
  Refresh_Arbre;
  gci_context.ArbreReduit:=dxsGenerations.Value;
  gci_context.ShouldSave:=true;
end;

procedure TFArbre.frbVerticalClick(Sender:TObject);
begin
{  oc.Rotated:=False;
  gci_context.ShouldSave:=true;
  gci_context.ArbreHorizontal:=false;}
end;


procedure TFArbre.option_OpenFicheClick(Sender:TObject);
begin
  with oc, dm do
  if assigned ( {$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF} ) Then
   Begin
    individu_clef:=PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( FocusedNode ){$ELSE}Selected.Data{$ENDIF})^.CleFiche;
    FMain.Ouvre_Et_Selecte_Individu;
    fCleIndiDepart:=individu_clef;
    if GFormIndividu<>nil then
      TFIndividu(GFormIndividu).doOpenFiche(fCleIndiDepart);

    Refresh_Arbre;
   end;
end;

procedure TFArbre.option_OpenFicheInBoxClick(Sender:TObject);
begin
  with oc do
  if assigned ( {$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF} ) Then
    OpenFicheIndividuInBox(PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( FocusedNode ){$ELSE}Selected.Data{$ENDIF})^.CleFiche);
end;

procedure TFArbre.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  case Key of
    _KEY_HELP:p_ShowHelp(_ID_ARBRE);
  end;
end;

procedure TFArbre.DoRefreshControls;
begin
//  oc.TreeOptions.PaintOptions:= [toocu_buttons_flat,ocDblClick,ocRect3D];
//  oc.TreeOptions.PaintOptions:= [ocButtons,ocDblClick,ocRect3D];
end;

procedure TFArbre.doDescendance;
var
  level,ACleFiche:integer;
  ascendant:integer;
  indi,indiParent:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin

  with IBSTree do
  Begin
    SQL.Text :='select t.tq_niveau,t.tq_cle_fiche,t.tq_ascendant'
      +',i.sexe,i.nom,i.prenom,i.date_naissance,i.date_deces,t.tq_num_sosa'
      +' from PROC_TQ_DESCENDANCE(:I_CLEF,:I_NIVEAU,0,1) t'
      +' inner join individu i on i.cle_fiche=t.tq_cle_fiche'
      +' ORDER BY t.TQ_NIVEAU,t.tq_num_sosa';//AL2009

    Params[0].AsInteger:=fCleIndiDepart;
    Params[1].AsInteger:=dxsGenerations.Value;

    ExecQuery;

    with oc{$IFNDEF VIRTUALTREES},Items{$ENDIF} do
    while not Eof do
    begin
      Level:=FieldByName('tq_niveau').AsInteger;
      ACleFiche:=FieldByName('tq_cle_fiche').AsInteger;
      ascendant:=FieldByName('tq_ascendant').AsInteger;
      if level=1 then
      //celui de départ
      begin
        //celui de départ
        indi := AddChild(nil,{$IFDEF VIRTUALTREES}nil{$ELSE}''{$ENDIF});
        ValidateNode ( indi{$IFDEF VIRTUALTREES},False{$ENDIF} );
        fStartIndividu:=PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF});
      end
      else
      begin
        indiParent:=nil;
        GetPere(ascendant,{$IFDEF VIRTUALTREES}RootNode.FirstChild{$ELSE}GetFirstNode{$ENDIF},indiParent);//AL2009
        indi := AddChild(indiParent,{$IFDEF VIRTUALTREES}nil{$ELSE}''{$ENDIF});
        ValidateNode ( indi{$IFDEF VIRTUALTREES},False{$ENDIF} );
      end;
      fAll.Add({$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF});

      with PIndividu ( {$IFDEF VIRTUALTREES}GetNodeData( indi){$ELSE}indi.Data{$ENDIF})^ do
       Begin
        Sexe:=FieldByName('SEXE').AsInteger;

        CleFiche:=ACleFiche;
        level:=level;
        Nom:=FieldByName('NOM').AsString;
        Prenom:=FieldByName('PRENOM').AsString;
        Naissance:=FieldByName('DATE_NAISSANCE').AsString;
        Deces:=FieldByName('DATE_DECES').AsString;
        SOSA:=FieldByName('tq_num_sosa').AsString;
       end;

      {$IFNDEF VIRTUALTREES}
      ocGetText(indi);
      {$ENDIF}
      next;
    end;

  end;

  //on s'assure que les hommes sont à droite, et les femmes à gauche
  //fStartIndividu.OrdreHommeFemme; //pas pour la descendance!

  //Create
end;

procedure TFArbre.cbDescendanceClick(Sender:TObject);
begin
  Refresh_Arbre;
end;

procedure TFArbre.ocMouseMove(Sender:TObject;Shift:TShiftState;X,
  Y:Integer);
var
  indi:TIndividu;
  LHitinfo : {$IFDEF VIRTUALTREES}THitInfo{$ELSE}THitTests{$ENDIF};
  {$IFNDEF VIRTUALTREES}HitNode:TTreeNode;{$ENDIF}
begin
  {$IFNDEF VIRTUALTREES}LHitinfo:={$ENDIF}oc.GetHitTestInfoAt(X,Y{$IFDEF VIRTUALTREES},False,LHitinfo{$ENDIF});
  {$IFDEF VIRTUALTREES}
  with LHitinfo do
  {$ELSE}
  HitNode:=oc.GetNodeAt(x,y);
  {$ENDIF}
  if ( HitNode <> nil ) then
    begin
      indi:=PIndividu({$IFDEF VIRTUALTREES}oc.GetNodeData( HitNode ){$ELSE}HitNode.Data{$ENDIF})^;
      if lHint.Caption<>indi.Nom+', '+indi.Prenom then
      begin
        if indi.Sexe=1 then
          lHint.Font.Color:=gci_context.ColorHomme
        else
          lHint.Font.Color:=gci_context.ColorFemme;

        lHint.Caption:=indi.Nom+', '+indi.Prenom;
        FMain.MsgBarreEtat(lHint.Caption);
      end;
    end
  else
    lHint.Caption:='';
end;

procedure TFArbre.option_PrintClick(Sender:TObject);
var
  bZoom:Boolean;
begin
  DoRefreshControls;
end;

end.

