{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Journal_Operation;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,Forms, Classes,
  Dialogs,DB,IBCustomDataSet,IBQuery,
  StdCtrls,Controls,ExtCtrls,U_ExtDBGrid,
  u_buttons_appli,IBSQL,
  u_ancestropictimages, u_extcomponent, Menus;

type

  { TFJournalOperations }

  TFJournalOperations=class(TF_FormAdapt)
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    IBQJournal:TIBQuery;
    DSJournal:TDataSource;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Image1:TIATitle;
    Panel2:TPanel;
    
    Label1:TLabel;
    IBQJournalQUI:TIBStringField;
    IBQJournalLE:TDateTimeField;
    IBQJournalTEXTE:TIBStringField;
    fpBoutons:TPanel;
    GoodBtn7:TFWClose;
    btnPurge:TFWInit;

    procedure sbCloseClick(Sender:TObject);

    procedure btnPurgeClick(Sender:TObject);
  private
  protected
    procedure DoShow; override;
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;

  end;

implementation

uses  u_dm,
      u_common_const,
      u_common_functions,
      fonctions_dialogs,
      fonctions_ini,
      u_common_ancestro_functions,
      u_genealogy_context,
      u_common_ancestro;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFJournalOperations.Loaded;
begin
  f_GetMemIniFile();
  pGeneral.Color:=gci_context.ColorLight;

  IBQJournal.Params[0].AsInteger:=dm.NumDossier;
  IBQJournal.Open;
  inherited;
end;

procedure TFJournalOperations.DoClose(
  var Action:TCloseAction);
begin
  IBQJournal.Close;
  inherited;
end;

//procedure TFJournalOperations.SetDialogMode(const Value:boolean);
//begin
//  fDialogMode:=Value;
//end;

procedure TFJournalOperations.sbCloseClick(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFJournalOperations.btnPurgeClick(Sender:TObject);
var
  q:TIBSQL;
begin
  if MyMessageDlg(rs_Do_you_want_to_delete_logbook,mmtConfirmation, mmbYesNo,Self)=mrYes then
  begin
    IBQJournal.DisableControls;
    IBQJournal.Close;
    q:=TIBSQL.Create(self);
    try
      q.Database:=dm.ibd_BASE;
      q.Transaction:=dm.IBTrans_Secondaire;
      q.Sql.Text:='DELETE FROM T_JOURNAL where KLE_DOSSIER=:dossier';
      q.Params[0].AsInteger:=dm.NumDossier;
      try
        q.ExecQuery;
      except
        MyShowMessage(rs_Error_Cannot_delete_Logbook);
      end;
      q.Close;
    finally
      q.Free;
    end;
    dm.IBTrans_Secondaire.CommitRetaining;
    dm.doMAJTableJournal('Purge du journal des opérations');
    IBQJournal.Open;
    IBQJournal.EnableControls;
  end;
end;

procedure TFJournalOperations.DoShow;
begin
  inherited;
  Height:=round(TControl(Owner).height*gci_context.TailleFenetre/100);
  width:=round(TControl(Owner).width*gci_context.TailleFenetre/100);
  caption:=rs_Processes_Logbook;
end;

end.

