{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_export_table_2_textfile;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt,forms,
  Dialogs,Controls,ComCtrls, IB,
  ExtJvXPCheckCtrls,SysUtils, FBSQLData,
  StdCtrls,Classes,ExtCtrls,u_buttons_appli,
  lazutf8classes, MaskEdit, u_comp_TBlueFlatSpeedButton,
  u_framework_components,IBSQL;

type

  { TFExportTable2TextFile }

  TFExportTable2TextFile=class(TF_FormAdapt)
    BlueFlaTCSpeedButton1: TBlueFlatSpeedButton;
    cbIncludeEntete: TJvXPCheckbox;
    DstList: TListView;
    edAutreSep: TMaskEdit;
    edFileName: TMaskEdit;
    edStringDelimitor: TFWComboBox;
    FlatPanel1: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    panEtape2: TPanel;
    panEtape3: TPanel;
    pBorder:TPanel;
    Panel4:TPanel;
    Panel8:TPanel;
    Panel5:TPanel;
    Label1:TLabel;
    panEtape1:TPanel;
    Label3:TLabel;
    Label6:TLabel;
    rbAutre: TRadioButton;
    rbPV: TRadioButton;
    rbTab: TRadioButton;
    rbV: TRadioButton;
    SaveDialog:TSaveDialog;
    
    btnOk:TFWOK;
    btnCancel:TFWCancel;
    Query:TIBSQL;
    procedure BlueFlaTCSpeedButton1Click(Sender:TObject);
    procedure btnOkClick(Sender:TObject);
    procedure SpeedButton1Click(Sender:TObject);

  private
    fTableName:string;
    fFieldNames:TStringlistUTF8;
    fPropositionFileNameExport:string;
    fCondSelect:string;
  protected
    procedure DoClose(var Action: TCloseAction); override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure Loaded; override;
    destructor Destroy; override;
    procedure DoShowFirstTime; override;
    procedure DoRefreshControls; override;
    property TableName:string read fTableName write fTableName;
    property PropositionFileNameExport:string read fPropositionFileNameExport write fPropositionFileNameExport;
    property CondSelect:string read fCondSelect write fCondSelect;
  end;

implementation

uses
  u_objet_TCut,u_common_functions,u_common_ancestro,
  u_common_const,IBHeader,DB,
  fonctions_dialogs, fonctions_ini,
  u_genealogy_context, LazFileUtils,fonctions_file,
  u_common_ancestro_functions,
  fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFExportTable2TextFile.Loaded;
begin
  f_GetMemIniFile();
  Panel4.Color:=gci_context.ColorLight;
  panEtape1.Color:=gci_context.ColorDark;
  panEtape2.Color:=gci_context.ColorDark;
  panEtape3.Color:=gci_context.ColorDark;
  BlueFlaTCSpeedButton1.Color:=gci_context.ColorDark;
//  BlueFlaTCSpeedButton1.ColorDown:=gci_context.ColorMedium;
  BlueFlaTCSpeedButton1.ColorFrameFocus:=gci_context.ColorMedium;
  Panel1.Color:=gci_context.ColorDark;

  fCondSelect:='';
  fTableName:='';
  fFieldNames:=TStringlistUTF8.create;
  fPropositionFileNameExport:='';
  inherited;
end;

procedure TFExportTable2TextFile.BlueFlaTCSpeedButton1Click(Sender:TObject);
begin
  if (fPropositionFileNameExport>'')and(edFileName.Text='') then
  begin
    SaveDialog.InitialDir:=gci_context.PathDocs;
    SaveDialog.FileName:=fPropositionFileNameExport;
  end;
  if SaveDialog.Execute then
  begin
    edFileName.Text:=SaveDialog.FileName;
    DoRefreshControls;
  end;
end;

procedure TFExportTable2TextFile.DoShowFirstTime;
var
  n:integer;
  item:TListItem;
begin
  Caption:=fs_RemplaceMsg(rs_Caption_Export_in_table_from_textfile,[fTableName]);
  fFieldNames.Clear;

  //Récupération de la liste des champs
  Query.Close;
  with Query do
    try
      Sql.Text:='select * from '+fTableName;
      ExecQuery;

      if Eof Then
       Exit;

      for n:=0 to FieldCount-1 do
      begin
        fFieldNames.Add(Fields[n].Name);
      end;
    finally
      Close;
    end;

  DstList.Items.BeginUpdate;
  try
    DstList.Items.Clear;
    for n:=0 to fFieldNames.Count-1 do
    begin
      item:=DstList.Items.Add;
      item.Caption:=fFieldNames[n];
      item.Checked:=true;
    end;
  finally
    DstList.Items.EndUpdate;
  end;

  DoRefreshControls;
end;

procedure TFExportTable2TextFile.btnOkClick(Sender:TObject);
var
  ok:boolean;
  k,n,w:integer;
  fCut:TCut;
  F:THandle;
  aField:ISQLData;
  Save_Cursor:TCursor;
  ADecimal : Char;
begin
  ok:=false;
  for n:=0 to DstList.items.Count-1 do
  begin
    if DstList.Items[n].Checked then
    begin
      ok:=true;
      break;
    end;
  end;

  if ok then
  begin
    Save_Cursor:=Screen.Cursor;
    Screen.Cursor:=crHourglass;
    fCut:=TCut.create;
    ADecimal := FormatSettings.DecimalSeparator;
    FormatSettings.DecimalSeparator := '.';
    try
      with Query,fCut do
      try
        //Séparateur de colonnes
        if rbPV.checked then
          ParamSeparator:=';'
        else if rbV.checked then
          ParamSeparator:=','
        else if rbTab.checked then
          ParamSeparator:=#9
        else if rbAutre.checked then
          ParamSeparator:=edAutreSep.text;

        //Délimiteur de chaînes de caractères
        StringDelimitor:=edStringDelimitor.Text;

        Params.Clear;
        for k:=0 to DstList.Items.Count-1 do
        begin
          if DstList.Items[k].checked then
          begin
            Params.CreateParam(ftString,'Param'+inttostr(k),ptInputOutput);
          end;
        end;

        Close;
        Sql.Text:='select * from '+fTableName;
        if fCondSelect>'' then
          Sql.Add('where '+fCondSelect);
        ExecQuery;

        if not Eof then
        begin
          btnOk.Enabled:=False;
          btnCancel.Enabled:=False;
          

          F:=FileCreateUTF8(edFileName.Text);
          try
            if cbIncludeEntete.checked then
            begin
              w:=0;
              for k:=0 to DstList.Items.Count-1 do
              begin
                if DstList.Items[k].checked then
                begin
                  Params[w].AsString:=DstList.Items[k].Caption;
                  w:=w+1;
                end;
              end;

              ParamsToStr;
              FileWriteLn(F,fCut.Line);
            end;

            while not Eof do
            begin
              w:=0;
              for k:=0 to DstList.Items.Count-1 do
              begin
                if DstList.Items[k].checked then
                with Params[w] do
                 begin
                  aField:=ISQLData(FieldByName(DstList.Items[k].Caption));
                  if aField<>nil then
                   Begin
                     case aField.SQLType of
                       SQL_BOOLEAN:Value:=aField.AsBoolean;
                       SQL_LONG,
                       SQL_INT64,
                       SQL_DOUBLE,
                       SQL_FLOAT,
                       SQL_SHORT,
                       SQL_D_FLOAT : Value:=aField.AsFloat ;
                       Else Value:=aField.AsString;
                     end;
                   End
                   else
                     Clear;
                  w:=w+1;
                 end;
              end;
              ParamsToStr;
              FileWriteLn(F,Line);
              Next;
            end;
          finally
            FileClose(F);
          end;

          MyMessageDlg(rs_Info_Export_is_a_success,mmtInformation, [mmbOK],Self);
          btnOk.Enabled:=True;
          btnCancel.Enabled:=True;
          ModalResult:=mrOk;
        end
        else
        begin
          MyMessageDlg(rs_Info_No_record_to_export,mmtInformation, [mmbOK],Self);
        end;
      except
      end;
    finally
      FormatSettings.DecimalSeparator := ADecimal;
      Screen.Cursor:=Save_Cursor;
      fCut.destroy;
    end;
  end
  else
    myMessageDlg(rs_Info_Nothing_to_export,mmtInformation, [mmbOK],Self);
end;

procedure TFExportTable2TextFile.DoRefreshControls;
var
  ok:boolean;
begin
  ok:=(trim(edFileName.Text)>'');
  btnOk.enabled:=ok;
end;

destructor TFExportTable2TextFile.Destroy;
begin
  inherited;
  fFieldNames.Free;
end;

procedure TFExportTable2TextFile.SpeedButton1Click(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFExportTable2TextFile.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  if Key=VK_ESCAPE then ModalResult:=mrCancel;
  inherited;
end;

procedure TFExportTable2TextFile.DoClose(
  var Action:TCloseAction);
begin
  Action:=caFree;
  inherited;
end;

end.

