{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_About;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, ShellApi, Windows,
{$ELSE}
{$ENDIF}
  Forms,SysUtils,StdCtrls,
  Classes, KMemo, KFunctions,
  u_buttons_appli,Graphics,
  ExtCtrls,Controls, DbCtrls,
  IBDatabaseInfo, ComCtrls, U_ExtImage;

type

  { TFAbout }

  TFAbout=class(TForm)
    btnClose: TFWClose;
    cxImage1: TExtImage;
    cxListBox1: TDBListBox;
    cxPageControl1:TPageControl;
    cxTabSheet1: TTabSheet;
    Image4: TImage;
    Label2: TLabel;
    Label3: TLabel;
    MemoVersions: TMemo;
    n1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Timer1:TTimer;
    RV:TKMemo;
    IBDatabaseInfo:TIBDatabaseInfo;

    procedure Timer1Timer(Sender:TObject);
    procedure cxPageControlDrawTabEx(AControl:TCustomTabControl;
      ATab:TTabSheet;Font:TFont);
    procedure Image4Click(Sender:TObject);
    procedure cxPageControl1Change(Sender:TObject);//BT
  private
    bFirstTime:boolean;
  protected
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;

  end;

implementation

uses u_dm,
     u_common_functions,
     u_common_ancestro,
     LazFileUtils,
     u_genealogy_context,
     StrUtils,
     fonctions_net,
     fonctions_ini,
     fonctions_system,
     fonctions_string,
     fonctions_dialogs,
     u_common_resources;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFAbout.Loaded;
const
  crlf:string=chr(13)+chr(10);
var
  S,PathExe:string;
  i:integer;
  procedure InfosFichier(s:string);
  var f:String;
  begin
    f:=PathExe+s;
    if FileExistsUTF8(f) { *Converted from FileExistsUTF8*  } then
    begin
      MemoVersions.Lines.Add(rs_Version+' '+s+': '+fs_VersionExe);
    end
    else
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Not_present_at_install, [s]));
  end;

begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  screen.Cursor:=crHourglass;
  cxPageControl1.ActivePageIndex:=0;
  Label2.Caption:='André Langlet'+crlf+crlf+'Matthieu GIROUX'+crlf+crlf+'Marc Duport'+crlf+crlf+'Claude Rolain';

  rv.Clear;

//  rv.FirstJumpNo:=0;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

  rv.Blocks.AddParagraph.InsertString(tkstring.Create('Philippe Cazaux-Moutou'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Créateur du projet en 1995'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Conception et développement du projet'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  avec Yann Uhel.'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  De 2001 à 2003 développement avec de'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  nombreux bénévoles sous licence GPL.'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  //- Remerciements 
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Remerciements particuliers à'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  // Bruno Trufier 
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Bruno Trufier et François David'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Des corrections de bugs...'));

  // Matthieu
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

  // Ransac
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Ransac'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Pour les améliorations importantes sur la gestion des lieux...'));

  // Lya -
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Lya'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Pour son aide aux utilisateurs sur le forum et ses jolies images'));

  // Claude Rolain 
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Claude Rolain'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Des corrections de bugs et la mise à jour des composants...'));

  // Thierry Collier 
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Thierry Collier'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;


  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Module de calendrier et de conversion des dates'));

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Laurent Robbe'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Créateur du BOA (version initiale de l''outil de requêtes intégré)'));
  
  //Pierre Garnier
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Pierre Garnier'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Pour la conception des dictionnaires d''Histoire'));

  // Facon 
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(tkstring.Create('Christian Facon'));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('  Pour son aide aux utilisateurs et les nombreux tests de déverminage'));

  //groupes de news Delphi
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('Les développeurs des groupes de news Delphi'));

  //membres des forum Ancestrologie, Ancestromania, La Guilde
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('Tous les membres des forum Ancestromania, Ancestromania'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('et La Guilde Ancestrologique pour leur entr''aide'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('et leurs connaissances de la généalogie.'));

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

  //les anonymes
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('Et tous ceux oubliés ou qui ont voulu rester anonymes.'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create('pour leur aide, leurs tests et leur contribution.'));
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10,20));

  MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_OS,fs_GetFullArchitecture));

  MemoVersions.Lines.Add('');

  s:=Application.ExeName;
  // Matthieu : Gestion de version dans Extended
//  GetFileBuildInfo(S,V[0],V[1],V[2],V[3]);
  MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Ancestromania_version,[IntToStr(gr_ExeVersion[0])+'.'+IntToStr(gr_ExeVersion[1])+'.'+IntToStr(gr_ExeVersion[2])+'.'+IntToStr(gr_ExeVersion[3])]));
  MemoVersions.Lines.Add('');
  PathExe:=ExtractFilePath(s);

  {$IFDEF WINDOWS}
  s:='fbclient.dll';
  if FileExistsUTF8(PathExe+s) { *Converted from FileExistsUTF8*  } then
  begin
    MemoVersions.Lines.Add(rs_Info_Firebird_embedded_is_installed);
    MemoVersions.Lines.Add(rs_Info_Files_library_versions);
    InfosFichier(s);
    s:='ib_util.dll';
    InfosFichier(s);
    s:='fbclient.dll';
    InfosFichier(s);
    MemoVersions.Lines.Add('');
  end;
  s:='isql.exe';
  InfosFichier(s);
  MemoVersions.Lines.Add('');
  {$ENDIF}

  if dm.ibd_BASE.Connected then
  begin
    with IBDatabaseInfo do
    begin
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Firebird_Version,[Version]));
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Server_Side,[DBSiteName]));
      MemoVersions.Lines.Add('');
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Connected_Database,[DBFileName]));
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Database_version,[sVersionBase]));
      if UserNames.Count>1 then
      begin
        MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Users,[UserNames[0]]));
        for I:=1 to UserNames.Count-1 do
          MemoVersions.Lines.Add('                    '+UserNames[I]);
      end
      else
        MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_User,[UserNames[0]]));
      MemoVersions.Lines.Add('');
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_File_size,[FormatFloat('#,',Allocation*PageSize)]));
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_Used_memory,[FormatFloat('#,',CurrentMemory)]));
      MemoVersions.Lines.Add(fs_RemplaceMsg(rs_Info_File_structure_version,[IntToStr(ODSMajorVersion)+'.'+IntToStr(ODSMinorVersion)]));

      if ForcedWrites=1 then
        MemoVersions.Lines.Add(rs_Info_Forced_Writing_on)
      else
        MemoVersions.Lines.Add(rs_Info_Forced_Writing_off);
    end;
  end
  else
    MemoVersions.Lines.Add(rs_Not_Connected_To_Database);

  
  screen.Cursor:=crDefault;
  bFirstTime:=true;
  inherited;
end;

procedure TFAbout.DoClose(var Action:TCloseAction);
begin
  inherited;
  Timer1.Free;
  Action:=caFree;
end;

procedure TFAbout.Timer1Timer(Sender:TObject);
var lipad : Integer;
begin
  if bFirstTime then
  begin
    Timer1.Interval:=500;
    bFirstTime:=false;
  end
  else
  begin
    lipad := rv.VertScrollPadding;
    rv.ScrollBy(0,1);
    if lipad=rv.VertScrollPadding Then
     begin
      rv.ScrollBy(0,-rv.VertScrollPadding);
      Timer1.Interval:=1000;
      bFirstTime:=true;
     end;
  end;
  
end;

procedure TFAbout.cxPageControlDrawTabEx(AControl:TCustomTabControl;
  ATab:TTabSheet;Font:TFont);
begin
  Font.Color:=gci_context.ColorTexteOnglets;
  if AControl.PageIndex=ATab.PageIndex then
    ATab.Color:=gci_context.ColorLight
  else
    ATab.Color:=gci_context.ColorDark;
end;

procedure TFAbout.Image4Click(Sender:TObject);
begin
  GoToThisUrl('http://www.firebirdsql.org');
end;

procedure TFAbout.cxPageControl1Change(Sender:TObject);
begin
  if cxPageControl1.ActivePageIndex=0 then
  begin
    rv.ScrollBy(0,-rv.VertScrollPadding);
    Timer1.Interval:=1000;
    bFirstTime:=true;
    Timer1.Enabled:=true;
  end
  else
    Timer1.Enabled:=false;
end;

end.

