{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Compte_Villes;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, TeEngine, Series, TeeProcs, DBChart, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  DB, Forms,
  IBCustomDataSet, IBQuery, Controls, Classes, ExtCtrls,
   u_buttons_appli,
     U_ExtDBGrid, U_OnFormInfoIni;

type

  { TFCompteVilles }

  TFCompteVilles = class(TForm)
    OnFormInfoIni1: TOnFormInfoIni;
    Query: TIBQuery;
    DataSource: TDataSource;
    QueryCOMBIEN: TLongintField;
    QueryRPA_LIBELLE: TIBStringField;
    Panel7: TPanel;
    Panel5: TPanel;
    btnFermer: TFWClose;
    Panel6: TPanel;
    cxGrid1: TExtDBGrid;
  private
    procedure OpenQuery;
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoShow; override;
  public
    procedure Loaded; override;

  end;

implementation

uses  u_dm,
      u_genealogy_context,
      fonctions_ini,
      u_common_functions,
      u_common_const,
      u_common_ancestro;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}


procedure TFCompteVilles.OpenQuery;
begin
  with Query do
   Begin
    DisableControls;
    try
      Close;
      ParamByName( IBQ_dossier ).asInteger:=dm.NumDossier;
      Open;
    finally
      EnableControls;
    end;

   end;
end;

procedure TFCompteVilles.ControlKeyDown(
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TFCompteVilles.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  Height := ClientHeight;
  OpenQuery;
  inherited;
end;

procedure TFCompteVilles.DoClose(
  var Action: TCloseAction);
begin
  inherited;
  Query.Close;
  Action := caFree;
end;

procedure TFCompteVilles.DoShow;
begin
  inherited;
  caption:=rs_Caption_Number_of_cities_by_country;
end;

end.
