unit u_Form_Histoire_Detail;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  LCLIntf, LCLType,
  u_Common_Const,
  u_common_resources,
  SysUtils,Graphics,Controls,Forms,
  Dialogs,DB,IBCustomDataSet,IBQuery,ExtCtrls,
  u_framework_dbcomponents, u_framework_components, Classes,
  StdCtrls,u_buttons_appli,IBUpdateSQL,DBCtrls,
  ExtDlgs,Menus,IB, IBDatabase, U_ExtDBImage;

type

  { TFormHistoireDetail }

  TFormHistoireDetail=class(TForm)
    btnFermer: TFWClose;
    btnNouveau: TFWAdd;
    btnValider: TFWOK;
    cbCategories: TFWComboBox;
    cxDBCheckBox1: TDBCheckBox;
    cxDBTextEdit2: TFWDBEdit;
    cxDBTextEdit3: TFWDBLookupCombo;
    DBTextMemo: TFWDBMemo;
    edDateTexte: TFWDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    OpenPictureDialog: TOpenPictureDialog;
    Panel1:TPanel;
    dsHistoire:TDataSource;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    qHistoire:TIBQuery;
    uHistoire:TIBUpdateSQL;
    cxGroupBox1:TGroupBox;
    cxGroupBox2:TGroupBox;
    Label4:TLabel;
    qHistoireHI_ID:TLongintField;
    qHistoireHI_DOSSIER:TLongintField;
    qHistoireHI_DATE_CODE_DEBUT:TLongintField;
    qHistoireHI_DICORIGINE:TIBStringField;
    qHistoireHI_DATE_TEXTE:TIBStringField;
    qHistoireHI_CAT:TLongintField;
    qHistoireHI_TITRE:TIBStringField;
    qHistoireHI_TEXTE:TMemoField;
    qHistoireHI_IMAGE:TBlobField;
    qListeOrigineHI_DICORIGINE:TIBStringField;
    cxDBImage1:TExtDBImage;
    pmFamille:TPopupMenu;
    GrandsParents1:TMenuItem;
    Parents1:TMenuItem;
    N1:TMenuItem;
    Onclesettantes1:TMenuItem;
    Cousines1:TMenuItem;
    Frresetsoeurs1:TMenuItem;
    Neveuxetnices1:TMenuItem;
    Conjoints1:TMenuItem;
    Enfants1:TMenuItem;
    Petitsenfants1:TMenuItem;
    qListeOrigine:TIBQuery;
    dsListeOrigine:TDataSource;
    procedure btnValiderClick(Sender:TObject);
    procedure btnNouveauClick(Sender:TObject);
    procedure cbCategoriesPropertiesChange(Sender:TObject);
    procedure cxDBImage1Click(Sender: TObject);
    procedure cxDBImage1PropertiesCustomClick(Sender:TObject);
    procedure dsHistoireStateChange(Sender:TObject;Field:TField);
    procedure edDateTextePropertiesChange(Sender: TObject);
    procedure qHistoireBeforePost(DataSet: TDataSet);
  private
    ans,mois,jours:integer;
    Cal:TCalendrier;
    { Déclarations privées }
  protected
    procedure DoShow; override;
  public
    { Déclarations publiques }
    iID:integer;
    bModif:boolean;
    procedure Loaded; override;
    destructor Destroy; override;
    function CloseQuery:Boolean; override;
  end;

implementation

uses  u_Dm,
      u_common_functions,
      bgrabitmap,bgrabitmaptypes,
      u_Form_Histoire,
      u_common_ancestro,
      u_common_ancestro_functions,
      u_genealogy_context,
      fonctions_dialogs,
      fonctions_ini,
      fonctions_images;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

{ TFormHistoireDetail }

procedure TFormHistoireDetail.Loaded;
var
  i:Integer;
begin
  inherited;
  f_GetMemIniFile;
  OpenPictureDialog.InitialDir:=f_IniReadSectionStr(Name,OpenPictureDialog.Name,gci_context.PathImages);
  Color:=gci_context.ColorLight;
  cxDBCheckBox1.Color:=Color;
  cbCategories.Items.Clear;
  for i:=0 to (Owner as TFHistoire).pmCategories.Items.Count-1 do
    cbCategories.Items.Add((Owner as TFHistoire).pmCategories.Items[i].Caption);
  with Owner as TFHistoire do
   Begin
     qHistoire.Params[0].AsInteger:=ibHistoireHI_ID.AsInteger;
   end;
  qListeOrigine.Params[0].AsInteger:=dm.NumDossier;
//  qListeOrigine.Open;
  qHistoire.open;
  if qHistoireHI_CAT.AsInteger>=0 then
    cbCategories.ItemIndex:=qHistoireHI_CAT.AsInteger-1;
end;

procedure TFormHistoireDetail.btnValiderClick(Sender:TObject);
begin
  if length(Trim(edDateTexte.Text))=0 then
  begin
    MyMessageDlg(rs_Error_Period_must_be_set,mmtError,[mmbCancel],Self);
    edDateTexte.SetFocus;
    Abort;
  end;
  bModif:=true;
  try
    qHistoire.Post;
    qHistoire.Transaction.Commit;
  except
    on E:EIBError do
      MyShowMessage(rs_Error_Cannot_Validate_on_database+_CRLF+_CRLF+E.Message);
  end;
  btnNouveau.Enabled:=True;
  btnValider.Enabled:=false;
end;

procedure TFormHistoireDetail.btnNouveauClick(Sender:TObject);
var
  sDico,sCombo:string;
begin
  sDico:=cxDBTextEdit3.Caption;
  sCombo:=cbCategories.Caption;
  qHistoire.Insert;
  if cxDBCheckBox1.Checked then
    qHistoireHI_DOSSIER.asInteger:=0
  else
    qHistoireHI_DOSSIER.asInteger:=dm.NumDossier;
  qHistoireHI_DICORIGINE.AsString:=sDico;
  cbCategories.Text:=sCombo;
  qHistoireHI_CAT.AsInteger:=cbCategories.ItemIndex+1;
  edDateTexte.SetFocus;
end;

function TFormHistoireDetail.CloseQuery:Boolean;
begin
  Result := inherited;
  if btnValider.Enabled then
    if MyMessageDlg(rs_Do_you_validate_changed_data,mmtWarning, mmbYesNo,Self)=mrYes then
      btnValiderClick(Self);
end;

destructor TFormHistoireDetail.Destroy;
begin
  f_GetMemIniFile;
  p_IniWriteSectionStr(Name,OpenPictureDialog.Name,OpenPictureDialog.InitialDir);
  qHistoire.Close;
  qListeOrigine.close;
  inherited;
end;

procedure TFormHistoireDetail.cbCategoriesPropertiesChange(Sender:TObject);
begin
  qHistoire.Edit;
  qHistoireHI_CAT.AsInteger:=cbCategories.ItemIndex+1;
end;

procedure TFormHistoireDetail.cxDBImage1Click(Sender: TObject);
var ABitmap, ABitmapMini : TBGRACustomBitmap;
    ARect : TRect ;
begin
  if OpenPictureDialog.Execute Then
   Begin
     ABitmap:=fci_FileToCustomImage ( OpenPictureDialog.FileName, True );
     if assigned ( ABitmap ) Then
      with ABitmap do
        try
          if Width>Height
           Then ABitmapMini := ABitmap.Resample(cxDBImage1.Width,Round( cxDBImage1.Width / Width * Height ) )
           Else
            Begin
             ABitmapMini := ABitmap.Resample(Round( cxDBImage1.Height / Height * Width * 16 / 9 ),Round(cxDBImage1.Height * 16 / 9));
             ARect.Top:=Round((ABitmapMini.height-ABitmapMini.Width)/2);
             ARect.Bottom:=Round((ABitmapMini.height+ABitmapMini.Width)/2);
             ARect.Left  :=0;
             ARect.Right  :=ABitmapMini.Width;
             ABitmapMini.PutImagePart( 0, 0 , ABitmapMini, ARect, dmSet );
             ABitmapMini.SetSize(ABitmapMini.Width,Round(ABitmapMini.Width/16*9));
            end;
          ABitmapMini := ABitmap.Resample(cxDBImage1.Width,Round( cxDBImage1.Width / Width * Height ) );
          qHistoire.Edit;
          cxDBImage1.AssignExtBitmap ( ABitmapMini );
        finally
          ABitmapMini.Free;
          ABitmap.Free;
        end;
   end;
end;

procedure TFormHistoireDetail.cxDBImage1PropertiesCustomClick(Sender:TObject);
begin
  with dm.OpenPictureDialog do
  if execute then
    p_FileToBitmap ( FileName, cxDBImage1.Picture.Bitmap, True);
end;

procedure TFormHistoireDetail.dsHistoireStateChange(Sender:TObject;
  Field:TField);
begin
  if dsHistoire.DataSet.State in [dsInsert,dsEdit] then
  begin
    btnValider.Enabled:=True;
    btnNouveau.Enabled:=False;
  end;
end;

procedure TFormHistoireDetail.DoShow;
begin
  inherited;
  if qHistoire.IsEmpty then
    btnNouveauClick(Self);
end;

procedure TFormHistoireDetail.edDateTextePropertiesChange(Sender: TObject);
var
  joursem,sDateTrans:string;
begin
  btnValider.Enabled:=True;
  if doTesteDateEtJour(edDateTexte.Text,joursem,sDateTrans,ans,mois,jours,Cal) then
  begin
    edDateTexte.Font.Color:=clWindowText;
    edDateTexte.Font.Style:= [];
  end
  else
  begin
    edDateTexte.Font.Color:=clRed;
    edDateTexte.Font.Style:= [fsBold];
  end;
end;

procedure TFormHistoireDetail.qHistoireBeforePost(DataSet: TDataSet);
var  datecode : Int64;
begin
  DefDateCode(ans,mois,jours,Cal,0,datecode);
  qHistoireHI_DATE_CODE_DEBUT.AsInteger:=datecode;

end;

end.

