unit u_Form_Histoire_Export;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  SysUtils,Controls,Forms,
  Dialogs,StdCtrls,u_buttons_appli,
  u_framework_components, U_ExtImage, U_OnFormInfoIni,
  IBSQL,
  ExtCtrls,Classes;

type

  { TFHistoireExport }

  TFHistoireExport=class(TForm)
    bsfbSelection: TFWOK;
    btnFermer: TFWClose;
    ComboBoxDico: TFWComboBox;
    ComboBoxDossier: TFWComboBox;
    cxImage1: TExtImage;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    OnFormInfoIni1: TOnFormInfoIni;
    Panel1:TPanel;
    Label3:TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SaveDialog:TSaveDialog;
    eNomFichier:TFWFileEdit;
    procedure bsfbSelectionClick(Sender:TObject);
    procedure cxButtonEdit1PropertiesButtonClick(Sender:TObject;
      AButtonIndex:Integer);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    bImport:boolean;
    iNumDossier:Integer;
    sDico,sFichier:string;
    procedure Loaded; override;
  end;

var
  FHistoireExport:TFHistoireExport;

implementation

uses u_Dm,
     u_common_ancestro,
     u_common_resources,
     u_genealogy_context,
     fonctions_dialogs,
     fonctions_ini,
     u_common_ancestro_functions,
     u_common_const, LazFileUtils;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFHistoireExport.Loaded;
var
  QueryRead:TIBSQL;
  chaine:string;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  eNomFichier.Text:=ExtractFilePath(Application.EXEName)+'Tables de references'+DirectorySeparator+'Histoire.dica';

  QueryRead:=TIBSQL.Create(Application);
  QueryRead.database:=dm.ibd_BASE;
  QueryRead.SQL.Add('select distinct h.hi_dossier,d.nom_dossier from ref_histoire h'
    +' inner join dossier d on d.cle_dossier=h.hi_dossier'
    +' order by h.hi_dossier');
  QueryRead.ExecQuery;
  ComboBoxDossier.Items.Clear;
  ComboBoxDossier.Items.Add('0 ,Dictionnaire de référence');

  with QueryRead do
  while not eof do
  begin
    chaine:=FieldByName('HI_DOSSIER').AsString;
    while Length(chaine)<2 do
      chaine:=chaine+' ';
    ComboBoxDossier.Items.Add(chaine+', '+FieldByName('NOM_DOSSIER').AsString);
    Next;
  end;

  QueryRead.Close;
  ComboBoxDossier.ItemIndex:=0;
  QueryRead.SQL.Clear;
  QueryRead.SQL.Add('select distinct hi_dicorigine from ref_histoire'
    +' order by hi_dicorigine');
  QueryRead.ExecQuery;
  ComboBoxDico.Items.Clear;

  with QueryRead do
  while not eof do
  begin
    ComboBoxDico.Items.Add(FieldByName('hi_dicorigine').AsString);
    Next;
  end;

  QueryRead.Close;
  QueryRead.Free;
  ComboBoxDico.ItemIndex:=0;
  inherited;
end;

procedure TFHistoireExport.bsfbSelectionClick(Sender:TObject);
begin
  iNumDossier:=StrToInt(trim(Copy(ComboBoxDossier.Text,1,2)));
  sDico:=ComboBoxDico.Text;
  sFichier:=eNomFichier.Text;
  bImport:=true;

  Close;
end;

procedure TFHistoireExport.cxButtonEdit1PropertiesButtonClick(
  Sender:TObject;AButtonIndex:Integer);
var
  ok:boolean;
begin
  //SaveDialog.Title := 'Regarder dans...';
  SaveDialog.InitialDir:=ExtractFilePath(Application.EXEName)+'Tables de references';

  if SaveDialog.execute then
  begin
    if FileExistsUTF8(SaveDialog.FileName) { *Converted from FileExistsUTF8*  } then
    begin
      Ok:=MyMessageDlg(rs_Selected_file_exists+_CRLF+_CRLF+
        rs_Do_you_overwrite_it,mmtWarning,mmbYesNo,Self)=mrYes;
    end
    else
      ok:=true;

    if ok then
      eNomFichier.Text:=SaveDialog.FileName;
  end;
end;

end.

