unit u_Form_Histoire_Import;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  SysUtils,Graphics,Forms,
  Dialogs,StdCtrls,u_buttons_appli,
  u_framework_components, U_ExtImage, U_OnFormInfoIni,
  ExtCtrls, Classes;

type

  { TFHistoireImport }

  TFHistoireImport=class(TForm)
    bsfbSelection: TFWOK;
    btnFermer: TFWClose;
    cxImage1: TExtImage;
    Label4: TLabel;
    lbLienDica: TLabel;
    OnFormInfoIni1: TOnFormInfoIni;
    Panel1:TPanel;
    Label3:TLabel;
    eNomFichier:TFWFileEdit;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    rgDossier: TRadioGroup;
    SaveDialog:TOpenDialog;
    procedure bsfbSelectionClick(Sender:TObject);
    procedure cxButtonEdit1PropertiesButtonClick(Sender:TObject;
      AButtonIndex:Integer);
    procedure lbLienDicaMouseEnter(Sender:TObject);
    procedure lbLienDicaMouseLeave(Sender:TObject);
    procedure lbLienDicaClick(Sender:TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    bImport:boolean;
    iNumDossier:Integer;
    sFichier:string;
    procedure Loaded; override;
  end;

var
  FHistoireImport:TFHistoireImport;

implementation

uses u_Dm,
     u_common_functions,
     u_genealogy_context,
     u_common_ancestro,
     fonctions_ini;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFHistoireImport.bsfbSelectionClick(Sender:TObject);
begin
  if rgDossier.ItemIndex=0 then
    iNumDossier:=0
  else
    iNumDossier:=dm.NumDossier;

  sFichier:=eNomFichier.Text;
  bImport:=true;
  Close;
end;

procedure TFHistoireImport.cxButtonEdit1PropertiesButtonClick(
  Sender:TObject;AButtonIndex:Integer);
begin
  SaveDialog.Title:=rs_Title_Have_a_look_into;
  SaveDialog.InitialDir:=ExtractFilePath(Application.EXEName)+'Tables de references';

  if SaveDialog.execute then
    eNomFichier.Text:=SaveDialog.FileName;
end;

procedure TFHistoireImport.lbLienDicaMouseEnter(Sender:TObject);
begin
  (Sender as TLabel).Font.Style:= [fsBold,fsUnderline];
end;

procedure TFHistoireImport.lbLienDicaMouseLeave(Sender:TObject);
begin
  (Sender as TLabel).Font.Style:= [];
end;

procedure TFHistoireImport.lbLienDicaClick(Sender:TObject);
begin
  GotoThisUrl(dm.GetUrlMajAuto+'DICA.zip');
end;

procedure TFHistoireImport.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  inherited;
end;

end.

