{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Infos;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt,StdCtrls,
  Controls,ExtCtrls,Classes, u_buttons_appli,
  u_ancestropictimages,SysUtils,u_buttons_defs;

type
  TFInfos=class(TF_FormAdapt)
    pBorder:TPanel;
    Panel7:TPanel;
    Panel9:TPanel;
    Image2:TIATitle;
    Panel10:TPanel;
    Panel11:TPanel;
    Label3:TLabel;
    Label1:TLabel;
    Label2:TLabel;
    Label4:TLabel;
    Label6:TLabel;
    Label7:TLabel;
    Label8:TLabel;
    Label9:TLabel;
    Label11:TLabel;
    Label12:TLabel;
    Label13:TLabel;
    Label14:TLabel;
    Label15:TLabel;
    Label16:TLabel;
    lHommes:TLabel;
    lFemmes:TLabel;
    lIndeter:TLabel;
    lUnions:TLabel;
    lEveInd:TLabel;
    lEveFam:TLabel;
    lAdresses:TLabel;
    lPatronymes:TLabel;
    lImages:TLabel;
    lPays:TLabel;
    lRegions:TLabel;
    lDepts:TLabel;
    lVilles:TLabel;
    lIndividus:TLabel;
    Panel8:TPanel;
    Panel4:TPanel;
    
    btnCarto:TFWXPButton;
    Label10:TLabel;
    Label20:TLabel;
    lDossier:TLabel;
    FlatPanel1:TPanel;
    btnFermer:TFWClose;

    procedure SpeedButton1Click(Sender:TObject);
    procedure btnCartoClick(Sender:TObject);
  private
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure DoShowFirstTime; override;
    procedure Loaded; override;
    procedure ShowStats;
  end;

implementation

uses u_dm,
     u_common_const,
     fonctions_dialogs,
     u_genealogy_context,
     u_common_ancestro,
     u_common_ancestro_functions,
     u_Form_Compte_Villes,IBSQL, u_common_functions;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFInfos.ShowStats;
var
  s_Proc:TIBSQL;
begin
  doShowWorking(rs_Please_Wait);
  s_Proc:=TIBSQL.Create(self);
  try
    with s_Proc do
    begin
      DataBase:=dm.ibd_BASE;
      SQL.ADD('SELECT * FROM PROC_COMPTAGE(:DOSSIER)');
      Params[0].AsInteger:=dm.NumDossier;
      ExecQuery;

      while not Eof do
      begin
        if FieldByName('LIBELLE').AsString='INDIVID' then
          lIndividus.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='TUNIONS' then
          lUnions.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='_HOMMES' then
          lHommes.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='_FEMMES' then
          lFemmes.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='INDETER' then
          lIndeter.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='EVE_IND' then
          lEveInd.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='EVE_FAM' then
          lEveFam.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='_VILLES' then
          lVilles.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='PATRONY' then
          lPatronymes.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='___PAYS' then
          lPays.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='REGIONS' then
          lRegions.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='DEPARTE' then
          lDepts.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='MULTIME' then
          lImages.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger)
        else if FieldByName('LIBELLE').AsString='ADRESSE' then
          lAdresses.Caption:=IntToStr(FieldByName('COMPTAGE').AsInteger);

        next;
      end;
      Close;
    end;
  finally
    s_Proc.Free;
    doCloseWorking;
  end;
end;

procedure TFInfos.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE:ModalResult:=mrOk;
    _KEY_HELP:p_ShowHelp(_ID_INFOS_DOSSIER);
  end;
  inherited;
end;

procedure TFInfos.SpeedButton1Click(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFInfos.Loaded;
begin
  Color:=gci_context.ColorLight;
  btnCarto.Color:=gci_context.ColorLight;
  btnCarto.ColorFrameFocus:=gci_context.ColorLight;
  lDossier.Caption:=fNomDossier;
  Label1.Font.Color:=gci_context.ColorHomme;
  Label2.Font.Color:=gci_context.ColorFemme;

  lHommes.Font.Color:=gci_context.ColorHomme;
  lFemmes.Font.Color:=gci_context.ColorFemme;

  inherited;
end;

procedure TFInfos.btnCartoClick(Sender:TObject);
var
  aFCompteVilles:TFCompteVilles;
begin
  aFCompteVilles:=TFCompteVilles.create(self);
  try
    aFCompteVilles.ShowModal;
  finally
    FreeAndNil(aFCompteVilles);
  end;
end;

procedure TFInfos.DoShowFirstTime;
begin
  caption:=rs_Caption_folder_infos;
end;

end.

