unit u_Form_Infos_Indi;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  SysUtils,Forms,StdCtrls,ExtCtrls,
  u_ancestropictimages,u_buttons_appli,
  IBSQL,Classes;

type

  { TFInfosIndi }

  TFInfosIndi=class(TForm)
    btnClose: TFWClose;
    Image1: TIATitle;
    Panel1: TPanel;
    l11:TLabel;
    cxGroupBox1:TGroupBox;
    l2:TLabel;
    l3:TLabel;
    l4:TLabel;
    l5:TLabel;
    l6:TLabel;
    l8:TLabel;
    l9:TLabel;
    l10:TLabel;
    lConjoints:TLabel;
    lEnfants:TLabel;
    lfreres:TLabel;
    lOncles:TLabel;
    lCousins:TLabel;
    lEvenements:TLabel;
    lMedias:TLabel;
    lAdresses:TLabel;
    IBQComptage:TIBSQL;
    lPtEnfants: TLabel;
    Label2: TLabel;
    lNeveux: TLabel;
    Label4: TLabel;
    Panel3: TPanel;
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    procedure Loaded; override;
    procedure doInit(clef:Integer);
  end;

implementation

uses fonctions_ini,
     u_genealogy_context,
     u_common_ancestro,
     u_common_const;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFInfosIndi.doInit(clef:Integer);
begin
  Caption:=rs_Information;
  with IBQComptage do
  begin
    ParamByName( IBQ_ICLEF ).AsInteger:=Clef;
    ExecQuery;
    while not eof do
    begin
      if FieldByName('Titre').AsString='UNION' then
        lConjoints.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='ENFAN' then
        lEnfants.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='PTENF' then
        lPtEnfants.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='NEVEU' then
        lNeveux.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='FRERE' then
        lFreres.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='ONCLE' then
        lOncles.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='COUSI' then
        lCousins.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='EVENT' then
        lEvenements.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='MEDIA' then
        lMedias.Caption:=IntToStr(FieldByName('Combien').AsInteger)
      else if FieldByName('Titre').AsString='ADRES' then
        lAdresses.Caption:=IntToStr(FieldByName('Combien').AsInteger);
      next;
    end;
    Close;
  end;
end;

procedure TFInfosIndi.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  Inherited;
end;

end.

