{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Qui_Habite_La;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,Forms,u_objet_TIntegerList,
  u_ancestropictimages,SysUtils, Classes,
  Dialogs,Menus,DB,KFunctions,
  IBCustomDataSet,IBQuery,KMemo,ExtCtrls,
  U_ExtDBGrid,StdCtrls,u_buttons_appli,
  Controls,Graphics,IB,IBUpdateSQL;

type

  { TFQuiHabiteLa }

  TFQuiHabiteLa=class(TF_FormAdapt)
    IATitle1: TIATitle;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    IBQNom:TIBQuery;
    DSNom:TDataSource;
    pmUnions:TPopupMenu;
    mFiche:TMenuItem;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Panel2:TPanel;
    N1:TMenuItem;
    ExporterenHTML1:TMenuItem;
    SaveDialog:TSaveDialog;
    Label8:TLabel;
    Panel9:TPanel;
    rv:TKMemo;
    IBQPere:TIBQuery;
    IBQPereCLE_FICHE:TLongintField;
    IBQPereNOM:TIBStringField;
    IBQPerePRENOM:TIBStringField;
    IBQEvPere:TIBQuery;
    IBQEvPereEV_IND_DATE_WRITEN:TIBStringField;
    IBQEvPereEV_IND_VILLE:TIBStringField;
    lPere:TLabel;
    lMere:TLabel;
    IBQConjoint:TIBQuery;
    IBQConjointCLE_FICHE:TLongintField;
    IBQConjointNOM:TIBStringField;
    IBQConjointPRENOM:TIBStringField;
    IBQConjointSEXE:TLongintField;
    IBQEvMere:TIBQuery;
    IBQEvMereEV_IND_DATE_WRITEN:TIBStringField;
    IBQEvMereEV_IND_VILLE:TIBStringField;
    IBQMere:TIBQuery;
    IBQMereCLE_FICHE:TLongintField;
    IBQMereNOM:TIBStringField;
    IBQMerePRENOM:TIBStringField;
    lConjoint:TLabel;
    IBQNomCLE_FICHE:TLongintField;
    IBQNomNOM:TIBStringField;
    IBQNomPRENOM:TIBStringField;
    IBQNomSEXE:TLongintField;
    IBQNomCLE_PERE:TLongintField;
    IBQNomCLE_MERE:TLongintField;
    IBQNomDATE_NAISSANCE:TIBStringField;
    IBQNomDATE_DECES:TIBStringField;
    lVille:TLabel;
    IBQNomEV_IND_CLEF: TLongintField;
    fpBoutons:TPanel;
    GoodBtn7:TFWClose;
    btnCopier:TFWCopy;
    IBUAdresses:TIBUpdateSQL;
    IBQNomEV_IND_DATE_WRITEN: TStringField;
    IBQNomEV_IND_DATE_YEAR: TLongintField;
    IBQNomEV_IND_DATE_YEAR_FIN: TLongintField;
    IBQNomEV_IND_DATE_MOIS: TLongintField;
    IBQNomEV_IND_DATE_MOIS_FIN: TLongintField;
    IBQNomEV_IND_DATE: TDateField;
    IBQNomVILLE_NAISSANCE: TStringField;
    IBQNomEV_IND_DATECODE_TARD: TLongintField;
    IBQNomEV_IND_DATE_JOUR: TSmallintField;
    IBQNomEV_IND_DATE_JOUR_FIN: TSmallintField;
    IBQNomEV_IND_DATECODE: TLongintField;
    IBQNomEV_IND_DATECODE_TOT: TLongintField;
    IBQNomEV_IND_TYPE_TOKEN1: TSmallintField;
    IBQNomEV_IND_TYPE_TOKEN2: TSmallintField;

    procedure sbCloseClick(Sender:TObject);
    procedure mFicheClick(Sender:TObject);
    procedure ExporterenHTML1Click(Sender:TObject);
    procedure pmUnionsPopup(Sender:TObject);
    procedure doFillBottomInfos;
    procedure btnCopierClick(Sender:TObject);
    procedure Image1Click(Sender:TObject);
    procedure dxDBGrid1DBTableView1FocusedRecordChanged(
      Sender:TObject;APrevFocusedRecord,
      AFocusedRecord:Longint;
      ANewItemRecordFocusingChanged:Boolean);
    procedure IBQNomBeforePost(DataSet:TDataSet);
    procedure DSNomStateChange(Sender:TObject);
    procedure dxDBGrid1Column7PropertiesChange(Sender: TObject);
  private
    fDialogMode:boolean;
    fCleFicheSelected:integer;
    fIndiJumpTag:TIntegerList;
    fIndiCle:TIntegerList;
    iAdr:integer;
    lsNom,lsPrenom,lsVille:string;

    procedure SetDialogMode(const Value:boolean);
  protected
    procedure DoClose(var Action: TCloseAction); override;
  public
    bModifier:boolean;
    procedure Loaded; override;
    procedure DoShowFirstTime; override;
    property DialogMode:boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected:integer read fCleFicheSelected write fCleFicheSelected;
    procedure doInit(iClef:integer;sNom,sPrenom,sville:string);
  end;

implementation

uses  u_common_const,
      u_common_ancestro,
      u_common_resources,
      u_common_functions,
      fonctions_string,
      u_form_main,
      u_form_individu_repertoire,
      u_Form_Individu,
      MaskEdit,
      u_common_ancestro_functions,
      fonctions_components,
      fonctions_dialogs,
      fonctions_ini,
      rxdbgrid,
      u_genealogy_context;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFQuiHabiteLa.Loaded;
begin
  f_GetMemIniFile();
  pGeneral.Color:=gci_context.ColorLight;
  fIndiCle:=TIntegerList.create;
  fIndiJumpTag:=TIntegerList.create;

  SaveDialog.InitialDir:=gci_context.PathDocs;

  IBQPere.Close;
  IBQPere.Open;
  IBQEvPere.Close;
  IBQEvPere.Open;
  IBQMere.Close;
  IBQMere.Open;
  IBQEvMere.Close;
  IBQEvMere.Open;
  IBQConjoint.Close;
  IBQConjoint.Open;
  inherited;
end;

procedure TFQuiHabiteLa.DoClose(
  var Action:TCloseAction);
begin
  IBQNom.Close;

  IBQPere.Close;
  IBQEvPere.Close;
  IBQConjoint.Close;
  IBQMere.Close;
  IBQEvMere.Close;

  fIndiCle.Free;
  fIndiJumpTag.Free;
end;

procedure TFQuiHabiteLa.SetDialogMode(const Value:boolean);
begin
  fDialogMode:=Value;
end;

procedure TFQuiHabiteLa.sbCloseClick(Sender:TObject);
begin
  if (IBQNom.Active)and(IBQNom.State in [dsEdit,dsInsert]) then
  begin
    IBQNom.Post;
    bModifier:=true;
  end;

  ModalResult:=mrCancel;
  Close;
end;

procedure TFQuiHabiteLa.mFicheClick(Sender:TObject);
begin
  fCleFicheSelected:=IBQNomCLE_FICHE.AsInteger;
  ModalResult:=mrOk;
end;

procedure TFQuiHabiteLa.ExporterenHTML1Click(Sender:TObject);
var
  SavePlace:TBookmark;
begin
  SavePlace:=nil;
  SaveDialog.FileName:='Liste des habitants.HTM';
  if SaveDialog.Execute then
  begin
    IBQNom.DisableControls;
    try
      SavePlace:=IBQNom.GetBookmark;
      ExportGridToHTML(SaveDialog.FileName,dxDBGrid1,True,True);
    finally
      IBQNom.GotoBookmark(SavePlace);
      IBQNom.FreeBookmark(SavePlace);
      IBQNom.EnableControls;
    end;
  end;
end;

procedure TFQuiHabiteLa.pmUnionsPopup(Sender:TObject);
begin
  mFiche.Enabled:=not IBQNom.IsEmpty;
  ExporterenHTML1.Enabled:=mFiche.Enabled;
end;

procedure TFQuiHabiteLa.doFillBottomInfos;
var
  JumpTag:integer;
  s,s2,s3:string;
  sexe:integer;
begin
  rv.Clear;
  JumpTag:=0;
  fIndiJumpTag.Clear;
  fIndiCle.Clear;

  sexe:=IBQNomSexe.AsInteger;

  //le nom
  s:=AssembleString([IBQNomNOM.AsString,IBQNomPRENOM.AsString]);

  s:=s+'    ---    NIP : '+IBQNomCLE_FICHE.AsString;

  with rv.Blocks.AddParagraph do
   Begin
     InsertString(AnsiStringToString(s));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
     case sexe of
      1:TextStyle.Font.Color:=gci_context.ColorHomme;
      2:TextStyle.Font.Color:=gci_context.ColorFemme;
      else
      TextStyle.Font.Color:=clWindowText;
     end;
  end;

  rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));

  s:=IBQNomDATE_NAISSANCE.AsString;
  if s>'' then
  begin
    case sexe of
      1:s3:='Né le';
      2:s3:='Née le';
      else
        s3:='Né(e) le';
    end;
    s:='                 '+s3+' '+s;
    s2:=trim(IBQNomVILLE_NAISSANCE.AsString);
    if s2>'' then
      s:=s+' '+'à'+' '+s2;
    rv.Blocks.AddParagraph.InsertString(AnsiStringToString(s));
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));
  end;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));

  //le père
  s:=AssembleString([IBQPereNOM.AsString,IBQPerePRENOM.AsString]);
  if (Length(s)>0) then
    s:=s+'    ---    NIP : '+IBQPereCLE_FICHE.AsString;

  if s>'' then
  begin
    with rv.Blocks.AddParagraph,TextStyle.Font do
     Begin
       InsertString(AnsiStringToString(lPere.Caption+' '));
       InsertString(AnsiStringToString(s));
       Style:=[fsBold];
       Size:=TextStyle.Font.Size+1;
       Color:=gci_context.ColorHomme;
    end;

    fIndiJumpTag.Add(JumpTag);
    fIndiCle.Add(IBQPereCLE_FICHE.AsInteger);
    inc(JumpTag);
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));
    s2:=trim(IBQEvPereEV_IND_DATE_WRITEN.AsString);
    s3:=trim(IBQEvPereEV_IND_VILLE.AsString);
    s:='';
    if s2>'' then
      s:='Né le '+s2+' ';

    if s3>'' then
      s:=s+'à  '+s3;

    if s>'' then
      rv.Blocks.AddParagraph.InsertString(AnsiStringToString('                 '+s));

    rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));
  end;

  //la mère
  s:=AssembleString([IBQMereNOM.AsString,IBQMerePRENOM.AsString]);
  if (Length(s)>0) then s:=s+'    ---    NIP : '+IBQMereCLE_FICHE.AsString;

  if s>'' then
  begin
    with rv.Blocks.AddParagraph,TextStyle.Font do
     Begin
       InsertString(AnsiStringToString(lMere.Caption+' '));
       InsertString(AnsiStringToString(s));
       Style:=[fsBold];
       Size:=TextStyle.Font.Size+1;
       Color:=gci_context.ColorFemme;
    end;

    fIndiJumpTag.Add(JumpTag);
    fIndiCle.Add(IBQMereCLE_FICHE.AsInteger);
    inc(JumpTag);

    rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));
    s2:=trim(IBQEvMereEV_IND_DATE_WRITEN.AsString);
    s3:=trim(IBQEvMereEV_IND_VILLE.AsString);
    s:='';
    if s2>'' then
      s:='Née le '+s2+' ';

    if s3>'' then
      s:=s+'à  '+s3;

    if s>'' then
      rv.Blocks.AddParagraph.InsertString(AnsiStringToString('                 '+s));

    rv.Blocks.AddParagraph.InsertString(tkstring.Create(#10));
  end;

  //les conjoints
  s:=AssembleString([IBQConjointNOM.AsString,IBQConjointPRENOM.AsString]);

  if s>'' then
    s:=s+'    ---    NIP : '+IBQConjointCLE_FICHE.AsString;

  if s>'' then
  begin
    with rv.Blocks.AddParagraph do
     Begin
       InsertString(AnsiStringToString(lConjoint.Caption+' '));
       TextStyle.Font.Style:=[fsBold,fsItalic];
       case sexe of
        1:TextStyle.Font.Color:=gci_context.ColorHomme;
        2:TextStyle.Font.Color:=gci_context.ColorFemme;
       end;
    end;

    rv.Cursor:=crHandPoint;

    fIndiJumpTag.Add(JumpTag);
    fIndiCle.Add(IBQConjointCLE_FICHE.AsInteger);
  end;

end;

procedure TFQuiHabiteLa.doInit(iClef:integer;sNom,sPrenom,sville:string);
begin
  lsNom:=sNom;
  lsPrenom:=sPrenom;
  lsVille:=sVille;

  lVille.Caption:=lsVille;

  iAdr:=iClef;
  IBQNom.close;
  IBQNom.Params[0].AsInteger:=iClef;
  IBQNom.Open;
  if not dxDBGrid1.DataSource.DataSet.IsEmpty then
    doFillBottomInfos;
end;

procedure TFQuiHabiteLa.btnCopierClick(Sender:TObject);
var
  aFIndividuRepertoire:TFIndividuRepertoire;
  aLettre:string;
  ev,i:integer;
begin
  //recherche d'un individu par le prénom
  aFIndividuRepertoire:=TFIndividuRepertoire.create(self);
  try
    aFIndividuRepertoire.Position:=poMainFormCenter;
    aFIndividuRepertoire.NomIndi:=IBQNomNOM.AsString;

    aLettre:=Copy(fs_FormatText(IBQNomNOM.AsString,mftUpper,True),1,1);
    aFIndividuRepertoire.InitIndividuPrenom(aLettre,'INDEX',0,IBQNomCLE_FICHE.AsInteger,True,True);
    aFIndividuRepertoire.Caption:=rs_Caption_Select_Persons_to_set_this_address;

    if aFIndividuRepertoire.ShowModal=mrOk then
    begin
      if MyMessageDlg(rs_confirm_address_copying,mmtConfirmation, mmbYesNo,Self)=mrYes then
      begin
        try
          for i:=0 to Length(aFIndividuRepertoire.L)-1 do
          begin
            if not TFIndividu(Owner.Owner).CollerEvenement(ev,iAdr,aFIndividuRepertoire.L[i]) then
            begin
              MyMessageDlg(rs_Errors_while_address_copying+_CRLF+rs_Should_better_cancel_update,mmtError,
                [mmbOk],Self);
              break;
            end;
          end;
          doInit(iAdr,lsNom,lsPrenom,lsVille);
          bModifier:=true;
        except
          on E:EIBError do
            MyMessageDlg(rs_Error_Cannot_copy_address+_CRLF+E.Message,mmtError,[mmbOk],Self);
        end;
      end;
    end;
  finally
    FreeAndNil(aFIndividuRepertoire);
  end;
end;

procedure TFQuiHabiteLa.Image1Click(Sender:TObject);
var
  i:integer;
begin
  for i:=0 to dxDBGrid1.Columns.Count-1 do
    dxDBGrid1.Columns[i].SortOrder:=smNone;
  IBQNom.Close;
  Screen.Cursor:=crSQLWait;
  IBQNom.Open;
  Screen.Cursor:=crDefault;
end;

procedure TFQuiHabiteLa.dxDBGrid1DBTableView1FocusedRecordChanged(
  Sender:TObject;APrevFocusedRecord,
  AFocusedRecord:Longint;
  ANewItemRecordFocusingChanged:Boolean);
begin
  doFillBottomInfos;
end;

procedure TFQuiHabiteLa.DoShowFirstTime;
begin
  Height:=round(FMain.height*gci_context.TailleFenetre/100);
  width:=round(FMain.width*gci_context.TailleFenetre/100);
  Caption:=rs_Caption_Own_at_the_same_address;
end;

procedure TFQuiHabiteLa.IBQNomBeforePost(DataSet:TDataSet);
begin
  TFIndividu(Owner.Owner).CalcChampsDateInd(DataSet);
end;

procedure TFQuiHabiteLa.DSNomStateChange(Sender:TObject);
begin
  if (DSNom.DataSet.State in [dsEdit,dsInsert]) then
    bModifier:=true;
end;

procedure TFQuiHabiteLa.dxDBGrid1Column7PropertiesChange(Sender: TObject);
var
  joursem,sDateTrans:string;
  ans,mois,jours:integer;
  Cal:TCalendrier;
begin
  if doTesteDateEtJour((sender as TMaskEdit).Text,joursem,sDateTrans,ans,mois,jours,Cal) then
    (sender as TMaskEdit).Font.Color:=clWindowText
  else
    (sender as TMaskEdit).Font.Color:=clRed;
end;

end.

