{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Qui_Porte_ce_Titre;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  Graphics,
  U_FormAdapt, u_ancestropictimages,Forms,SysUtils,Dialogs,Menus,DB,
  IBCustomDataSet,IBQuery,ExtCtrls, KFunctions,
  U_ExtDBGrid, u_framework_components,StdCtrls,u_buttons_appli,
  Controls,Classes, u_reports_components, KMemo,
  PrintersDlgs, Grids, DBGrids;

type

  { TFQuiPorteCeTitre }

  TFQuiPorteCeTitre=class(TF_FormAdapt)
    IATitle1: TIATitle;
    Label8: TLabel;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    IBQNom:TIBQuery;
    DSNom:TDataSource;
    pmTitres: TPopupMenu;
    mFiche:TMenuItem;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Panel2:TPanel;
    mImprimer: TMenuItem;
    ExporterenHTML1:TMenuItem;
    SaveDialog:TSaveDialog;
    Panel9:TPanel;
    rv:TKMemo;
    IBQConjoint:TIBQuery;
    lVille:TLabel;
    IBQNomCLE_FICHE:TLongintField;
    IBQNomNOM:TIBStringField;
    IBQNomNAISSANCE: TIBStringField;
    IBQNomCLE_PERE:TLongintField;
    IBQNomCLE_MERE:TLongintField;
    IBQNomDECES: TStringField;
    IBQNomSEXE:TLongintField;
    IBQNomPERE_NOM: TStringField;
    IBQNomPERE_NAISSANCE: TStringField;
    IBQNomMERE_NOM: TStringField;
    IBQNomMERE_NAISSANCE: TStringField;
    fpBoutons:TPanel;
    Label1:TLabel;
    GoodBtn7:TFWClose;
    cbTitre: TFWComboBox;
    dxComponentPrinter1: TPrinterSetupDialog;
    btnPrint: TFWPrintGrid;
    procedure cbTitreChange(Sender: TObject);
    procedure dxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure mFicheClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender:TObject);
    procedure pmTitresPopup(Sender:TObject);
    procedure cbTitrePropertiesCloseUp(Sender:TObject);
    procedure Image1Click(Sender:TObject);
    procedure dxDBGrid1DBTableView1FocusedRecordChanged(
      Sender:TObject;APrevFocusedRecord,
      AFocusedRecord:Longint;
      ANewItemRecordFocusingChanged:Boolean);
    procedure dxDBGrid1DBTableView1DblClick(Sender: TObject);
    procedure DoShowFirstTime; override;
    procedure dxDBGrid1MouseEnter(Sender: TObject);
    procedure dxDBGrid1MouseLeave(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure mImprimerClick(Sender: TObject);
  private
    procedure doInit;
  protected
    procedure DoShow; override;
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure doFillBottomInfos;
    procedure Loaded; override;
    destructor Destroy; override;

  end;

implementation

uses u_dm,u_common_ancestro,
     u_form_main,u_genealogy_context,
     IBSQL, fonctions_components,
     fonctions_ini,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFQuiPorteCeTitre.Loaded;
begin
  f_GetMemIniFile();
  dxDBGrid1.Hint:=rs_Hint_You_can_Resize_the_columns_preview_resizing_your_grid_columns;
  pGeneral.Color:=gci_context.ColorLight;
  SaveDialog.InitialDir:=gci_context.PathDocs;
  Height:=round(FMain.height*gci_context.TailleFenetre/100);
  width:=round(FMain.width*gci_context.TailleFenetre/100);
  // Matthieu ?
//  dxDBGrid1DBTableView1.RestoreFromRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_TITRES');
  IBQConjoint.Open;
  inherited;
end;

destructor TFQuiPorteCeTitre.Destroy;
begin
  inherited Destroy;
  FMain.aFQuiPorteCeTitre:=nil
end;

procedure TFQuiPorteCeTitre.dxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
Begin
  if Column = dxDBGrid1.SelectedColumn then
    if dxDBGrid1.Canvas.Brush.Color=dxDBGrid1.Color then
      dxDBGrid1.Canvas.Brush.Color:=gci_context.ColorMedium;

end;

procedure TFQuiPorteCeTitre.cbTitreChange(Sender: TObject);
begin
  doInit;
  btnPrint.DestroyReport;
end;

procedure TFQuiPorteCeTitre.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  IBQNom.Close;
  IBQConjoint.Close;
  // Matthieu ?
  //  dxDBGrid1DBTableView1.StoreToRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_TITRES');
  Action:=caFree;
end;

procedure TFQuiPorteCeTitre.mFicheClick(Sender:TObject);
begin
  dm.individu_clef:=IBQNomCLE_FICHE.AsInteger;
  FMain.Ouvre_Et_Selecte_Individu;
end;

procedure TFQuiPorteCeTitre.ExporterenHTML1Click(Sender:TObject);
var
  SavePlace:TBookmark;
begin
  SavePlace:=nil;
  SaveDialog.FileName:='Individus du titre.HTM';
  if SaveDialog.Execute then
  begin
    IBQNom.DisableControls;
    try
      SavePlace:=IBQNom.GetBookmark;
      ExportGridToHTML(SaveDialog.FileName,dxDBGrid1,True,True);
    finally
      IBQNom.GotoBookmark(SavePlace);
      IBQNom.FreeBookmark(SavePlace);
      IBQNom.EnableControls;
    end;
  end;
end;

procedure TFQuiPorteCeTitre.pmTitresPopup(Sender:TObject);
begin
  mFiche.Enabled:=not IBQNom.IsEmpty;
  ExporterenHTML1.Enabled:=mFiche.Enabled;
  mImprimer.Enabled:=mFiche.Enabled;
end;

procedure TFQuiPorteCeTitre.doFillBottomInfos;
var
  string1,string2 : String;
  sexe:integer;
begin
  rv.Clear;
  sexe:=IBQNomSexe.AsInteger;
  //le nom
  string1:=IBQNomNOM.AsString+'    ---    NIP : '+IBQNomCLE_FICHE.AsString;
  {
  case sexe of
    1:RVStyle.TextStyles.Items[2].Color:=gci_context.ColorHomme;
    2:RVStyle.TextStyles.Items[2].Color:=gci_context.ColorFemme;
  else
    RVStyle.TextStyles.Items[2].Color:=clWindowText;
  end;}
  with rv.Blocks.AddParagraph do
   Begin
     InsertString(AnsiStringToString(string1));
     TextStyle.Font.Style:=[fsBold];
     TextStyle.Font.Size:=TextStyle.Font.Size+1;
   end;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

  string1:=IBQNomNAISSANCE.AsString;
  if string1>'' then
  begin
    if sexe=2 then
      string2:='Née: '
    else
      string2:='Né: ';
    string1:='                 '+string2+string1;
    rv.Blocks.AddParagraph.InsertString(AnsiStringToString(string1));
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  end;
  rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  //le père
  string1:=IBQNomPERE_NOM.AsString;
  if (Length(string1)>0) then
  begin
    string1:=string1+'    ---    NIP : '+IBQNomCLE_PERE.AsString;
    //RVStyle.TextStyles.Items[4].Color:=gci_context.ColorHomme;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create('Son père: '));
    with rv.Blocks.AddParagraph do
     Begin
       InsertString(AnsiStringToString(string1));
       TextStyle.Font.Style:=[fsBold];
     end;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

    string1:=IBQNomPERE_NAISSANCE.AsString;
    if string1>'' then
    begin
      string1:='Né: '+string1;
      rv.Blocks.AddParagraph.InsertString(AnsiStringToString('                 '+string1));
    end;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  end;
  //la mère
  string1:=IBQNomMERE_NOM.AsString;
  if (Length(string1)>0) then
  begin
    string1:=string1+'    ---    NIP : '+IBQNomCLE_MERE.AsString;
//    RVStyle.TextStyles.Items[5].Color:=gci_context.ColorFemme;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create('Sa mère: '));
    with rv.Blocks.AddParagraph do
     Begin
       InsertString(AnsiStringToString(string1));
       TextStyle.Font.Style:=[fsBold];
     end;

    rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));

    string1:=IBQNomMERE_NAISSANCE.AsString;
    if string1>'' then
    begin
      string1:='Née: '+string1;
      rv.Blocks.AddParagraph.InsertString(AnsiStringToString('                 '+string1));
    end;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create(' '));
  end;
  //conjoint
  string1:=IBQConjoint.FieldByName('NOM').AsString;
  if (Length(string1)>0) then
  begin
    string1:=string1+'    ---    NIP : '+IBQConjoint.FieldByName('CLE_FICHE').AsString;
    rv.Blocks.AddParagraph.InsertString(tkstring.Create('Son dernier conjoint: '));
    case IBQConjoint.FieldByName('SEXE').AsInteger of
      1: with rv.Blocks.AddParagraph do
           Begin
             InsertString(AnsiStringToString(string1));
             TextStyle.Font.Style:=[fsBold];
           end;
      2: with rv.Blocks.AddParagraph do
           Begin
             InsertString(AnsiStringToString(string1));
             TextStyle.Font.Style:=[fsBold,fsItalic];
           end;
    end;
  end;
  rv.Cursor:=crHandPoint;
end;

procedure TFQuiPorteCeTitre.doInit;
begin
  IBQNom.DisableControls;
  try
    IBQNom.close;
    IBQNom.Params[0].AsInteger:=dm.NumDossier;
    IBQNom.Params[1].AsString:=cbTitre.Text;
    Screen.Cursor:=crSQLWait;
    IBQNom.Open;
    Screen.Cursor:=crDefault;
    if not IBQNom.IsEmpty then
      doFillBottomInfos;
  finally
    IBQNom.EnableControls;
  end;
end;

procedure TFQuiPorteCeTitre.cbTitrePropertiesCloseUp(Sender:TObject);
begin
  doInit;
end;

procedure TFQuiPorteCeTitre.DoShow;
var
  q:TIBSQL;
begin
  inherited;
  cbTitre.Items.Clear;
  q:=TIBSQL.Create(self);
  with q do
  try
    Database:=dm.ibd_BASE;
    Transaction:=dm.IBT_BASE;
    SQL.Text:='select DISTINCT EV_IND_DESCRIPTION FROM evenements_ind'
      +' WHERE EV_IND_TYPE=''TITL'' and EV_IND_KLE_DOSSIER=:DOSSIER order by EV_IND_DESCRIPTION';
    Params[0].AsInteger:=dm.NumDossier;
    ExecQuery;
    while not Eof do
    begin
      cbTitre.Items.Add(Fields[0].AsString);
      Next;
    end;
    Close;
  finally
    Free;
  end;
end;

procedure TFQuiPorteCeTitre.Image1Click(Sender:TObject);
var
  i:integer;
begin
  // Matthieu : À refaire avec du code déjà mis en place
//  for i:=0 to dxDBGrid1DBTableView1.ColumnCount-1 do
//    dxDBGrid1DBTableView1.Columns[i].SortOrder:=soNone;
  IBQNom.Close;
  Screen.Cursor:=crSQLWait;
  IBQNom.Open;
  Screen.Cursor:=crDefault;
end;

procedure TFQuiPorteCeTitre.dxDBGrid1DBTableView1FocusedRecordChanged(
  Sender:TObject;APrevFocusedRecord,
  AFocusedRecord:Longint;
  ANewItemRecordFocusingChanged:Boolean);
begin
  doFillBottomInfos;
end;


procedure TFQuiPorteCeTitre.dxDBGrid1DBTableView1DblClick(Sender: TObject);
begin
  mFicheClick(sender);
end;

procedure TFQuiPorteCeTitre.DoShowFirstTime;
begin
  Caption:=rs_Caption_Who_has_this_job;
end;

procedure TFQuiPorteCeTitre.dxDBGrid1MouseEnter(Sender: TObject);
begin
  // Matthieu ?
//  dm.ControleurHint.HintStyle.Standard:=true;
end;

procedure TFQuiPorteCeTitre.dxDBGrid1MouseLeave(Sender: TObject);
begin
//  dm.ControleurHint.HintStyle.Standard:=false;
end;

procedure TFQuiPorteCeTitre.btnPrintClick(Sender: TObject);
begin
  // Matthieu
  with btnPrint do
  if IBQNom.RecordCount>1 then
    DBTitle:=fs_RemplaceMsg(rs_Caption_Title_s_owners, [cbTitre.Text])
  else
    DBTitle:=fs_RemplaceMsg(rs_Caption_Title_s_owner, [cbTitre.Text]);

end;

procedure TFQuiPorteCeTitre.mImprimerClick(Sender: TObject);
begin
  btnPrintClick(sender);
end;

end.

