{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Evements_Ajout;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt, U_OnFormInfoIni,  DB,U_ExtDBGrid,
  IBCustomDataSet, IBQuery, StdCtrls, Controls, ExtCtrls, forms, Classes,  u_buttons_appli,
  u_ancestropictimages;

type

  { TFEvenement_Ajout }

  TFEvenement_Ajout = class(TF_FormAdapt)
    OnFormInfoIni: TOnFormInfoIni;
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    pBottom: TPanel;
    DSAjoutEve: TDataSource;
    IBQAjoutEve: TIBQuery;
    IBQAjoutEveREF_EVE_LIB_COURT: TIBStringField;
    IBQAjoutEveREF_EVE_LIB_LONG: TIBStringField;
    IBQAjoutEveREF_EVE_CAT: TLongintField;
    Panel1: TPanel;
    Image1: TIATitle;
    dxDBGrid1: TExtDBGrid;
    Label8: TLabel;
    fpBoutons: TPanel;
    bsfbSelection: TFWOK;
    btnFermer: TFWClose;

    procedure btnOkClick(Sender: TObject);
    procedure dxDBGrid1DBTableView1CellDblClick(Sender: TObject;
      ACellViewInfo: Longint; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
  private
    fRef_Eve_Lib_Court: string;
    fRef_Eve_Lib_Long: string;

    procedure doSelect;
  protected
    procedure DoClose(var Action: TCloseAction); override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    constructor Create(AOwner: Tcomponent); override;
    property Ref_Eve_Lib_Court: string read fRef_Eve_Lib_Court write fRef_Eve_Lib_Court;
    property Ref_Eve_Lib_Long: string read fRef_Eve_Lib_Long write fRef_Eve_Lib_Long;

    procedure up_Init(I_CLEF: Integer; A_MODE: string);
  end;

implementation

uses u_dm,
     u_common_const,
     u_common_functions,
     u_genealogy_context;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFEvenement_Ajout.up_Init(I_CLEF:Integer;A_MODE:string);
begin
  Screen.Cursor := crHourglass;
  with IBQAjoutEve,SQL do
   Begin
      DisableControls;
      Close;

      BeginUpdate;
      Text := 'select ref_eve_lib_court,ref_eve_lib_long,ref_eve_cat from ref_evenements';
      Add(' where ref_eve_visible=1 and ref_eve_langue=:LANGUE');


      if a_Mode='U' then
      begin
        Height:=365;
        Add('and ref_eve_type in(''U'',''D'')');
      end
      else
      begin
        Height:=600;
        Add('and ref_eve_type in(''A'',''E'',''D'')'
                           +' and ref_eve_lib_court not in'
                           +' (select e.ev_ind_type'
                           +' from evenements_ind e'
                           +' inner join ref_evenements r on r.ref_eve_lib_court=e.ev_ind_type'
                                                +' and r.ref_eve_une_fois=1'
                           +' where e.ev_ind_kle_fiche=:I_CLEF)');
      end;
      Add('order by ref_eve_cat, ref_eve_lib_long');
      EndUpdate;
      Params[0].AsString:=gci_context.Langue;
      if a_Mode<>'U' then
        Params[1].AsInteger:=I_CLEF;
      Open;
      EnableControls;

   end;

  Screen.Cursor := crDefault;
end;

procedure TFEvenement_Ajout.DoClose(var Action: TCloseAction);
begin
  IBQAjoutEve.Close;
  inherited;
end;

procedure TFEvenement_Ajout.btnOkClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFEvenement_Ajout.doSelect;
begin
  if (IBQAjoutEve.Active) and (length(IBQAjoutEveREF_EVE_LIB_COURT.AsString)>0) then
  begin
    fRef_Eve_Lib_Court := IBQAjoutEveREF_EVE_LIB_COURT.AsString;
    fRef_Eve_Lib_Long := IBQAjoutEveREF_EVE_LIB_LONG.AsString;
    ModalResult := mrOk;
  end;
end;

procedure TFEvenement_Ajout.dxDBGrid1DBTableView1CellDblClick(
  Sender: TObject; ACellViewInfo: Longint;
  AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
begin
  doSelect;
end;

procedure TFEvenement_Ajout.ControlKeyDown(
  var Key: Word; Shift: TShiftState);
var
  c:Char;
begin
{  if Key=_KEY_HELP then
    p_ShowHelp(_HELP_INDI_IDENTITE)
  else
    if Key in [ord('A')..ord('Z')] then
    begin
      c:=ansichar(Key);
      IBQAjoutEve.LocateNext('ref_eve_lib_long',c,[loCaseInsensitive,loPartialKey]);
    end;        }
end;

constructor TFEvenement_Ajout.Create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  Color:=gci_context.ColorLight;
  DefaultCloseAction:=caHide;
end;


end.
