//{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Restore;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt, u_ancestropictimages,
  Dialogs, Classes, IB,
  StdCtrls, Controls, ExtCtrls,
  forms, SysUtils, u_buttons_appli;

type

  { TFRestore }

  TFRestore=class(TF_FormAdapt)
    GoodBtn1: TFWOK;
    IAMouse1: TIAMouse;
    IATitle1: TIATitle;
    Label7: TLabel;
    Panel2: TPanel;
    Panel3:TPanel;
    Panel4:TPanel;
    Panel1:TPanel;
    Notebook:TNotebook;
    page1:TPage;
    
    Memo1:TMemo;
    uPath: TLabel;
    procedure GoodBtn1Click(Sender:TObject);
    procedure NotebookChange(Sender: TObject);
  private
    procedure Loaded; override;
    destructor Destroy; override;

  end;

implementation

uses u_dm, u_form_main,
     u_common_functions,
     u_common_resources,
     fonctions_dialogs,
     fonctions_ini,
     fonctions_dbobjects,
     u_common_ancestro,u_common_const,
     u_genealogy_context,
     u_common_ancestro_functions,
     IBServices,IBSQL, LazFileUtils, fonctions_string;
{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFRestore.GoodBtn1Click(Sender:TObject);
var
  DiskSize:Int64;
  sr:TSearchRec;
  TailleFichier:LongInt;
  Pos:integer;
  Save_Cursor:TCursor;
  ibRestore:TIBRestoreService;
  IBBackup:TIBBackupService;
  FileNameGBK,PathNameGBK,BackFile,Serveur,NomBase:string;
  lecteur:string;
  Prot:TProtocol;
  q:TIBSQL;
begin
  GoodBtn1.Enabled:=False;
  dm.doCloseDatabase;

  SendFocus(Memo1);

  {$IFDEF WINDOWS}
  Pos:=AnsiPos(':',gs_DefaultDatabase);
  if Pos>2 then
  {$ELSE}
  Pos:=AnsiPos(DirectorySeparator,gs_DefaultDatabase);
  if Pos > 1 then
  {$ENDIF}
  begin
    Prot:=TCP;
    Serveur:=copy(gs_DefaultDatabase,1,Pos-1);
    NomBase:=copy(gs_DefaultDatabase,Pos+1,250);
    BackFile:='optimisation.fbk';
  end
  else
  begin
    Prot:=Local;
    Serveur:='';
    NomBase:=gs_DefaultDatabase;
    FileNameGBK:=ExtractFileNameOnly(gs_DefaultDatabase)+FormatDateTime('yymmddhh',Now);
    FileNameGBK:=ChangeFileExt(FileNameGBK,'.FBK');
{$IFDEF WINDOWS}
    if Pos=2 then
{$ELSE}
    if ( gs_DefaultDatabase > '' )
    and ( gs_DefaultDatabase [1] = DirectorySeparator ) Then
{$ENDIF}
     begin
      lecteur:=AnsiUpperCase(gci_context.PathSauvegarde);
      DiskSize:=DiskFree({$IFDEF WINDOWS}ord(lecteur[1])-ord('A')+1{$ELSE}0{$ENDIF});
      FindFirstUTF8(NomBase, faAnyFile, sr); { *Converted from FindFirstUTF8*  }
      TailleFichier:=sr.Size;
      FindCloseUTF8(sr); { *Converted from FindCloseUTF8*  }
      if DiskSize>TailleFichier
       then PathNameGBK:=gci_context.PathSauvegarde
       else PathNameGBK:=ExtractFilePath(NomBase)+_REL_PATH_BACKUP;
     end
      else
        PathNameGBK:=gci_context.PathSauvegarde;
    if not ForceDirectoriesUTF8(PathNameGBK) { *Converted from ForceDirectories*  } then
    begin
      MyMessageDlg(fs_RemplaceMsg(rs_Error_Restore_Directory_does_not_exists,[PathNameGBK]),mmtError,[mmbOk]);
      DefaultCloseAction:=caFree;
      dm.doOpenDatabase;
      FMain.Ouvre_Et_Selecte_Individu;
      Close;
      exit;
    end;
    BackFile:=ExcludeTrailingPathDelimiter(PathNameGBK)+DirectorySeparator+FileNameGBK;
  end;
  if FileExistsUTF8(BackFile) Then
    DeleteFileUTF8(BackFile);
  Save_Cursor:=Screen.Cursor;
  Screen.Cursor:=crHourglass;
  try
    IBBackup:=TIBBackupService.Create(Self);
    with IBBackup do
    begin
      LoginPrompt:=False;
      with Params do
       Begin
        Add('user_name='+_user_name);
        Add('password='+_password);
        //Add('lc_ctype='_lc_ctypeUTF8);
       end;
      Protocol:=Prot;
      ServerName:=Serveur;
      Active:=True;
      try
        Verbose:=True;
        Options:= [IgnoreLimbo];
        DatabaseName:=NomBase;
        BackupFile.Add(BackFile);
        uPath.Caption:=fs_RemplaceMsg(rs_Caption_Save_in,[BackFile]);
        Memo1.Clear;
        ServiceStart;
        while not Eof do
         Begin
          Memo1.Lines.Append(GetNextLine);
          Application.ProcessMessages;
         end;
      finally
        Active:=False;
        Destroy;
      end;
    end;

    ibRestore:=TIBRestoreService.Create(Self);
    with IBRestore do
    begin
      LoginPrompt:=False;
      Params.Add('user_name='+_user_name);
      Params.Add('password='+_password);
      Protocol:=Prot;
      ServerName:=Serveur;
      Active:=True;
      try
        Verbose:=True;
        Options:= [Replace];
        PageBuffers:=32000;
        PageSize:=4096;
        DatabaseName.Add(NomBase);
        BackupFile.Add(BackFile);
        uPath.Caption:=fs_RemplaceMsg(rs_Caption_Restore_database,[gs_DefaultDatabase]);
        Memo1.Clear;
        ServiceStart;
        while not Eof do
          Memo1.Lines.Append(GetNextLine);
      finally
        Active:=False;
        FreeAndNil(ibRestore);
      end;
    end;

    dm.ibd_BASE.Connected:=true;
    dm.IBT_base.Active:=true;
    q:=TIBSQL.Create(self);
    try
      q.Database:=dm.ibd_BASE;
      q.Transaction:=dm.IBT_BASE;
      q.SQL.Add('select rdb$get_context(''USER_SESSION'',''RATIO_TAILLE'') from rdb$database');
      q.ExecQuery;
      if not q.Fields[0].IsNull then
      begin
        q.Close;
        q.SQL.Clear;
        q.SQL.Add('update t_version_base set octets_fichier=null');
        q.ExecQuery;
      end;
      q.Close;
    finally
      q.Free;
    end;
    dm.IBT_base.Commit;
    dm.ibd_BASE.Connected:=false;

    Memo1.Lines.Clear;

    Screen.Cursor:=Save_Cursor;
   
    dm.doOpenDatabase;

    dm.doMAJTableJournal(rs_Log_Optimising_database);
    MyMessageDlg(rs_Optimising_database_is_a_success,mmtInformation, [mmbOk]);
  Except
    Screen.Cursor:=Save_Cursor;
    MyMessageDlg(rs_Error_One_Error_has_occured_while_optimising_Verify_if_you_are_admin
      ,mmtError, [mmbOk]);
    if not dm.ibd_BASE.Connected then
      dm.doOpenDatabase;
  end;
  DefaultCloseAction:=caFree;;
  FMain.Ouvre_Et_Selecte_Individu;
  Close;
end;

procedure TFRestore.NotebookChange(Sender: TObject);
begin

end;

procedure TFRestore.Loaded;
begin
  f_GetMemIniFile();
  Panel4.Color:=gci_context.ColorLight;
  GoodBtn1.Color:=gci_context.ColorLight;
  GoodBtn1.ColorFrameFocus:=gci_context.ColorLight;

  uPath.Caption:=rs_Database+': '+gs_DefaultDatabase;
  inherited;
end;

destructor TFRestore.Destroy;
begin
  inherited Destroy;
  FMain.aFRestoreDatabase := nil;
end;

end.

