{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_TriEvent;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,DB, Classes,
  IBUpdateSQL,IBQuery,
  ExtCtrls,U_ExtDBGrid,Forms, StdCtrls, u_ancestropictimages,
  u_buttons_appli;

type

  { TFTriEvent }

  TFTriEvent=class(TF_FormAdapt)
    Label1: TLabel;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    Panel1:TPanel;
    Image1:TIATitle;
    qTri:TIBQuery;
    IBUTri:TIBUpdateSQL;
    dsTri:TDataSource;
    dxDBGrid1:TExtDBGrid;
    fpBoutons:TPanel;
    bsfbSelection:TFWOK;
    btnFermer:TFWClose;
    procedure bsfbSelectionClick(Sender: TObject);
    procedure dsTriStateChange(Sender: TObject);
    procedure dxDBGrid1MouseEnter(Sender: TObject);
    procedure dxDBGrid1MouseLeave(Sender: TObject);
  private
    fModif:boolean;
  public
    procedure Loaded; override;
    procedure DoShowFirstTime; override;
    procedure DoClose(var Action: TCloseAction); override;
    property Modif:boolean read fModif write fModif;
    procedure doInit(iKey:Integer;TypEvent:string);
  end;

implementation

uses u_common_const,
     u_common_functions,
     u_genealogy_context,
     u_common_ancestro,
     fonctions_ini;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFTriEvent.Loaded;

begin
  f_GetMemIniFile();
  pGeneral.Color:=gci_context.ColorLight;
  inherited;
end;

procedure TFTriEvent.doInit(iKey:Integer;TypEvent:string);
begin
  qTri.Close;
  if TypEvent='I' then
  begin
    qTri.SQL.Text:='select e.ev_ind_clef as ev_clef'
      +',iif(char_length(e.ev_ind_titre_event)>0,e.ev_ind_titre_event,r.ref_eve_lib_long)'
      +'||coalesce('' (''||e.EV_IND_DATE_WRITEN||'')'','''') as ref_eve_lib_long'
      +',e.ev_ind_ordre as ev_ordre'
      +' from  EVENEMENTS_IND e'
      +' inner join ref_evenements r on r.ref_eve_lib_court=e.EV_IND_TYPE'
      +' and r.ref_eve_langue=:langue'
      +' where  e.ev_ind_kle_fiche=:KEY'
      +' order by e.ev_ind_ordre nulls last'
      +'   ,e.ev_ind_datecode nulls last'
      +'   ,r.ref_eve_ecran';
    IBUTri.ModifySQL.Text:='update evenements_ind set EV_IND_ORDRE=:EV_ORDRE'
      +' where EV_IND_CLEF=:EV_CLEF';
  end
  else
  begin
    qTri.SQL.Text:='select e.ev_fam_clef as ev_clef'
      +',iif(char_length(e.ev_fam_titre_event)>0,e.ev_fam_titre_event,r.ref_eve_lib_long)'
      +'||coalesce('' (''||e.EV_fam_DATE_WRITEN||'')'','''') as ref_eve_lib_long'
      +',e.ev_fam_ordre as ev_ordre'
      +' from  EVENEMENTS_fam e'
      +' inner join ref_evenements r on r.ref_eve_lib_court=e.EV_fam_TYPE'
      +' and r.ref_eve_langue=:langue'
      +' where  e.ev_fam_kle_famille=:KEY'
      +' order by e.ev_fam_ordre nulls last'
      +'   ,e.ev_fam_datecode nulls last';
    IBUTri.ModifySQL.Text:='update evenements_fam set EV_fam_ORDRE=:EV_ORDRE'
      +' where EV_fam_CLEF=:EV_CLEF';
  end;
  qTri.Params[0].AsString:=gci_context.Langue;
  qTri.Params[1].AsInteger:=iKey;
  qTri.Open;
end;

procedure TFTriEvent.DoShowFirstTime;
begin
  Caption:=rs_Caption_Events_order;
end;

procedure TFTriEvent.DoClose(var Action: TCloseAction);
begin
  qTri.Close;
  inherited;
end;

procedure TFTriEvent.bsfbSelectionClick(Sender: TObject);
begin
  if fModif then
    qTri.Post;
  Close;
end;

procedure TFTriEvent.dsTriStateChange(Sender: TObject);
begin
  if dsTri.DataSet.State in [dsInsert,dsEdit] then
  begin
    bsfbSelection.Enabled:=True;
    fModif:=true;
  end;
end;

procedure TFTriEvent.dxDBGrid1MouseEnter(Sender: TObject);
begin
  // Matthieu pas de style
//dm.ControleurHint.HintStyle.Standard:=true;
end;

procedure TFTriEvent.dxDBGrid1MouseLeave(Sender: TObject);
begin
  // Matthieu pas de style
//dm.ControleurHint.HintStyle.Standard:=false;
end;

end.

