{-----------------------------------------------------------------------}

{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }

{-----------------------------------------------------------------------}

{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{-----------------------------------------------------------------------}

{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{2009 nettoyage, 2011 refonte liens Pays, Région, Département par André }
{-----------------------------------------------------------------------}

unit u_form_Ville_Ajout;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt, u_ancestropictimages, Forms,
  U_ExtDBGrid, IBCustomDataSet, IBUpdateSQL, DB, IBQuery, ExtCtrls, StdCtrls, Classes, u_buttons_appli,
  u_framework_dbcomponents,
  CompSuperForm;

type

  { TFVilleAjout }

  TFVilleAjout = class(TF_FormAdapt)
    dbLat: TFWDBSpinEdit;
    dbLong: TFWDBSpinEdit;
    dxDBEdit1: TFWDBEdit;
    dxDBEdit3: TFWDBEdit;
    dxDBEdit8: TFWDBEdit;
    dxDBPanel: TExtDBGrid;
    dxDBPEDept: TFWDBEdit;
    dxDBPEPays: TFWDBEdit;
    dxDBPERegion: TFWDBEdit;
    edVille: TFWDBEdit;
    IAWorld: TIAWorld;
    IBQCPCP_LONGITUDE: TFloatField;
    Label11: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel2: TPanel;
    Panel22: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    pBorder: TPanel;
    pDept: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    panDock: TPanel;
    IBQCP: TIBQuery;
    DSCP: TDataSource;
    IBUCP: TIBUpdateSQL;
    DSDept: TDataSource;
    DSRegion: TDataSource;
    DSPays: TDataSource;
    IBQDept: TIBQuery;
    IBQRegion: TIBQuery;
    IBQPays: TIBQuery;
    IBQDeptRDP_CODE: TLongintField;
    IBQDeptRDP_LIBELLE: TIBStringField;
    IBQCP_PAYS: TStringField;
    IBQCP_REGION: TStringField;
    IBQCP_DEPT: TStringField;
    IBQRegionRRG_CODE: TLongintField;
    IBQRegionRRG_LIBELLE: TIBStringField;
    IBQPaysRPA_CODE: TLongintField;
    IBQPaysRPA_LIBELLE: TIBStringField;
    IBQCPCP_CODE: TLongintField;
    IBQCPCP_CP: TIBStringField;
    IBQCPCP_VILLE: TIBStringField;
    IBQCPCP_DEPT: TLongintField;
    IBQCPCP_REGION: TLongintField;
    IBQCPCP_PAYS: TLongintField;
    IBQCPCP_INSEE: TIBStringField;
    IBQCPCP_HABITANTS: TFloatField;
    IBQCPCP_DENSITE: TFloatField;
    IBQCPCP_DIVERS: TIBStringField;
    IBQCPCP_LATITUDE: TFMTBCDField;
    IBQCPRCV_LONGITUDE: TFMTBCDField;
    IBQRegionRRG_PAYS: TLongintField;

    fpBoutons: TPanel;
    bsfbSelection: TFWOK;
    BtnAnnuler: TFWCancel;
    procedure sbCloseClick(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure IBQCPNewRecord(DataSet: TDataSet);
    procedure dxDBPEDeptInitPopup(Sender: TObject);
    procedure dxDBPERegionInitPopup(Sender: TObject);
    procedure dxDBPEPaysInitPopup(Sender: TObject);
    procedure dxDBPanelDblClick(Sender: TObject);
    procedure dxDBPanelKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure DSCPDataChange(Sender: TObject; Field: TField);
  private
    fVille: string;
    fCode: integer;
    fCodePays: integer;
  protected
    procedure DoClose(var Action: TCloseAction); override;
    procedure ControlKeyDown(var Key: word; Shift: TShiftState); override;
  public
    procedure Loaded; override;
    procedure DoShowFirstTime; override;
    property Code: integer read fCode write fCode;
    property Ville: string read fVille write fVille;
    property CodePays: integer read fCodePays write fCodePays;
    function Prepare: boolean;
  end;

implementation

uses u_dm,
     u_common_const,
     u_common_functions,
     u_common_ancestro,
     fonctions_db,
     u_genealogy_context,
     fonctions_ini,
     IBSQL,u_form_list_villes;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFVilleAjout.Loaded;
begin
  f_GetMemIniFile();
  pGeneral.Color := gci_context.ColorLight;
  Panel22.Color := gci_context.ColorDark;
  fCode := -1;
  fVille := '';
  pDept.Width := 400;
  pDept.Height := 250;
  IBQRegion.Open;
  IBQPays.Open;
  IBQDept.Open;
  inherited;
end;

procedure TFVilleAjout.DoClose(var Action: TCloseAction);
begin
  inherited;
  IBQDept.Close;
  IBQRegion.Close;
  IBQPays.Close;
  IBQCP.Close;
end;

procedure TFVilleAjout.sbCloseClick(Sender: TObject);
begin
  IBQCP.Cancel;
  Close;
end;

procedure TFVilleAjout.bsfbSelectionClick(Sender: TObject);
var
  q: TIBSQL;
begin
  if (IBQCP.State in [dsEdit, dsInsert]) then
  begin
    IBQCPCP_PAYS.AsInteger := IBQPaysRPA_CODE.AsInteger;
    IBQCPCP_REGION.AsInteger :=
      IBQRegionRRG_CODE.AsInteger;
    IBQCPCP_DEPT.AsInteger := IBQDeptRDP_CODE.AsInteger;
    IBQCP.Post;
    fVille := IBQCPCP_VILLE.AsString;
    fCodePays := IBQPaysRPA_CODE.AsInteger;
    IBQCP.Close;
    dm.IBTransParam.CommitRetaining;
  end;
end;

procedure TFVilleAjout.IBQCPNewRecord(DataSet: TDataSet);
begin
  fCode := TFListVilles(Owner).CleUnique('REF_CP_VILLES');
  IBQCPCP_CODE.AsInteger := fCode;
end;

procedure TFVilleAjout.dxDBPEDeptInitPopup(Sender: TObject);
begin
  Label9.Caption := rs_Caption_Departments;
  dxDBPanel.DataSource := DSDept;
  // Matthieu : pas sûr du grid
  //  dxDBPanel.DataSource.DataSet.LookupFieldNames:='RDP_CODE';
  //dxDBGCLibelle.FieldName:='RDP_LIBELLE';
  dxDBPanel.Columns[0].FieldName := 'RDP_LIBELLE';
end;

procedure TFVilleAjout.dxDBPERegionInitPopup(Sender: TObject);
begin
  Label9.Caption := rs_Caption_Regions;
  dxDBPanel.DataSource := DSRegion;
  // Matthieu : pas sûr du grid
  //dxDBPanelDBTableView1.DataController.LookupFieldNames:='RRG_CODE';
  //dxDBGCLibelle.FieldName:='RRG_LIBELLE';
  dxDBPanel.Columns[0].FieldName := 'RRG_LIBELLE';
end;

procedure TFVilleAjout.dxDBPEPaysInitPopup(Sender: TObject);
begin
  Label9.Caption := rs_Caption_Countries;
  dxDBPanel.DataSource := DSPays;
  // Matthieu : pas sûr du grid
  //  dxDBPanelDBTableView1.DataController.LookupFieldNames:='RPA_CODE';
  //  dxDBGCLibelle.FieldName:='RPA_LIBELLE';
  dxDBPanel.Columns[0].FieldName := 'RPA_LIBELLE';
end;

function TFVilleAjout.Prepare: boolean;
begin
  Result := False;
  with IBQCP do
  case FormMode of
    sfmNew:
    begin
      Close;
      ParamByName( IBQ_CODE ).AsInteger := -1;
      Open;
      Insert;
      IBQPays.Locate('RPA_CODE', fCodePays, []);
      Result := True;
    end;
    sfmEdit:
    begin
      Close;
      ParamByName( IBQ_CODE ).AsInteger := fCode;
      Open;
      IBQPays.Locate('RPA_CODE', IBQCPCP_PAYS.AsInteger, []);
      IBQRegion.Locate('RRG_CODE', IBQCPCP_REGION.AsInteger, []);
      IBQDept.Locate('RDP_CODE', IBQCPCP_DEPT.AsInteger, []);
      if not EOF then
        Result := True;
      case IBQCPCP_PAYS.AsInteger of
        1: IAWorld.ImageOn := caFrance;
        else
          IAWorld.ImageOn := caWorld;
      end;
    end;
  end;
  bsfbSelection.Enabled := False;
end;

procedure TFVilleAjout.dxDBPanelDblClick(Sender: TObject);
begin
  p_DatasetEditIfNotEdited(IBQCP);
  GetParentForm(dxDBPanel).Close;
end;

procedure TFVilleAjout.dxDBPanelKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then
  begin
    GetParentForm(dxDBPanel).Close;
  end
  else if (Key = VK_RETURN) then
    dxDBPanelDblClick(Sender);
end;

procedure TFVilleAjout.DSCPDataChange(Sender: TObject; Field: TField);
begin
  bsfbSelection.Enabled := True;
end;

procedure TFVilleAjout.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case Key of
    _KEY_HELP: p_ShowHelp(_ID_VILLES);
  end;
end;

procedure TFVilleAjout.DoShowFirstTime;
begin
  if FormMode = sfmEdit then
    Caption := rs_Caption_Modify_a_city
  else
    Caption := rs_Caption_Add_a_city;
end;

end.




