{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_anniversaires;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt, u_ancestropictimages,Forms,Dialogs,Classes,
  Sysutils,Menus,DB,IBQuery,
  StdCtrls,
  PrintersDlgs, ExtCtrls, u_buttons_appli,
  Controls, u_buttons_flat,
  u_reports_components,
  U_ExtDBGrid, U_OnFormInfoIni, Grids, DBGrids;

type

  { TFAnniversaires }

  TFAnniversaires=class(TF_FormAdapt)
    BlueFlaTCSpeedButton8: TCSpeedButton;
    cxGrid1: TExtDBGrid;
    IATitle1: TIATitle;
    OnFormInfoIni: TOnFormInfoIni;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    panDock:TPanel;
    DSAnni:TDataSource;
    IBQAnni:TIBQuery;
    Panel2:TPanel;
    Panel3:TPanel;
    pmGrid:TPopupMenu;
    ExporterenHTML1:TMenuItem;
    SaveDialog:TSaveDialog;
    
    Label1:TLabel;
    dxComponentPrinter1:TPrinterSetupDialog;
    fpBoutons: TPanel;
    rbTous: TRadioButton;
    rbVivant: TRadioButton;
    btnFermer: TFWClose;
    bsfbSelection: TFWOK;
    btnPrint: TFWPrintGrid;
    Panel5: TPanel;
    BlueFlaTCSpeedButton1: TCSpeedButton;
    BlueFlaTCSpeedButton2: TCSpeedButton;
    BlueFlaTCSpeedButton3: TCSpeedButton;
    BlueFlaTCSpeedButton4: TCSpeedButton;
    BlueFlaTCSpeedButton5: TCSpeedButton;
    BlueFlaTCSpeedButton6: TCSpeedButton;
    BlueFlaTCSpeedButton7: TCSpeedButton;
    BlueFlaTCSpeedButton9: TCSpeedButton;
    BlueFlaTCSpeedButton10: TCSpeedButton;
    BlueFlaTCSpeedButton11: TCSpeedButton;
    BlueFlaTCSpeedButton12: TCSpeedButton;
    Splitter3: TSplitter;
    procedure cxGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure Panel5Click(Sender: TObject);

    procedure init(Sender:TObject);
    procedure btnOkClick(Sender:TObject);
    procedure dxDBGrid1DblClick(Sender:TObject);
    procedure ExporterenHTML1Click(Sender:TObject);
    procedure pmGridPopup(Sender:TObject);
    procedure btnPrintClick(Sender:TObject);
  private
    i_Mois:SmallInt;
    s_Mois:string;
    procedure uf_ChargeNom;
    procedure doSelect;
  protected
    procedure DoShow; override;
    procedure DoClose(var Action: TCloseAction); override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure Loaded; override;
    destructor Destroy; override;
    procedure DoRefreshControls; override;

  end;

implementation

uses u_dm,
  u_common_functions,u_common_const, DateUtils,
  u_common_ancestro, u_form_main,
  fonctions_ini,
  fonctions_string, fonctions_components,
  u_genealogy_context;
{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFAnniversaires.Loaded;
var
  n,i:integer;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  cxGrid1.Hint:=rs_Hint_You_can_Resize_the_columns_preview_resizing_your_grid_columns;

  SaveDialog.InitialDir:=gci_context.PathDocs;
  Height:=round(TControl(Owner).Height*gci_context.TailleFenetre/100);
  width:=round(TControl(Owner).Width*gci_context.TailleFenetre/100);

  i_mois:=MonthOf(now);

  for n:=0 to ComponentCount-1 do
    if (Components[n].GetParentComponent=Panel5) and (Components[n]is TCSpeedButton) then
     with TCSpeedButton(Components[n]) do
      begin
//        ColorDown:=gci_context.ColorMedium; MG not in component
        i:=Tag;
        if i <= high (LongMonthNames) Then
          Caption:=fs_FormatText({$IFDEF WINDOWS}AnsiToUtf8{$ENDIF}(LongMonthNames[i]),mftFirstIsMaj);
        if i=i_mois then
        begin
          Font.Color :=gci_context.ColorTexteOnglets;
          down:=true;
          s_Mois:=Caption;
        end;
      end;
  uf_ChargeNom;
  inherited;
end;

procedure TFAnniversaires.cxGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  with cxGrid1 do
  if Column = SelectedColumn then
    if Canvas.Brush.Color=Color then
      Canvas.Brush.Color:=gci_context.ColorMedium;
end;

procedure TFAnniversaires.Panel5Click(Sender: TObject);
begin

end;

procedure TFAnniversaires.init(Sender:TObject);
begin
  if sender is TCSpeedButton then
  begin
    i_Mois:=(Sender as TCSpeedButton).Tag;
    s_Mois:=(Sender as TCSpeedButton).Caption;
  end;
  uf_ChargeNom;
  btnPrint.DestroyReport;
end;

procedure TFAnniversaires.uf_ChargeNom;
var
  i_Mode:smallint;
begin
  if rbTous.Checked then
    i_Mode:=1
  else
    i_Mode:=0;

  IBQAnni.DisableControls;
  try
    IBQAnni.Close;
    IBQAnni.ParamByName( IBQ_mois ).AsInteger:=i_Mois;
    IBQAnni.ParamByName( IBQ_mode ).AsInteger:=i_Mode;
    IBQAnni.ParamByName( IBQ_dossier ).AsInteger:=dm.NumDossier;
    IBQAnni.Open;
  finally
    IBQAnni.EnableControls;
  end;
  doRefreshControls;
end;

procedure TFAnniversaires.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  IBQAnni.Close;
  Action:=caFree;
end;

procedure TFAnniversaires.btnOkClick(Sender:TObject);
begin
  doSelect;
end;

procedure TFAnniversaires.doSelect;
begin
  dm.individu_clef:=IBQAnni.FieldByName('CLE_FICHE').AsInteger;
  FMain.Ouvre_Et_Selecte_Individu;
end;

procedure TFAnniversaires.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE:Close;
    _KEY_HELP:p_ShowHelp(_ID_ANNIVERSAIRE);
  end;
end;

destructor TFAnniversaires.Destroy;
begin
  inherited Destroy;
  FMain.aFAnniversaires:=nil;
end;

procedure TFAnniversaires.DoRefreshControls;
begin
  bsfbSelection.enabled:=IBQAnni.Active and not IBQAnni.IsEmpty;
end;

procedure TFAnniversaires.dxDBGrid1DblClick(Sender:TObject);
begin
  doSelect;
end;

procedure TFAnniversaires.ExporterenHTML1Click(Sender:TObject);
var
  SavePlace:TBookmark;
begin
  SavePlace:=nil;
  SaveDialog.FileName:='Anniversaire du  mois en cours.HTM';
  if SaveDialog.Execute then
  begin
    IBQAnni.DisableControls;
    try
      SavePlace:=IBQAnni.GetBookmark;
      ExportGridToHTML(SaveDialog.FileName,cxGrid1,true,True,'html');
    finally
      IBQAnni.GotoBookmark(SavePlace);
      IBQAnni.FreeBookmark(SavePlace);
      IBQAnni.EnableControls;
    end;
  end;
end;

procedure TFAnniversaires.pmGridPopup(Sender:TObject);
begin
  ExporterenHTML1.enabled:=not IBQAnni.IsEmpty;
end;

procedure TFAnniversaires.DoShow;
begin
  inherited;
  Caption:=rs_Caption_Birthdays + ','+ rs_on_date+' ' + _GDate.MonthNum2MonthGedcom(i_Mois) + ',' + IntToStr(YearOf(now)) ;
end;

procedure TFAnniversaires.btnPrintClick(Sender:TObject);
begin
  // Matthieu
  btnPrint.DBTitle:=Caption;
end;

end.

