{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_confirm_add_to_favoris;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,
  StdCtrls,ExtCtrls,Classes,
  u_ancestropictimages,
  u_buttons_appli;

type
  TFConfirmAddToFavoris=class(TF_FormAdapt)
    pBorder:TPanel;
    Panel2:TPanel;
    lAction: TLabel;
    Label2:TLabel;
    lTitre:TLabel;
    Panel9:TPanel;
    Image1:TIATitle;
    Label3:TLabel;
    fpBoutons:TPanel;
    btnFermer:TFWClose;
    btnAjouter: TFWAdd;
  private
    fNom:string;
    fSexe:Integer;
  protected
    procedure DoShow; override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure Loaded; override;
    procedure doInit;
    property Nom:string read fNom write fNom;
    property Sexe:Integer read fSexe write fSexe;
  end;

implementation

uses  u_dm,
      u_common_functions,
      u_common_ancestro,
      u_genealogy_context,
      u_common_const,
      fonctions_ini,
      graphics;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFConfirmAddToFavoris.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  fNom:='';
  fSexe:=-1;
  inherited;
end;

procedure TFConfirmAddToFavoris.DoShow;
begin
  inherited;
  case fSexe of
    1:lTitre.Font.Color:=gci_context.ColorHomme;
    2:lTitre.Font.Color:=gci_context.ColorFemme;
    else
      lTitre.Font.Color:=clWindowText;
  end;
  lTitre.Caption:=coupechaine(fNom,lTitre);
  Caption:=rs_Caption_Add_to_favorites;
end;

procedure TFConfirmAddToFavoris.ControlKeyDown(
  var Key:Word;Shift:TShiftState);
begin
  inherited;
  case Key of
    _KEY_HELP:p_ShowHelp(_HELP_FAVORIS);
  end;
end;

procedure TFConfirmAddToFavoris.doInit;
begin
  lAction.Caption:='Ancestromania va ajouter cet individu à vos Favoris.';
end;

end.

