{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_dossier;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, ShlObj, Mask, Windows,
{$ELSE}
  LCLType, LazFileUtils,
{$ENDIF}
  U_FormAdapt,DB,
  StdCtrls,Controls,DBCtrls,Classes,
  ExtCtrls,u_framework_dbcomponents,
  u_buttons_appli,
  u_extDBDirectoryEdit,
  Dialogs,SysUtils, ExtJvXPCheckCtrls,
  IBQuery, IBUpdateSQL, Forms;

type

  { TFEditDossier }

  TFEditDossier=class(TF_FormAdapt)
    bsfbSelection: TFWOK;
    btnFermer: TFWClose;
    cbImages: TJvXPCheckbox;
    cbLangue: TFWDBComboBox;
    DBText1: TDBText;
    dxDBMemo1: TFWDBMemo;
    dxDBEdit1: TFWDBEdit;
    edFicNotes: TFWDBFileEdit;
    edPathBaseMedias: TExtDBDirectoryEdit;
    fpBoutons: TPanel;
    Label1: TLabel;
    LabelFolder: TLabel;
    LabelDescr: TLabel;
    Label4: TLabel;
    LabelFileNotes: TLabel;
    LabelLang: TLabel;
    panDock: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    pBorder:TPanel;
    DataSource:TDataSource;
    
    pGlobal: TPanel;
    SelectFichier:TOpenDialog;
    IBDossier : TIBQuery;
    IBUpdateDossier : TIBUpdateSQL;

    procedure bsfbSelectionClick(Sender: TObject);
    procedure bFermerClick(Sender: TObject);
  private
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  public
    procedure Loaded; override;
    procedure DoShowFirstTime; override;

  end;

implementation

uses  u_dm,
      u_common_const,
      fonctions_dialogs,
      u_common_functions,
      u_common_ancestro_functions,
      u_genealogy_context,
      fonctions_ini,
      u_common_ancestro,IBSQL;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFEditDossier.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  edFicNotes.Hint:=rs_Hint_Directory_select;
  inherited;
end;

procedure TFEditDossier.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case Key of
    VK_ESCAPE:ModalResult:=mrCancel;
    _KEY_HELP:p_ShowHelp(_ID_DOSSIER);
  end;
end;

procedure TFEditDossier.bsfbSelectionClick(Sender: TObject);
begin
  with ibdossier,Transaction do
    if State in [dsEdit,dsInsert] Then
      try
        Post;
        Commit;

      Except
      end;
  Close;
end;

procedure TFEditDossier.bFermerClick(Sender: TObject);
begin
  IbDossier.Cancel;
  Close;
end;

procedure TFEditDossier.DoShowFirstTime;
var
  q:TIBSQL;
begin
  ibdossier.Params [ 0 ].Value := dm.NumDossier;
  ibdossier.Open;
  caption:=rs_Form_Modifying_folder;
  q:=TIBSQL.Create(self);
  try
    q.Database:=dm.ibd_BASE;
    q.Transaction:=dm.IBT_BASE;
    q.SQL.Clear;
    q.SQL.Add('select count(*) from individu where kle_dossier=:dossier');
    q.Params[0].AsInteger:=DataSource.DataSet.FieldByName('CLE_DOSSIER').AsInteger;
    q.ExecQuery;
    cbLangue.Enabled:=q.Fields[0].AsInteger=0;
    q.Close;
  finally
    q.Free;
  end;
end;


end.

