{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{ auteur du pourquoi faire simple quand on peut faire compliqué.        }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_postit;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, Windows,
{$ELSE}
  LCLIntf,
{$ENDIF}
{$IFDEF WINDOWS}
  Messages,
{$ENDIF}
  U_FormAdapt,DB,Dialogs,
  IBUpdateSQL,IBQuery,Forms,ExtCtrls,Controls,u_buttons_flat,
  Classes,u_buttons_appli,JvXPButtons,
  u_ancestropictimages,u_framework_dbcomponents;

type

  { TFPostit }

  TFPostit=class(TF_FormAdapt)
    query:TIBQuery;
    IBUpdateSQL:TIBUpdateSQL;
    DataSource:TDataSource;
    Panel5:TPanel;
    Panel15:TPanel;
    SpeedButton2:TCSpeedButton;
    Panel4:TPanel;
    fpBoutons:TPanel;
    Panel1:TPanel;
    Panel2:TPanel;
    Panel3:TPanel;
    Panel6:TPanel;
    GoodBtn2:TJvXPButton;
    Image1:TIAQuestion;
    queryM_CLEF:TLongintField;
    queryM_MEMO:TBlobField;
    queryM_DOSSIER:TLongintField;
    
    bsfbDelete:TFWErase;
    GoodBtn3:TFWClose;
    Shape1:TShape;
    memo:TFWDBMemo;
    procedure bsfbDeleteClick(Sender:TObject);
    procedure GoodBtn2Click(Sender:TObject);
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    procedure Panel6MouseDown(Sender:TObject;Button:TMouseButton;
      Shift:TShiftState;X,Y:Integer);
  private

  public
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoShowFirstTime; override;
    function doOpenQuery:boolean;
    destructor Destroy; override;

  end;

implementation

uses u_dm,u_common_functions,
     u_common_ancestro,  u_form_main,
     u_common_ancestro_functions,
     fonctions_dialogs,
     fonctions_db,
     u_common_const;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

function TFPostit.doOpenQuery:boolean;
var
  k:integer;
  s:string;
begin
  result:=false;
  s:=rs_this_is_to_remember;
  with query do
   Begin
    Close;
    ParamByName( IBQ_KLE_DOSSIER ).AsInteger:=dm.NumDossier;
    Open;

    if IsEmpty then
    begin
        //On en créé un
      Insert;
      QueryM_DOSSIER.AsInteger:=dm.NumDossier;
      QueryM_MEMO.AsString:=s;
      Post;
      result:=true;
    end
    else
      result:=true;

   end;
end;

destructor TFPostit.Destroy;
begin
  inherited Destroy;
  FMain.aFPostit:=nil;
end;

procedure TFPostit.bsfbDeleteClick(Sender:TObject);
begin
  if MyMessageDlg(rs_Do_you_delete_the_content_of_this_notebook,mmtConfirmation, mmbYesNo,self)=mrYes then
  begin
    try
      if Query.Active then
      begin
        p_DatasetPostIfEdited(Query);
        queryM_MEMO.Clear;
        Query.Post;
      end;
    except
    end;
  end;
end;

procedure TFPostit.GoodBtn2Click(Sender:TObject);
begin
  Close;
end;

procedure TFPostit.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case Key of
    // VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP:p_ShowHelp(_ID_POSTIT);
  end;
end;

procedure TFPostit.Panel6MouseDown(Sender:TObject;Button:TMouseButton;
  Shift:TShiftState;X,Y:Integer);
begin
  ReleaseCapture;
  {$IFDEF WINDOWS}
  TForm(Self).perform(WM_SYSCOMMAND,$F012,0);
  {$ENDIF}
end;

procedure TFPostit.DoClose(var Action: TCloseAction);
begin
  inherited;
  try
    if (Query.State in [dsInsert,dsEdit]) then
    begin
      Query.Post;
      dm.IBTrans_Secondaire.CommitRetaining;
    end;
  except
  end;
  Query.Close;
  Action:=caFree;
end;

procedure TFPostit.DoShowFirstTime;
begin
  Caption:=rs_Post_it;
end;

end.

