{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestro 2003 GPL)           }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_select_database;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, ShlObj, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,Forms,
  Dialogs,u_buttons_defs,StdCtrls,
  ExtCtrls,Graphics,Controls,SysUtils,
  u_buttons_appli,
  u_framework_components, u_ancestropictimages,
  Menus, Classes;

type

  { TFSelectDatabase }

  TFSelectDatabase=class(TF_FormAdapt)
    BtnEffacer: TFWErase;
    BtnOuvrir: TFWOK;
    BtnParcourir: TFWFolder;
    Image1: TIATitle;
    Image3: TImage;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LabelPathDB: TLabel;
    lbEmplacementbdd: TFWComboBox;
    Panel2: TPanel;
    Panel3:TPanel;
    Panel4:TPanel;
    Panel1:TPanel;
    Image2:TIAMouse;
    Label7:TLabel;
    Panel5: TPanel;
    Label11:TLabel;

    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    StatusConnect: TLabel;
    procedure BtnParcourirClick(Sender: TObject);
    procedure BtnOuvrirClick(Sender:TObject);
    procedure lbEmplacementbddPropertiesButtonClick(Sender:TObject);
    procedure Effacerhistorique1Click(Sender:TObject);

  private
    procedure SaveIni( const ASavePathIni : Boolean = True );
  protected
    procedure DoClose(var Action: TCloseAction); override;

  public
    procedure DoShowFirstTime; override;
    procedure Loaded; override;

  end;

implementation

uses u_dm,
     u_form_main,
     u_common_functions,
     u_common_ancestro,
     u_common_const,
     u_genealogy_context,IniFiles,
     fonctions_components,
     fonctions_ini,
     fonctions_dbobjects,
     fonctions_dialogs,
     LazFileUtils,
     u_common_ancestro_functions,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFSelectDatabase.DoShowFirstTime;
begin
  screen.Cursor:=crDefault;
  if dm.ibd_BASE.Connected then
  begin
    StatusConnect.Font.Color:=clGreen;
    StatusConnect.Caption:=fs_RemplaceMsg(rs_Ancestromania_is_connected_to_this_database,[gs_DefaultDatabase]);
  end
  else
  begin
    StatusConnect.Font.Color:=clRed;
    StatusConnect.Caption:=rs_Ancestromania_is_not_connected_to_a_database;
  end;
end;

procedure TFSelectDatabase.BtnParcourirClick(Sender: TObject);
var
  NewFileName:string;
begin
  NewFileName:=lbEmplacementbdd.Text;
  with dm.OpenFirebird do
   Begin
    FileName:='';
      //préparation de la boite OpenDialog
    if DirectoryExistsUTF8(ExtractFilePath(lbEmplacementbdd.Text)) then
      begin
        InitialDir:=ExtractFilePath(lbEmplacementbdd.Text);
        if FileExistsUTF8(lbEmplacementbdd.Text)  then
          FileName:=ExtractFileName(lbEmplacementbdd.Text);
      end
      else
      begin
        if FileExistsUTF8(dm.ibd_BASE.DatabaseName) then
        begin
          InitialDir:=ExtractFilePath(dm.ibd_BASE.DatabaseName);
          FileName:=ExtractFileName(dm.ibd_BASE.DatabaseName);
        end
        else
          {$IFDEF WINDOWS}
          InitialDir:=fPath_MesDocuments;
          {$ELSE}
          InitialDir:=DEFAULT_FIREBIRD_DATA_DIR;
          {$ENDIF}
      end;

    if Execute then
     Begin
      fb_AddToCombo ( lbEmplacementbdd,FileName,True);
      lbEmplacementbddPropertiesButtonClick(Self);
     end;
   end;
end;


procedure TFSelectDatabase.Loaded;
begin
  f_GetMemIniFile;
  p_ReadComboBoxItems(lbEmplacementbdd,lbEmplacementbdd.Items);
  lbEmplacementbdd.ItemIndex := f_IniReadSectionInt(Name,lbEmplacementbdd.name,lbEmplacementbdd.ItemIndex);
  Color:=gci_context.ColorLight;
  BtnOuvrir.Color:=gci_context.ColorLight;
  BtnOuvrir.ColorFrameFocus:=gci_context.ColorLight;
  screen.Cursor:=crHourglass;

  lbEmplacementbdd.Text:=gs_DefaultDatabase;

  BtnOuvrir.Hint:=rs_Hint_if_server_version_is_used_maj_will_open_connexion_dialog;
  inherited;
end;

procedure TFSelectDatabase.SaveIni( const ASavePathIni : Boolean = True );
begin
  f_GetMemIniFile();
  gci_context.PathFileNameBdd:=trim(lbEmplacementbdd.Text);
  p_writeComboBoxItems(lbEmplacementbdd,lbEmplacementbdd.Items);
  p_IniWriteSectionInt(Name,lbEmplacementbdd.name,lbEmplacementbdd.ItemIndex);
  if ASavePathIni Then
    fb_iniWriteFile(FIniFile,False);
end;

procedure TFSelectDatabase.BtnOuvrirClick(Sender:TObject);
begin
  BtnOuvrir.Enabled:=false;
  try
    dm.doCloseDatabase;
    fb_AddToCombo(lbEmplacementbdd,lbEmplacementbdd.Text);
    SaveIni(False);
    dm.doOpenDatabase;
    FMain.doRefreshControls;

    doCloseWorking;
    if dm.ibd_BASE.Connected then
    begin
      //sauvegarde si la base est connectée uniquement
      SaveIni;
      StatusConnect.Font.Color:=clGreen;
      StatusConnect.Caption:=fs_RemplaceMsg(rs_Ancestromania_is_connected_to_this_database,[gs_DefaultDatabase]);

      FMain.doAfterOpenDatabase;;
      Close;
    end
    else
    begin
      StatusConnect.Font.Color:=clRed;
      StatusConnect.Caption:=rs_Ancestromania_is_not_connected_to_a_database;
      BtnOuvrir.Enabled:=true;
    end;
  finally
    screen.Cursor:=crDefault;
  end;
end;

procedure TFSelectDatabase.lbEmplacementbddPropertiesButtonClick(
  Sender:TObject);
Begin
  BtnOuvrir.Enabled:=True;
end;

procedure TFSelectDatabase.Effacerhistorique1Click(Sender:TObject);
begin
  lbEmplacementbdd.Items.Clear;
end;

procedure TFSelectDatabase.DoClose(var Action: TCloseAction);
begin
  inherited;
  Action:=caFree;
end;

end.

