{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{           André Langlet (Main), Matthieu Giroux (LAZARUS),            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_ask_name_files_to_export_report;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,  Dialogs,
  u_buttons_flat, StdCtrls, Classes, MaskEdit,
  ExtCtrls,  u_buttons_appli, U_OnFormInfoIni;

type

  { TFAskNameFilesToExportReport }

  TFAskNameFilesToExportReport = class(TF_FormAdapt)
    btn1: TCSpeedButton;
    btn2: TCSpeedButton;
    btn3: TCSpeedButton;
    edAutreSep: TMaskEdit;
    edNameFile1: TMaskEdit;
    edNameFile2: TMaskEdit;
    edNameFile3: TMaskEdit;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel7: TPanel;
    pBorder: TPanel;
    Panel2: TPanel;
    Panel8: TPanel;
    Panel3: TPanel;
    lbFile1: TLabel;
    lbFile2: TLabel;
    lbFile3: TLabel;
    FlatGroupBox1: TGroupBox;
    Panel6: TPanel;
    rbAutre: TRadioButton;
    rbPV: TRadioButton;
    rbV: TRadioButton;
    rbTab: TRadioButton;
    FlatGroupBox2: TGroupBox;
    cbIncludeEntete: TCheckBox;
    SaveDialog1: TSaveDialog;
    SaveDialog2: TSaveDialog;
    SaveDialog3: TSaveDialog;

    btnOk: TFWOK;
    btnCancel: TFWCancel;
    procedure SpeedButton1Click(Sender: TObject);


    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);

  private
    fNbFileToAsk: integer;

  public
    procedure Loaded; override;
    procedure DoRefreshControls; override;
    procedure DoShowFirstTime; override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    property NbFileToAsk: integer read fNbFileToAsk write fNbFileToAsk;

  end;

implementation

uses u_dm,  u_common_functions,
     u_common_ancestro,
     u_genealogy_context,
     fonctions_ini,
     u_common_resources;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFAskNameFilesToExportReport.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;

  fNbFileToAsk := 1;
  SaveDialog1.InitialDir := gci_context.PathDocs;
  SaveDialog2.InitialDir := gci_context.PathDocs;
  SaveDialog3.InitialDir := gci_context.PathDocs;
  inherited;
end;

procedure TFAskNameFilesToExportReport.DoRefreshControls;
var
  Ok: boolean;
begin
  case fNbFileToAsk of
    1: Ok := (edNameFile1.Text > '');
    2: Ok := (edNameFile1.Text > '') and (edNameFile2.Text > '');
    3: Ok := (edNameFile1.Text > '') and (edNameFile2.Text > '') and (edNameFile3.Text > '');
    else
      Ok := false;
  end;
  btnOk.Enabled := Ok;
end;

procedure TFAskNameFilesToExportReport.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFAskNameFilesToExportReport.DoShowFirstTime;
begin
  //Hauteur de la fenêtre
  case fNbFileToAsk of
    1: ClientHeight := 210;
    2: ClientHeight := 260;
    3:ClientHeight:=310;
  end;
  if fNbFileToAsk=1 then
    Caption:=rs_Caption_Name_of_file_to_export
  else
    Caption:=rs_Caption_Names_of_files_to_export;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.btn1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then edNameFile1.Text := SaveDialog1.FileName;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.btn2Click(Sender: TObject);
begin
  if SaveDialog2.Execute then edNameFile2.Text := SaveDialog2.FileName;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.btn3Click(Sender: TObject);
begin
  if SaveDialog3.Execute then edNameFile3.Text := SaveDialog3.FileName;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case Key of
    _KEY_HELP: p_ShowHelp(_ID_PRINT);
  end;
end;

end.
