{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_param_reports;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,DB,IBCustomDataSet,IBQuery,
  StdCtrls,ExtCtrls,Classes,Forms,SysUtils,ExtJvXPCheckCtrls,u_buttons_appli,
  MaskEdit, DBGrids, Spin, U_OnFormInfoIni;

type

  { TFParamReports }

  TFParamReports=class(TF_FormAdapt)
    btnRefresh: TFWConfig;
    cbAnniv_Deces: TJvXPCheckbox;
    cbAnniv_Mariage: TJvXPCheckbox;
    cbAnniv_Naissance: TJvXPCheckbox;
    cbAvecEnfants: TJvXPCheckbox;
    cbAvecMariages: TJvXPCheckbox;
    cbFFEvAexporter: TJvXPCheckbox;
    cbFIEvAexporter: TJvXPCheckbox;
    cbLimitOnSosa: TJvXPCheckbox;
    cbLimitOnYear: TJvXPCheckbox;
    cbOnlySosaEclair: TJvXPCheckbox;
    cbPhotos: TJvXPCheckbox;
    cbPhotosIndi: TJvXPCheckbox;
    cbSosaFam: TJvXPCheckbox;
    cbSosaIndi: TJvXPCheckbox;
    cbTous: TJvXPCheckbox;
    chDept: TJvXPCheckbox;
    edInterval: TComboBox;
    edVilleEclair: TMaskEdit;
    edYearFrom: TSpinEdit;
    edYearTo: TSpinEdit;
    gridCouples: TDBGrid;
    Label1: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Notebook: TNotebook;
    OnFormInfoIni: TOnFormInfoIni;
    IBConjoints:TIBQuery;
    IBConjointsCLE_FICHE:TLongintField;
    IBConjointsNOM:TIBStringField;
    IBConjointsPRENOM:TIBStringField;
    IBConjointsUNION_CLEF:TLongintField;
    IBConjointsNOM_PRENOM:TStringField;
    DSConjoints:TDataSource;
    page1: TPage;
    page2: TPage;
    page3: TPage;
    page4: TPage;
    page5: TPage;
    page6: TPage;
    page7: TPage;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    pBorder: TPanel;
    PickMonth: TComboBox;
    RadioButton1: TRadioButton;
    rbChoixUser: TRadioButton;
    rbTrieParPatronyme: TRadioButton;
    rgListeEvenements: TRadioGroup;
    rgStats: TRadioGroup;

    procedure Button1Click(Sender:TObject);
    procedure DoShowFirstTime; override;
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
  private
    year,month,day:word;
    fPtrListReport:TForm;
  public
    procedure Loaded; override;
    property PtrListReport:TForm read fPtrListReport write fPtrListReport;
  end;

implementation

uses u_dm,
     u_form_list_report,
     u_common_const,
     u_common_functions,
     u_common_ancestro,
     u_genealogy_context,
     fonctions_ini,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFParamReports.Loaded;
var
  n:integer;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  DefaultCloseAction:=caHide;

  fPtrListReport:=nil;
  for n:=1 to 12 do
    PickMonth.Items.Add(fs_FormatText(LongMonthNames[n],mftFirstIsMaj));
  DecodeDate(Now,year,month,day);
  PickMonth.ItemIndex:=month-1;
  inherited;
end;

procedure TFParamReports.Button1Click(Sender:TObject);
begin
  if fPtrListReport<>nil then
    TFListReport(fPtrListReport).doRefreshReport;
end;

procedure TFParamReports.DoShowFirstTime;
var
  RectMonitor:TRect;
begin
  //Positionnement de la fenêtre en bas à droite du moniteur de listreport
  RectMonitor:=fPtrListReport.Monitor.WorkareaRect;
  Top:=RectMonitor.Bottom-Height;
  Left:=RectMonitor.Right-Width;

  Caption:=rs_Caption_Printed_documents_options;
end;

procedure TFParamReports.ControlKeyDown(var Key: Word; Shift: TShiftState);
begin
  case Key of
    _KEY_HELP:p_ShowHelp(_ID_PRINT);
  end;
end;

end.

