unit u_form_report_fiche_ind;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$mode delphi}

interface

uses
  Forms, RLReport, DB, Classes,
  u_reports_rlcomponents,u_dm;

type

  { TFReportFicheInd }

  TFReportFicheInd = class(TForm)
    RLHeader: TRLBand;
    RLBand2: TRLBand;
    RLColumnHeader: TRLBand;
    RLColumn: TRLBand;
    RLDBExtImage1: TRLDBExtImage;
    RLDBSexe: TRLDBExtImageList;
    RLDBText1: TRLDBText;
    RLDBText10: TRLDBText;
    RLDBText11: TRLDBText;
    RLDBText12: TRLDBText;
    RLDBText13: TRLDBText;
    RLDBText14: TRLDBText;
    RLDBText15: TRLDBText;
    RLDBText2: TRLDBText;
    RLDBText3: TRLDBText;
    RLDBText6: TRLDBText;
    RLDBText8: TRLDBText;
    RLLabel1: TRLLabel;
    RLLabel13: TRLLabel;
    RLLabel16: TRLLabel;
    RLLabel19: TRLLabel;
    RLLabel2: TRLLabel;
    RLLabel22: TRLLabel;
    RLLabel27: TRLLabel;
    RLLabel28: TRLLabel;
    RLLabel3: TRLLabel;
    RLLabel31: TRLLabel;
    RLLabel34: TRLLabel;
    RLLabel35: TRLLabel;
    RLLabel4: TRLLabel;
    RLTitle: TRLLabel;
    RLReport: TRLReport;
    RLSystemInfo1: TRLSystemInfo;
    RLSystemInfo2: TRLSystemInfo;
    RLSystemInfo3: TRLSystemInfo;
  private
    { private declarations }
  public
    { public declarations }
    procedure Loaded; override;
    procedure SetDatasource ( const ADatasource : TDatasource );
  end;

var
  FReportFicheInd: TFReportFicheInd = nil;

implementation

uses fonctions_proprietes,
     fonctions_reports;

{ TFReportFicheInd }

procedure TFReportFicheInd.Loaded;
begin
  RLDBSexe.Images := dm.ImageSexe;
  RLColumn      .Color :=  ExtColumnColorBack     ;
  RLColumnHeader.Color :=  ExtColumnHeaderColorBack ;
  RLHeader      .Color :=  ExtHeaderColorBack       ;
  RLHeader      .Font.Name  := ExtHeaderFont.Name       ;
  RLHeader      .Font.Color := ExtHeaderFont.Color      ;
  RLColumnHeader.Font.Name  := ExtColumnHeaderFont.Name ;
  RLColumnHeader.Font.Color := ExtColumnHeaderFont.Color;
  RLColumn      .Font.Name := ExtColumnFont.Name       ;
  RLColumn      .Font.Color  := ExtColumnFont.Color      ;
  Inherited;
end;

procedure TFReportFicheInd.SetDatasource(const ADatasource: TDatasource);
var i : Integer;
begin
  for i := 0 to ComponentCount -1  do
    p_SetComponentObjectProperty(Components[i],CST_DBPROPERTY_DATASOURCE,ADatasource);
end;

{$R *.lfm}


end.

