unit u_Form_ChercheNIP;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
{$ENDIF}
  SysUtils,Forms, Classes,
  Dialogs,StdCtrls,u_buttons_appli,
  IBSQL,MaskEdit, ExtCtrls;

type

  { TFChercheNIP }

  TFChercheNIP=class(TForm)
    bsfbAppliquer: TFWOK;
    eNIP:TMaskEdit;
    FBClose1: TFWClose;
    Label1:TLabel;
    Panel1: TPanel;
    procedure bsfbAppliquerClick(Sender:TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    iNip:integer;
    procedure Loaded; override;
  end;

var
  FChercheNIP:TFChercheNIP;

implementation

uses u_Dm,
     u_common_ancestro_functions,
     fonctions_dialogs,
     fonctions_ini,
     u_genealogy_context,
     u_common_ancestro;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFChercheNIP.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  iNip:=-1;
  inherited;
end;

procedure TFChercheNIP.bsfbAppliquerClick(Sender:TObject);
var
  q:TIBSQL;
  ok:boolean;
begin
  ok:=false;
  if tryStrToInt(Trim(eNip.text),iNip) then
  begin
    q:=TIBSQL.Create(Application);
    try
      q.DataBase:=dm.ibd_BASE;
      q.SQL.ADD('select cle_fiche from individu where kle_dossier=:i_dossier and cle_fiche=:NIP');
      q.Params[0].AsInteger:=dm.NumDossier;
      q.Params[1].AsInteger:=iNip;
      q.ExecQuery;
      iNip:=q.Fields[0].AsInteger;
      q.close;
    finally
      q.Free;
    end;
    ok:=iNip>0;
  end;
  if not ok then
  begin
    MyMessageDlg(rs_No_person_with_this_key,mmtInformation,[mmbOk],Self);
    iNip:=-1;
  end;
  Close;
end;

end.

