{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Liste_Nouveaux_Indi;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt,Forms,SysUtils,U_ExtDBGrid,ExtJvXPCheckCtrls,
  Dialogs,Menus,DB,IBQuery, IBUpdateSQL,
  StdCtrls,Controls,ExtCtrls,
  Classes,u_buttons_appli, DateTimePicker,
  u_ancestropictimages, U_OnFormInfoIni;

type

  { TFListeNouveauxIndi }

  TFListeNouveauxIndi=class(TF_FormAdapt)
    Fermer: TFWClose;
    IBUNouveaux: TIBUpdateSQL;
    OnFormInfoIni: TOnFormInfoIni;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    fpBoutons:TPanel;
    pBottom:TPanel;
    IBQNouveaux:TIBQuery;
    DSNouveaux:TDataSource;
    pmNouveaux: TPopupMenu;
    mOuvreFiche: TMenuItem;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Image1:TIATitle;
    Panel2:TPanel;
    N1:TMenuItem;
    ExporterenHTML1:TMenuItem;
    SaveDialog:TSaveDialog;
    rbNew:TRadioButton;
    rbModify:TRadioButton;
    cbNew:TJvXPCheckBox;
    DateTimePicker:TDateTimePicker;
    
    Label1:TLabel;
    GoodBtn7:TFWCLose;

    procedure sbCloseClick(Sender:TObject);

    procedure mOuvreFicheClick(Sender:TObject);
    procedure ExporterenHTML1Click(Sender:TObject);
    procedure pmNouveauxPopup(Sender:TObject);
    procedure DateTimePickerCloseUp(Sender:TObject);
    procedure cbNewClick(Sender:TObject);
    procedure rbModifyClick(Sender:TObject);
    procedure rbNewClick(Sender:TObject);
    procedure dxDBGrid1DBTableView1CellDblClick(
      Sender:TObject;
      ACellViewInfo:Longint;AButton:TMouseButton;
      AShift:TShiftState;var AHandled:Boolean);
  private

    fDialogMode:boolean;
    fCleFicheSelected:integer;

    procedure SetDialogMode(const Value:boolean);
    procedure doOpen;
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    procedure DoShow; override;
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;
    procedure DoShowFirstTime; override;
    property DialogMode:boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected:integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm,
     u_common_const,
     u_common_functions,
     fonctions_ini,
     u_common_ancestro,
     u_genealogy_context,
     fonctions_components;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFListeNouveauxIndi.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;

  // Matthieu :?Utiliser le OnFormInfoIni
//  dxDBGrid1DBTableView1.RestoreFromRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_NOUVEAUX_INDIS');

  cbNew.checked:=gci_context.ShowNew;

  DateTimePicker.Date:=date-7;
  SaveDialog.InitialDir:=gci_context.PathDocs;
  doOpen;
  inherited;
end;

procedure TFListeNouveauxIndi.DoShow;
begin
  inherited;
  Height:=round(TControl(Owner).height*gci_context.TailleFenetre/100);
  width:=round(TControl(Owner).width*gci_context.TailleFenetre/100);
end;

procedure TFListeNouveauxIndi.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  IBQNouveaux.Close;
  // Matthieu :?Utiliser le OnFormInfoIni
//  dxDBGrid1DBTableView1.StoreToRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_NOUVEAUX_INDIS');
end;

procedure TFListeNouveauxIndi.SetDialogMode(const Value:boolean);
begin
  fDialogMode:=Value;
end;

procedure TFListeNouveauxIndi.sbCloseClick(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFListeNouveauxIndi.mOuvreFicheClick(Sender:TObject);
begin
  if (IBQNouveaux.Active)and(not IBQNouveaux.IsEmpty) then
  begin
    fCleFicheSelected:=IBQNouveaux.FieldByName('CLE_FICHE').AsInteger;
    ModalResult:=mrOk;
  end;
end;

procedure TFListeNouveauxIndi.ExporterenHTML1Click(Sender:TObject);
var
  SavePlace:TBookmark;
begin
  SavePlace:=nil;
  SaveDialog.FileName:='Liste des derniers individus saisis.HTM';
  if SaveDialog.Execute then
  begin
    IBQNouveaux.DisableControls;
    try
      SavePlace:=IBQNouveaux.GetBookmark;
      ExportGridToHTML(SaveDialog.FileName,dxDBGrid1,True,True);
    finally
      IBQNouveaux.GotoBookmark(SavePlace);
      IBQNouveaux.FreeBookmark(SavePlace);
      IBQNouveaux.EnableControls;
    end;
  end;
end;

procedure TFListeNouveauxIndi.pmNouveauxPopup(Sender:TObject);
begin
  mOuvreFiche.Enabled:=(IBQNouveaux.Active)and(not IBQNouveaux.IsEmpty);
  ExporterenHTML1.Enabled:=mOuvreFiche.Enabled;
end;

procedure TFListeNouveauxIndi.doOpen;
begin
  with IBQNouveaux do
   Begin
    Close;
    ParamByName( IBQ_d_date ).AsDate:=DateTimePicker.Date;
    ParamByName( IBQ_i_dossier ).AsInteger:=dm.NumDossier;
    if rbNew.Checked
     then ParamByName( IBQ_mode ).AsInteger:=1
     else ParamByName( IBQ_mode ).AsInteger:=0;
    Open;
   end;
end;

procedure TFListeNouveauxIndi.DateTimePickerCloseUp(Sender:TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.cbNewClick(Sender:TObject);
begin
  gci_context.ShowNew:=cbNew.Checked;
  gci_context.ShouldSave:=true;
end;

procedure TFListeNouveauxIndi.rbModifyClick(Sender:TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.rbNewClick(Sender:TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.ControlKeyDown(
  var Key:Word;Shift:TShiftState);
begin
  case Key of
    VK_ESCAPE:ModalResult:=mrOk;
    _KEY_HELP:p_ShowHelp(_ID_NOUVEAUX_INDI);
  end;
  inherited;
end;

procedure TFListeNouveauxIndi.dxDBGrid1DBTableView1CellDblClick(
  Sender:TObject;
  ACellViewInfo:Longint;AButton:TMouseButton;
  AShift:TShiftState;var AHandled:Boolean);
begin
  mOuvreFicheClick(Sender);
end;

procedure TFListeNouveauxIndi.DoShowFirstTime;
begin
  Caption:= rs_Caption_Last_persons_files;
end;

end.

