unit u_form_Actes_Liste;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}
{$i ../extends.inc}

interface

uses
{$IFNDEF FPC}
  jpeg, CommCtrl, Windows,
  ExtJvXPCheckCtrls,
{$ELSE}
  ExtJvXPCheckCtrls,
{$ENDIF}
  U_FormAdapt, StdCtrls,
  ExtCtrls,Controls,Classes,Graphics,
  Menus,
{$IFDEF VIRTUALTREES}
  VirtualTrees,
{$IFDEF WINDOWS}
  ActiveX,
{$ELSE}
  FakeActiveX,
{$ENDIF}
{$ELSE}
  ComCtrls,
{$ENDIF}
  IBSQL,
  u_reports_components,
  u_buttons_appli, U_OnFormInfoIni, u_framework_components, PrintersDlgs;

type
  TActe=record
    {$IFDEF VIRTUALTREES}
    ActText,
    {$ENDIF}
    TypeTable:string;
    cleImage,
    ImageIdx,
    cleEvent,
    TypeActe:integer;
  end;
  TActe2=record
    ActText,
    TypeTable:string;
    cleImage,
    ImageIndex,
    cleEvent,
    TypeActe:integer;
  end;
  PActe=^TActe;

  { TFActesListe }
  TFActesListe=class(TF_FormAdapt)
    cb_PaperSize: TComboBox;
    ch_portrait: TJvXPCheckbox;
    ch_pdf: TJvXPCheckbox;
    Label3: TLabel;
    OnFormInfoIni1: TOnFormInfoIni;
    Panel3:TPanel;
    Panel1:TPanel;
    dxComponentPrinter1:TPrinterSetupDialog;
    btnPrint:TFWPrintVTree;
    lNom:TLabel;
    Label8:TLabel;
    pmActes:TPopupMenu;
    mOuvreDocument:TMenuItem;
    sp_Fonte: TFWSpinEdit;
    {$IFDEF VIRTUALTREES}
    tvActe:TVirtualStringTree;
    {$ELSE}
    tvActe:TTreeView;
    {$ENDIF}
    Visualiser1:TMenuItem;
    ibActes:TIBSQL;
    BtnFermer:TFWClose;
    procedure btnPrintClick(Sender:TObject);
    procedure mOuvreDocumentClick(Sender:TObject);
    {$IFDEF VIRTUALTREES}
    procedure tvActeBeforeCellPaint(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
      TargetCanvas: TCanvas; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; Column: TColumnIndex;
      CellPaintMode: TVTCellPaintMode; CellRect: TRect; var ContentRect: TRect);
    procedure tvActeGetText(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
  Node: {$IFDEF VIRTUALTREES}PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: String{$ELSE}TTreeNode{$ENDIF});
    procedure tvActeDragDrop(Sender: TBaseVirtualTree; Source: TObject; DataObject: IDataObject;
    Formats: TFormatArray; Shift: TShiftState; const Pt: TPoint; var Effect: LongWord; Mode: TDropMode);
    procedure tvActeDragOver(Sender: TBaseVirtualTree; Source: TObject; Shift: TShiftState; State: TDragState;
    const Pt: TPoint; Mode: TDropMode; var Effect: LongWord; var Accept: Boolean);
    {$ELSE}
    procedure ValidateNode(ANode: TTreeNode);
    procedure tvActeDragDrop(Sender,Source:TObject;X,Y:Integer);
    procedure tvActeDragOver(Sender,Source:TObject;X,Y:Integer;
      State:TDragState;var Accept:Boolean);
    {$ENDIF}
    procedure tvActeContextPopup(Sender:TObject;MousePos:TPoint;
      var Handled:Boolean);
    procedure pmActesPopup(Sender:TObject);
    procedure tvActeGetImageIndex(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}
      {$IFDEF VIRTUALTREES};Kind: TVTImageKind; Column: TColumnIndex; var Ghosted: Boolean;var ImageIndex: Integer{$ENDIF});
    procedure tvActeInitNode({$IFDEF VIRTUALTREES}Sender: TBaseVirtualTree; ParentNode,{$ENDIF}
      Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}{$IFDEF VIRTUALTREES}; var InitialStates: TVirtualNodeInitStates{$ENDIF});
    procedure Visualiser1Click(Sender:TObject);
    procedure tvActeMouseDown(Sender:TObject;Button:TMouseButton;
      Shift:TShiftState;X,Y:Integer);
    procedure BtnFermerClick(Sender:TObject);
    procedure tvActeMouseMove(Sender:TObject;Shift:TShiftState;X,
      Y:Integer);

  private
    { Déclarations privées }
    iClePhoto:integer;
    fCanDeletionTV:boolean;
    sTitre:array[-3..1] of string;
    ModeDialog:boolean;
    unActe : TActe2;
  public
    { Déclarations publiques }
    bModified:boolean;

    procedure Loaded; override;
    procedure DoShowFirstTime; override;
    destructor Destroy; override;
    function doOpenQuerys:boolean;
    procedure doInit(iClef:integer;sNom:string;sexe:integer);

  end;

implementation

uses u_common_functions,u_common_ancestro,
     u_Common_const,u_Dm,
     u_common_ancestro_functions,
     u_common_resources,
     fonctions_string,
     fonctions_ini,
     fonctions_dialogs,
     sysutils,
     u_genealogy_context,
     fonctions_reports,
     u_form_individu;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}
var    fFormIndividu:TFIndividu;

{$IFNDEF VIRTUALTREES}
procedure TFActesListe.ValidateNode ( ANode : TTreeNode );
var Acte : PActe;
Begin
  New(Acte);
  with ANode do
   Begin
    Data:=Acte;
   end;
  tvActeInitNode(ANode);
end;
{$ENDIF}

procedure TFActesListe.Loaded;
begin
  tvActe:= {$IFDEF VIRTUALTREES}TVirtualStringTree{$ELSE}TTreeview{$ENDIF}.Create(self);
  with tvActe do
   Begin
    Parent:=Self;
    {$IFNDEF VIRTUALTREES}
    ReadOnly:=True;
    {$ENDIF}
    Left := 0;
    Height := 404;
    Hint := 'Liste des actes';
    Top := 20;
    Width := 613;
    Align := alClient;
    Color := clWindow;
    DragMode := dmAutomatic;
    Font.Color := clWindowText;
    {$IFDEF VIRTUALTREES}
    Header.AutoSizeIndex := 0;
    with Header.Columns.add do
      Begin
        Position := 0;
        Width := 611;
      end;
    Header.DefaultHeight := 17;
    Header.Height := 17;
    Header.Options := [hoAutoResize, hoDrag, hoShowSortGlyphs];
    Header.SortColumn := 0;
    TreeOptions.AutoOptions := [toAutoDropExpand, toAutoScrollOnExpand, toAutoSort, toAutoTristateTracking, toAutoDeleteMovedNodes];
    TreeOptions.MiscOptions := [toFullRepaintOnResize, toInitOnSave, toToggleOnDblClick, toWheelPanning, toEditOnClick];
    OnBeforeCellPaint := tvActeBeforeCellPaint;
    OnGetText := tvActeGetText;
    OnInitNode := tvActeInitNode;
    {$ENDIF}
    Images := dm.ImgCat;
    ParentFont := False;
    ParentShowHint := False;
    PopupMenu := pmActes;
    ShowHint := True;
    TabOrder := 2;
    OnDragOver := tvActeDragOver;
    OnDragDrop := tvActeDragDrop;
    OnGetImageIndex := tvActeGetImageIndex;
    OnMouseDown := tvActeMouseDown;
    OnMouseMove := tvActeMouseMove;
   end;

  btnPrint.Tree:=tvActe;
  f_GetMemIniFile();
  {$IFDEF VIRTUALTREES}
  tvActe .NodeDataSize := Sizeof(TActe)+1;
  {$ENDIF}
  fCanDeletionTV:=false;
  sTitre[-3]:=rs_Acts_Ignore;
  sTitre[-2]:=rs_Acts_Search;
  sTitre[-1]:=rs_Acts_demanded;
  sTitre[0]:=rs_Acts_Not_In;
  sTitre[1]:=rs_Acts_Found;
  ModeDialog:=true;
  tvActe.Hint:=rs_Hint_Modifying_Act_s_type_with_drag_drop;
  align:=AlClient;
  fFormIndividu:=TFIndividu(Owner);
  lNom.PopupMenu:=FFormIndividu.pmNom;
  lNom.OnMouseEnter:=FFormIndividu.lNomMouseEnter;
  lNom.OnMouseLeave:=FFormIndividu.lNomMouseLeave;
  lNom.OnMouseMove:=FFormIndividu.lNomMouseMove;
  lNom.OnClick:=FFormIndividu.lNomClick;
  lNom.Cursor:=5;
  inherited;
end;

procedure TFActesListe.DoShowFirstTime;
begin
  fCanDeletionTV:=true;
end;

destructor TFActesListe.Destroy;
begin
  tvActe.{$IFNDEF VIRTUALTREES}Items.{$ENDIF}Clear;
  inherited Destroy;
end;

function TFActesListe.doOpenQuerys:boolean;
begin
  ModeDialog:=FFormIndividu.DialogMode;
  tvActe.ShowHint:=not ModeDialog;
  with FFormIndividu do
     doInit(CleFiche,coupechaine(NomIndiComplet,lNom)
     ,QueryIndividu.FieldByName('SEXE').AsInteger);
  result:=True;
end;

procedure TFActesListe.doInit(iClef:integer;sNom:string;sexe:integer);
var
  NoeudAjoute,NoeudConjoint:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
  NoeudParent:array[-3..1] of {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}Integer{$ENDIF};

  procedure CreeunActe;
  begin
    with unActe do
     Begin
       cleImage:=0;
       cleEvent:=0;
       TypeActe:=0;
       TypeTable:='';
     end;
  end;

  procedure AjouteNoeudParent(const Aindex:integer);
  begin
    CreeunActe;
    with unActe do
     Begin
      ActText:=sTitre[aindex];
      TypeActe:=Aindex;
      case Aindex of
        -3:ImageIndex:=19;
        -2:ImageIndex:=10;
        -1:ImageIndex:=4;
        1:ImageIndex:=2;
        else
          ImageIndex:=18;
      end;
     end;

    with tvActe{$IFNDEF VIRTUALTREES},Items{$ENDIF} do
     Begin
      {$IFDEF VIRTUALTREES}
      NoeudParent[Aindex]:=AddChild(nil,nil);
      ValidateNode(NoeudParent[Aindex]{$IFDEF VIRTUALTREES},False{$ELSE}^{$ENDIF});
      {$ELSE}
      with AddChild(nil,'') do
       NoeudParent[Aindex]:=Index;
      ValidateNode(Item[(NoeudParent[Aindex])]);
      {$ENDIF}
     end;

//      SelectedIndex:=NoeudParent[index].ImageIndex;
  end;
begin
  with tvActe{$IFNDEF VIRTUALTREES},Items{$ENDIF}, ibActes do
   Begin
    DisableAlign;
    bModified:=false;
    Clear;
    case sexe of
      1:lNom.Font.Color:=gci_context.ColorHomme;
      2:lNom.Font.Color:=gci_context.ColorFemme;
      else
        lNom.Font.Color:=clWindowText;
    end;
    {$IFDEF VIRTUALTREES}
    NodeDataSize := Sizeof(TActe)+1;
    {$ENDIF}
    lNom.Caption:=sNom;
    Close;
    ParamByName( IBQ_i_indi ).AsInteger:=iClef;
    ExecQuery;
    AjouteNoeudParent(1);
    AjouteNoeudParent(-3);
    AjouteNoeudParent(-1);
    AjouteNoeudParent(-2);
    AjouteNoeudParent(0);

    while not Eof do
      begin
        with unActe do
         Begin
          CreeunActe;

          ActText:=FieldByName('TITRE_EVENT').AsString;
          if Length(FieldByName('DESCRIPTION_EVENT').AsString)>0 then
            AppendStr(ActText,' - '+FieldByName('DESCRIPTION_EVENT').AsString);
          if Length(FieldByName('DATE_WRITEN_EVENT').AsString)>0 then
            AppendStr(ActText,' - '+FieldByName('DATE_WRITEN_EVENT').AsString);
          if Length(FieldByName('CP_EVENT').AsString)>0 then
            AppendStr(ActText,' - '+FieldByName('CP_EVENT').AsString);
          if Length(FieldByName('VILLE_EVENT').AsString)>0 then
            AppendStr(ActText,' - '+FieldByName('VILLE_EVENT').AsString);

          cleEvent:=FieldByName('CLEF_EVENT').AsInteger;
          TypeTable:=FieldByName('TYPE_TABLE').AsString;
          cleImage:=FieldByName('MEDIA_EVENT').AsInteger;
          TypeActe:=FieldByName('ACTE_EVENT').AsInteger;
           if cleImage>0 then
             ImageIndex:=17
           else
             ImageIndex:=FieldByName('CAT_EVENT').AsInteger;
           if (TypeActe > 1)
           or (TypeActe <-3 )
            Then
             MyShowMessage(IntToStr(TypeActe));
           {$IFDEF VIRTUALTREES}
           NoeudAjoute:=AddChild(NoeudParent[TypeActe],nil);
           ValidateNode(NoeudAjoute,False);
           {$ELSE}
           NoeudAjoute:=AddChild(Item[NoeudParent[TypeActe]],'');
           ValidateNode(NoeudAjoute);
           {$ENDIF}

         end;

        if not FieldByName('NOM_CONJOINT').IsNull then
        begin
          CreeunActe;
          with unActe do
           Begin
            ActText:=FieldByName('NOM_CONJOINT').AsString;
            if Length(FieldByName('PRENOM_CONJOINT').AsString)>0 then
              AppendStr(ActText,', '+FieldByName('PRENOM_CONJOINT').AsString);

            if FieldByName('SEXE_CONJOINT').AsInteger=2 then
            begin
              if length(FieldByName('NAISSANCE_CONJOINT').AsString)>0 then
                AppendStr(ActText,' née '+FieldByName('NAISSANCE_CONJOINT').AsString);
              if length(FieldByName('DECES_CONJOINT').AsString)>0 then
                AppendStr(ActText,' décédée '+FieldByName('DECES_CONJOINT').AsString);
            end
            else
            begin
              if length(FieldByName('NAISSANCE_CONJOINT').AsString)>0 then
                AppendStr(ActText,' né '+FieldByName('NAISSANCE_CONJOINT').AsString);
              if length(FieldByName('DECES_CONJOINT').AsString)>0 then
                AppendStr(ActText,' décédé '+FieldByName('DECES_CONJOINT').AsString);
            end;

            TypeActe:=FieldByName('ACTE_EVENT').AsInteger;
            if FieldByName('SEXE_CONJOINT').AsInteger=2 then
              ImageIndex:=16
            else
              ImageIndex:=15;
           end;
          NoeudConjoint:=AddChild(NoeudAjoute,{$IFDEF VIRTUALTREES}@unActe{$ELSE}''{$ENDIF});
          ValidateNode(NoeudConjoint{$IFDEF VIRTUALTREES},False{$ENDIF});

    //      NoeudConjoint.SelectedIndex:=NoeudConjoint.ImageIndex;
        end;
        Next
      end;
    ibActes.Close;
    FullExpand;
    EnableAlign;
    {$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF} :={$IFDEF VIRTUALTREES}RootNode.FirstChild{$ELSE}Items.GetFirstNode{$ENDIF};
    {$IFDEF VIRTUALTREES}
    VisiblePath[RootNode.FirstChild]:=true;
    {$ENDIF}
   end;
end;

procedure TFActesListe.btnPrintClick(Sender:TObject);
begin
// Matthieu
  btnPrint.DestroyReport;
  p_setColumnsPrintSizeFonts (sp_Fonte.Value);
  p_SetBtnPrint ( btnPrint, fs_RemplaceMsg(rs_List_of_acts_by_type_of,[lNom.Caption]),cb_PaperSize.Text,ch_portrait.Checked, Integer(ch_pdf.Checked), fPathBaseMedias);
end;

procedure TFActesListe.pmActesPopup(Sender:TObject);
begin
  with tvActe do
    iClePhoto:=PActe({$IFDEF VIRTUALTREES}GetNodeData( focusedNode ){$ELSE}Selected.Data{$ENDIF})^.cleImage;
  mOuvreDocument.Enabled:=iClePhoto>0;
  Visualiser1.Enabled:=iClePhoto>0;
end;

procedure TFActesListe.mOuvreDocumentClick(Sender:TObject);
begin
  if iClePhoto>0 then
    ImprimeImage(iClePhoto,lNom.Caption);
end;

{$IFDEF VIRTUALTREES}
procedure TFActesListe.tvActeBeforeCellPaint(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
  TargetCanvas: TCanvas; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; Column: TColumnIndex;
  CellPaintMode: TVTCellPaintMode; CellRect: TRect; var ContentRect: TRect);
begin
  with Sender,Font do
  begin
    if Node^.Parent = nil then
    begin
      case PActe(GetNodeData(Node))^.TypeActe of
        -3:
          begin
            Color:=clGreen;
            Style:= [fsBold];
          end;
        -2:
          begin
            Color:=clRed;
            Style:= [fsBold];
          end;
        -1:
          begin
            Color:=clFuchsia;
            Style:= [fsBold];
          end;
        1:
          begin
            Color:=clGreen;
            Style:= [fsBold];
          end;
        else
          begin
            Color:=clGrayText;
            Style:= [fsBold];
          end;
      end;
    end
    else
    begin
      Color:=clWindowText;
      Style:= [];
    end;
    if Selected[Node] then
      Sender.Color:=gci_context.ColorMedium;
  end;
end;
{$ENDIF}

procedure TFActesListe.tvActeContextPopup(Sender:TObject;
  MousePos:TPoint;var Handled:Boolean);
begin
  with tvActe,{$IFDEF VIRTUALTREES}FocusedNode^{$ELSE}Selected{$ENDIF} do
  if ( Parent <> nil ) and ( {$IFDEF VIRTUALTREES}Parent^{$ELSE}Parent{$ENDIF}.Parent = {$IFDEF VIRTUALTREES}RootNode{$ELSE}nil{$ENDIF} ) then
    PopupMenu:=pmActes
  else
    PopupMenu:=nil;
end;

procedure TFActesListe.tvActeMouseMove(Sender:TObject;Shift:TShiftState;
  X,Y:Integer);
var
  Noeud:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  with tvActe do
   Begin
    Noeud:=GetNodeAt(X,Y);
    if (Noeud<>nil) and ({$IFDEF VIRTUALTREES}Noeud^{$ELSE}Noeud{$ENDIF}.Parent<>nil) and ({$IFDEF VIRTUALTREES}Noeud^.Parent^{$ELSE}Noeud.Parent{$ENDIF}.Parent={$IFDEF VIRTUALTREES}RootNode{$ELSE}nil{$ENDIF}) then
    begin
      pmActes.AutoPopup:=true;
      Cursor:=_CURPOPUP;
    end
    else
    begin
      pmActes.AutoPopup:=false;
      Cursor:=crDefault;
    end;
    if ModeDialog then
      DragMode:=dmManual
    else
      if (Noeud<>nil) and ({$IFDEF VIRTUALTREES}Noeud^{$ELSE}Noeud{$ENDIF}.Parent<>nil) and ({$IFDEF VIRTUALTREES}Noeud^.Parent^{$ELSE}Noeud.Parent{$ENDIF}.Parent={$IFDEF VIRTUALTREES}RootNode{$ELSE}nil{$ENDIF}) then
        DragMode:=dmAutomatic
      else
        DragMode:=dmManual;
   end;
end;

{$IFDEF VIRTUALTREES}
procedure TFActesListe.tvActeDragOver(Sender: TBaseVirtualTree; Source: TObject; Shift: TShiftState; State: TDragState;
    const Pt: TPoint; Mode: TDropMode; var Effect: LongWord; var Accept: Boolean);
{$ELSE}
procedure TFActesListe.tvActeDragOver(Sender,Source:TObject;X,
    Y:Integer;State:TDragState;var Accept:Boolean);
{$ENDIF}
var
  NoeudSurvole,NoeudDrag:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  with tvActe do
  try
    NoeudDrag:={$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF};
    {$IFDEF VIRTUALTREES}
    with pt do
    {$ENDIF}
    NoeudSurvole:=GetNodeAt(X,Y);
    Accept:=(NoeudSurvole<>nil) and ({$IFDEF VIRTUALTREES}NoeudDrag^{$ELSE}NoeudDrag{$ENDIF}.Parent<>nil)
      and ({$IFDEF VIRTUALTREES}NoeudDrag^.Parent^{$ELSE}NoeudDrag.Parent{$ENDIF}.Parent=nil)
      and(PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudSurvole ){$ELSE}NoeudSurvole.Data{$ENDIF})^.TypeActe<>PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudDrag ){$ELSE}NoeudDrag.Data{$ENDIF})^.TypeActe);
  except
    Accept:=false;
  end;
end;

{$IFDEF VIRTUALTREES}
procedure TFActesListe.tvActeDragDrop(Sender: TBaseVirtualTree; Source: TObject; DataObject: IDataObject;
Formats: TFormatArray; Shift: TShiftState; const Pt: TPoint; var Effect: LongWord; Mode: TDropMode);
{$ELSE}
procedure TFActesListe.tvActeDragDrop(Sender,Source:TObject;X,
  Y:Integer);
{$ENDIF}
var
  NoeudSurvole,NoeudDrag,NoeudDelete:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
  q:TIBSQL;
begin
  with tvActe do
   Begin
    NoeudDrag:={$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF};
    {$IFDEF VIRTUALTREES}
    with pt do
    {$ENDIF}
    NoeudSurvole:=GetNodeAt(X,Y);
    if (NoeudSurvole=nil)
      or (NoeudDrag=nil)
      or (({$IFDEF VIRTUALTREES}NoeudDrag^{$ELSE}NoeudDrag{$ENDIF}.Parent=nil)
      or (({$IFDEF VIRTUALTREES}NoeudDrag^{$ELSE}NoeudDrag{$ENDIF}.Parent<>{$IFDEF VIRTUALTREES}RootNode{$ELSE}nil{$ENDIF})
      and ({$IFDEF VIRTUALTREES}NoeudDrag^.Parent^{$ELSE}NoeudDrag.Parent{$ENDIF}.Parent={$IFDEF VIRTUALTREES}RootNode{$ELSE}nil{$ENDIF})))
      or (PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudSurvole ){$ELSE}NoeudSurvole.Data{$ENDIF})^.TypeActe=PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudDrag ){$ELSE}NoeudDrag.Data{$ENDIF})^.TypeActe) then
      exit;
    while {$IFDEF VIRTUALTREES}NoeudSurvole^{$ELSE}NoeudSurvole{$ENDIF}.Parent <> nil do
      NoeudSurvole:={$IFDEF VIRTUALTREES}NoeudSurvole^{$ELSE}NoeudSurvole{$ENDIF}.Parent;
    {$IFDEF VIRTUALTREES}
    MoveTo(NoeudDrag,NoeudSurvole,amAddChildLast,True);
    {$ELSE}
    NoeudDelete:=NoeudDrag;
    NoeudDrag:=Items.AddChildObject(NoeudSurvole, NoeudDrag.Text, NoeudDrag.Data );
    Items.Delete(NoeudDelete);
    {$ENDIF}
    PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudDrag ){$ELSE}NoeudDrag.Data{$ENDIF})^.TypeActe:=PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudSurvole ){$ELSE}NoeudSurvole.Data{$ENDIF})^.TypeActe;
    {$IFDEF VIRTUALTREES}
    Expanded[NoeudDrag]:=true;
    {$ELSE}
    NoeudDrag.Expand(True);
    {$ENDIF}
    q:=TIBSQL.Create(self);
    with q do
    try
      Database:=dm.ibd_BASE;
      Transaction:=dm.IBT_BASE;
      if PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudDrag ){$ELSE}NoeudDrag.Data{$ENDIF})^.TypeTable='I' then
        SQL.Text:='update evenements_ind set ev_ind_acte=:TypeActe where ev_ind_clef=:CleEve'
      else
        SQL.Text:='update evenements_fam set ev_fam_acte=:TypeActe where ev_fam_clef=:CleEve';
      ParamByName( IBQ_TypeActe ).AsInteger:=PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudSurvole ){$ELSE}NoeudSurvole.Data{$ENDIF})^.TypeActe;
      ParamByName( IBQ_CleEve ).AsInteger:=PActe({$IFDEF VIRTUALTREES}GetNodeData( NoeudDrag ){$ELSE}NoeudDrag.Data{$ENDIF})^.cleEvent;
      ExecQuery;
    finally
      q.Destroy;
    end;
    if fFormIndividu<>nil then
    with FFormIndividu do
    begin
      Modified:=true;
      DoRefreshControls;
    end;
   end;
  bModified:=True;
end;


procedure TFActesListe.tvActeGetImageIndex(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TObject{$ENDIF}; Node: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}
      {$IFDEF VIRTUALTREES};Kind: TVTImageKind; Column: TColumnIndex; var Ghosted: Boolean;var ImageIndex: Integer{$ENDIF});
begin
  {$IFNDEF VIRTUALTREES}
  with Node do
  {$ENDIF}
    ImageIndex:=PActe({$IFDEF VIRTUALTREES}Sender.GetNodeData( Node ){$ELSE}Data{$ENDIF})^.ImageIdx;
end;

{$IFDEF VIRTUALTREES}
procedure TFActesListe.tvActeGetText(Sender: {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF};
  Node: {$IFDEF VIRTUALTREES}PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: String{$ELSE}TTreeNode{$ENDIF});
begin
  {$IFNDEF VIRTUALTREES}
  with Node do
  {$ENDIF}
    {$IFDEF VIRTUALTREES}CellText{$ELSE}Text{$ENDIF}:=PActe({$IFDEF VIRTUALTREES}Sender.GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^.ActText;
end;
{$ENDIF}

procedure TFActesListe.tvActeInitNode({$IFDEF VIRTUALTREES}Sender: TBaseVirtualTree; ParentNode,{$ENDIF}
  Node:{$IFDEF VIRTUALTREES}PVirtualNode; var InitialStates: TVirtualNodeInitStates{$ELSE}TTreeNode{$ENDIF});
begin
  with PActe({$IFDEF VIRTUALTREES}Sender.GetNodeData( Node ){$ELSE}Node.Data{$ENDIF})^ do
   Begin
    {$IFDEF VIRTUALTREES}ActText{$ELSE}Node.Text{$ENDIF}  :=unActe.ActText;
    cleEvent   :=unActe.cleEvent;
    cleImage   :=unActe.cleImage;
    ImageIdx   :=unActe.ImageIndex;
    TypeActe   :=unActe.TypeActe;
    TypeTable  :=unActe.TypeTable;
   end;
end;

procedure TFActesListe.Visualiser1Click(Sender:TObject);
begin
  if iClePhoto>0 then
    VisualiseMedia(iClePhoto,dm.ReqSansCheck);
end;

procedure TFActesListe.tvActeMouseDown(Sender:TObject;
  Button:TMouseButton;Shift:TShiftState;X,Y:Integer);
var
  Noeud:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  Noeud:=tvActe.GetNodeAt(X,Y);
  if Noeud<>nil then
    {$IFDEF VIRTUALTREES}
    tvActe.Selected[Noeud]:=ssShift in Shift;
    {$ELSE}
    if ssShift in Shift then
      tvActe.Selected:=Noeud;
    {$ENDIF}
end;

procedure TFActesListe.BtnFermerClick(Sender:TObject);
begin
  close;
end;

end.

