{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{  refonte quasi totale de la logique par André Langlet décembre 2009   }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Affecte_Enfant;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  U_FormAdapt,Sysutils,
  Controls,ExtCtrls,StdCtrls,Forms,Classes,Graphics,Dialogs,
  u_buttons_appli,
  u_ancestropictimages;

type

  { TFAffecte_Enfant }

  TFAffecte_Enfant=class(TF_FormAdapt)
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    Panel1:TPanel;
    Image1:TIATitle;
    rg:TRadioGroup;
    Panel2:TPanel;
    fpBoutons:TPanel;
    bsfbAbandon:TFWClose;
    btnFermer:TFWOK;
    label1 :TLabel;
    label2 :TLabel;
    lmere :TLabel;
    lpere :TLabel;
    lenfant :TLabel;
    function ChercheAutreParent(SexeParent:Integer):boolean;
    procedure rgClick(Sender:TObject);
  private
    fDialogMode:boolean;
    fClefPere,fClefMere,ClefEnfant:integer;
    NomEnfant:string;
    iLastIndex:Integer;
    bM:boolean;
    iCleConjoint:array of Integer;
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoShow; override;
  public
    creation:boolean;
    procedure Loaded; override;
    property ClefMere:integer read fClefMere write fClefMere;
    property ClefPere:integer read fClefPere write fClefPere;
    procedure DoInit(i_clef,i_conjoint,i_enfant,SexeIndi:Integer;NomIndi:string);
  end;

implementation

uses u_dm,
     u_form_individu_repertoire,
     fonctions_dialogs,
     fonctions_string,
     fonctions_ini,
     u_common_functions,
     u_common_const,
     u_common_ancestro,
     u_genealogy_context,
     u_common_ancestro_functions,
     IBSQL;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFAffecte_Enfant.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  pBottom.Color:=gci_context.ColorDark;

  fDialogMode:=false;
  Panel2.top:=75;
  rg.top:=-7;
  rg.height:=10;
  Panel2.Left:=91;
  rg.Left:=-6;
  rg.width:=300;
  rg.Font.Style:= [fsBold];
  rg.Visible:=False;
  fClefPere:=-1;
  fClefMere:=-1;
  creation:=false;
  iLastIndex:=-2;
  lmere.Visible:=False;
  rg.visible:=true;
  inherited;
end;

procedure TFAffecte_Enfant.DoShow;
begin
  inherited;
  if Application.ModalLevel>0
   Then DefaultCloseAction:=caHide
   Else DefaultCloseAction:=caFree;
end;

procedure TFAffecte_Enfant.DoInit(i_clef,i_conjoint,i_enfant,SexeIndi:Integer;NomIndi:string);
var
  i:integer;
  q:TIBSQL;
begin
  Screen.Cursor:=crHourglass;
  bM:=SexeIndi=1;
  ClefEnfant:=i_enfant;
  fClefPere:=i_clef;
  lPere.Caption:=NomIndi;
  if bM then
  begin
    lPere.font.Color:=gci_context.ColorHomme;
    Label1.Caption:=rs_Caption_Has_got_father;
    Label2.Caption:=rs_Caption_Has_got_mother;
    rg.Font.Color:=gci_context.ColorFemme;
    Caption:=rs_Caption_Select_the_mother;
  end
  else
  begin
    lPere.font.Color:=gci_context.ColorFemme;
    Label1.Caption:=rs_Caption_Has_got_mother;
    Label2.Caption:=rs_Caption_Has_got_father;
    rg.Font.Color:=gci_context.ColorHomme;
    Caption:=rs_Caption_Select_the_Father;
  end;
  q:=TIBSQL.Create(self);
  with q do
  try
    Database:=dm.ibd_BASE;
    Transaction:=dm.IBT_BASE;
    SQL.Add('select nom,prenom,sexe from individu where cle_fiche=:i_enfant');
    Params[0].AsInteger:=ClefEnfant;
    ExecQuery;
    NomEnfant:=FieldByName('nom').AsString;
    lEnfant.Caption:=AssembleString([NomEnfant,FieldByName('prenom').AsString]);

    if FieldByName('sexe').AsInteger=1 then
      lEnfant.Font.Color:=gci_context.ColorHomme
    else if FieldByName('sexe').AsInteger=2 then
      lEnfant.Font.Color:=gci_context.ColorFemme
    else
      lEnfant.Font.Color:=clWindowText;

    Close;
    SQL.Clear;

    SQL.Add('select p.conjoint,c.nom,c.prenom from proc_conjoints_ordonnes(:indi,0) p'
      +' inner join individu c on c.cle_fiche=p.conjoint order by p.ordre');
    ParamByName( IBQ_indi ).AsInteger:=i_clef;
    ExecQuery;

    SetLength(iCleConjoint,0);
    i:=-1;
    rg.ItemIndex:=-1;
    while not Eof do
    begin
      inc(i);
      SetLength(iCleConjoint,i+1);
      ClientHeight:=ClientHeight+20;
      rg.Height:=rg.Height+20;
      rg.Items.Add(AssembleString([FieldByName('nom').AsString,FieldByName('prenom').AsString]));
      if (rg.Width<Length(rg.Items[i])*7) then
        rg.Width:=Length(rg.Items[i])*7;
      iCleConjoint[i]:=FieldByName('conjoint').AsInteger;
      if iCleConjoint[i]=i_conjoint then
        rg.ItemIndex:=i;
      Next;
    end;
  finally
    Free;
    Screen.Cursor:=crDefault;
  end;

  rg.Height:=rg.Height+40;
  Panel2.Width:=rg.Width-10;
  Panel2.Height:=Rg.Height-10;

  SetLength(iCleConjoint,i+3);
  iCleConjoint[i+1]:=0;
  iCleConjoint[i+2]:=0;
  iLastIndex:=i+2;
  if bM then
  begin
    rg.Items.Add(rs_Item_Other_known_mother);
    rg.Items.Add(rs_Unknown_mother);
  end
  else
  begin
    rg.Items.Add(rs_Item_Other_known_father);
    rg.Items.Add(rs_Unknown_father);
  end;
  if rg.ItemIndex=-1 then
    rg.ItemIndex:=iLastIndex;
end;

procedure TFAffecte_Enfant.ControlKeyDown(
  var Key:Word;Shift:TShiftState);
begin
  if Key=VK_ESCAPE then
    ModalResult:=mrCancel;
end;

function TFAffecte_Enfant.ChercheAutreParent(SexeParent:Integer):boolean;
var
  aFIndividuRepertoire:TFIndividuRepertoire;
  aLettre,TexteShow:string;
begin
  if SexeParent=1 then
    TexteShow:='son père'
  else
    TexteShow:='sa mère';
  aFIndividuRepertoire:=TFIndividuRepertoire.create(self);
  try
    aFIndividuRepertoire.Position:=poMainFormCenter;
    aFIndividuRepertoire.NomIndi:=NomEnfant;
    aLettre:=Copy(fs_FormatText(NomEnfant,mftUpper,True),1,1);
    aFIndividuRepertoire.InitIndividuPrenom(aLettre,'',SexeParent,0,False,True);
    if SexeParent=1 then
      aFIndividuRepertoire.Caption:=rs_caption_Select_Father
    else
      aFIndividuRepertoire.Caption:=rs_caption_Select_Mother;
    aFIndividuRepertoire.Creation:=false;
    if aFIndividuRepertoire.ShowModal=mrOk then
      if (aFIndividuRepertoire.ClefIndividuSelected=ClefEnfant) then
      begin
        MyMessageDlg(rs_Error_person_cannot_be_itself_and+TexteShow,mmtError, [mmbOk],Self);
        result:=false
      end
      else
      begin
        rg.Items[rg.ItemIndex]:=aFIndividuRepertoire.NomPrenomIndividuSelected;
        iCleConjoint[rg.ItemIndex]:=aFIndividuRepertoire.ClefIndividuSelected;
        result:=true
      end
    else
      result:=false;
    creation:=aFIndividuRepertoire.Creation;
  finally
    FreeAndNil(aFIndividuRepertoire);
  end
end;

procedure TFAffecte_Enfant.rgClick(Sender:TObject);
begin
  if rg.ItemIndex=iLastIndex-1 then
  begin
    if bM then
    begin
      if not ChercheAutreParent(2) then
        rg.ItemIndex:=iLastIndex;
    end
    else
    begin
      if not ChercheAutreParent(1) then
        rg.ItemIndex:=iLastIndex;
    end;
  end;
end;

procedure TFAffecte_Enfant.DoClose(
  var Action:TCloseAction);
begin
  if bM then
  begin
    if rg.ItemIndex<>-1 then
    begin
      fClefMere:=icleConjoint[rg.Itemindex];
      lMere.Caption:=rg.Items[rg.Itemindex]
    end
    else
      fClefMere:=0;
  end
  else
  begin
    if rg.ItemIndex<>-1 then
    begin
      fClefMere:=fClefPere;
      fClefPere:=icleConjoint[rg.Itemindex];
      lMere.Caption:=lPere.Caption;
      lPere.Caption:=rg.Items[rg.Itemindex]
    end
    else
      fClefPere:=0;
  end;
end;

end.

