{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}
unit u_form_individu_edit_event_life;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface
uses
{$IFNDEF FPC}
  jpeg, Mask, Windows,
{$ELSE}
  MaskEdit, LCLIntf, LCLType,
{$ENDIF}
  U_FormAdapt, Menus, Forms,  IBUpdateSQL,
  DB, IBQuery, u_buttons_defs, StdCtrls,
  Graphics, SysUtils, U_ExtNumEdits,
  Controls, Classes, ExtCtrls, u_ancestropictimages,
  u_ancestropictbuttons, u_extdateedit,
  u_buttons_appli, u_extsearchedit,
  Dialogs, u_framework_components,
  u_framework_dbcomponents, CompSuperForm,
  variants, IBSQL, ComCtrls,
  U_ExtDBGrid, U_ExtDBImageList, types;
type

  { TFIndividuEditEventLife }

  TFIndividuEditEventLife=class(TF_FormAdapt)
    bsfbAjout: TFWAdd;
    bsfbRetirer: TFWDelete;
    btnDetail: TFWXPButton;
    btnInternet: TXAWeb;
    btnMail: TXAWeb;
    btnWeb: TXAWeb;
    btnVillesFavoris: TXAFavorite;
    btnVillesVoisines: TXANeighbor;
    cxComboBoxActe: TFWDBComboBox;
    cxGridMedias: TExtDBGrid;
    cxGridTemoins: TExtDBGrid;
    dsEveMailSite: TDataSource;
    DBTextAge: TLabel;
    DSCountries: TDatasource;
    DsJobs: TDatasource;
    DsCities: TDatasource;
    dxDBImageEdit1: TExtDBImageList;
    edCause: TFWDBEdit;
    edCommentaires: TFWDBMemo;
    edCP: TExtSearchDBEdit;
    edDate: TExtDBDateEdit;
    edDept: TFWDBEdit;
    edDesc: TExtSearchDBEdit;
    edHeure: TFWDBDateTimePicker;
    edInsee: TExtSearchDBEdit;
    edLongitude: TFWDBSpinEdit;
    edLatitude: TFWDBSpinEdit;
    edPays: TExtSearchDBEdit;
    edSite: TExtSearchDBEdit;
    edRegion: TFWDBEdit;
    edMail: TExtSearchDBEdit;
    edSources: TFWDBMemo;
    edVille: TExtSearchDBEdit;
    edAdresse: TExtSearchDBEdit;
    fbInfosVilles: TXAInfo;
    IBJobs: TIBQuery;
    DBTextJour: TLabel;
    UIBMedias: TIBUpdateSQL;
    LabelAdresse: TFWLabel;
    LabelCause: TFWLabel;
    LabelCP: TFWLabel;
    LabelDate: TFWLabel;
    LabelDescription: TFWLabel;
    LabelINSEE: TFWLabel;
    LabelLat: TFWLabel;
    LabelLong: TFWLabel;
    LabelHour: TFWLabel;
    LabelPays: TFWLabel;
    LabelSite: TFWLabel;
    LabelRegion: TFWLabel;
    LabelMail: TFWLabel;
    LabelSubd: TFWLabel;
    LabelVille: TFWLabel;
    LabelDept: TFWLabel;
    MenuItem1: TMenuItem;
    OngletMedias: TTabSheet;
    OngletNotes: TTabSheet;
    OngletSources: TTabSheet;
    OngletTemoins: TTabSheet;
    PageControl: TPageControl;
    PanButtons: TPanel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    pGlobal:TPanel;
    panDock:TPanel;
    DataSourceEve:TDataSource;
    IBTemoins:TIBQuery;
    Panel2:TPanel;
    Panel3:TPanel;
    Panel5:TPanel;
    DBText1:TLabel;
    pmDate:TPopupMenu;
    btnPrecedent:TXAPrior;
    btnSuivant:TXANext;
    btnFermer:TFWClose;
    Label17:TFWLabel;
    PanelEdits:TGroupBox;
    dbcbDivers:TFWDBComboBox;
    dxStatusBar:TStatusBar;
    pmHeure:TPopupMenu;
    mSupprimerheure:TMenuItem;
    pmVideLieu:TPopupMenu;
    mEffacerlelieu:TMenuItem;
    PanLieu:TPanel;
    edSubdi:TFWDBEdit;
    DSTemoins:TDataSource;
    IBTemoinsASSOC_CLEF:TLongintField;
    IBTemoinsASSOC_KLE_IND:TLongintField;
    IBTemoinsASSOC_KLE_ASSOCIE:TLongintField;
    IBTemoinsASSOC_KLE_DOSSIER:TLongintField;
    IBTemoinsASSOC_EVENEMENT:TLongintField;
    IBTemoinsASSOC_TABLE:TStringField;
    IBTemoinsASSOC_LIBELLE:TStringField;
    IBTemoinsNOM:TStringField;
    IBTemoinsPRENOM:TStringField;
    IBTemoinsSEXE:TLongintField;
    IBTemoinsANNEE_NAISSANCE:TLongintField;
    IBTemoinsANNEE_DECES:TLongintField;
    IBTemoinsNOM_PRENOM:TStringField;
    IBUTemoins:TIBUpdateSQL;
    PmChangeFiche:TPopupMenu;
    Ouvrirlafiche1:TMenuItem;
    IBUMedias:TIBUpdateSQL;
    IBMedias:TIBQuery;
    DSMedias:TDataSource;
    pmImage:TPopupMenu;
    mVisualiseActe:TMenuItem;
    mImprimeActe:TMenuItem;
    mAjouterDocument:TMenuItem;
    mEnleverDocument:TMenuItem;
    mRemplacerDocument:TMenuItem;
    mAjouterTemoin:TMenuItem;
    mEnleverTemoin:TMenuItem;
    N1:TMenuItem;
    pmGoogle: TPopupMenu;
    mAcquerir: TMenuItem;
    procedure btnMailClick(Sender: TObject);
    procedure btnVillesVoisinesContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure btnWebClick(Sender: TObject);
    procedure cxGridTemoinsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure cxGridTemoinsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure dxDBImageEdit1PictureChanged(Sender: TObject);
    procedure edDateChanged(Sender: TObject);
    procedure edDateChangeLabel(const DateControl: TExtDBDateEdit;
      const IsBlank: Boolean);
    procedure edMailChange(Sender: TObject);
    procedure edSiteChange(Sender: TObject);
    procedure edVilleLocate(Sender: TObject);
    procedure edVilleSet(Sender: TObject);
    procedure edDateChange(Sender:TObject);
    procedure fbInfosVillesClick(Sender:TObject);
    procedure bsfbAjoutClick(Sender:TObject);
    procedure DataSourceEveStateChange(Sender:TObject);
    procedure btnVillesFavorisClick(Sender:TObject);
    procedure fbChangeDate(Sender:TObject);
    procedure btnSuivantClick(Sender:TObject);
    procedure btnPrecedentClick(Sender:TObject);
    procedure btnDetailClick(Sender:TObject);
    procedure edDescEnter(Sender:TObject);
    procedure dbcbDiversEnter(Sender:TObject);
    procedure edDescChange(Sender:TObject);
    procedure edDescExit(Sender:TObject);
    procedure dbcbDiversExit(Sender:TObject);
    procedure dbcbDiversChange(Sender:TObject);
    procedure pmImagePopup(Sender:TObject);
    procedure DataSourceEveDataChange(Sender:TObject;Field:TField);
    procedure edCPEnter(Sender:TObject);
    procedure edCPExit(Sender:TObject);
    procedure edInseeEnter(Sender:TObject);
    procedure edInseeExit(Sender:TObject);
    procedure mImprimeActeClick(Sender:TObject);
    procedure cxComboBoxActePropertiesEditValueChanged(Sender:TObject);
    procedure edVilleMouseEnter(Sender:TObject);
    procedure edVilleMouseLeave(Sender: TObject);
    procedure mSupprimerheureClick(Sender:TObject);
    procedure btnInternetPopupMenuPopup(Sender:TObject;
      var APopupMenu:TPopupMenu;var AHandled:Boolean);
    procedure PageControlDrawTabEx(AControl:TCustomTabControl;
      ATab:TTabSheet;Font:TFont);
    procedure PageControlChange(Sender:TObject);
    procedure edCommentairesKeyDown(Sender:TObject;var Key:Word;
      Shift:TShiftState);
    procedure edSourcesKeyDown(Sender:TObject;var Key:Word;
      Shift:TShiftState);
    procedure edCommentairesDblClick(Sender:TObject);
    procedure edSourcesDblClick(Sender:TObject);
    procedure PageControlClick(Sender:TObject);
    procedure dxDBImageEdit1Enter(Sender:TObject);
    procedure mEffacerlelieuClick(Sender:TObject);
    procedure IBTemoinsCalcFields(DataSet:TDataSet);
    procedure PmChangeFichePopup(Sender:TObject);
    procedure Ouvrirlafiche1Click(Sender:TObject);
    procedure cxGridTableTemoinsDblClick(Sender:TObject);
    procedure cxGridTableTemoinsColNomDrawColumnCell(
      Sender:TObject;ACanvas:TCanvas;
      AViewInfo:Longint;var ADone:Boolean);
    procedure DSTemoinsStateChange(Sender:TObject);
    procedure bsfbRetirerClick(Sender:TObject);
    procedure mVisualiseActeClick(Sender:TObject);
    procedure cxGridTableMediasCellDblClick(Sender:TObject;
      ACellViewInfo:Longint;AButton:TMouseButton;
      AShift:TShiftState;var AHandled:Boolean);
    procedure mRemplacerDocumentClick(Sender:TObject);
    procedure DSMediasStateChange(Sender:TObject);
    procedure cxGridTemoinsExit(Sender:TObject);
    procedure edCommentairesKeyPress(Sender:TObject;var Key:Char);
    procedure cxGridTableMediasEditKeyDown(Sender:TObject;
      AItem:Longint;AEdit:TCustomMaskEdit;var Key:Word;
      Shift:TShiftState);
    procedure cxGridTableMediasEditKeyPress(Sender:TObject;
      AItem:Longint;AEdit:TCustomMaskEdit;var Key:Char);
    procedure edCommentairesMouseEnter(Sender:TObject);
    procedure cxGridTableTemoinsInitEdit(Sender:TObject;
      AItem:Longint;AEdit:TCustomMaskEdit);
    procedure IBTemoinsMediasBeforeClose(DataSet:TDataSet);
    procedure cxComboBoxActeExit(Sender:TObject);
    procedure edCommentairesPropertiesEditValueChanged(Sender: TObject);
    procedure colMemoPropertiesEditValueChanged(Sender: TObject);
    procedure mAcquerirClick(Sender: TObject);
    procedure pmGooglePopup(Sender: TObject);
    procedure InfoCopie(Sender: TObject);
    procedure EffaceBarreEtat(Sender: TObject);

  private
    bFinish:boolean;
    REF_EVE_LIB_LONG,
    pNomConjoint:string;
    s_cp_entree,s_insee_entree:string;
    ev_cp_modifie:integer;
    cp_modifie,insee_modifie:boolean;
    OkEvent,OkModif:boolean;
    aFIndividuIdentite:TForm;
    BloqueCar:boolean;
    GFormIndividu : TSuperForm;
    bPremOuverture:boolean;
    clef_ev:integer;

    procedure InitCoordCity;
    procedure p_AfterDownloadCoord;
    procedure doTestCoherence;
    procedure AjouteTemoin( const Temoin,Sexe:integer;NomPrenom,Naissance,Deces:string);
  protected
    procedure ControlKeyDown(var Key:Word;
      Shift:TShiftState); override;
    procedure DoShow; override;
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoHide; override;
 public
    constructor Create ( AOwner : TComponent ); override;
    destructor  Destroy; override;
    procedure Resize; override;
    procedure DoShowFirstTime; override;
    procedure Deactivate; override;
    procedure DoRefreshControls; override;
    property NomConjoint:string read pNomConjoint write pNomConjoint;

  end;

implementation

uses  u_dm,
      u_form_individu,u_form_individu_repertoire,
      u_common_functions,u_common_ancestro,
      LazUTF8,
      u_common_const,
      u_common_resources,
      u_form_biblio_Sources,
      u_form_main,
      fonctions_ibx,
      fonctions_system,
      u_genealogy_context,
      u_common_ancestro_functions,
      fonctions_dialogs,
      fonctions_db,
      fonctions_string,
      u_form_individu_identite;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}
const
  _onglet_notes=0;
  _onglet_sources=1;
  _onglet_temoins=2;
  _onglet_medias=3;


constructor TFIndividuEditEventLife.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  aFIndividuIdentite:=TForm(AOwner);
  GFormIndividu:=Aowner.owner as TSuperForm;
  DataSourceEve.DataSet:=TFIndividuIdentite(aFIndividuIdentite).IBQEve;
  TFIndividu(AOwner.Owner).SetPaysVilles(DSCountries,DsCities);

  btnVillesFavoris.Hint:=rs_Hint_Opens_favorite_sites_window_Ctrl_F_From_City_or_division_fields;

  Color:=gci_context.ColorLight;
  Panel3.Color:=gci_context.ColorDark;
  bsfbAjout.Color:=gci_context.ColorLight;
  bsfbRetirer.Color:=gci_context.ColorLight;
  fbInfosVilles.Color:=gci_context.ColorLight;
  btnVillesFavoris.Color:=gci_context.ColorLight;
  bsfbAjout.ColorFrameFocus:=gci_context.ColorLight;
  bsfbRetirer.ColorFrameFocus:=gci_context.ColorLight;
  fbInfosVilles.ColorFrameFocus:=gci_context.ColorLight;
  btnVillesFavoris.ColorFrameFocus:=gci_context.ColorLight;
  DBText1.Font.Color:=gci_context.ColorTexteOnglets;
  PanLieu.Cursor:=_CURPOPUP;
  PanLieu.Color:=gci_context.ColorLight;
//  btnSuivant.ColorBorder:=btnSuivant.Color;
//  btnPrecedent.ColorBorder:=btnPrecedent.Color;

  bFinish:=True;

  dbcbDivers.Items.Assign(dm.ListeDiversInd);

  btnInternet.PopupMenu:=FMain.pmLieuInternet;
  btnVillesVoisines.PopupMenu:=FMain.pmVillesVoisines;
  bPremOuverture:=false;
  BloqueCar:=false;
  clef_ev:=0;
  cxGridTemoins.Hint:=rs_Hint_You_can_add_a_wittness_by_drag_drop;
end;

destructor TFIndividuEditEventLife.Destroy;
begin
  inherited Destroy;
  (aFIndividuIdentite as TFIndividuIdentite ).aFIndividuEditEventLife := nil;
end;

procedure TFIndividuEditEventLife.edDateChanged(Sender: TObject);
var s : String ;
begin
  if edDate.Font.Style <> [fsBold] then
   with aFIndividuIdentite as TFIndividuIdentite do
    begin
      if IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString='BIRT' then
        DBTextAge.Caption:=''
      else
      begin
        s:=Age_Texte(TFIndividu(GFormIndividu).sDateNaissance,edDate.Text);
        if s='' then
          DBTextAge.Caption:=''
        else if s[1]in ['a','e','i','o','u','y'] then
          DBTextAge.Caption:=fs_RemplaceMsg(rs_oldd,[s])
        else
          DBTextAge.Caption:=fs_RemplaceMsg(rs_olded,[s]);
      end;
    end
    else
    begin
      DBTextAge.Caption:='';
    end;
end;

procedure TFIndividuEditEventLife.dxDBImageEdit1PictureChanged(Sender: TObject);
begin
  with DBText1 do
  case dxDBImageEdit1.ImageIndex of
    0 : Text := rs_Cat_Event;
    1 : Text := rs_Cat_Death;
    2 : Text := rs_Cat_Birth;
    3 : Text := rs_Cat_Job;
    4 : Text := rs_Cat_DSCR;
    5 : Text := rs_Cat_EDUC;
    6 : Text := rs_Cat_EMIG;
    7 : Text := rs_Cat_GRAD;
    8 : Text := rs_Cat_IDNO;
    9 : Text := rs_Cat_IMMI;
    10: Text := rs_Cat_NATI;
    11: Text := rs_Cat_Naturalisation;
    12: Text := rs_Cat_PROP;
    13: Text := rs_Cat_Religion;
    14: Text := rs_Cat_SSN;
    15: Text := rs_Cat_Title;
  end;
end;

procedure TFIndividuEditEventLife.btnVillesVoisinesContextPopup(
  Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
  InitCoordCity;
end;

procedure TFIndividuEditEventLife.btnWebClick(Sender: TObject);
begin
  if edSite.Text > ''
   Then
    Begin
      p_OpenFileOrDirectory(edSite.Text);
      btnWeb.Enabled:=False;
    end;
end;

procedure TFIndividuEditEventLife.btnMailClick(Sender: TObject);
var ls_mail : String;
begin
  if edMail.Text > ''
   Then
    Begin
      if ( FMain.PrenomIndi > '' )
      or ( FMain.NomIndi    > '' )
       Then ls_mail := fs_RemplaceEspace('?to='+FMain.PrenomIndi+ ' ' + FMain.NomIndi+'<' + edMail.Text + '>&body='+fs_RemplaceMsg(rs_Hello,[FMain.PrenomIndi]),'%20')
       Else ls_mail := edMail.Text;
      p_OpenFileOrDirectory('mailto:'+ls_mail);
      btnMail.Enabled:=False;
    end;
end;


procedure TFIndividuEditEventLife.cxGridTemoinsDragDrop(Sender,
  Source: TObject; X, Y: Integer);
begin
  try
    AjouteTemoin(FMain.IndiDrag.cle,FMain.IndiDrag.sexe,FMain.IndiDrag.nomprenom
      ,FMain.IndiDrag.naissance,FMain.IndiDrag.deces);
  finally
    Abort;
  end;
end;

procedure TFIndividuEditEventLife.cxGridTemoinsDragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if TFIndividu(GFormIndividu).DialogMode
    or not bsfbAjout.Visible
    or not bsfbAjout.Enabled then
    Accept:=False
  else
    Accept:=True;

end;

procedure TFIndividuEditEventLife.edDateChangeLabel(const DateControl: TExtDBDateEdit;
  const IsBlank: Boolean);
var s : String ;
begin
  if IsBlank
   then
      DBTextAge.Caption:=''
   Else
   with aFIndividuIdentite as TFIndividuIdentite do
    begin
      if IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString='BIRT' then
        DBTextAge.Caption:=''
      else
      begin
        s:=Age_Texte(TFIndividu(GFormIndividu).sDateNaissance,edDate.Text);
        if s='' then
          DBTextAge.Caption:=''
        else if s[1]in ['a','e','i','o','u','y'] then
          DBTextAge.Caption:=fs_RemplaceMsg(rs_oldd,[s])
        else
          DBTextAge.Caption:=fs_RemplaceMsg(rs_olded,[s]);
      end;
    end;

end;

procedure TFIndividuEditEventLife.edMailChange(Sender: TObject);
begin
  btnMail.Enabled:=True;
end;

procedure TFIndividuEditEventLife.edSiteChange(Sender: TObject);
begin
  btnWeb.Enabled:=True;
end;

procedure TFIndividuEditEventLife.edVilleLocate(Sender: TObject);
begin
  with DsCities.DataSet do
   Begin
    edCP.Text := FieldByName('CODE').AsString;
    edDept.Text := FieldByName('DEPARTEMENT').AsString;
    edPays.Text := FieldByName('PAYS').AsString;
    edRegion.Text := FieldByName('REGION').AsString;
    edInsee.Text := FieldByName('INSEE').AsString;
    edLatitude.Text := FieldByName('LATITUDE').AsString;
    edLongitude.Text := FieldByName('LONGITUDE').AsString;
   End;
end;

procedure TFIndividuEditEventLife.edVilleSet(Sender: TObject);
var
    typeeve:string;
begin
  edVilleLocate(Sender);
  with aFIndividuIdentite as TFIndividuIdentite do
   begin
    typeeve:=IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString;
    if typeeve='BIRT' then
    begin
      TFIndividu(GFormIndividu).sVilleNaissance:=edVille.Text;
      RefreshTitle;
    end
    else if typeeve='DEAT' then
    begin
      TFIndividu(GFormIndividu).sVilleDeces:=edVille.Text;
      RefreshTitle;
    end;
   end;
end;


procedure TFIndividuEditEventLife.edDateChange(Sender:TObject);
begin
  with aFIndividuIdentite as TFIndividuIdentite do
  if IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString='BIRT' then
    DBTextAge.Visible:=False;
end;


procedure TFIndividuEditEventLife.fbInfosVillesClick(Sender:TObject);
var
  Pays,Region,Dept,Code,Insee,Ville,Subd:string;Lat,Long:double;
  typeve:string;
  Numpays:Integer;
begin
  with DSCountries do
    if Assigned(DataSet)
    and DataSet.Active
     Then Numpays:=DataSet.FieldByName('RPA_CODE').AsInteger
     Else Numpays:=-1;
  if FMain.ChercheVille(self,Numpays,edPays.Text,edVille.Text,
    Pays,Region,Dept,Code,Insee,Ville,Subd,Lat,Long) then
  with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
  begin
    AutoCalcFields:=False;
    try
      p_DatasetEditIfNotEdited(IBQEve);
      fieldbyname ( IBQ_EV_IND_PAYS ).asString:=Pays;
      fieldbyname ( IBQ_EV_IND_REGION ).asString:=Region;
      fieldbyname ( IBQ_EV_IND_DEPT ).asString:=Dept;
      fieldbyname ( IBQ_EV_IND_CP ).asString:=Code;
      fieldbyname ( IBQ_EV_IND_INSEE ).asString:=Insee;
      fieldbyname ( IBQ_EV_IND_VILLE ).asString:=Ville;
      fieldbyname ( IBQ_EV_IND_SUBD ).asString:=Subd;
      fieldbyname ( IBQ_EV_IND_LATITUDE ).Value:=Lat;
    finally
      AutoCalcFields:=True;
    end;
    fieldbyname ( IBQ_EV_IND_LONGITUDE ).Value:=Long;
    typeve:=fieldbyname ( IBQ_EV_IND_TYPE ).AsString;
    if typeve='BIRT' then
    begin
      TFIndividu(GFormIndividu).sVilleNaissance:=Ville;
      RefreshTitle;
    end
    else if typeve='DEAT' then
    begin
      TFIndividu(GFormIndividu).sVilleDeces:=Ville;
      RefreshTitle;
    end;
    edSubdi.SetFocus;
  end;
end;

procedure TFIndividuEditEventLife.DoRefreshControls;
var
  OkOCCU:boolean;
begin
  bFinish:=False;
  try
    if Visible and (DataSourceEve.DataSet<>nil) Then
    with DataSourceEve,DataSet do
    begin
      OkEvent:=(TFIndividu(GFormIndividu).CleFiche<>-1) and(Active)and(not IsEmpty);
    OkModif:=OkEvent and(TFIndividu(GFormIndividu).DialogMode=false);
    OkOCCU:=OkModif and(FieldByName(IBQ_EV_IND_TYPE).AsString='OCCU');
    edDate.enabled:=OkEvent;
    pmDate.AutoPopup:=OkModif;
    edCP.enabled:=OkEvent;
    edVille.enabled:=OkEvent;
    fbInfosVilles.enabled:=OkModif;
    btnVillesFavoris.enabled:=OkModif;
    edDept.enabled:=OkEvent;
    edPays.enabled:=OkEvent;
    edRegion.enabled:=OkEvent;
    edInsee.enabled:=OkEvent;
    edSubdi.enabled:=OkEvent;
    edDesc.enabled:=OkEvent;
    edSources.enabled:=OkEvent;
    edCommentaires.enabled:=OkEvent;
    edLongitude.enabled:=OkEvent;
    edLatitude.enabled:=OkEvent;
    edHeure.enabled:=OkEvent;
    edCause.enabled:=OkEvent;
    dbcbDivers.Enabled:=OkEvent;
    AutoEdit:=OkModif;
    DSTemoins.AutoEdit:=OkModif;
    DSMedias.AutoEdit:=OkModif;
    pmVideLieu.AutoPopup:=OkModif;

    btnPrecedent.Enabled:=RecNo>1;
    btnSuivant.Enabled:=not(RecNo>RecordCount-1);
    dbcbDivers.Visible:=FieldByName(IBQ_EV_IND_TYPE).AsString='EVEN';
    DBText1.Visible:=not dbcbDivers.Visible;

    IBTemoins.Close;
    IBMedias.Close;
    IBTemoins.Open;
    IBMedias.Open;
    PageControlChange(nil);//met à jour le PageControl

      if OkOCCU then
      with IBJobs do
      begin
        try
          Close;
          Params[0].AsInteger:=dm.NumDossier;
          Open;
        finally
        end;
      end
      else if OkModif and(FieldByName(IBQ_EV_IND_TYPE).AsString='EVEN') then
      begin
        dbcbDivers.Items.assign(dm.ListeDiversInd);
      end;
      { Matthieu ?
      for i:=0 to edPays.Properties.Buttons.Count-1 do
        edPays.Properties.Buttons.Items[i].Visible:=OkModif;
      for i:=0 to edVille.Properties.Buttons.Count-1 do
        edVille.Properties.Buttons.Items[i].Visible:=OkModif;
      for i:=0 to cxComboBoxActe.Properties.Buttons.Count-1 do
        cxComboBoxActe.Properties.Buttons.Items[i].Visible:=OkModif;
      for i:=0 to dbcbDivers.Properties.Buttons.Count-1 do
        dbcbDivers.Properties.Buttons.Items[i].Visible:=OkModif;
      for i:=0 to edDesc.Properties.Buttons.Count-1 do
        edDesc.Properties.Buttons.Items[i].Visible:=OkOCCU;
                  }
      cxComboBoxActe.ReadOnly:=not OkModif;
      cxComboBoxActe.Visible:=OkEvent;
//      newlistevilles; //fait à l'entrée dans le champ Ville
      case FieldByName(IBQ_EV_IND_ACTE).AsInteger of
        1:cxComboBoxActe.Text:=rs_Act_Found;
        -1:cxComboBoxActe.Text:=rs_Act_demanded;
        -2:cxComboBoxActe.Text:=rs_Act_ToSearch;
        -3:cxComboBoxActe.Text:=rs_Act_ToIgnore;
        else
          cxComboBoxActe.Text:=rs_Act_Not_In;
      end;
      clef_ev:=(aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_clef ).AsInteger;//pour éviter de rafraîchir 2 fois
    end;
  finally
    bFinish:=True;
  end;
end;

procedure TFIndividuEditEventLife.AjouteTemoin( const Temoin,Sexe:integer;NomPrenom,Naissance,Deces:string);
var
  suite:boolean;
begin
  p_DatasetPostIfEdited(IBTemoins);
  IBTemoins.DisableControls;
  try
    suite:=True;
    IBTemoins.First;
    while not IBTemoins.Eof do
    begin
      if IBTemoinsASSOC_KLE_ASSOCIE.AsInteger=Temoin then
      begin
        suite:=False;
        Break;
      end;
      IBTemoins.Next;
    end;
    if suite then
     with aFIndividuIdentite as TFIndividuIdentite do
    begin
      IBTemoins.Append;
      IBTemoinsASSOC_KLE_DOSSIER.AsInteger:=dm.NumDossier;
      IBTemoinsASSOC_TABLE.AsString:='I';
      IBTemoinsASSOC_EVENEMENT.AsInteger:=IBQEve.fieldbyname ( IBQ_EV_IND_CLEF ).AsInteger;
      IBTemoinsASSOC_KLE_IND.AsInteger:=TFIndividu(GFormIndividu).CleFiche;
      IBTemoinsASSOC_KLE_ASSOCIE.AsInteger:=Temoin;
      IBTemoinsASSOC_LIBELLE.AsString:=dm.AssociationDefaut;
      IBTemoinsNOM.AsString:=NomPrenom;
      IBTemoinsSEXE.AsInteger:=Sexe;
      if _GDate.DecodeHumanDate(Naissance) then
        if _GDate.UseDate1 then
          IBTemoinsANNEE_NAISSANCE.AsInteger:=_GDate.Year1;
      if _GDate.DecodeHumanDate(Deces) then
        if _GDate.UseDate1 then
          IBTemoinsANNEE_DECES.AsInteger:=_GDate.Year1;

      IBTemoins.Post;
      TFIndividu(GFormIndividu).doBouton(true);
      PageControlChange(nil);
      cxGridTemoins.SetFocus;
    end;
  finally
    IBTemoins.EnableControls;
  end;
end;

procedure TFIndividuEditEventLife.bsfbAjoutClick(Sender:TObject);
var
  lettre,TypeEven:string;
  q:TIBSQL;
  aFIndividuRepertoire:TFIndividuRepertoire;
  i_clef:integer;

  procedure ValDefaut;
  begin
    i_clef:=TFIndividu(GFormIndividu).CleFiche;
    aFIndividuRepertoire.NomIndi:=TFIndividu(GFormIndividu).QueryIndividuNOM.AsString;
  end;
begin
  if bsfbAjout.Visible and bsfbAjout.Enabled then
  begin
    if PageControl.ActivePageIndex=_onglet_temoins then
    begin
      TFIndividu(GFormIndividu).PostIndividu;//mise à jour au cas où le nom aurait été modifié
      //Création de la boite de recherche d'un individu par le prénom
      aFIndividuRepertoire:=TFIndividuRepertoire.create(self);
      try
        CentreLaFiche(aFIndividuRepertoire,FMain);
        if TFIndividu(GFormIndividu).QueryIndividuSEXE.AsInteger=2 then
        begin
          TypeEven:=(aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString;
          if (TypeEven='DEAT')or(TypeEven='CREM')or(TypeEven='BURI') then
          begin
            q:=TIBSQL.Create(self);
            q.Database:=dm.ibd_BASE;
            q.Transaction:=dm.IBT_BASE;
            q.SQL.Add('select first(1) p.conjoint, c.nom'
              +' from proc_conjoints_ordonnes(:clef,0) p'
              +' inner join individu c on c.cle_fiche=p.conjoint order by p.ordre desc');
            q.Params[0].AsInteger:=TFIndividu(GFormIndividu).CleFiche;
            q.ExecQuery;
            if q.Eof then
              ValDefaut
            else
            begin
              i_clef:=q.Fields[0].AsInteger;
              aFIndividuRepertoire.NomIndi:=q.Fields[1].AsString;
            end;
            q.Close;
            q.Free;
          end
          else
            ValDefaut;
        end
        else
          ValDefaut;

        lettre:=copy(fs_FormatText(aFIndividuRepertoire.NomIndi,mftUpper,True),1,1);
        aFIndividuRepertoire.InitIndividuPrenom(lettre,'INDEX',0,i_clef,False,True);
        aFIndividuRepertoire.Caption:=rs_caption_Select_Witness;
        if aFIndividuRepertoire.ShowModal=mrOk then
        begin
          AjouteTemoin(aFIndividuRepertoire.ClefIndividuSelected,aFIndividuRepertoire.SexeIndividuSelected
            ,aFIndividuRepertoire.NomPrenomIndividuSelected,aFIndividuRepertoire.NaissanceIndividuSelected
            ,aFIndividuRepertoire.DecesIndividuSelected);
        end;
      finally
        FreeAndNil(aFIndividuRepertoire);
      end;
    end
    else //_onglet_medias
    begin
      i_clef:=FMain.OuvreBiblioMedias(True,(aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_CLEF ).AsInteger,'I','A');
      if i_clef>0 then
      begin
        IBMedias.Close;
        IBMedias.Open;
        TFIndividu(GFormIndividu).doBouton(true);
        if IBMedias.RecordCount=1 then //c'est le premier
        begin
          p_DatasetEditIfNotEdited(DataSourceEve.DataSet);
          (aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_media ).AsInteger:=i_clef;
        end;
        PageControlChange(nil);
      end;

    end;
  end;
end;

procedure TFIndividuEditEventLife.DataSourceEveStateChange(Sender:TObject);
begin
  if (DataSourceEve.DataSet.State in [dsEdit,dsInsert]) then
    TFIndividu(GFormIndividu).doBouton(true);
end;

procedure TFIndividuEditEventLife.btnVillesFavorisClick(Sender:TObject);
var
  Pays,Region,Dept,Code,Insee,Ville,Subd:string;Lat,Long:double;
  typeve:string;
  Numpays:Integer;
begin
  with DSCountries do
    if Assigned(DataSet)
    and DataSet.Active
     Then Numpays:=DataSet.FieldByName('RPA_CODE').AsInteger
     Else Numpays:=-1;
  if FMain.ChercheLieuFavori(self,Numpays,edPays.Text,edVille.Text,edSubdi.Text,
    Pays,Region,Dept,Code,Insee,Ville,Subd,Lat,Long) then
  with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
  begin
    AutoCalcFields:=False;
    with IBQEve do
    try
      p_DatasetEditIfNotEdited(IBQEve);
      fieldbyname ( IBQ_EV_IND_PAYS ).asString:=Pays;
      fieldbyname ( IBQ_EV_IND_REGION ).asString:=Region;
      fieldbyname ( IBQ_EV_IND_DEPT ).asString:=Dept;
      fieldbyname ( IBQ_EV_IND_CP ).asString:=Code;
      fieldbyname ( IBQ_EV_IND_INSEE ).asString:=Insee;
      fieldbyname ( IBQ_EV_IND_VILLE ).asString:=Ville;
      fieldbyname ( IBQ_EV_IND_SUBD ).asString:=Subd;
      fieldbyname ( IBQ_EV_IND_LATITUDE ).value:=Lat;
      fieldbyname ( IBQ_EV_IND_LONGITUDE ).value:=Long;
    finally
      AutoCalcFields:=True;
    end;

    typeve:=FieldByName(IBQ_EV_IND_TYPE).AsString;
    if typeve='BIRT' then
    begin
      TFIndividu(GFormIndividu).sVilleNaissance:=Ville;
      TFIndividuIdentite(aFIndividuIdentite).RefreshTitle;
    end
    else if typeve='DEAT' then
    begin
      TFIndividu(GFormIndividu).sVilleDeces:=Ville;
      TFIndividuIdentite(aFIndividuIdentite).RefreshTitle;
    end;
    edSubdi.SetFocus;
  end;
end;

procedure TFIndividuEditEventLife.doTestCoherence;
var
  s,t:string;
begin
  with DataSourceEve.DataSet,TFIndividu(GFormIndividu) do
   Begin
    if IsEmpty Then Exit;
    s:=FieldByName(IBQ_EV_IND_DATE_WRITEN).AsString;
    t:=FieldByName(IBQ_EV_IND_TYPE).AsString;
    if t='BIRT' then
      CoherenceDate.Naissance.SetDateWriten(s)
    else if t='DEAT' then
      CoherenceDate.Deces.SetDateWriten(s)
    else
      CoherenceDate.AddInfoDateWriten(
        s,
        t,
        (aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_CLEF ).AsInteger,
        CoherenceDate.AutresEventInd
        );
    CoherenceDate.Test;
end;
end;

procedure TFIndividuEditEventLife.DoHide;
begin
  inherited;
  doTestCoherence;
end;

procedure TFIndividuEditEventLife.ControlKeyDown(
  var Key:Word;Shift:TShiftState);
begin
  if Key=_KEY_HELP then
    p_ShowHelp(_HELP_INDI_IDENTITE);
  inherited;
end;

procedure TFIndividuEditEventLife.DoShow;
begin
  inherited;
  doRefreshControls;
end;

procedure TFIndividuEditEventLife.fbChangeDate(Sender:TObject);
var
  typeve:string;
begin
  with aFIndividuIdentite as TFIndividuIdentite do
   Begin
    typeve:=IBQEve.fieldbyname ( IBQ_EV_IND_TYPE ).AsString;
    if typeve='BIRT' then
      begin
        TFIndividu(GFormIndividu).sDateNaissance:=IBQEve.fieldbyname ( IBQ_EV_IND_DATE_WRITEN ).AsString;
        RefreshTitle;
      end
      else if typeve='DEAT' then
      begin
        TFIndividu(GFormIndividu).sDateDeces:=IBQEve.fieldbyname ( IBQ_EV_IND_DATE_WRITEN ).AsString;
        RefreshTitle;
      end;
   end;
end;

procedure TFIndividuEditEventLife.mImprimeActeClick(Sender:TObject);
var
  iClef:Integer;
begin
  iClef:=IBMedias.FieldByName('mp_media').AsInteger;
  if iClef>0 then
    ImprimeImage(iClef,'')
  else
    MyMessageDlg(rs_Error_None_picture_for_this_document,mmtError, [mmbOk],Self);
end;

procedure TFIndividuEditEventLife.btnSuivantClick(Sender:TObject);
begin
  DataSourceEve.DataSet.Next;
end;

procedure TFIndividuEditEventLife.btnPrecedentClick(Sender:TObject);
begin
  DataSourceEve.DataSet.Prior;
end;

procedure TFIndividuEditEventLife.btnDetailClick(Sender:TObject);
var
  aFBiblio_Sources:TFBiblio_Sources;
  details:integer;
begin
  PageControl.ActivePageIndex:=_onglet_sources;
  p_DatasourcePostIfEdited(DataSourceEve);

  aFBiblio_Sources:=TFBiblio_Sources.create(self);
  with DataSourceEve.DataSet do
  try
    CentreLaFiche(aFBiblio_Sources,FMain);
    aFBiblio_Sources.FormIndividu:=TFIndividu(GFormIndividu);
    aFBiblio_Sources.Caption:=fs_RemplaceMsg(rs_Caption_Event_s_sources,[FieldByName('_LIBELLE').AsString]);
    aFBiblio_Sources.doOpenQuerys(FieldByName(IBQ_EV_IND_CLEF).AsInteger,'I');
    if aFBiblio_Sources.ShowModal=mrOk then
    begin
      if dm.IBQSources_Record.State in [dsEdit,dsInsert] then
      begin
        Edit;
        FieldByName(IBQ_EV_IND_SOURCE).AsString:=aFBiblio_Sources.sText;
        dm.IBQSources_Record.Post;
      end;
      p_DatasetPostIfEdited(aFBiblio_Sources.IBMultimedia);
    end
    else
    begin
     p_DatasetCancelUpdatesIfEdited(dm.IBQSources_Record);
     p_DatasetCancelUpdatesIfEdited(aFBiblio_Sources.IBMultimedia);
    end;
    if aFBiblio_Sources.Modif=True then
    begin
      TFIndividu(GFormIndividu).doBouton(true);
      if not aFBiblio_Sources.IBMultimedia.IsEmpty
        or(length(aFBiblio_Sources.dxDBMemo2.Text)>0)
        or(length(aFBiblio_Sources.dxDBMemo3.Text)>0)
        or(length(aFBiblio_Sources.dxDBMemo4.Text)>0)
        or(length(aFBiblio_Sources.dxDBMemo5.Text)>0)
        or(length(aFBiblio_Sources.dxDBEdit3.Text)>0) then
        details:=1
      else
        details:=0;
      if FieldByName(IBQ_EV_IND_DETAILS).AsInteger<>details then
      begin
        Edit;
        FieldByName(IBQ_EV_IND_DETAILS).AsInteger:=details;
        PageControlChange(nil);
      end;
    end;
  finally
    FreeAndNil(aFBiblio_Sources);
  end;
end;

procedure TFIndividuEditEventLife.dbcbDiversEnter(Sender:TObject);
begin
  dbcbDivers.MaxLength:=89-Length(edDesc.Text);
  if dbcbDivers.MaxLength>25 then
    dbcbDivers.MaxLength:=25;
  if dbcbDivers.MaxLength<=0 then
  begin
    dbcbDivers.MaxLength := 0;
    dbcbDivers.Enabled:=false;
    edDesc.SetFocus;
  end
  else
    dbcbDivers.Enabled:=true;
  Label17.Visible:=True;
end;

procedure TFIndividuEditEventLife.edDescEnter(Sender:TObject);
begin
  with DataSourceEve.DataSet do
  if (dbcbDivers.Text=REF_EVE_LIB_LONG)or
    (length(dbcbDivers.text)=0)or
    (FieldByName(IBQ_EV_IND_TYPE).asString<>'EVEN')
   then edDesc.MaxLength:=90
   else edDesc.MaxLength:=89-Length(dbcbDivers.Text);
  Label17.Visible:=edDesc.MaxLength<90;
end;

procedure TFIndividuEditEventLife.edDescChange(Sender:TObject);
begin
  if (edDesc.MaxLength=90) or not (DataSourceEve.DataSet.State in [dsInsert,dsEdit]) then
    exit;
  Label17.Caption:=fs_RemplaceMsg(rs_Caption_Describe_you_can_press_arg_chars,[IntTostr(edDesc.MaxLength-Length(edDesc.Text))]);
end;

procedure TFIndividuEditEventLife.edDescExit(Sender:TObject);
begin
  Label17.Visible:=False;
  Label17.Caption:='';
end;

procedure TFIndividuEditEventLife.dbcbDiversExit(Sender:TObject);
begin
  Label17.Caption:='';
  Label17.Visible:=False;
end;

procedure TFIndividuEditEventLife.dbcbDiversChange(Sender:TObject);
begin
  Label17.Caption:=fs_RemplaceMsg(rs_Caption_Describe_you_can_press_arg_chars,[IntTostr(dbcbDivers.MaxLength-Length(dbcbDivers.Text))]);
end;

procedure TFIndividuEditEventLife.pmImagePopup(Sender:TObject);
var
  iClef:integer;
begin
  iClef:=IBMedias.FieldByName('mp_media').AsInteger;
  mImprimeActe.Visible:=(iClef>0)and(IBMedias.FieldByName('multi_image_rtf').AsInteger=0);
  mVisualiseActe.Visible:=iClef>0;
end;

procedure TFIndividuEditEventLife.DataSourceEveDataChange(Sender:TObject;
  Field:TField);
begin
  ev_cp_modifie:=0;
  cp_modifie:=false;
  insee_modifie:=false;
  btnVillesVoisines.enabled:=(length(trim(edLatitude.Text))>0)and(length(trim(edLongitude.Text))>0);
  btnInternet.Enabled:=not((length(trim(edVille.Text))=0)
            and(not fCassiniDll or(UTF8UpperCase(edPays.Text)<>'FRANCE'))
            and(not btnVillesVoisines.enabled));
  with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
  if not fieldbyname ( IBQ_EV_IND_clef ).IsNull
    and (fieldbyname ( IBQ_EV_IND_clef ).AsInteger<>clef_ev)
    and (fieldbyname ( IBQ_EV_IND_clef ).AsInteger > 0 ) then
  begin
    Self.DoRefreshControls;
  end;
end;

procedure TFIndividuEditEventLife.edCPEnter(Sender:TObject);
begin
  s_cp_entree:=edCP.Text;
end;

procedure TFIndividuEditEventLife.edCPExit(Sender:TObject);
begin
  if edCP.Text<>s_cp_entree then
  begin
    ev_cp_modifie:=(aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_clef ).AsInteger;
    cp_modifie:=true;
    edVille.SetFocus;
  end;
end;

procedure TFIndividuEditEventLife.edInseeEnter(Sender:TObject);
begin
  s_insee_entree:=edInsee.Text;
end;

procedure TFIndividuEditEventLife.edInseeExit(Sender:TObject);
begin
  if edInsee.Text<>s_insee_entree then
  begin
    ev_cp_modifie:=(aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_clef ).AsInteger;
    insee_modifie:=true;
    edVille.SetFocus;
  end;
end;

procedure TFIndividuEditEventLife.cxComboBoxActePropertiesEditValueChanged(
  Sender:TObject);
begin
  if not bFinish then exit;

  with DataSourceEve,DataSet do
   Begin
    p_DatasetEditIfNotEdited(DataSet);

    if cxComboBoxActe.Text=rs_Act_Found then
      FieldByName(IBQ_EV_IND_ACTE).AsInteger:=1
    else if cxComboBoxActe.Text=rs_Act_demanded then
      FieldByName(IBQ_EV_IND_ACTE).AsInteger:=-1
    else if cxComboBoxActe.Text=rs_Act_ToSearch then
      FieldByName(IBQ_EV_IND_ACTE).AsInteger:=-2
    else if cxComboBoxActe.Text=rs_Act_ToIgnore then
      FieldByName(IBQ_EV_IND_ACTE).AsInteger:=-3
    else
      FieldByName(IBQ_EV_IND_ACTE).AsInteger:=0;
  End;
end;

procedure TFIndividuEditEventLife.DoShowFirstTime;
var
  DecalX,DecalY:integer;
  FormProp:TForm;
begin
  Height:=gci_context.HautEven;
  if TFIndividu(GFormIndividu).DialogMode then
    FormProp:=GFormIndividu
  else
    FormProp:=FMain;
  DecalX:=(FormProp.Width-Width)div 2;
  DecalY:=((FormProp.Height-Height)div 2)+25;
  CentreLaFiche(self,FormProp,DecalX,DecalY);
  Caption:=rs_Caption_Details_of_event;
  PageControl.ActivePageIndex:=_onglet_notes;
  bPremOuverture:=true;
end;


procedure TFIndividuEditEventLife.edVilleMouseEnter(Sender:TObject);
begin
  dxStatusBar.Panels[0].Text:='le raccourci Ctrl+F dans Ville ou Subdivision présélectionne un lieu favori';
end;

procedure TFIndividuEditEventLife.edVilleMouseLeave(Sender:TObject);
begin
  dxStatusBar.Panels[0].Text:='';
end;

procedure TFIndividuEditEventLife.mSupprimerheureClick(Sender:TObject);
begin
  with (aFIndividuIdentite as TFIndividuIdentite).IBQEve do
   Begin
    Edit;
    fieldbyname ( IBQ_EV_IND_heure ).Clear;
   end;
end;
procedure TFIndividuEditEventLife.InitCoordCity;
Begin
  FMain.Lieu_Pays:=edPays.Text;
  FMain.Lieu_Region:=edRegion.Text;
  FMain.Lieu_CP:=edCP.Text;
  FMain.Lieu_Ville:=edVille.Text;
  FMain.Lieu_Latitude:=edLatitude.Text;
  FMain.Lieu_Longitude:=edLongitude.Text;
  FMain.Lieu_Subdivision:=edSubdi.Text;

end;

procedure TFIndividuEditEventLife.btnInternetPopupMenuPopup(
  Sender:TObject;var APopupMenu:TPopupMenu;var AHandled:Boolean);
begin
  InitCoordCity;
end;


procedure TFIndividuEditEventLife.PageControlDrawTabEx(
  AControl:TCustomTabControl;ATab:TTabSheet;Font:TFont);
begin
  Font.Color:=gci_context.ColorTexteOnglets;
  if TPageControl(AControl).ActivePageIndex=ATab.PageIndex then
    ATab.Color:=gci_context.ColorLight
  else
    ATab.Color:=gci_context.ColorDark;
end;

procedure TFIndividuEditEventLife.PageControlChange(Sender:TObject);
var
  k:integer;
begin
  k:=PageControl.ActivePageIndex;
  btnDetail.Visible:=(k=_onglet_sources)
    and((TFIndividu(GFormIndividu).DialogMode=false)or((aFIndividuIdentite as TFIndividuIdentite).IBQEve.fieldbyname ( IBQ_EV_IND_DETAILS ).AsInteger=1))
    and not DataSourceEve.DataSet.IsEmpty;//1
  bsfbAjout.Visible:=((k=_onglet_temoins)or(k=_onglet_medias))
    and(TFIndividu(GFormIndividu).DialogMode=false);
  bsfbRetirer.Visible:=bsfbAjout.Visible;
  bsfbAjout.Enabled:=not DataSourceEve.DataSet.IsEmpty;
  if k=_onglet_temoins then
  begin
    bsfbRetirer.Enabled:=not IBTemoins.IsEmpty;
    mAjouterTemoin.Visible:=bsfbAjout.Visible and bsfbAjout.Enabled;
    mEnleverTemoin.Visible:=bsfbRetirer.Visible and bsfbRetirer.Enabled;
    bsfbAjout.Hint:=rs_Hint_Add_a_witness_to_this_event;
    bsfbRetirer.Hint:=rs_Hint_Delete_the_witness_s_link;
  end
  else
  begin
    bsfbRetirer.Enabled:=not IBMedias.IsEmpty;
    mAjouterDocument.Visible:=bsfbAjout.Visible and bsfbAjout.Enabled;
    mEnleverDocument.Visible:=bsfbRetirer.Visible and bsfbRetirer.Enabled;
    mRemplacerDocument.Visible:=mEnleverDocument.Visible;
    cxGridMedias.ShowHint:=mEnleverDocument.Visible;
    bsfbAjout.Hint:=rs_Hint_Add_a_doc_to_this_event;
    bsfbRetirer.Hint:=rs_Hint_Delete_the_doc_s_link;
  end;
  PageControl.ShowHint:=(k=_onglet_temoins) and bsfbAjout.Visible and bsfbAjout.Enabled;

  if DataSourceEve.dataset<>nil then
  with (aFIndividuIdentite as TFIndividuIdentite).IBQEve do
  begin
    if fieldbyname ( IBQ_EV_IND_COMMENT ).AsString>'' then
      PageControl.Pages[_onglet_notes].ImageIndex:=74
    else
      PageControl.Pages[_onglet_notes].ImageIndex:=66;
    if (fieldbyname ( IBQ_EV_IND_DETAILS ).AsInteger=1)
      or(fieldbyname ( IBQ_EV_IND_SOURCE ).AsString>'') then
      PageControl.Pages[_onglet_sources].ImageIndex:=74
    else
      PageControl.Pages[_onglet_sources].ImageIndex:=66;
    if not IBTemoins.IsEmpty then
      PageControl.Pages[_onglet_temoins].ImageIndex:=74
    else
      PageControl.Pages[_onglet_temoins].ImageIndex:=66;
    if not IBMedias.IsEmpty then
      PageControl.Pages[_onglet_medias].ImageIndex:=74
    else
      PageControl.Pages[_onglet_medias].ImageIndex:=66;
  end
  else
  begin
    PageControl.Pages[_onglet_notes].ImageIndex:=66;
    PageControl.Pages[_onglet_sources].ImageIndex:=66;
    PageControl.Pages[_onglet_temoins].ImageIndex:=66;
    PageControl.Pages[_onglet_medias].ImageIndex:=66;
  end;
end;

procedure TFIndividuEditEventLife.edCommentairesKeyDown(Sender:TObject;
  var Key:Word;Shift:TShiftState);
var
  s:string;
  k:integer;
begin
  if not TFIndividu(GFormIndividu).DialogMode then
  begin
    s:=edCommentaires.Text;
    k:=edCommentaires.SelStart;
    if dm.RemplaceRaccourcis(Key,Shift,s,k) then
     with aFIndividuIdentite as TFIndividuIdentite do
      begin
        p_DatasetEditIfNotEdited(IBQEve);
        IBQEve.fieldbyname ( IBQ_EV_IND_COMMENT ).AsString:=s;
        edCommentaires.SelStart:=k;
        BloqueCar:=true;
      end;
  end;
end;

procedure TFIndividuEditEventLife.edSourcesKeyDown(Sender:TObject;
  var Key:Word;Shift:TShiftState);
var
  s:string;
  k:integer;
begin
  if not TFIndividu(GFormIndividu).DialogMode then
  begin
    s:=edSources.Text;
    k:=edSources.SelStart;
    if dm.RemplaceRaccourcis(Key,Shift,s,k) then
     with aFIndividuIdentite as TFIndividuIdentite do
      begin
        p_DatasetEditIfNotEdited(IBQEve);
        IBQEve.fieldbyname ( IBQ_EV_IND_SOURCE ).AsString:=s;
        edSources.SelStart:=k;
        BloqueCar:=true;
      end;
  end;
end;

procedure TFIndividuEditEventLife.edCommentairesDblClick(Sender:TObject);
begin
  ExecuteChaineDansChaine(edCommentaires.Text,edCommentaires.SelStart,edCommentaires.SelLength);
end;

procedure TFIndividuEditEventLife.edSourcesDblClick(Sender:TObject);
begin
  ExecuteChaineDansChaine(edSources.Text,edSources.SelStart,edSources.SelLength);
end;

procedure TFIndividuEditEventLife.PageControlClick(Sender:TObject);
begin
  case PageControl.ActivePageIndex of
    _onglet_notes:SendFocus(edCommentaires);
    _onglet_sources:SendFocus(edSources);
    _onglet_temoins:SendFocus(cxGridTemoins);
    _onglet_medias:SendFocus(cxGridMedias);
  end;
end;

procedure TFIndividuEditEventLife.dxDBImageEdit1Enter(Sender:TObject);
begin
  if edDesc.CanFocus then
    edDesc.SetFocus
  else if edDate.CanFocus then
    edDate.SetFocus;
end;

procedure TFIndividuEditEventLife.mEffacerlelieuClick(Sender:TObject);
begin
  with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
   Begin
    p_DatasetEditIfNotEdited(IBQEve);
    fieldbyname ( IBQ_EV_IND_CP ).Clear;
    fieldbyname ( IBQ_EV_IND_VILLE ).Clear;
    fieldbyname ( IBQ_EV_IND_PAYS ).Clear;
    fieldbyname ( IBQ_EV_IND_DEPT ).Clear;
    fieldbyname ( IBQ_EV_IND_REGION ).Clear;
    fieldbyname ( IBQ_EV_IND_INSEE ).Clear;
    fieldbyname ( IBQ_EV_IND_LATITUDE ).Clear;
    fieldbyname ( IBQ_EV_IND_LONGITUDE ).Clear;
    fieldbyname ( IBQ_EV_IND_SUBD ).Clear;
   end;
end;

procedure TFIndividuEditEventLife.IBTemoinsCalcFields(DataSet:TDataSet);
begin
  IBTemoinsNOM_PRENOM.AsString:=
    AssembleString([IBTemoinsNOM.AsString,IBTemoinsPRENOM.AsString])
  +GetStringNaissanceDeces(IBTemoinsANNEE_NAISSANCE.AsString
    ,IBTemoinsANNEE_DECES.AsString);
end;

procedure TFIndividuEditEventLife.PmChangeFichePopup(Sender:TObject);
begin
  if IBTemoinsASSOC_KLE_ASSOCIE.AsInteger>0 then
    Ouvrirlafiche1.Visible:=true
  else
    Ouvrirlafiche1.Visible:=false;
end;

procedure TFIndividuEditEventLife.Ouvrirlafiche1Click(Sender:TObject);
begin
  if IBTemoinsASSOC_KLE_ASSOCIE.AsInteger>0 then
  begin
    dm.individu_clef:=IBTemoinsASSOC_KLE_ASSOCIE.AsInteger;
    FMain.Ouvre_Et_Selecte_Individu;
  end;
end;

procedure TFIndividuEditEventLife.cxGridTableTemoinsDblClick(
  Sender:TObject);
begin
  Ouvrirlafiche1Click(Sender);
end;

procedure TFIndividuEditEventLife.cxGridTableTemoinsColNomDrawColumnCell(
  Sender:TObject;ACanvas:TCanvas;
  AViewInfo:Longint;var ADone:Boolean);
var
  v:Variant;
begin
  v:=IBTemoinsSEXE.Value;
  if not VarIsNull(v) then
    case v of
      1:ACanvas.Font.Color:=gci_context.ColorHomme;
      2:ACanvas.Font.Color:=gci_context.ColorFemme;
      else
        ACanvas.Font.Color:=clWindowText;
    end
  else
    ACanvas.Font.Color:=clWindowText;
end;

procedure TFIndividuEditEventLife.DSTemoinsStateChange(Sender:TObject);
begin
  if DSTemoins.DataSet.State in [dsEdit,dsInsert] then
    TFIndividu(GFormIndividu).doBouton(true);
end;

procedure TFIndividuEditEventLife.bsfbRetirerClick(Sender:TObject);
begin
  if bsfbRetirer.Visible and bsfbRetirer.Enabled then
  begin
    if PageControl.ActivePageIndex=_onglet_temoins then
    begin
      if MyMessageDlg(rs_Confirm_deleting_this_witness_associated_with+_CRLF+FMain.NomIndiComplet+' ?',
        mmtConfirmation, mmbYesNo,Self)=mrYes then
      begin
        IBTemoins.Delete;
        TFIndividu(GFormIndividu).doBouton(true);
        PageControlChange(nil);
      end;
    end
    else
    begin//_onglet_medias
      if MyMessageDlg(rs_Confirm_media_unlink_from_event,
        mmtConfirmation, mmbYesNo,Self)=mrYes then
      begin
        IBMedias.Delete;
        if IBMedias.IsEmpty then
         with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
        begin
          p_DatasetEditIfNotEdited(IBQEve);
          IBQEve.fieldbyname ( IBQ_EV_IND_media ).AsInteger:=0;
          PageControlChange(nil);
        end;
        TFIndividu(GFormIndividu).doBouton(true);
      end;
    end;
  end;
end;

procedure TFIndividuEditEventLife.mVisualiseActeClick(Sender:TObject);
var
  iClef:integer;
begin
  with IBMedias do
  if Active and not IsEmpty then
  begin
    iClef:=FieldByName('mp_media').AsInteger;
    VisualiseMedia(iClef,dm.ReqSansCheck);
  end;
end;

procedure TFIndividuEditEventLife.cxGridTableMediasCellDblClick(
  Sender:TObject;
  ACellViewInfo:Longint;AButton:TMouseButton;
  AShift:TShiftState;var AHandled:Boolean);
begin
  mVisualiseActeClick(sender);
end;

procedure TFIndividuEditEventLife.Resize;
begin
  inherited;
  if bPremOuverture then
  begin
    gci_context.ShouldSave:=true;
    gci_context.HautEven:=Height;
  end;
end;

procedure TFIndividuEditEventLife.mRemplacerDocumentClick(Sender:TObject);
var
  q:TIBSQL;
  mp_clef,mp_media:integer;
begin
  mp_media:=FMain.OuvreBiblioMedias(True,0,'','');
  if mp_media>0 then
  begin
    mp_clef:=IBMedias.FieldByName('mp_clef').AsInteger;
    p_DatasetPostIfEdited(IBMedias);
    IBMedias.Close;
    q:=TIBSQL.Create(self);
    with q do
    try
      Database:=dm.ibd_BASE;
      Transaction:=dm.IBT_BASE;
      SQL.Add('update media_pointeurs set mp_media=:mp_media where mp_clef=:mp_clef');
      ParamByName( IBQ_mp_media ).AsInteger:=mp_media;
      ParamByName( IBQ_mp_clef  ).AsInteger:=mp_clef;
      ExecQuery;
      Close;
    finally
      Free;
    end;
    IBMedias.Open;
    TFIndividu(GFormIndividu).doBouton(true);
  end;
end;

procedure TFIndividuEditEventLife.DSMediasStateChange(Sender:TObject);
begin
  if DSMedias.DataSet.State in [dsEdit,dsInsert] then
    TFIndividu(GFormIndividu).doBouton(true);
end;

procedure TFIndividuEditEventLife.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  p_DatasetPostIfEdited(DataSourceEve.DataSet);
  p_DatasetPostIfEdited(IBTemoins);
  p_DatasetPostIfEdited(IBMedias);
  Action:=caHide;
end;

procedure TFIndividuEditEventLife.cxGridTemoinsExit(Sender:TObject);
begin//nécessaire si l'utilisateur n'a pas validé par Enter
  p_DatasetPostIfEdited(IBTemoins);
end;

procedure TFIndividuEditEventLife.edCommentairesKeyPress(Sender:TObject;
  var Key:Char);
begin
  if BloqueCar then
  begin
    BloqueCar:=false;
    Key:=#0;
  end;
end;

procedure TFIndividuEditEventLife.cxGridTableMediasEditKeyDown(
  Sender:TObject;AItem:Longint;
  AEdit:TCustomMaskEdit;var Key:Word;Shift:TShiftState);
{var
  s:string;
  k:integer;}
begin
{ Matthieu ?
if (AItem=colMemo)and(not TFIndividu(GFormIndividu).DialogMode) then
  begin
    s:=(aEdit as TMemo).Text;
    k:=(aEdit as TMemo).SelStart;
    if dm.RemplaceRaccourcis(Key,Shift,s,k) then
    begin
      if not(IBMedias.State in [dsEdit,dsInsert]) then
        IBMedias.Edit;
      IBMediasMULTI_MEMO.AsString:=s;
      (aEdit as TMemo).SelStart:=k;
      BloqueCar:=true;
    end;
  end;}
end;

procedure TFIndividuEditEventLife.cxGridTableMediasEditKeyPress(
  Sender:TObject;AItem:Longint;
  AEdit:TCustomMaskEdit;var Key:Char);
begin
  if BloqueCar then
  begin
    BloqueCar:=false;
    Key:=#0;
  end;
end;

procedure TFIndividuEditEventLife.edCommentairesMouseEnter(
  Sender:TObject);
begin
  dxStatusBar.Panels[0].Text:='Les raccourcis de saisie sont utilisables dans les champs Notes, Sources et Ville';
end;

procedure TFIndividuEditEventLife.cxGridTableTemoinsInitEdit(
  Sender:TObject;AItem:Longint;
  AEdit:TCustomMaskEdit);
begin
{ Matthieu ?
  if AItem=cxGridTableTemoinsColRole then
  begin
    for i:=0 to(AEdit as TFWDBLookupCombo).Properties.Buttons.Count-1 do
      (AEdit as TFWDBLookupCombo).Properties.Buttons.Items[i].Visible:=DSTemoins.AutoEdit;

    if DSTemoins.AutoEdit then
    begin
      (AEdit as TFWDBLookupCombo).Style.ButtonStyle:=btsOffice11;
      (AEdit as TFWDBLookupCombo).Style.ButtonTransparency:=ebtHideUnselected;
    end;
  end;}
end;

procedure TFIndividuEditEventLife.IBTemoinsMediasBeforeClose(DataSet:TDataSet);
begin
  p_DatasetPostIfEdited(dataset);
end;

procedure TFIndividuEditEventLife.cxComboBoxActeExit(Sender: TObject);
begin
  if GetKeyState(VK_TAB)<0 then
  begin
    PageControl.ActivePage:=OngletNotes;
    SendFocus(edCommentaires);
  end;
end;

procedure TFIndividuEditEventLife.Deactivate;
begin
  inherited;
  TFIndividu(GFormIndividu).Temporisation:=true;
end;

procedure TFIndividuEditEventLife.edCommentairesPropertiesEditValueChanged(
  Sender: TObject);
begin //le Post n'est pas automatique lors du changement d'enregistrement si seul le mémo a été effacé!
  with Sender as TCustomMemo do
  if (DataSourceEve.DataSet.State=dsEdit)
    and (Text='') then
      DataSourceEve.DataSet.Post;
end;

procedure TFIndividuEditEventLife.colMemoPropertiesEditValueChanged(
  Sender: TObject);
begin //le Post n'est pas automatique lors du changement d'enregistrement si seul le mémo a été effacé!
  if (DSMedias.State=dsEdit) and ((Sender as TcustomMemo).Text='') then
    IBMedias.Post;
end;
procedure TFIndividuEditEventLife.p_AfterDownloadCoord;
begin
  with aFIndividuIdentite as TFIndividuIdentite, IBQEve do
   Begin
    AutoCalcFields:=False;
    try
      p_DatasetEditIfNotEdited(IBQEve);
      if dm.UneSubd>'' then
        fieldbyname ( IBQ_EV_IND_SUBD ).asString:=dm.UneSubd;
     fieldbyname ( IBQ_EV_IND_LATITUDE ).AsFloat:=dm.UneLatitude;
    finally
      AutoCalcFields:=True;
    end;
    fieldbyname ( IBQ_EV_IND_LONGITUDE ).AsFloat:=dm.UneLongitude;
   end;
end;

procedure TFIndividuEditEventLife.mAcquerirClick(Sender: TObject);
begin
  dm.UneLatitude:=edLatitude.Value;
  dm.UneLongitude:=edLongitude.Value;
  dm.UneSubd:=edSubdi.Text;
  DoCoordNext:=TProcedureOfObject(p_AfterDownloadCoord);
  dm.GetCoordonneesInternet(edVille.Text,edDept.Text,edRegion.Text,edPays.Text,self);
end;

procedure TFIndividuEditEventLife.pmGooglePopup(Sender: TObject);
begin
  dxStatusBar.Panels[0].Text:=mAcquerir.Hint;
end;

procedure TFIndividuEditEventLife.InfoCopie(Sender: TObject);
begin
  dxStatusBar.Panels[0].Text:='Ctrl+G demande les coordonnées sur Google Maps.';
end;

procedure TFIndividuEditEventLife.EffaceBarreEtat(Sender: TObject);
begin
  dxStatusBar.Panels[0].Text:='';
end;

end.


