{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_observations;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,Classes,Controls,StdCtrls,
  ExtCtrls,Db, u_framework_dbcomponents, U_OnFormInfoIni;

type

  { TFIndividuObservations }

  TFIndividuObservations=class(TF_FormAdapt)
    OnFormInfoIni: TOnFormInfoIni;
    Panel10:TPanel;
    Panel13:TPanel;
    DataSource:TDataSource;
    lNom:TLabel;
    Label8:TLabel;
    Panel1:TPanel;
    Panel2:TPanel;
    Panel3:TPanel;
    Panel4:TPanel;
    LabelNotes:TLabel;
    LabelSources:TLabel;
    Notes: TFWDBMemo;
    Sources: TFWDBMemo;
    Splitter1: TSplitter;
    procedure cxSplitter1Moved(Sender:TObject);
    procedure NotesKeyDown(Sender:TObject;var Key:Word;
      Shift:TShiftState);
    procedure NotesDblClick(Sender:TObject);
    procedure SourcesDblClick(Sender:TObject);
    procedure NotesKeyPress(Sender:TObject;var Key:Char);
    procedure NotesEnter(Sender: TObject);
    procedure NotesExit(Sender: TObject);

  private
    BloqueCar:boolean;
  protected
    procedure DoShow; override;
  public
    procedure DoRefreshControls; override;
    procedure Loaded; override;
  end;

implementation

uses u_form_individu,u_dm,
     u_common_functions,
     u_genealogy_context,
     u_common_ancestro,
     fonctions_ini;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

var    fFormIndividu:TFIndividu;


procedure TFIndividuObservations.DoRefreshControls;
begin
  DataSource.AutoEdit:=not FFormIndividu.DialogMode;
end;

procedure TFIndividuObservations.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  Panel3.Color:=gci_context.ColorDark;
  Panel4.Color:=gci_context.ColorDark;
  LabelNotes.Font.Color:=gci_context.ColorTexteOnglets;
  LabelSources.Font.Color:=gci_context.ColorTexteOnglets;
  BloqueCar:=false;
  Notes.Hint:=rs_Hint_Notes;
  Sources.Hint:=rs_Hint_Notes;
  fFormIndividu:=TFIndividu(Owner);
  DataSource.DataSet:=FFormIndividu.QueryIndividu;
  lNom.PopupMenu:=FFormIndividu.pmNom;
  lNom.OnMouseEnter:=FFormIndividu.lNomMouseEnter;
  lNom.OnMouseLeave:=FFormIndividu.lNomMouseLeave;
  lNom.OnMouseMove:=FFormIndividu.lNomMouseMove;
  lNom.OnClick:=FFormIndividu.lNomClick;
  inherited;
end;

procedure TFIndividuObservations.cxSplitter1Moved(Sender:TObject);
begin
  gci_context.PanelInfosHeight:=Panel2.Height;
end;

procedure TFIndividuObservations.DoShow;
begin
inherited;
  Panel2.Height:=gci_context.PanelInfosHeight;
end;

procedure TFIndividuObservations.NotesKeyDown(Sender:TObject;
  var Key:Word;Shift:TShiftState);
var
  s:string;
  k:integer;
  memo:TFWDBMemo;
begin
  if not FFormIndividu.DialogMode then
  begin
    memo:=sender as TFWDBMemo;
    s:=memo.Text;
    k:=memo.SelStart;
    if dm.RemplaceRaccourcis(Key,Shift,s,k) then
    begin
      memo.Lines.Text:=s;
      memo.SelStart:=k;
      BloqueCar:=true;
    end;
  end;
end;

procedure TFIndividuObservations.NotesDblClick(Sender:TObject);
begin
  ExecuteChaineDansChaine(Notes.Text,Notes.SelStart,Notes.SelLength);
end;

procedure TFIndividuObservations.SourcesDblClick(Sender:TObject);
begin
  ExecuteChaineDansChaine(Sources.Text,Sources.SelStart,Sources.SelLength);
end;

procedure TFIndividuObservations.NotesKeyPress(Sender:TObject;
  var Key:Char);
begin
  if BloqueCar then
  begin
    BloqueCar:=false;
    Key:=#0;
  end;
end;

procedure TFIndividuObservations.NotesEnter(Sender: TObject);
begin
  (Sender as TControl).ShowHint:=False;
end;

procedure TFIndividuObservations.NotesExit(Sender: TObject);
begin
  (Sender as TControl).ShowHint:=True;
end;

end.

