{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{ Modifications logique et affichage utilisations par André Langlet 2010}
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_photos_et_docs;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  ShellAPI, Windows,
{$ELSE}
  LCLIntf,
{$ENDIF}
  U_FormAdapt,  Dialogs, graphics, U_ExtDBGrid, MaskEdit,
  U_ExtImage, u_buttons_appli, DB,
  U_ExtDBImage, JvXPbuttons, ExtCtrls,
  Menus, IBCustomDataSet, IBUpdateSQL, IBQuery, IBSQL, u_framework_dbcomponents,
  U_GroupView, StdCtrls, Controls, Classes, Forms, ExtDlgs,
  Grids, DBGrids, ComCtrls;

type
  TModeUpdate=(ModeMedia,ModePointeur);

  { TFIndividuPhotosEtDocs }

  TFIndividuPhotosEtDocs=class(TF_FormAdapt)
    bt_abandonner: TFWCancel;
    bt_enregistrer: TFWOK;
    bt_in_item: TFWInSelectV;
    bt_out_item: TFWOutSelectV;
    bt_out_total: TFWOutAllV;
    bt_TypePro: TJvXPButton;
    DSMultimedia:TDataSource;
    AEdit: TFWDBMemo;
    DSPerson: TDataSource;
    IBMultimedia:TIBQuery;
    IBMultimediaMP_CLEF1: TLongintField;
    IBMultimediaMP_CLEF2: TLongintField;
    IBMultimediaMP_IDENTITE1: TLongintField;
    IBMultimediaMP_IDENTITE2: TLongintField;
    IBMultimediaMP_POSITION1: TLongintField;
    IBMultimediaMP_POSITION2: TLongintField;
    IBMultimediaMULTI_CLEF1: TLongintField;
    IBMultimediaMULTI_CLEF2: TLongintField;
    IBMultimediaMULTI_IMAGE_RTF1: TLongintField;
    IBMultimediaMULTI_IMAGE_RTF2: TLongintField;
    IBMultimediaMULTI_INFOS1: TIBStringField;
    IBMultimediaMULTI_INFOS2: TIBStringField;
    IBMultimediaMULTI_MEDIA1: TBlobField;
    IBMultimediaMULTI_MEDIA2: TBlobField;
    IBMultimediaMULTI_MEMO1: TMemoField;
    IBMultimediaMULTI_MEMO2: TMemoField;
    IBMultimediaMULTI_NOM: TIBStringField;
    IBMultimediaMULTI_NOM1: TIBStringField;
    IBMultimediaMULTI_NOM2: TIBStringField;
    IBMultimediaMULTI_PATH1: TIBStringField;
    IBMultimediaMULTI_PATH2: TIBStringField;
    IBMultimediaMULTI_REDUITE1: TBlobField;
    IBMultimediaMULTI_REDUITE2: TBlobField;
    IBSQLPointeur: TIBSQL;
    IBUMultimedia:TIBUpdateSQL;
    Image2: TExtDBImage;
    lPoint: TImage;
    Label1: TLabel;
    Photos: TImageList;
    lv_PhotosIn: TDBGroupView;
    lv_PhotosOut: TDBGroupView;
    Panel10:TPanel;
    lNom:TLabel;
    IBMultimediaMULTI_CLEF:TLongintField;
    IBMultimediaMULTI_INFOS:TIBStringField;
    IBMultimediaMULTI_DATE_MODIF:TDateTimeField;
    IBMultimediaMULTI_MEDIA:TBlobField;
    IBMultimediaMULTI_MEMO:TMemoField;
    IBMultimediaMULTI_REDUITE:TBlobField;
    IBMultimediaMULTI_IMAGE_RTF:TLongintField;
    IBMultimediaMULTI_PATH:TIBStringField;
    IBMultimediaMP_CLEF:TLongintField;
    IBMultimediaMP_IDENTITE:TLongintField;
    IBMultimediaMP_POSITION:TLongintField;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    pInfos: TPanel;
    PmListe:TPopupMenu;
    mListe_Charger:TMenuItem;
    N1:TMenuItem;
    mListe_Enlever:TMenuItem;
    N2:TMenuItem;
    mListe_SetIdentite:TMenuItem;
    Label8:TLabel;
    mListe_Enregistrer:TMenuItem;
    
    btnAjout:TFWAdd;
    N3:TMenuItem;
    mListe_Imprimer:TMenuItem;
    btnDel:TFWDelete;
    DBGraphic:TExtDBImage;
    Panel2:TPanel;
    Panel1:TPanel;
    mListe_Visualiser:TMenuItem;
    Panel3:TPanel;
    dxDBPathMedia:TFWDBEdit;
    LabelPath:TLabel;
    PmImage:TPopupMenu;
    mImage_Charger:TMenuItem;
    MenuItem2:TMenuItem;
    mImage_SetIdentite:TMenuItem;
    MenuItem4:TMenuItem;
    mImage_Enregistrer:TMenuItem;
    MenuItem6:TMenuItem;
    mImage_Imprimer:TMenuItem;
    mImage_Visualiser:TMenuItem;
    mImage_Enlever:TMenuItem;
    N4:TMenuItem;
    mImage_MontrerRepere:TMenuItem;
    mImage_PoserRepere:TMenuItem;
    mImage_SupprimerPosition:TMenuItem;
    N5:TMenuItem;
    mImage_QuiUtilise:TMenuItem;
    N6:TMenuItem;
    mListe_MontrerRepere:TMenuItem;
    mListe_SupprimerPosition:TMenuItem;
    N7:TMenuItem;
    mListe_QuiUtilise:TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    ScrollBox1: TScrollBox;
    Splitter1: TSplitter;
    procedure btnAjoutClick(Sender:TObject);
    procedure bt_enregistrerClick(Sender: TObject);
    procedure lv_PhotosInClick(Sender: TObject);
    function lv_PhotosInDataAddFieldsInsert(const Sender: TObject): String;
    function lv_PhotosInDataAddFieldsValues(const Sender: TObject): String;
    procedure lv_PhotosInDataRecorded(DataSet: TDataSet);
    procedure lv_PhotosInDblClick(Sender: TObject);
    procedure lv_PhotosOutClick(Sender: TObject);
    procedure mListe_SetIdentiteClick(Sender:TObject);
    procedure btnDelClick(Sender:TObject);
    procedure DSMultimediaStateChange(Sender:TObject);
    procedure mListe_EnregistrerClick(Sender:TObject);
    procedure PmListePopup(Sender:TObject);
    procedure mListe_ImprimerClick(Sender:TObject);
    procedure mListe_VisualiserClick(Sender:TObject);
    procedure Image2DblClick(Sender:TObject);
    procedure PmImagePopup(Sender:TObject);
    procedure mImage_PoserRepereClick(Sender:TObject);
    procedure mImage_SupprimerPositionClick(Sender:TObject);
    procedure MontrerRepere;
    procedure mImage_MontrerRepereClick(Sender:TObject);
    procedure pPhotoResize(Sender:TObject);
    procedure mImage_QuiUtiliseClick(Sender:TObject);
    procedure GridListeEditKeyPress(Sender: TObject;
      AItem: Longint; AEdit: TCustomMaskEdit; var Key: Char);
    procedure GridListeMULTI_MEMOPropertiesEditValueChanged(
      Sender: TObject);
  private
    bOpen:boolean;
    PointSouris:TPoint;
    BloqueCar:boolean;
    procedure doTesteReseau;
    procedure SetModeUpdate(ModeUpdate:TModeUpdate);
  protected
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;
    procedure DoRefreshControls; override;
    procedure doInitialize;
    function doOpenQuerys:boolean;
    procedure DoGoto (const AKey : Integer);
  end;

implementation

uses u_dm,
     u_form_main,
     u_form_individu,
     fonctions_dialogs,
     strutils,
     sysutils,
     fonctions_db,
     fonctions_ini,
     u_common_functions,
     u_firebird_functions,
     u_common_ancestro,
     u_genealogy_context,
     u_common_ancestro_functions,
     u_common_const,Types,Math;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

var
      fFormIndividu:TFIndividu;

procedure TFIndividuPhotosEtDocs.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  btnAjout.Color:=gci_context.ColorLight;
  btnDel.Color:=gci_context.ColorLight;
  dxDBPathMedia.Color:=gci_context.ColorLight;

  bOpen:=false;

  fFormIndividu:=TFIndividu(Owner);
  DSPerson.DataSet := fFormIndividu.QueryIndividu;

  //GridListe.Width:=gci_context.PanelMediaWidth;
  SetModeUpdate(ModeMedia);
  lPoint.Visible:=gci_context.MontrerRepere;
  BloqueCar:=false;
  lNom.PopupMenu:=FFormIndividu.pmNom;
  lNom.OnMouseEnter:=FFormIndividu.lNomMouseEnter;
  lNom.OnMouseLeave:=FFormIndividu.lNomMouseLeave;
  lNom.OnMouseMove:=FFormIndividu.lNomMouseMove;
  lNom.OnClick:=FFormIndividu.lNomClick;
  inherited;
end;


procedure TFIndividuPhotosEtDocs.DoRefreshControls;
begin
  Image2.visible:=IBMultimedia.Active and not IBMultimedia.IsEmpty;
  DSMultimedia.AutoEdit:=not FFormIndividu.DialogMode;
end;

procedure TFIndividuPhotosEtDocs.doInitialize;
begin
  IBMultimedia.Close;
end;

function TFIndividuPhotosEtDocs.doOpenQuerys:boolean;
begin
  doTesteReseau;
  result:=true;
end;

procedure TFIndividuPhotosEtDocs.DoGoto(const AKey: Integer);
begin
  IBMultimedia.Locate('MULTI_CLEF',Akey,[]);
end;


function TFIndividuPhotosEtDocs.lv_PhotosInDataAddFieldsInsert(
  const Sender: TObject): String;
begin
  Result := ', MP_POINTE_SUR,MP_TABLE,MP_TYPE_IMAGE,MP_KLE_DOSSIER';
end;

function TFIndividuPhotosEtDocs.lv_PhotosInDataAddFieldsValues(
  const Sender: TObject): String;
begin
  Result := ','+FFormIndividu.QueryIndividuCLE_FICHE.AsString+',''I'',''I'','+IntToStr(dm.NumDossier);
end;

procedure TFIndividuPhotosEtDocs.lv_PhotosInDataRecorded(DataSet: TDataSet);
begin

end;

procedure TFIndividuPhotosEtDocs.lv_PhotosInDblClick(Sender: TObject);
begin

end;

procedure TFIndividuPhotosEtDocs.lv_PhotosOutClick(Sender: TObject);
begin
  with lv_PhotosIn do
  if assigned(Selected) Then
   Begin
    VisualiseMedia(StrToInt(Selected.SubItems[1]),dm.ReqSansCheck);
   End;
end;

procedure TFIndividuPhotosEtDocs.btnAjoutClick(Sender:TObject);
var
  enr:integer;
begin
  if btnAjout.Visible and btnAjout.Enabled then
  begin
    enr:=0;
    if FMain.OuvreBiblioMedias(True,FFormIndividu.QueryIndividuCLE_FICHE.AsInteger,'I','I')>0 then
    begin
      FFormIndividu.doBouton(true);
      enr:=IBMultimedia.RecNo;
    end;
    lv_PhotosIn .Refresh;
    lv_PhotosOut.Refresh;
    bt_enregistrer.Enabled:=True;
  end;
end;

procedure TFIndividuPhotosEtDocs.bt_enregistrerClick(Sender: TObject);
begin
  fFormIndividu.bsfbAppliquer.Click;
end;

procedure TFIndividuPhotosEtDocs.lv_PhotosInClick(Sender: TObject);
begin
  with lv_PhotosIn do
   if assigned ( Selected ) Then
    with Selected do
      DoGoto ( StrToInt(SubItems[SubItems.Count-1]));
end;

procedure TFIndividuPhotosEtDocs.DSMultimediaStateChange(Sender:TObject);
begin
  if DSMultimedia.State in [dsEdit,dsInsert] then
    FFormIndividu.doBouton(true);
end;

procedure TFIndividuPhotosEtDocs.mListe_EnregistrerClick(
  Sender:TObject);
begin
  DBGraphic.SaveToFile;
end;

procedure TFIndividuPhotosEtDocs.PmListePopup(Sender:TObject);
begin
  mListe_Charger.enabled:=btnAjout.Visible and btnAjout.Enabled;
  mListe_Enregistrer.enabled:=IBMultimedia.Active
    and(TBlobField(IBMultimediaMULTI_MEDIA).BlobSize>0);
  mListe_SetIdentite.enabled:=mListe_Charger.enabled
    and(TBlobField(IBMultimediaMULTI_REDUITE).BlobSize>0)
    and(IBMultimediamp_identite.AsInteger=0);
  mListe_Imprimer.enabled:=mListe_Enregistrer.enabled and
    (IBMultimediaMULTI_IMAGE_RTF.AsInteger=0);
  mListe_Visualiser.enabled:=IBMultimedia.Active and not IBMultimedia.IsEmpty;
  mListe_Enlever.enabled:=btnDel.Visible and btnDel.Enabled;
  mListe_Charger.Visible:=(FFormIndividu.DialogMode=false);
  mListe_SetIdentite.Visible:=(FFormIndividu.DialogMode=false);
  mListe_Enlever.Visible:=(FFormIndividu.DialogMode=false);
  mListe_MontrerRepere.Checked:=gci_context.MontrerRepere;
  mListe_SupprimerPosition.Visible:=mListe_Enlever.enabled
    and(IBMultimediamp_position.AsInteger<>0)
    and(FFormIndividu.DialogMode=false);
  mListe_QuiUtilise.Visible:=mListe_Visualiser.enabled;
end;

procedure TFIndividuPhotosEtDocs.PmImagePopup(Sender:TObject);
begin
  PointSouris:=(sender as TPopupMenu).PopupPoint;
  PmListePopup(sender);
  mImage_Charger.enabled:=mListe_Charger.enabled;
  mImage_Enregistrer.enabled:=mListe_Enregistrer.enabled;
  mImage_SetIdentite.enabled:=mListe_SetIdentite.enabled;
  mImage_Imprimer.enabled:=mListe_Imprimer.enabled;
  mImage_Visualiser.enabled:=mListe_Visualiser.enabled;
  mImage_Enlever.enabled:=mListe_Enlever.enabled;
  mImage_Charger.Visible:=mListe_Charger.Visible;
  mImage_SetIdentite.Visible:=mListe_SetIdentite.Visible;
  mImage_Enlever.Visible:=mListe_Enlever.Visible;
  mImage_MontrerRepere.Checked:=mListe_MontrerRepere.Checked;
  mImage_SupprimerPosition.Visible:=mListe_SupprimerPosition.Visible;
  mImage_QuiUtilise.Visible:=mListe_Visualiser.enabled;

  mImage_PoserRepere.Visible:=mImage_Charger.enabled
    and(FFormIndividu.DialogMode=false)
    and FichEstImage(IBMultimediaMULTI_PATH.AsString)
    and(Image2.Picture.Height>0)and(Image2.Picture.Width>0);
end;

procedure TFIndividuPhotosEtDocs.mListe_SetIdentiteClick(Sender:TObject);
var
  RecIdent:integer;
begin
  RecIdent:=IBMultimedia.RecNo;
  SetModeUpdate(ModePointeur);
  bOpen:=false;//au cas où DisableControls ne bloque pas AfterScrool
  IBMultimedia.DisableControls;
  try
    IBMultimedia.First;
    while not IBMultimedia.Eof do
    begin
      if (IBMultimediaMP_IDENTITE.AsInteger=1)and(IBMultimedia.RecNo<>RecIdent) then
      begin
        p_DatasetEditIfNotEdited(IBMultimedia);
        IBMultimediaMP_IDENTITE.AsInteger:=0;
      end
      else if (IBMultimedia.RecNo=RecIdent) then
      begin
        p_DatasetEditIfNotEdited(IBMultimedia);
        IBMultimediaMP_IDENTITE.AsInteger:=1;
      end;
      IBMultimedia.Next;
    end;
  finally
    IBMultimedia.RecNo:=RecIdent;
    IBMultimedia.EnableControls;
    bOpen:=true;
    SetModeUpdate(ModeMedia);//fait le dernier post si nécessaire
  end;

  if gci_context.Photos then //AL
  begin
    FFormIndividu.aFIndividuIdentite.idPhoto:=IBMultimediaMP_CLEF.AsInteger;
    FFormIndividu.aFIndividuIdentite.PPhoto.Visible:=true;
    FFormIndividu.aFIndividuIdentite.bIdentiteVisible:=true;
    FFormIndividu.aFIndividuIdentite.Image2.Picture:=Image2.Picture;
  end;
  FFormIndividu.doBouton(true);
end;

procedure TFIndividuPhotosEtDocs.mListe_ImprimerClick(Sender:TObject);
begin
  if IBMultimediaMULTI_IMAGE_RTF.AsInteger=0 then
    ImprimeImage(IBMultimediaMULTI_CLEF.AsInteger,'Image attachée à '+FFormIndividu.NomIndiComplet);
end;

procedure TFIndividuPhotosEtDocs.btnDelClick(Sender:TObject);
begin
  if btnDel.Visible and btnDel.Enabled then
  begin
    if MyMessageDlg(rs_Confirm_deleting_document,mmtConfirmation, mmbYesNo,FMain)=mrYes then
    begin
      IBMultimedia.Delete;
      FFormIndividu.doBouton(true);
      btnDel.Enabled:=IBMultimedia.RecNo>0;
      lv_PhotosIn.Refresh;
      lv_PhotosOut.Refresh;
    end;
  end;
end;


procedure TFIndividuPhotosEtDocs.doTesteReseau;
begin
  IBMultimedia.Close;
  if gci_context.OngletMultimediaReseau then
  begin
    Image2.PopupMenu:=PmImage;
    label1.Caption:='';
    pInfos.Visible:=false;
    Panel2.Visible:=true;
    btnAjout.enabled:=true;//invisible en mode dialog
    try
      IBMultimedia.Params[0].AsInteger:=FFormIndividu.CleFiche;//Cle de l'individu
      IBMultimedia.Open;
    except
        //
    end;
    btnDel.enabled:=IBMultimedia.Active and(IBMultimedia.RecNo>0);//invisible en mode dialog
  end
  else
  begin
    Image2.PopupMenu:=nil;
    label1.Caption:=rs_Caption_You_have_disabled_this_sheet_in_Preferences;
    pInfos.Visible:=true;
    Panel2.Visible:=false;
    btnAjout.enabled:=false;
    btnDel.enabled:=false;
  end;
end;

procedure TFIndividuPhotosEtDocs.mListe_VisualiserClick(Sender:TObject);
begin
  if IBMultimedia.Active and not IBMultimedia.IsEmpty then
    VisualiseMedia(IBMultimediaMULTI_CLEF.AsInteger,dm.ReqSansCheck);
end;

procedure TFIndividuPhotosEtDocs.Image2DblClick(Sender:TObject);
begin
  if IBMultimedia.Active and not IBMultimedia.IsEmpty then
    VisualiseMedia(IBMultimediaMULTI_CLEF.AsInteger,dm.ReqSansCheck);
end;

procedure TFIndividuPhotosEtDocs.DoClose(
  var Action:TCloseAction);
begin
  IBMultimedia.Close;
end;

procedure TFIndividuPhotosEtDocs.SetModeUpdate(ModeUpdate:TModeUpdate);//AL
begin
  p_DatasetPostIfEdited(IBMultimedia);
  IBUMultimedia.ModifySQL.Clear;
  case ModeUpdate of
    ModeMedia:
      IBUMultimedia.ModifySQL.Add('update multimedia set multi_memo=:multi_memo where multi_clef=:multi_clef');
    ModePointeur:
      IBUMultimedia.ModifySQL.Add('update media_pointeurs'
        +' set mp_identite=:mp_identite,mp_position=:mp_position where mp_clef=:mp_clef');
  end;
end;

procedure TFIndividuPhotosEtDocs.mImage_PoserRepereClick(Sender:TObject);
var
  p:TPoint;
  r,l,h,x,y:single;
begin
  if (Image2.Picture.Height>0)and(Image2.Picture.Width>0) then
  begin
    p:=Image2.ScreenToClient(PointSouris);
    l:=Image2.Picture.Width;
    h:=Image2.Picture.Height;
    if (l>Image2.Width)or(h>Image2.Height) then
    begin
      r:=min(Image2.Width/l,Image2.Height/h);
      l:=l*r;
      h:=h*r;
    end;
    x:=p.X-(Image2.Width-l)/2;
    y:=p.Y-(Image2.Height-h)/2;
    x:=max(0,x);
    y:=max(0,y);
    x:=min(x,l);
    y:=min(y,h);
    SetModeUpdate(ModePointeur);
    try
      IBMultimedia.Edit;
      IBMultimediaMP_POSITION.AsInteger:=XYZenINT(round(x*$FFF/l),round(y*$FFF/h),0);
      IBMultimedia.Post;
    finally
      SetModeUpdate(ModeMedia);
    end;
    MontrerRepere;
  end;
end;

procedure TFIndividuPhotosEtDocs.mImage_SupprimerPositionClick(Sender:TObject);
begin
  SetModeUpdate(ModePointeur);
  try
    IBMultimedia.Edit;
    IBMultimediaMP_POSITION.AsInteger:=0;
    IBMultimedia.Post;
  finally
    SetModeUpdate(ModeMedia);
  end;
  lPoint.Visible:=false;
end;

procedure TFIndividuPhotosEtDocs.MontrerRepere;
var
  x,y,z:integer;
  r,l,h:single;
begin
  with IBMultimedia, Image2 do
  if Active and (FieldByName('MP_POSITION').AsInteger>0)and(Picture.Height>0)and(Picture.Width>0) then
  begin
    IntenXYZ(FieldByName('MP_POSITION').AsInteger,x,y,z);
    l:=Picture.Width;
    h:=Picture.Height;
    if (l>Width)or(h>Height) then
    begin
      r:=min(Width/l,Height/h);
      l:=l*r;
      h:=h*r;
    end;
    lPoint.Left:=round(x*l/$FFF+(Width-l)/2-lPoint.Width/2)+Left;
    lPoint.Top:=round(y*h/$FFF+(Height-h)/2-lPoint.Height/2)+Top;
    lPoint.Visible:=true;
  end
  else
  begin
    lPoint.Visible:=false
  end;
end;

procedure TFIndividuPhotosEtDocs.mImage_MontrerRepereClick(Sender:TObject);
begin
  gci_context.MontrerRepere:=not gci_context.MontrerRepere;
  if gci_context.MontrerRepere then
    MontrerRepere
  else
    lPoint.Visible:=false;
  gci_context.ShouldSave:=true;
end;

procedure TFIndividuPhotosEtDocs.pPhotoResize(Sender:TObject);
begin
  if gci_context.MontrerRepere then
    MontrerRepere;
end;

procedure TFIndividuPhotosEtDocs.mImage_QuiUtiliseClick(Sender:TObject);
begin
  FMain.OuvreFUtilisationMedia(IBMultimediaMULTI_CLEF.asInteger);
end;

procedure TFIndividuPhotosEtDocs.GridListeEditKeyPress(
  Sender: TObject; AItem: Longint;
  AEdit: TCustomMaskEdit; var Key: Char);
begin
  if BloqueCar then
  begin
    BloqueCar:=false;
    Key:=#0;
  end;
end;

procedure TFIndividuPhotosEtDocs.GridListeMULTI_MEMOPropertiesEditValueChanged(
  Sender: TObject);
begin //le Post n'est pas automatique lors du changement d'enregistrement si seul le mémo a été effacé!
  if (DSMultimedia.State=dsEdit) and ((Sender as TExtDBGrid).Columns [ 1 ].Field.IsNull) then
    IBMultimedia.Post;
end;
end.

