{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}


unit u_form_list_villes_Doublons;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,IBCustomDataSet,SysUtils,U_ExtDBGrid,Menus,DB,IBQuery,StdCtrls,
  Controls,ExtCtrls,forms,Dialogs,u_buttons_appli, u_ancestropictimages,
   IBSQL, Classes;

type

  { TFListeVillesDoublons }

  TFListeVillesDoublons=class(TF_FormAdapt)
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    fpBoutons:TPanel;
    pBottom:TPanel;
    IBQDoublons:TIBQuery;
    DSDoublons:TDataSource;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Image1:TIATitle;
    Panel2:TPanel;
    pBravo:TPanel;
    Image2:TIASearch;
    Label1:TLabel;
    
    pmGrid:TPopupMenu;
    Supprimerlafiche1:TMenuItem;
    IBQDoublonsrcv_CODE:TLongintField;
    IBQDoublonsrcv_VILLE:TIBStringField;
    IBQDoublonsrcv_INSEE:TIBStringField;
    IBQDoublonsrcv_POSTE:TIBStringField;
    IBQDoublonsrcv_LONGITUDE:TFloatField;
    IBQDoublonsrcv_LATITUDE:TFloatField;
    IBQDoublonsRPA_LIBELLE:TIBStringField;
    btnFermer:TFWClose;
    GoodBtn1:TFWDelete;
    IBQDelVille: TIBSQL;

    procedure sbCloseClick(Sender:TObject);
    procedure pmGridPopup(Sender:TObject);
    procedure Supprimerlafiche1Click(Sender:TObject);
  private
    procedure doShowDoublons;
  protected
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;
    procedure DoRefreshControls; override;
    procedure DoShowFirstTime; override;

  end;

implementation

uses u_dm,
     u_common_ancestro,
     u_common_functions,
     u_common_ancestro_functions,
     fonctions_dialogs,
     u_genealogy_context,
     fonctions_ini,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.lfm}{$ENDIF}

procedure TFListeVillesDoublons.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  doRefreshControls;
  inherited;
end;

procedure TFListeVillesDoublons.doShowDoublons;
begin
  IBQDoublons.Close;
  IBQDoublons.Open;
  doRefreshControls;
end;

procedure TFListeVillesDoublons.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  IBQDoublons.Close;
end;

procedure TFListeVillesDoublons.sbCloseClick(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFListeVillesDoublons.pmGridPopup(Sender:TObject);
var
  ok:boolean;
begin
  ok:=(IBQDoublons.Active)and(IBQDoublons.IsEmpty=false)
    and(dm.individu_clef<>IBQDoublonsrcv_CODE.AsInteger);
  Supprimerlafiche1.enabled:=ok;
end;

procedure TFListeVillesDoublons.Supprimerlafiche1Click(Sender:TObject);
var
  L:array of integer;
  sMessage:string;
  i:integer;
begin
  SetLength(L,dxDBGrid1.SelectedRows.Count);
  if Length(L)>1 then
    sMessage:= fs_RemplaceMsg(rs_Confirm_deleting_selected_cities,[intToStr(Length(L))])
  else
    sMessage:=rs_Confirm_deleting_selected_city;

  if MyMessageDlg(sMessage,mmtWarning,mmbYesNo,Self)=mrYes then
  with dxDBGrid1.DataSource.DataSet do
  begin
    DisableControls;
    screen.Cursor:=crSQLWait;
    
    try
      dm.IBTrans_Secondaire.Active:=true;
      for i:=0 to Length(L)-1 do
       Begin
         GotoBookMark(dxDBGrid1.SelectedRows[i]);
         L[i]:=FieldByName('rcv_CODE').AsInteger;
       end;
      IBQDoublons.Close;
      for i:=0 to Length(L)-1 do
      begin
        IBQDelVille.params[0].asInteger:=L[i];
        IBQDelVille.ExecQuery;
      end;
      IBQDelVille.Close;
      dm.IBTrans_Secondaire.CommitRetaining;
      doShowDoublons;
    finally
      screen.Cursor:=crDefault;
      EnableControls;
    end;
  end;
end;

procedure TFListeVillesDoublons.DoRefreshControls;
begin
  dxDBGrid1.Enabled:=(IBQDoublons.Active)and(IBQDoublons.IsEmpty=false);
  pBravo.Visible:=(IBQDoublons.Active)and(IBQDoublons.IsEmpty);
end;

procedure TFListeVillesDoublons.DoShowFirstTime;
begin
  Height:=round(TControl(Owner).height*gci_context.TailleFenetre/100);
  width:=round(TControl(Owner).width*gci_context.TailleFenetre/100);
  Caption:=rs_Caption_Duplicated_cities;
  doShowDoublons;
end;

end.

