{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_list_villes_Voisines;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt, U_OnFormInfoIni,Forms,
  Dialogs,Menus,DB,IBCustomDataSet,IBQuery,
  StdCtrls,Controls,ExtCtrls,U_ExtDBGrid,Classes,
  u_buttons_appli,u_framework_components, u_ancestropictimages,
  u_ancestropictbuttons, Grids, DBGrids;

type

  { TFVillesVoisines }

  TFVillesVoisines=class(TF_FormAdapt)
    fpBoutons:TPanel;
    IBQVillesVoisines:TIBQuery;
    DSVillesVoisines:TDataSource;
    OnFormInfoIni: TOnFormInfoIni;
    pmGrille: TPopupMenu;
    dxDBGrid1:TExtDBGrid;
    Panel3:TPanel;
    Image1:TIATitle;
    ExporterenHTML1:TMenuItem;
    SaveDialog:TSaveDialog;
    Label1:TLabel;
    bt_Close:TFWClose;
    cxSEDistance:TFWSpinEdit;
    Distance:TLabel;
    Autour:TLabel;
    lVille:TLabel;
    btnVillesVoisines:TXAWorld;
    IBQVillesVoisinesCP_CP:TIBStringField;
    IBQVillesVoisinesCP_VILLE:TIBStringField;
    IBQVillesVoisinesCP_INSEE:TIBStringField;
    IBQVillesVoisinesCP_LONGITUDE:TFloatField;
    IBQVillesVoisinesCP_LATITUDE:TFloatField;
    IBQVillesVoisinesDISTANCE:TFloatField;
    IBQVillesVoisinesDEPARTEMENT: TStringField;
    IBQVillesVoisinesREGION: TStringField;
    IBQVillesVoisinesPAYS: TStringField;
    IBQVillesVoisinesDIRECTION: TStringField;
    procedure dxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure dxDBGrid1FWBeforeEnter(Sender: TObject);
    procedure sbCloseClick(Sender:TObject);

    procedure ExporterenHTML1Click(Sender:TObject);
    procedure btnVillesVoisinesClick(Sender:TObject);
    procedure pmGrillePopup(Sender:TObject);
    procedure IBQVillesVoisinesCalcFields(DataSet: TDataSet);
    procedure dxDBGrid1MouseEnter(Sender: TObject);
    procedure dxDBGrid1MouseLeave(Sender: TObject);
  private
    iDossier:integer;
    lLat,lLong:double;
    procedure doOpen;
  protected
    procedure DoClose(var Action: TCloseAction); override;
  public
    procedure Loaded; override;
    destructor Destroy; override;
    procedure doInit(ville,Subd:string;lat,long:double;iMode:integer);
  end;

implementation

uses u_dm,
     u_common_functions,
     fonctions_dialogs,
     u_common_ancestro,
     u_form_main,Math,
     fonctions_components,
     u_genealogy_context,
     fonctions_ini,
     u_common_ancestro_functions,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.lfm}{$ENDIF}

procedure TFVillesVoisines.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  // Matthieu ?
  //  dxDBGrid1DBTableView1.RestoreFromRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_VILLES_VOISINES');

  cxSEDistance.Value:=gci_context.DistanceVillesVoisines;

  SaveDialog.InitialDir:=gci_context.PathImportExport;
  inherited;
end;

destructor TFVillesVoisines.Destroy;
begin
  inherited Destroy;
  FMain.aFVillesVoisines:=nil;
end;

procedure TFVillesVoisines.dxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  if Column = dxDBGrid1.SelectedColumn then
    if dxDBGrid1.Canvas.Brush.Color=dxDBGrid1.Color then
      dxDBGrid1.Canvas.Brush.Color:=gci_context.ColorMedium;
end;

procedure TFVillesVoisines.dxDBGrid1FWBeforeEnter(Sender: TObject);
begin

end;

procedure TFVillesVoisines.doInit(ville, Subd: string; lat, long: double;
  iMode: integer);
begin
  iDossier:=iMode;
  lVille.Caption:=Ville;
  if Subd>'' then
    lVille.Caption:=lVille.Caption+' - '+Subd;
  if iDossier=0 then
  begin
    Caption:=rs_Caption_Neighbor_cities_in_cities_index;
    Label1.Caption:=fs_RemplaceMsg(rs_Caption_Neighbor_cities_of_in_cities_index,[lVille.Caption]);
    IBQVillesVoisines.Database:=dm.IBBaseParam;
    IBQVillesVoisines.Transaction:=dm.IBTransParam;
    IBQVillesVoisines.SQL.Text:='SELECT cp_cp'
      +',cp_ville'
      +',cp_insee'
      +',distance'
      +',cp_latitude'
      +',cp_longitude'
      +',departement'
      +',region'
      +',pays'
      +' FROM PROC_PREP_VILLES_RAYON(:RAYON,:LATITUDE,:LONGITUDE)'
      +'order by DISTANCE,CP_VILLE';
  end
  else
  begin
    Caption:=rs_Caption_Neighbor_sites_recorded_in_folder;
    Label1.Caption:=fs_RemplaceMsg(rs_Caption_Recorded_sites_on_this_folder_neighbor_of,[lVille.Caption]);
    IBQVillesVoisines.Database:=dm.ibd_BASE;
    IBQVillesVoisines.Transaction:=dm.IBT_BASE;
    IBQVillesVoisines.SQL.Text:='SELECT cp_cp'
      +',cp_ville'
      +',cp_insee'
      +',distance'
      +',cp_latitude'
      +',cp_longitude'
      +',departement'
      +',region'
      +',pays'
      +' FROM PROC_PREP_VILLES_RAYON(:RAYON,:LATITUDE,:LONGITUDE,:DOSSIER)'
      +'order by DISTANCE,CP_VILLE';
  end;
  lLat:=lat;
  lLong:=long;
  doOpen;
end;

procedure TFVillesVoisines.doOpen;
begin
  if (lLat<>0)and(lLong<>0) then
  begin
    IBQVillesVoisines.Close;
    IBQVillesVoisines.Params[0].AsFloat:=cxSEDistance.Value;
    IBQVillesVoisines.Params[1].AsFloat:=lLat;
    IBQVillesVoisines.Params[2].AsFloat:=lLong;
    if iDossier>0 then
      IBQVillesVoisines.Params[3].AsInteger:=iDossier;
    IBQVillesVoisines.Open;
  end
  else
  begin
    MyMessageDlg(fs_RemplaceMsg(rs_Error_None_Coord_of,[lVille.Caption])
      ,mmtInformation,[mmbCancel],Self);
  end;
end;

procedure TFVillesVoisines.sbCloseClick(Sender:TObject);
begin
  ModalResult:=mrCancel;
  Close;
end;

procedure TFVillesVoisines.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  gci_context.DistanceVillesVoisines:=cxSEDistance.Value;
  IBQVillesVoisines.Close;
  // Matthieu ?
  //  dxDBGrid1DBTableView1.StoreToRegistry(gci_context.KeyRegistry +DirectorySeparator+'W_VILLES_VOISINES');
  if FMain.Lieu_Proprietaire=nil then //sinon la propriétaire s'en charge
  begin
    Action:=caFree;
  end;
end;

procedure TFVillesVoisines.ExporterenHTML1Click(Sender:TObject);
var
  SavePlace:TBookmark;
  s_Fichier:string;
begin
  SavePlace:=nil;
  s_Fichier:='Liste des Villes voisines.HTM';
  SaveDialog.FileName:=s_Fichier;
  if SaveDialog.Execute then
  begin
    IBQVillesVoisines.DisableControls;
    try
      SavePlace:=IBQVillesVoisines.GetBookmark;
      ExportGridToHTML(s_fichier,dxDBGrid1,True,True);
    finally
      IBQVillesVoisines.GotoBookmark(SavePlace);
      IBQVillesVoisines.FreeBookmark(SavePlace);
      IBQVillesVoisines.EnableControls;
    end;
  end;
end;

procedure TFVillesVoisines.btnVillesVoisinesClick(Sender:TObject);
begin
  doOpen;
end;

procedure TFVillesVoisines.pmGrillePopup(Sender:TObject);
begin
  ExporterenHTML1.enabled:=not dxDBGrid1.DataSource.DataSet.IsEmpty;
end;


procedure TFVillesVoisines.IBQVillesVoisinesCalcFields(DataSet: TDataSet);
var
  vLat,vLong,dLat,dLong,AngleRad:Double;
begin
  vLat:=IBQVillesVoisinesCP_LATITUDE.AsFloat;
  vLong:=IBQVillesVoisinesCP_LONGITUDE.AsFloat;
  if (lLat=0)or(vLat=0)or(lLong=0)or(vLong=0)or((lLat=vLat)and(lLong=vLong)) then
    IBQVillesVoisinesDIRECTION.AsString:='-'
  else
  begin
    try
      dLat:=vLat-lLat;
      dLong:=(vLong-lLong)*sin(lLat*Pi/180);
      AngleRad:=ArcTan2(dLat,dLong);

      case Round(AngleRad*4/Pi) of
        0:IBQVillesVoisinesDIRECTION.AsString:='E';
        1:IBQVillesVoisinesDIRECTION.AsString:='NE';
        2:IBQVillesVoisinesDIRECTION.AsString:='N';
        3:IBQVillesVoisinesDIRECTION.AsString:='NW';
        4:IBQVillesVoisinesDIRECTION.AsString:='W';
        -1:IBQVillesVoisinesDIRECTION.AsString:='SE';
        -2:IBQVillesVoisinesDIRECTION.AsString:='S';
        -3:IBQVillesVoisinesDIRECTION.AsString:='SW';
        -4:IBQVillesVoisinesDIRECTION.AsString:='W';
      else
        IBQVillesVoisinesDIRECTION.AsString:='-';
      end;
    except
      IBQVillesVoisinesDIRECTION.AsString:='-';
    end;
  end;
end;

procedure TFVillesVoisines.dxDBGrid1MouseEnter(Sender: TObject);
begin
  // Matthieu ?
//  dm.cxHintStyleController1.HintStyle.Standard:=true;
end;

procedure TFVillesVoisines.dxDBGrid1MouseLeave(Sender: TObject);
begin
  // Matthieu ?
//  dm.cxHintStyleController1.HintStyle.Standard:=false;
end;

end.

