{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{AL 2009 création nouvelles variables date, suppression _LastPosMiniature}
{-----------------------------------------------------------------------}

unit u_common_treeind;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}
{$i ../extends.inc}


interface

uses
  {$IFDEF VIRTUALTREES}
  VirtualTrees;
  {$ELSE}
  ComCtrls;
  {$ENDIF}


type
  TNodeIndividu=record
    fSexe,
    fOrdre,
    fOrdre2,
    fImageIndex,
    fCleFiche,
    fClefUnion:integer;
    fSosa:Double;//André 17/12/07 était Int64 (limité à 63 générations)
    FHasSosa:Boolean;
    {$IFDEF VIRTUALTREES}fCaption,{$ENDIF}
    fNomComplet,
    fDateNaissanceDeces,
    fDateDeces,
    fNom,
    fHint:string;
  end;
  PNodeIndividu=^TNodeIndividu;


procedure TreeSelectNode(const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const ACleFiche:integer);
procedure TreeFindNode(const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const ACleFiche:integer;var FoundNode:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF});
function TreeNodeIsPresent ( const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const iclefiche : Integer):Boolean;


implementation


function TreeNodeIsPresent ( const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const iclefiche : Integer):Boolean;
var
  LNode:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
Begin
  LNode:=nil;
  TreeFindNode(ATree,{$IFDEF VIRTUALTREES}ATree.RootNode{$ELSE}nil{$ENDIF},iclefiche,LNode);
  Result:=LNode <> nil;
end;



procedure TreeSelectNode(const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const ACleFiche:integer);
var
  LNode:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  LNode:=nil;
  TreeFindNode(ATree,{$IFDEF VIRTUALTREES}ATree.RootNode{$ELSE}nil{$ENDIF},ACleFiche,LNode);
  with ATree do
  if LNode <> nil Then
   Begin
     {$IFDEF VIRTUALTREES}FocusedNode{$ELSE}Selected{$ENDIF}:=LNode;
   end;
end;

procedure TreeFindNode(const ATree : {$IFDEF VIRTUALTREES}TBaseVirtualTree{$ELSE}TTreeview{$ENDIF}; const ANode: {$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF}; const ACleFiche:integer;var FoundNode:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF});
var
  LNode:{$IFDEF VIRTUALTREES}PVirtualNode{$ELSE}TTreeNode{$ENDIF};
begin
  if ( ANode = nil )
  {$IFDEF VIRTUALTREES}or ( ANode = ATree.RootNode){$ENDIF}
   Then
    Exit;
  with ATree,PNodeIndividu({$IFDEF VIRTUALTREES}GetNodeData( ANode ){$ELSE}ANode.Data{$ENDIF})^ do
  if fCleFiche=ACleFiche Then
    Begin
      FoundNode := Anode;
      Exit;
    end;
  if FoundNode <> nil Then Exit;
  LNode:={$IFDEF VIRTUALTREES}ANode^.FirstChild{$ELSE}ANode.GetFirstChild{$ENDIF};
  while LNode<>nil do
    Begin
      TreeFindNode(ATree,LNode,ACleFiche,FoundNode);
      LNode:=LNode.{$IFDEF VIRTUALTREES}NextSibling{$ELSE}GetNextSibling{$ENDIF};
    end;
end;

end.

