unit u_Form_Capture_Photos;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  TPanelUnit, DirectShow9, DSPack, DSUtil, Windows,
{$ELSE}
{$ENDIF}
  Forms,StdCtrls,ExtCtrls, Classes,
  u_buttons_appli,JvXPButtons;

type

  { TFCapture_Photo }

  TFCapture_Photo=class(TForm)
//    FilterGraph:TFilterGraph;
//    Filter:TFilter;
//    SampleGrabber:TSampleGrabber;
    Panel3:TPanel;
    Image1:TImage;
    Label2:TLabel;
    Label1:TLabel;
//    VideoWindow:TVideoWindow;
    VideoCapFilters:TListBox;
    Panel1:TPanel;
    btnCancel:TFWCancel;
    btnEnregistrer:TFWOK;
    SnapShot:TJvXPButton;
    Image:TImage;
    FlatPanel1:TPanel;
    FlatPanel2:TPanel;
    procedure SnapShotClick(Sender:TObject);
    procedure VideoCapFiltersClick(Sender:TObject);
    procedure btnEnregistrerClick(Sender:TObject);
    procedure btnCancelClick(Sender:TObject);
  private
    { Déclarations privées }
    fImage:string;
  protected
    procedure DoShow; override;
  public
    { Déclarations publiques }
    procedure Loaded; override;
    property sImage:string read fImage write fImage;
  end;

var
  FCapture_Photo:TFCapture_Photo;
//  SysDev:TSysDevEnum;
implementation

uses fonctions_ini,
     u_common_ancestro,
     u_common_ancestro_functions,
     u_genealogy_context;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFCapture_Photo.SnapShotClick(Sender:TObject);
begin
//  SampleGrabber.GetBitmap(Image.Picture.Bitmap);
  btnEnregistrer.Enabled:=True;
end;

procedure TFCapture_Photo.VideoCapFiltersClick(Sender:TObject);
begin
{  SysDev.SelectGUIDCategory(CLSID_VideoInputDeviceCategory);

  if VideoCapFilters.ItemIndex<>-1 then
  begin
    FilterGraph.ClearGraph;
    FilterGraph.Active:=false;
    Filter.BaseFilter.Moniker:=SysDev.GetMoniker(VideoCapFilters.ItemIndex);
    FilterGraph.Active:=true;

    with FilterGraph as ICaptureGraphBuilder2 do
      RenderStream(@PIN_CATEGORY_PREVIEW,
        nil,Filter as IBaseFilter,SampleGrabber as IBaseFilter,VideoWindow as IbaseFilter);
    FilterGraph.Play;

    SnapShot.Enabled:=True;
  end;}
end;

procedure TFCapture_Photo.Loaded;

var
  i:integer;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
{  SysDev:=TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);

  for i:=0 to SysDev.CountFilters-1 do
    VideoCapFilters.Items.Add(SysDev.Filters[i].FriendlyName);

  VideoCapFilters.ItemIndex:=0;
  VideoCapFiltersClick(Sender);}
  inherited;
end;

procedure TFCapture_Photo.btnEnregistrerClick(Sender:TObject);
begin
  if Image.Picture<>nil then
  begin
    fImage:=_TempPath+'Temp.BMP';
    Image.Picture.SaveToFile(fImage);
  end;
  Close;
end;

procedure TFCapture_Photo.btnCancelClick(Sender:TObject);
begin
  fImage:='';
  Close;
end;

procedure TFCapture_Photo.DoShow;
begin
  inherited;
  Caption:=rs_Caption_Capture_a_picture;
end;

end.

