{-----------------------------------------------------------------------}
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to now (LAZARUS),              }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Mutancestre                               }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{           André Langlet                                               }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Mutancestre est un Logiciel Libre                           }
{  refonte complète le 27/05/2011                                       }
{-----------------------------------------------------------------------}

unit u_Form_Mutation_Base;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, ShlObj, Windows,
{$ELSE}
  LCLIntf,
{$ENDIF}
  Forms,IB, IBBlob,
  StdCtrls,Controls,ExtCtrls,u_buttons_appli,JvXPButtons,Classes,
  u_framework_components, u_ancestropictimages,DB,
  U_ExtDBGrid,IBCustomDataSet,SysUtils,
  Dialogs, u_framework_dbcomponents,
  IBQuery, BGRAAnimatedGif, BGRABitmapTypes,
  IBDatabase,StrUtils,
  IBSQL,u_objet_TMotsClesDate,u_objet_TGedcomDate, rxlookup;

type

  { TFMutationBase }

  TFMutationBase=class(TForm)
    btnConnectOrigine: TJvXPButton;
    cbDossierDestination: TFWDBLookupCombo;
    cbDossierOrigine: TFWDBLookupCombo;
    Label2: TLabel;
    lbEmplacementbdd: TFWComboBox;
    Panel2: TPanel;
    Panel3:TPanel;
    Image1:TIATitle;
    Label1:TLabel;
    gbDestination:TGroupBox;
    gbOrigine:TGroupBox;
    gDestination:TExtDBGrid;
    dsDossierOrigine:TDataSource;
    dsIndiOrigine:TDataSource;
    Panel4: TPanel;
    QueryToClone: TIBQuery;
    qIndiDestinationCLE_FICHE1: TLongintField;
    qIndiDestinationNOM1: TIBStringField;
    qIndiDestinationPRENOM1: TIBStringField;
    qIndiOrigine:TIBQuery;
    qIndiOrigineCLE_FICHE:TLongintField;
    qIndiOrigineNOM:TIBStringField;
    qIndiOriginePRENOM:TIBStringField;
    Panel1:TPanel;
    btnImport:TFWImport;
    btnClose:TFWClose;
    IBBaseOrigine:TIBDatabase;
    IBTrans_Origine:TIBTransaction;
    dsIndiDestination:TDataSource;
    qIndiDestination:TIBQuery;
    dsDossierDestination:TDataSource;
    gOrigine:TExtDBGrid;
    qIndiDestinationCLE_FICHE:TLongintField;
    qIndiDestinationNOM:TIBStringField;
    qIndiDestinationPRENOM:TIBStringField;
    lImport:TLabel;
    pAnime:TPanel;
    Animate:TBGRAAnimatedGif;
    SelectFichier:TOpenDialog;
    QTestTableChamp:TIBSQL;
    qPhoto:TIBSQL;
    QmajMedia:TIBSQL;
    TDossierDestination:TIBQuery;
    TDossierDestinationCLE_DOSSIER:TLongintField;
    TDossierDestinationNOM_DOSSIER:TIBStringField;
    tDossierOrigine:TIBQuery;
    tDossierOrigineCLE_DOSSIER:TLongintField;
    tDossierOrigineNOM_DOSSIER:TIBStringField;
    qTestLangue: TIBSQL;

    procedure btnCloseClick(Sender:TObject);
    procedure btnConnectOrigineClick(Sender:TObject);
    procedure btnImportClick(Sender:TObject);
    procedure cbDossierDestinationClosePopup(Sender: TObject;
      SearchResult: boolean);
    procedure cbDossierOrigineClosePopup(Sender: TObject; SearchResult: boolean
      );
    procedure cbBaseOriginePropertiesButtonClick(Sender:TObject;
      AButtonIndex:Integer);
    procedure cbBaseOriginePropertiesChange(Sender:TObject);
    procedure lbEmplacementbddChange(Sender: TObject);
  private
    bOrigAvecDateCode:Boolean;
    MotsClesDecode:TMotsClesDate;
    MaDate:TGedcomDate;
    procedure doImport;
    function NbrIndiDossier(Req:TIBQuery):string;
    function TestTableChamp(Table,Champ:string):boolean;
  protected
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoShow; override;
  public
    procedure Loaded; override;
    destructor Destroy; override;

  end;

implementation

uses  u_dm,
      u_common_ancestro,
      u_common_resources,
      LazUTF8,
      fonctions_dialogs,
      fonctions_db,
      fonctions_dbobjects,
      fonctions_components,
      fonctions_system,
      u_common_const,
      u_common_functions,
      IBDatabaseInfo,
      fonctions_string,
      fonctions_ini,
      u_common_ancestro_functions,
      fonctions_images,
      {$IFNDEF IMAGING}
       bgrabitmap,
      {$ELSE}
      ImagingTypes,
      {$ENDIF}
      u_genealogy_context,
      LazFileUtils,
      u_connexion;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}

procedure TFMutationBase.Loaded;
begin
  f_GetMemIniFile;
  p_ReadComboBoxItems(lbEmplacementbdd,lbEmplacementbdd.Items);
  lbEmplacementbdd.ItemIndex := f_IniReadSectionInt(Name,lbEmplacementbdd.name,lbEmplacementbdd.ItemIndex);
  Color:=gci_context.ColorLight;
  // -- création et initialisation de la fenetre --------------------
  tDossierDestination.Open;
  cbDossierDestination.Caption:=fNomDossier;

  qIndiDestination.Params[0].AsInteger:=tDossierDestination.FieldByName(IBQ_CLE_DOSSIER).AsInteger;
  qIndiDestination.Open;

  gbDestination.Caption:=fs_RemplaceMsg(rs_Caption_Destination_Persons,[NbrIndiDossier(qIndiDestination)]);
  sOrdreLIT:='';
  sOrdreNUM:='';
  btnConnectOrigine.Hint:=rs_Hint_if_server_version_is_used_maj_will_open_connexion_dialog;
  MotsClesDecode:=TMotsClesDate.create;
  MaDate:=TGedcomDate.Create;
  MaDate.InitTGedcomDate(_MotsClesDate,_MotsClesDate);
  Animate:=TBGRAAnimatedGif.Create(fs_getImagesSoftDir+'pleasewait.gif');
  inherited;
end;

procedure TFMutationBase.DoClose(var Action:TCloseAction);
begin
  inherited;
  //Fermeture des tables, bases et fenetre
  tDossierOrigine.Close;
  qIndiDestination.Close;
  qIndiOrigine.close;
  tDossierDestination.Close;
  IBTrans_Origine.Active:=False;
  IBBaseOrigine.Close;
  sOrdreLIT:='';
  sOrdreNUM:='';

  f_GetMemIniFile;
  p_writeComboBoxItems(lbEmplacementbdd,lbEmplacementbdd.Items);
  p_IniWriteSectionInt(Name,lbEmplacementbdd.name,lbEmplacementbdd.ItemIndex);
  fb_iniWriteFile(FIniFile,False);

  Action:=caFree;
end;

procedure TFMutationBase.DoShow;
begin
  inherited DoShow;
  if lbEmplacementbdd.ItemIndex > -1 Then
   btnConnectOrigine.Enabled:=True;
end;

procedure TFMutationBase.btnCloseClick(Sender:TObject);
begin
  Animate.Hide(Canvas,ClientRect);
  Close;
end;

procedure TFMutationBase.btnConnectOrigineClick(Sender:TObject);
var
  s,Id,Pw,Rl:string;
  q:TIBSQL;
  n:Single;
  b:boolean;
  sChaineConnect:string;

begin
  tDossierOrigine.Close;
  qIndiOrigine.Close;
  if IBTrans_Origine.Active then
    IBTrans_Origine.Commit;
  IBBaseOrigine.Close;
  btnImport.Enabled:=false;
  gbOrigine.Caption:=' Origine ';
  if btnConnectOrigine.Caption='Déconnecter' then
  begin
    btnConnectOrigine.Caption:='Connecter';
  end
  else
  begin
    sChaineConnect:=lbEmplacementbdd.Text;
    Id:=_user_name;
    Pw:=_password;
    Rl:=_role_name;
    if not ConnexionBase(IBBaseOrigine,sChaineConnect,IBTrans_Origine,_lc_ctypeUTF8
      ,Id,Pw,Rl,'INDIVIDU',b) then
      exit;

    btnConnectOrigine.Caption:='Déconnecter';
    q:=TIBSQL.Create(self);
    with q do
    try
      Database:=IBBaseOrigine;
      Transaction:=IBTrans_Origine;
      SQL.Text:='select FIRST(1) VER_VERSION FROM T_VERSION_BASE';
      try
        ExecQuery;
        s:=Fields[0].AsString;
        Close;
        lImport.Caption:='Base origine version '+s;
        
        n:=StrToFloat(AnsiReplaceStr(s,'.',DefaultFormatSettings.DecimalSeparator));
      except
        s:='inconnue car table T_VERSION_BASE absente,';
        n:=0;
      end;
      if n<=1.0429 then
      begin
        MyMessageDlg(fs_RemplaceMsg(rs_Error_this_Database_version_is_too_old,[s])
          ,mmtError, [mmbCancel],Self);
        IBTrans_Origine.Commit;
        IBBaseOrigine.Close;
        lbEmplacementbdd.SetFocus;
        btnConnectOrigine.Caption:='Connecter';
        Exit;
      end;
      if n<=3.569 then
      begin
        MyMessageDlg(fs_RemplaceMsg(rs_Warning_this_Database_version_is_old,[s])
          ,mmtWarning, [mmbOk],Self);
      end;
    finally
      q.Free;
    end;

    tDossierOrigine.Open;
    fb_AddToCombo ( lbEmplacementbdd,sChaineConnect,True);
    cbDossierOrigine.Clear;
    cbDossierOrigine.Enabled:=true;
    //cbDossierOrigine.DroppedDown:=true; MG ?
  end;
end;

function TFMutationBase.TestTableChamp(Table,Champ:string):boolean;
begin
  with QTestTableChamp do
  begin
    Close;
    Params[0].AsString:=UTF8UpperCase(Table);
    Params[1].AsString:=UTF8UpperCase(Champ);
    ExecQuery;
    Result:=not Eof;
    Close;
  end;
end;

procedure TFMutationBase.btnImportClick(Sender:TObject);
var
  DBInfos:TIBDatabaseInfo;
  PCOrigine,PCDestination,BaseOrigine,BaseDestination,langue:string;
begin
  //contrôle des connections
  if (qIndiOrigine.Active=False)or(qIndiDestination.Active=False) then
  begin
    MyMessageDlg(rs_Error_import_forbidden+_CRLF+rs_Error_Folders_not_defined
      ,mmtError, [mmbCancel],Self);
    Exit;
  end;

  //contrôle pour éviter bouclage
  DBInfos:=TIBDatabaseInfo.Create(self);
  try
    DBInfos.Database:=IBBaseOrigine;
    PCOrigine:=DBInfos.DBSiteName;
    BaseOrigine:=DBInfos.DBFileName;
    DBInfos.Database:=dm.ibd_BASE;
    PCDestination:=DBInfos.DBSiteName;
    BaseDestination:=DBInfos.DBFileName;
  finally
    DBInfos.Free;
  end;
  if (PCDestination=PCOrigine)and(BaseDestination=BaseOrigine)
    and(tDossierDestination.FieldByName(IBQ_CLE_DOSSIER).AsInteger=tDossierOrigine.FieldByName(IBQ_CLE_DOSSIER).AsInteger) then
  begin
    MyMessageDlg(rs_Error_import_forbidden+_CRLF+rs_Error_Same_folders
      ,mmtError, [mmbCancel],Self);
    exit;
  end;
  bOrigAvecDateCode:=TestTableChamp('EVENEMENTS_IND',IBQ_EV_IND_CALENDRIER);
  langue:='FRA';
  if TestTableChamp('DOSSIER','DS_LANGUE') then
   with qTestLangue do
    begin
      Close;
      Params[0].AsInteger:=tDossierOrigineCLE_DOSSIER.AsInteger;
      ExecQuery;
      langue:=Fields[0].AsString;
      Close;
     end;
  MotsClesDecode.LoadMotClefDate(QueryToClone,langue);
  MaDate.InitTGedcomDate(MotsClesDecode,_MotsClesDate);
  doImport;
end;

procedure TFMutationBase.cbDossierDestinationClosePopup(Sender: TObject;
  SearchResult: boolean);
begin
 with qIndiDestination do
  Begin
   Close;
   DisableControls;
   Params[0].AsInteger:=tDossierDestination.FieldByName(IBQ_CLE_DOSSIER).AsInteger;
   Open;
   EnableControls;
  end;
 gbDestination.Caption:=fs_RemplaceMsg(rs_Caption_Destination_Persons,[NbrIndiDossier(qIndiOrigine)]);
end;

procedure TFMutationBase.cbDossierOrigineClosePopup(Sender: TObject;
  SearchResult: boolean);
begin
 screen.Cursor:=crHourglass;

 with qIndiOrigine do
  Begin
   Close;
   DisableControls;
   Params[0].AsInteger:=tDossierOrigine.FieldByName(IBQ_CLE_DOSSIER).AsInteger;
   Open;
   EnableControls;
  end;
 btnImport.Enabled:=(not qIndiOrigine.Eof);
 cbDossierDestination.Enabled:=btnImport.Enabled;
 gbOrigine.Caption:=fs_RemplaceMsg(rs_Caption_Source_Persons,[NbrIndiDossier(qIndiOrigine)]);

 screen.Cursor:=crDefault;
end;


procedure TFMutationBase.cbBaseOriginePropertiesButtonClick(Sender:TObject;
  AButtonIndex:Integer);
begin
  with SelectFichier do
   Begin
    InitialDir:=ExtractFileDir(gs_DefaultDatabase);
    Title:=rs_Title_Original_database;
    if Execute then
      lbEmplacementbdd.Text:=FileName;
   end;
end;

procedure TFMutationBase.cbBaseOriginePropertiesChange(Sender:TObject);
begin
  btnConnectOrigine.Enabled:=Length(lbEmplacementbdd.Text)>5;
  tDossierOrigine.Close;
  qIndiOrigine.Close;
  if IBTrans_Origine.Active then
    IBTrans_Origine.Commit;
  IBBaseOrigine.Close;
  btnImport.Enabled:=false;
  gbOrigine.Caption:=rs_Caption_Original_source;
  cbDossierOrigine.Enabled:=False;
  btnConnectOrigine.Caption:=rs_Caption_Connect;
end;

procedure TFMutationBase.lbEmplacementbddChange(Sender: TObject);
begin
  btnConnectOrigine.Enabled:=True;
  cbDossierDestination.Enabled:=False;
end;


procedure TFMutationBase.doImport;
var
  SQLQSource,SQLQCible,SQLQCible2,SQLQCible3,SQLQCible4:TIBSQL;
  IG_ID,i,p,id,NbrEnr,annee1,annee2:Integer;
  tampon,tampon2:TMemoryStream;
  ImageData : {$IFNDEF IMAGING}TBGRACustomBitmap{$ELSE}TImageData{$ENDIF};
  dossiers,dossierc,s:string;
  bNouvVersion,EVavecLIGNES_ADRESSES,bContinuer:boolean;

//Corps de la procédure ButtonImporterClick
//La table temporaire TQ_CONSANG de la base cible est utilisée pour mémoriser la
//correspondance entre les anciennes (INDI) et les nouvelles clefs (DECUJUS).
//ID est l'identifiant de la table
// 1 INDIVIDU
// 2 MULTIMEDIA
// 3 EVENEMENTS_IND
// 4 T_UNION
// 5 EVENEMENTS_FAM
// 6 SOURCES_RECORD
  procedure p_LoadFromStream ( const ASQLQSource : TIBSQL; const AFieldSource : String );
  Begin
   (ASQLQSource.FieldByName(AFieldSource) as TIBBlobStream).SaveToStream(tampon);
  end;

  procedure p_LoadFromStream2 ( const ASQLQSource : TIBSQL; const AFieldSource : String );
  Begin
    (ASQLQSource.ParamByName(AFieldSource) as TIBBlobStream).SaveToStream(tampon2);
  end;

  procedure p_SaveToStream ( const ASQLQCible : TIBSQL; const AFieldCible : String );
  Begin
    (ASQLQCible.paramByName(AFieldCible) as TIBBlobStream).LoadFromStream(tampon);
  end;

 begin
  Dossiers:=tDossierOrigine.FieldByName(IBQ_CLE_DOSSIER).AsString;
  Dossierc:=tDossierDestination.FieldByName(IBQ_CLE_DOSSIER).AsString;

  btnImport.Enabled:=false;
  btnClose.Enabled:=false;
  pAnime.Visible:=True;

  Animate.Show(Canvas,ClientRect);
  Animate.Resume;

  screen.Cursor:=crHourglass;
  

  //initialisation
  qIndiDestination.Close;

  SQLQSource:=TIBSQL.Create(self);
  SQLQSource.Database:=IBBaseOrigine;
  SQLQSource.Transaction:=IBTrans_Origine;

  SQLQCible:=TIBSQL.Create(self);
  SQLQCible.Database:=dm.ibd_BASE;// Base de destination
  SQLQCible.Transaction:=dm.ibd_BASE.DefaultTransaction;// Base de destination

  SQLQCible2:=TIBSQL.Create(self);
  SQLQCible2.Database:=dm.ibd_BASE;// Base de destination
  SQLQCible2.Transaction:=dm.ibd_BASE.DefaultTransaction;// Base de destination

  SQLQCible3:=TIBSQL.Create(self);
  SQLQCible3.Database:=dm.ibd_BASE;// Base de destination
  SQLQCible3.Transaction:=dm.ibd_BASE.DefaultTransaction;// Base de destination

  SQLQCible4:=TIBSQL.Create(self);
  SQLQCible4.Database:=dm.ibd_BASE;// Base de destination
  SQLQCible4.Transaction:=dm.ibd_BASE.DefaultTransaction;// Base de destination

  SQLQCible.SQL.Text:='insert into T_IMPORT_GEDCOM (IG_ID,IG_PATH) values('
    +IntToStr(IG_ID)+','''+IBBaseOrigine.DatabaseName+' dossier '+dossiers
    +' dans dossier '+dossierc+''')';

  with SQLQSource, SQLQCible.SQL, SQLQCible.Params do
  try//du finally de cloture

  //insertion de l'import
    IG_ID:=dm.uf_GetClefUnique('T_IMPORT_GEDCOM');
    try
      SQLQCible.ExecQuery;
    except
      on E:EIBError do
      begin
        MyMessageDlg(rs_Error_T_IMPORT_GEDCOM_update+_CRLF+_CRLF+E.Message
          ,mmtError, [mmbCancel],Self);
        dm.IBT_base.RollbackRetaining;
        exit;
      end;
    end;

  //effacement de TQ_CONSANG
    SQLQCible.Close;
    Text:='DELETE FROM TQ_CONSANG';

    try
      SQLQCible.ExecQuery;
    except
      on E:EIBError do
      begin
        MyMessageDlg(rs_Error_TQ_CONSANG_deleting+_CRLF+_CRLF+E.Message
          ,mmtError, [mmbCancel],Self);
        dm.IBT_base.RollbackRetaining;
        exit;
      end;
    end;

    SQLQCible.Close;

  //recherche de l'ordre des éléments de la date (jour, mois, année) dans la base source.
    SQL.Text := 'select first(2) r.token from dossier d' + #10 +
                           'inner join ref_token_date r on r.langue=d.ds_langue and r.type_token=23' + #10 +
                           'where d.cle_dossier='+dossiers + #10 +
                           'order by r.ID';
    try
      ExecQuery;
      if not Eof then
      begin
        s:=UTF8UpperCase(Fields[0].AsString);
        if (s='DMY')or(s='MDY')or(s='YMD') then
        begin
          sOrdreLIT:=s;
          sOrdreNUM:=s;
          Next;
          if not Eof then
          begin
            s:=UTF8UpperCase(Fields[0].AsString);
            if (s='DMY')or(s='MDY')or(s='YMD') then
              sOrdreNUM:=s;
          end;
        end;
      end;
      Close;
    except
    // table ref_token_date absente de la base source. On espère que les formats sont les mêmes..
    end;

  // -- table INDIVIDU---------------------------------------------------------------------------------------
    lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['INDIVIDU']);
    

    SQL.Text:='select count(*) from INDIVIDU where KLE_DOSSIER='+dossiers;
    ExecQuery;
    NbrEnr:=Fields[0].AsInteger;
    Close;
    SQL.Text:='select * from INDIVIDU where KLE_DOSSIER='+dossiers;
    ExecQuery;

    if not Eof then
    begin
      I:=0;
      Text:=' insert into INDIVIDU ('+_CRLF
        +'CLE_FICHE'+_CRLF
        +',KLE_DOSSIER'+_CRLF
        +',SEXE'+_CRLF
        +',CLE_PARENTS'+_CRLF
        +',CLE_PERE'+_CRLF
        +',CLE_MERE'+_CRLF
        +',PREFIXE'+_CRLF
        +',NOM'+_CRLF
        +',PRENOM'+_CRLF
        +',SURNOM'+_CRLF
        +',SUFFIXE'+_CRLF
        +',SOURCE'+_CRLF
        +',COMMENT'+_CRLF
        +',FILLIATION'+_CRLF
        +',MODIF_PAR_QUI'+_CRLF
        +',NCHI'+_CRLF
        +',NMR'+_CRLF
        +',ID_IMPORT_GEDCOM'+_CRLF
        +',IND_CONFIDENTIEL'+_CRLF
        +')'+_CRLF
        +' values('+_CRLF
        +'gen_id(gen_individu,1)'+_CRLF
        +','+dossierc+_CRLF
        +',:SEXE'+_CRLF
        +',:CLE_PARENTS'+_CRLF
        +',:CLE_PERE'+_CRLF
        +',:CLE_MERE'+_CRLF
        +',:PREFIXE'+_CRLF
        +',:NOM'+_CRLF
        +',:PRENOM'+_CRLF
        +',:SURNOM'+_CRLF
        +',:SUFFIXE'+_CRLF
        +',:SOURCE'+_CRLF
        +',:COMMENT'+_CRLF
        +',:FILLIATION'+_CRLF
        +',:MODIF_PAR_QUI'+_CRLF
        +',:NCHI'+_CRLF
        +',:NMR'+_CRLF
        +','+IntToStr(IG_ID)+_CRLF
        +',:IND_CONFIDENTIEL'+_CRLF
        +')returning cle_fiche';
      SQLQCible2.SQL.Text:='insert into TQ_CONSANG (ID,INDI,DECUJUS) values(1,:cle_fiche,:decujus)';
      tampon:=TMemoryStream.Create;
      try
        SQLQCible .Params.Modified;//needed to create params
        SQLQCible2.Params.Modified;//needed to create params
        while not Eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['INDIVIDU',IntToStr(I),IntToStr(NbrEnr)]);
            
          byName( IBQ_SEXE ).AsInteger:=SQLQSource.FieldByName(IBQ_SEXE).AsInteger;
          for p:=2 to  Count-1 do //initialisation des paramètres qui peuvent être nuls
             getSQLParam (p).Clear;
          if FieldByName(IBQ_CLE_PARENTS).IsNull
            then byName( IBQ_CLE_PARENTS ).IsNull:=True
            Else byName( IBQ_CLE_PARENTS ).AsInteger:=FieldByName(IBQ_CLE_PARENTS).AsInteger;
          if FieldByName(IBQ_CLE_PERE).AsInteger=0
            then byName( IBQ_CLE_PERE ).IsNull:=True
            Else byName( IBQ_CLE_PERE ).AsInteger:=FieldByName(IBQ_CLE_PERE).AsInteger;
          if FieldByName(IBQ_CLE_MERE).AsInteger=0
            then byName( IBQ_CLE_MERE ).IsNull:=True
            Else byName( IBQ_CLE_MERE ).AsInteger:=FieldByName(IBQ_CLE_MERE).AsInteger;
          if FieldByName(IBQ_PREFIXE).AsString=''
           then byName( IBQ_PREFIXE ).IsNull:=True
           Else byName( IBQ_PREFIXE ).AsString:=FieldByName(IBQ_PREFIXE).AsString;
          if FieldByName(IBQ_NOM).AsString=''
            then byName( IBQ_NOM ).IsNull:=True
            Else byName( IBQ_NOM ).AsString:=fs_FormatText(FieldByName(IBQ_NOM).AsString,mftUpper);//AL2011
          if FieldByName(IBQ_PRENOM).AsString=''
            then byName( IBQ_PRENOM ).IsNull:=True
            Else byName( IBQ_PRENOM ).AsString:=fs_FormatText(FieldByName(IBQ_PRENOM).AsString,mftFirstIsMaj);
          if FieldByName(IBQ_SURNOM).AsString=''
            then byName( IBQ_SURNOM ).IsNull:=True
            Else byName( IBQ_SURNOM ).AsString:=FieldByName(IBQ_SURNOM).AsString;
          if FieldByName(IBQ_SUFFIXE).AsString=''
            then byName( IBQ_SUFFIXE ).IsNull:=True
            Else byName( IBQ_SUFFIXE ).AsString:=FieldByName(IBQ_SUFFIXE).AsString;

          if FieldByName(IBQ_SOURCE).IsNull
            then byName( IBQ_SOURCE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'SOURCE');
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,'SOURCE');
              end;

          if FieldByName(IBQ_COMMENT).IsNull
            then byName( IBQ_COMMENT ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'COMMENT');
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,'COMMENT');
              end;

          if FieldByName( IBQ_FILLIATION ).AsString=''
            then byName( IBQ_FILLIATION ).IsNull:=True
            Else byName( IBQ_FILLIATION ).AsString:=FieldByName(IBQ_FILLIATION).AsString;

          if FieldByName(IBQ_MODIF_PAR_QUI).AsString=''
            then byName( IBQ_MODIF_PAR_QUI ).IsNull:=True
            Else byName( IBQ_MODIF_PAR_QUI ).AsString:=FieldByName(IBQ_MODIF_PAR_QUI).AsString;

          try//champs inexistants sur anciennes bases
            if FieldByName(IBQ_NCHI).IsNull
              then byName( IBQ_NCHI ).IsNull:=True
              Else byName( IBQ_NCHI ).AsInteger:=FieldByName(IBQ_NCHI).AsInteger;
            if FieldByName(IBQ_NMR).IsNull
              then byName( IBQ_NMR ).IsNull := True
              Else byName( IBQ_NMR ).AsInteger:=FieldByName(IBQ_NMR).AsInteger;
          except
          end;

          try//champ inexistant sur anciennes bases
            if FieldByName(IBQ_IND_CONFIDENTIEL).IsNull
              then byName( IBQ_IND_CONFIDENTIEL).IsNull:=True
              Else byName( IBQ_IND_CONFIDENTIEL).AsInteger:=FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger;
          except
          end;

          try
            SQLQCible.ExecQuery;//transfert individu
            SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
            SQLQCible2.ParamByName(IBQ_CLE_FICHE).Value:=FieldByName(IBQ_CLE_FICHE).Value;
            SQLQCible2.ExecQuery;//transfert individu
          except
            on E:EIBError do
            begin
              MyMessageDlg(rs_Error_person_transfer_with_NIP+FieldByName(IBQ_CLE_FICHE).AsString
                +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
              dm.IBT_base.RollbackRetaining;
              exit;
            end;
          end;
          Next;
        end;
      finally
        tampon.Free;
      end;
    with SQLQCible do
     Begin
      Close;
      SQL.Text := 'update INDIVIDU i set i.CLE_PERE=(select DECUJUS from TQ_CONSANG' + #10 +
                  ' where ID=1 and INDI=i.CLE_PERE)' + #10 +
                  ' where i.ID_IMPORT_GEDCOM='+IntToStr(IG_ID) + #10 +
                  ' and i.CLE_PERE is not null';
      lImport.Caption:=rs_Caption_Updating_father_key_of_PERSON;
      
      try
        ExecQuery;//mise à jour cle_pere
      except
        on E:EIBError do
        begin
          MyMessageDlg(rs_Error_person_cle_pere_father_key
            +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
          dm.IBT_base.RollbackRetaining;
          exit;
        end;
      end;
      Close;
      SQL.Text := 'update INDIVIDU i set i.CLE_MERE=(select DECUJUS from TQ_CONSANG' + #10 +
                  ' where ID=1 and INDI=i.CLE_MERE)' + #10 +
                  ' where i.ID_IMPORT_GEDCOM='+IntToStr(IG_ID) + #10 +
                  ' and i.CLE_MERE is not null';
      lImport.Caption:=rs_Caption_Updating_Mother_key_of_PERSON;
      
      try
        ExecQuery;//mise à jour cle_mere
      except
        on E:EIBError do
        begin
          MyMessageDlg(rs_Error_person_cle_mere_mother_key
            +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
          dm.IBT_base.RollbackRetaining;
          exit;
        end;
      end;
      Close;
     End;
    end;// fin de If not Eof

    Close;

    // -- Table MULTIMEDIA-------------------------------------------------------------------------------------
    lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['MULTIMEDIA']);
    
    SQL.Text:='select count(*) from MULTIMEDIA where MULTI_DOSSIER='+dossiers;
    ExecQuery;
    NbrEnr:=Fields[0].AsInteger;
    Close;
    SQL.Text:='select * from MULTIMEDIA where MULTI_DOSSIER='+dossiers;
    ExecQuery;

    if not Eof then
    begin
      i:=0;
      Text:=' insert into MULTIMEDIA ('
        +'MULTI_CLEF'
        +',MULTI_DOSSIER'
        +',ID_IMPORT_GEDCOM'
        +',MULTI_INFOS'
        +',MULTI_MEDIA'
        +',MULTI_DATE_MODIF'
        +',MULTI_MEMO'
        +',MULTI_REDUITE'
        +',MULTI_IMAGE_RTF'
        +',MULTI_PATH'
        +')'
        +' values('
        +'gen_id(gen_multimedia,1)'
        +','+dossierc
        +','+IntToStr(IG_ID)
        +',:MULTI_INFOS'
        +',:MULTI_MEDIA'
        +',:MULTI_DATE_MODIF'
        +',:MULTI_MEMO'
        +',:MULTI_REDUITE'
        +',:MULTI_IMAGE_RTF'
        +',:MULTI_PATH'
        +')returning multi_clef';
      SQLQCible2.SQL.Text:='insert into TQ_CONSANG (ID,INDI,DECUJUS) values(2,:MULTI_CLEF,:decujus)';

      tampon:=TMemoryStream.Create;
      try
        SQLQCible.Params.Modified;//needed to create params
        SQLQCible2.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) then
          begin
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['MULTIMEDIA',IntToStr(I),IntToStr(NbrEnr)]);
            
          end;
          byName( IBQ_MULTI_CLEF).AsInteger:=FieldByName(IBQ_MULTI_CLEF).AsInteger;//NouvCle;
          for p:=1 to  Count-1 do //initialisation des paramètres qui peuvent être nuls
             getSQLParam (p).Clear;

          if FieldByName(IBQ_MULTI_INFOS).AsString=''
            then byName( IBQ_MULTI_INFOS).IsNull:=True
            Else byName( IBQ_MULTI_INFOS).AsString:=FieldByName(IBQ_MULTI_INFOS).AsString;

          if FieldByName(IBQ_MULTI_MEDIA).IsNull
            then byName( IBQ_MULTI_MEDIA ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_MULTI_MEDIA);
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,IBQ_MULTI_MEDIA);
              end;

          if FieldByName(IBQ_MULTI_DATE_MODIF).IsNull
            then byName( IBQ_MULTI_DATE_MODIF).IsNull:=True
            Else byName( IBQ_MULTI_DATE_MODIF).AsDateTime:=FieldByName(IBQ_MULTI_DATE_MODIF).AsDateTime;

          if FieldByName(IBQ_MULTI_MEMO).IsNull
           then byName( IBQ_MULTI_MEMO ).IsNull:=True
           Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_MULTI_MEMO);
              if tampon.Size>0 then
                p_SaveToStream ( SQLQCible,IBQ_MULTI_MEMO);
            end;

          if FieldByName(IBQ_MULTI_REDUITE).IsNull
           then byName( IBQ_MULTI_REDUITE ).IsNull:=True
           Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_MULTI_REDUITE);
              if tampon.Size>0 then
                p_SaveToStream ( SQLQCible,IBQ_MULTI_REDUITE);
            end;

          if FieldByName(IBQ_MULTI_IMAGE_RTF).IsNull
            then byName( IBQ_MULTI_IMAGE_RTF ).IsNull:=True
            Else byName( IBQ_MULTI_IMAGE_RTF ).AsInteger:=FieldByName(IBQ_MULTI_IMAGE_RTF).AsInteger;

          if FieldByName(IBQ_MULTI_PATH).AsString=''
            then byName( IBQ_MULTI_PATH ).IsNull:=True
            Else byName( IBQ_MULTI_PATH ).AsString:=FieldByName(IBQ_MULTI_PATH).AsString;

          try
            SQLQCible.ExecQuery;
            SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
            SQLQCible2.ParamByName(IBQ_MULTI_CLEF).Value:=FieldByName(IBQ_MULTI_CLEF).Value;
            SQLQCible2.ExecQuery;//transfert individu
          except
            on E:EIBError do
            begin
              MyMessageDlg(rs_Error_media_number_transfer+FieldByName(IBQ_MULTI_CLEF).AsString
                +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
              dm.IBT_base.RollbackRetaining;
              exit;
            end;
          end;

          Next;
        end;
      finally
        tampon.Free;
      end;

      SQLQCible .Close;
      SQLQCible2.Close;
    end;// fin de If not Eof
    Close;

    dm.InactiveTriggersLieuxFavoris(true);
    tampon:=TMemoryStream.Create;
    tampon2:=TMemoryStream.Create;
    try
    // -- Table EVENEMENTS_IND---------------------------------------------------------------------------------
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['EVENEMENTS_IND']);
      
      SQL.Text:='select count(*) from individu i';
      SQL.Add('inner join evenements_ind e on e.ev_ind_kle_fiche=i.cle_fiche');
      SQL.Add('where i.kle_dossier='+dossiers);
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Text:='select e.* from individu i';
      SQL.Add('inner join evenements_ind e on e.ev_ind_kle_fiche=i.cle_fiche');
      SQL.Add('where i.kle_dossier='+dossiers);
      ExecQuery;

      Text:='insert into EVENEMENTS_IND ('
        +IBQ_EV_IND_CLEF
        +',EV_IND_KLE_FICHE'
        +',EV_IND_KLE_DOSSIER'
        +',EV_IND_TYPE'
        +',EV_IND_DATE_WRITEN'
        +',EV_IND_DATE_YEAR'
        +',EV_IND_DATE_MOIS'
        +',EV_IND_CALENDRIER1'
        +',EV_IND_CALENDRIER2'
        +',EV_IND_DATE'
        +',EV_IND_DATE_YEAR_FIN'
        +',EV_IND_DATE_MOIS_FIN'
        +',EV_IND_DATECODE'
        +',EV_IND_DATECODE_TOT'
        +',EV_IND_DATECODE_TARD'
        +',EV_IND_DATE_JOUR'
        +',EV_IND_DATE_JOUR_FIN'
        +',EV_IND_TYPE_TOKEN1'
        +',EV_IND_TYPE_TOKEN2'
        +',EV_IND_CP'
        +',EV_IND_VILLE'
        +',EV_IND_DEPT'
        +',EV_IND_PAYS'
        +',EV_IND_CAUSE'
        +',EV_IND_SOURCE'
        +',EV_IND_COMMENT'
        +',EV_IND_DESCRIPTION'
        +',EV_IND_REGION'
        +',EV_IND_SUBD'
        +',EV_IND_ACTE'
        +',EV_IND_INSEE'
        +',EV_IND_ORDRE'
        +',EV_IND_HEURE'
        +',EV_IND_TITRE_EVENT'
        +',EV_IND_LATITUDE'
        +',EV_IND_LONGITUDE'
        +',EV_IND_LIGNES_ADRESSE'
        +',EV_IND_TEL'
        +',EV_IND_MAIL'
        +',EV_IND_WEB'
        +')'
        +' values('
        +'gen_id(gen_ev_ind_clef,1)'
        +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:EV_IND_KLE_FICHE)'
        +','+dossierc
        +',:EV_IND_TYPE'
        +',:EV_IND_DATE_WRITEN'
        +',:EV_IND_DATE_YEAR'
        +',:EV_IND_DATE_MOIS'
        +',:EV_IND_CALENDRIER1'
        +',:EV_IND_CALENDRIER2'
        +',:EV_IND_DATE'
        +',:EV_IND_DATE_YEAR_FIN'
        +',:EV_IND_DATE_MOIS_FIN'
        +',:EV_IND_DATECODE'
        +',:EV_IND_DATECODE_TOT'
        +',:EV_IND_DATECODE_TARD'
        +',:EV_IND_DATE_JOUR'
        +',:EV_IND_DATE_JOUR_FIN'
        +',:EV_IND_TYPE_TOKEN1'
        +',:EV_IND_TYPE_TOKEN2'
        +',:EV_IND_CP'
        +',:EV_IND_VILLE'
        +',:EV_IND_DEPT'
        +',:EV_IND_PAYS'
        +',:EV_IND_CAUSE'
        +',:EV_IND_SOURCE'
        +',:EV_IND_COMMENT'
        +',:EV_IND_DESCRIPTION'
        +',:EV_IND_REGION'
        +',:EV_IND_SUBD'
        +',:EV_IND_ACTE'
        +',:EV_IND_INSEE'
        +',:EV_IND_ORDRE'
        +',:EV_IND_HEURE'
        +',:EV_IND_TITRE_EVENT'
        +',:EV_IND_LATITUDE'
        +',:EV_IND_LONGITUDE'
        +',:EV_IND_LIGNES_ADRESSE'
        +',:EV_IND_TEL'
        +',:EV_IND_MAIL'
        +',:EV_IND_WEB'
        +')returning EV_IND_CLEF';
      SQLQCible2.SQL.Text:='insert into TQ_CONSANG (ID,INDI,DECUJUS) values(3,:EV_IND_CLEF,:decujus)';

      EVavecLIGNES_ADRESSES:=TestTableChamp('EVENEMENTS_IND',IBQ_EV_IND_LIGNES_ADRESSE);

      if not Eof then
      begin
        I:=0;
        SQLQCible.Params.Modified;//needed to create params
        SQLQCible2.Params.Modified;//needed to create params
        while (not eof) do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) then
          begin
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['EVENEMENTS_IND',IntToStr(I),IntToStr(NbrEnr)]);
            
          end;
          byName( IBQ_EV_IND_CLEF ).AsInteger:=FieldByName(IBQ_EV_IND_CLEF).AsInteger;
          byName( IBQ_EV_IND_KLE_FICHE ).AsInteger:=FieldByName(IBQ_EV_IND_KLE_FICHE).AsInteger;
          for p:=2 to  Count-1 do
             getSQLParam (p).Clear;
          if FieldByName(IBQ_EV_IND_TYPE).AsString=''
            then byName(IBQ_EV_IND_TYPE).IsNull:=True
            Else
              if FieldByName(IBQ_EV_IND_TYPE).AsString='TITR' then
                byName(IBQ_EV_IND_TYPE).AsString:='TITL'
              else if FieldByName(IBQ_EV_IND_TYPE).AsString='INHU' then
                byName(IBQ_EV_IND_TYPE).AsString:='BURI'
              else if FieldByName(IBQ_EV_IND_TYPE).AsString='BENE' then
                byName(IBQ_EV_IND_TYPE).AsString:='BLES'
              else if FieldByName(IBQ_EV_IND_TYPE).AsString='DIPL' then
                byName(IBQ_EV_IND_TYPE).AsString:='GRAD'
              else
                byName(IBQ_EV_IND_TYPE).AsString:=FieldByName(IBQ_EV_IND_TYPE).AsString;

          if bOrigAvecDateCode then
          begin
            if FieldByName(IBQ_EV_IND_DATE_YEAR).IsNull then
              annee1:=_AnMini
            else
              annee1:=FieldByName(IBQ_EV_IND_DATE_YEAR).AsInteger;
            if FieldByName(IBQ_EV_IND_DATE_YEAR_FIN).IsNull then
              annee2:=_AnMini
            else
              annee2:=FieldByName(IBQ_EV_IND_DATE_YEAR_FIN).AsInteger;
            bContinuer:=MaDate.DecodeHumanDate(annee1,
              FieldByName(IBQ_EV_IND_DATE_MOIS).AsInteger,
              FieldByName(IBQ_EV_IND_DATE_JOUR).AsInteger,
              FieldByName(IBQ_EV_IND_TYPE_TOKEN1).AsInteger,
              TCalendrier(FieldByName(IBQ_EV_IND_CALENDRIER1).AsInteger),
              annee2,
              FieldByName(IBQ_EV_IND_DATE_MOIS_FIN).AsInteger,
              FieldByName(IBQ_EV_IND_DATE_JOUR_FIN).AsInteger,
              FieldByName(IBQ_EV_IND_TYPE_TOKEN2).AsInteger,
              TCalendrier(FieldByName(IBQ_EV_IND_CALENDRIER2).AsInteger));
          end
          else
            bContinuer:=(Length(FieldByName(IBQ_EV_IND_DATE_WRITEN).AsString)>0)
              and MaDate.DecodeHumanDate(FieldByName(IBQ_EV_IND_DATE_WRITEN).AsString);

          if Length(FieldByName(IBQ_EV_IND_DATE_WRITEN).AsString)>0 then
          begin
            s:=Trim(Copy(MaDate.HumanDate,1,100));
            if Length(s)>0 then
              byName( IBQ_EV_IND_DATE_WRITEN).AsString:=s;
          end;

          if bContinuer then //AL2009 modif 2012
          begin
            if MaDate.ValidDateTime1 then
              byName( IBQ_EV_IND_DATE).AsDateTime:=MaDate.DateTime1;
            byName( IBQ_EV_IND_DATECODE).AsInteger:=MaDate.DateCode1;
            byName( IBQ_EV_IND_DATECODE_TOT).AsInteger:=MaDate.DateCodeTot;
            byName( IBQ_EV_IND_DATECODE_TARD).AsInteger:=MaDate.DateCodeTard;
            byName( IBQ_EV_IND_DATE_YEAR).AsInteger:=MaDate.Year1;
            byName( IBQ_EV_IND_CALENDRIER1).AsInteger:=ord(MaDate.Calendrier1);
            if MaDate.Month1>0 then
              byName( IBQ_EV_IND_DATE_MOIS).AsInteger:=MaDate.Month1;
            if MaDate.Day1>0 then
              byName( IBQ_EV_IND_DATE_JOUR).AsInteger:=MaDate.Day1;
            if MaDate.Type_Key1>0 then
              byName( IBQ_EV_IND_TYPE_TOKEN1).AsInteger:=MaDate.Type_Key1;
            if MaDate.UseDate2 then
            begin
              byName( IBQ_EV_IND_DATE_YEAR_FIN).AsInteger:=MaDate.Year2;
              if MaDate.Month2>0 then
                byName( IBQ_EV_IND_DATE_MOIS_FIN).AsInteger:=MaDate.Month2;
              if MaDate.Day2>0 then
                byName( IBQ_EV_IND_DATE_JOUR_FIN).AsInteger:=MaDate.Day2;
              if MaDate.Type_Key2>0 then
                byName( IBQ_EV_IND_TYPE_TOKEN2).AsInteger:=MaDate.Type_Key2;
              byName( IBQ_EV_IND_CALENDRIER2).AsInteger:=ord(MaDate.Calendrier2);
            end;
          end;

          if EVavecLIGNES_ADRESSES then //à partir b5.148 Intégration des adresses dans EVENEMENTS_IND
          begin
            if FieldByName(IBQ_EV_IND_LIGNES_ADRESSE).IsNull
              then byName(IBQ_EV_IND_LIGNES_ADRESSE).IsNull:=True
              Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_IND_LIGNES_ADRESSE);
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,IBQ_EV_IND_LIGNES_ADRESSE);
              end;
            if FieldByName(IBQ_EV_IND_TEL).IsNull
             then byName(IBQ_EV_IND_TEL).IsNull:=True
             Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_IND_TEL);
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,IBQ_EV_IND_TEL);
              end;
            if FieldByName(IBQ_EV_IND_MAIL).AsString=''
              then byName( IBQ_EV_IND_MAIL ).IsNull:=True
              Else byName( IBQ_EV_IND_MAIL ).AsString:=FieldByName(IBQ_EV_IND_MAIL).AsString;
            if FieldByName(IBQ_EV_IND_WEB).AsString=''
              then byName( IBQ_EV_IND_WEB ).IsNull:=True
              Else byName( IBQ_EV_IND_WEB ).AsString:=FieldByName(IBQ_EV_IND_WEB).AsString;
          end;

          if FieldByName(IBQ_EV_IND_CP).AsString=''
            then byName( IBQ_EV_IND_CP ).IsNull:=True
            Else byName( IBQ_EV_IND_CP ).AsString:=FieldByName(IBQ_EV_IND_CP).AsString;
          if FieldByName(IBQ_EV_IND_VILLE).AsString=''
            then byName( IBQ_EV_IND_VILLE ).IsNull:=True
            Else byName( IBQ_EV_IND_VILLE).AsString:=FieldByName(IBQ_EV_IND_VILLE).AsString;
          if FieldByName(IBQ_EV_IND_DEPT).AsString=''
            then byName( IBQ_EV_IND_DEPT ).IsNull:=True
            Else byName( IBQ_EV_IND_DEPT).AsString:=FieldByName(IBQ_EV_IND_DEPT).AsString;
          if FieldByName(IBQ_EV_IND_PAYS).AsString=''
            then byName( IBQ_EV_IND_PAYS ).IsNull:=True
            Else byName( IBQ_EV_IND_PAYS).AsString:=FieldByName(IBQ_EV_IND_PAYS).AsString;
          if FieldByName(IBQ_EV_IND_CAUSE).AsString=''
            then byName( IBQ_EV_IND_CAUSE ).IsNull:=True
            Else byName( IBQ_EV_IND_CAUSE ).AsString:=FieldByName(IBQ_EV_IND_CAUSE).AsString;

          if FieldByName(IBQ_EV_IND_SOURCE).IsNull
            then byName( IBQ_EV_IND_SOURCE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_IND_SOURCE);
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,IBQ_EV_IND_SOURCE);
              end;

          if FieldByName(IBQ_EV_IND_COMMENT).IsNull
            then byName( IBQ_EV_IND_COMMENT ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_IND_COMMENT);
                if tampon.Size>0 then
                  p_SaveToStream ( SQLQCible,IBQ_EV_IND_COMMENT);
              end;

          if FieldByName(IBQ_EV_IND_DESCRIPTION).AsString=''
            then byName( IBQ_EV_IND_DESCRIPTION ).IsNull:=True
            Else byName( IBQ_EV_IND_DESCRIPTION ).AsString:=FieldByName(IBQ_EV_IND_DESCRIPTION).AsString;
          if FieldByName(IBQ_EV_IND_REGION).AsString=''
            then byName( IBQ_EV_IND_REGION ).IsNull:=True
            Else byName( IBQ_EV_IND_REGION).AsString:=FieldByName(IBQ_EV_IND_REGION).AsString;
         if FieldByName(IBQ_EV_IND_SUBD).AsString=''
            then //récupération de l'ex champ Lieu si subdivision est vide
            try //évitera l'erreur le jour où EV_IND_ADRESSE sera supprimé
              if FieldByName(IBQ_EV_IND_ADRESSE).AsString=''
                then byName( IBQ_EV_IND_SUBD ).IsNull:=True
                Else byName( IBQ_EV_IND_SUBD ).AsString:=FieldByName(IBQ_EV_IND_ADRESSE).AsString;
            except
            end
             Else byName( IBQ_EV_IND_SUBD).AsString:=FieldByName(IBQ_EV_IND_SUBD).AsString;
          if FieldByName(IBQ_EV_IND_ADRESSE).AsString=''
            then byName( IBQ_EV_IND_ADRESSE ).IsNull:=True
            Else byName( IBQ_EV_IND_ADRESSE ).AsString:=FieldByName(IBQ_EV_IND_ADRESSE).AsString;
          if FieldByName(IBQ_EV_IND_ACTE).IsNull
            then byName( IBQ_EV_IND_ACTE ).IsNull:=True
            Else byName(IBQ_EV_IND_ACTE).AsInteger:=FieldByName(IBQ_EV_IND_ACTE).AsInteger;
          if FieldByName(IBQ_EV_IND_INSEE).AsString=''
            then byName( IBQ_EV_IND_INSEE ).IsNull:=True
            Else byName( IBQ_EV_IND_INSEE).AsString:=FieldByName(IBQ_EV_IND_INSEE).AsString;

          try
            if FieldByName(IBQ_EV_IND_ORDRE ).IsNull
            then byName( IBQ_EV_IND_ORDRE ).IsNull:=True
            Else byName( IBQ_EV_IND_ORDRE).AsInteger:=FieldByName(IBQ_EV_IND_ORDRE).AsInteger;
          except
          end;

          try
            if FieldByName(IBQ_EV_IND_HEURE ).IsNull
            then byName( IBQ_EV_IND_HEURE ).IsNull:=True
            Else byName( IBQ_EV_IND_HEURE).AsDateTime:=FieldByName(IBQ_EV_IND_HEURE).AsDateTime;
          except
          end;

          try
            if FieldByName(IBQ_EV_IND_TITRE_EVENT).AsString=''
            then byName( IBQ_EV_IND_TITRE_EVENT ).IsNull:=True
            Else
              begin
                s:=FieldByName(IBQ_EV_IND_TITRE_EVENT).AsString;
                if Length(s)>25 Then s:=AnsiLeftStr(s,25);
                byName( IBQ_EV_IND_TITRE_EVENT).AsString:=s;
              end;
          except
          end;

          try
            if FieldByName(IBQ_EV_IND_LATITUDE).IsNull
            then byName( IBQ_EV_IND_LATITUDE ).IsNull:=True
            Else byName( IBQ_EV_IND_LATITUDE ).AsDouble:=FieldByName(IBQ_EV_IND_LATITUDE).AsDouble;
          except
          end;

          try
            if FieldByName(IBQ_EV_IND_LONGITUDE ).IsNull
            then byName( IBQ_EV_IND_LONGITUDE ).IsNull:=True
            Else byName( IBQ_EV_IND_LONGITUDE).AsDouble:=FieldByName(IBQ_EV_IND_LONGITUDE).AsDouble;
          except
          end;

          try
            SQLQCible.ExecQuery;
            SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
            SQLQCible2.ParamByName(IBQ_EV_IND_CLEF).Value:=FieldByName(IBQ_EV_IND_CLEF).Value;
            SQLQCible2.ExecQuery;//transfert individu
         except
            on E:EIBError do
            begin
              MyMessageDlg(rs_Error_person_event_transfer
                +FieldByName(IBQ_EV_IND_CLEF).AsString
                +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
              dm.IBT_base.RollbackRetaining;
              exit;
            end;
          end;

          Next;
        end;
        SQLQCible .Close;
        SQLQCible2.Close;
      end;// fin de If not Eof

      Close;

    //Table ADRESSES_IND si elle existe
      if TestTableChamp('ADRESSES_IND','ADR_CLEF')
      Then
      begin
        lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['ADRESSES_IND']);
        
        SQL.Text:='select count(*) from individu i' +#10+
                  'inner join adresses_ind a on a.adr_kle_ind=i.cle_fiche' +#10+
                  'where i.kle_dossier='+dossiers;
        ExecQuery;
        NbrEnr:=Fields[0].AsInteger;
        Close;
        SQL.Text:='select a.* from individu i' +#10+
                  'inner join adresses_ind a on a.adr_kle_ind=i.cle_fiche' +#10+
                  'where i.kle_dossier='+dossiers;
        ExecQuery;

        if not Eof
         Then
          begin
            i:=0;
            Text:='insert into EVENEMENTS_IND('
              +IBQ_EV_IND_CLEF
              +',EV_IND_KLE_FICHE'
              +',EV_IND_KLE_DOSSIER'
              +',EV_IND_TYPE'
              +',EV_IND_DATE_WRITEN'
              +',EV_IND_DATE_YEAR'
              +',EV_IND_DATE_MOIS'
              +',0'//la table ADRESSES_IND n'a été qu'en grégorien
              +',0'
              +',EV_IND_DATE'
              +',EV_IND_DATE_YEAR_FIN'
              +',EV_IND_DATE_MOIS_FIN'
              +',EV_IND_DATECODE'
              +',EV_IND_DATECODE_TOT'
              +',EV_IND_DATECODE_TARD'
              +',EV_IND_DATE_JOUR'
              +',EV_IND_DATE_JOUR_FIN'
              +',EV_IND_TYPE_TOKEN1'
              +',EV_IND_TYPE_TOKEN2'
              +',EV_IND_CP'
              +',EV_IND_VILLE'
              +',EV_IND_DEPT'
              +',EV_IND_PAYS'
              +',EV_IND_COMMENT'
              +',EV_IND_REGION'
              +',EV_IND_SUBD'
              +',EV_IND_INSEE'
              +',EV_IND_LATITUDE'
              +',EV_IND_LONGITUDE'
              +',EV_IND_LIGNES_ADRESSE'
              +',EV_IND_TEL'
              +',EV_IND_MAIL'
              +',EV_IND_WEB'
              +')'
              +' values('
              +'gen_id(gen_ev_ind_clef,1)'
              +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:EV_IND_KLE_FICHE)'
              +','+dossierc
              +',:EV_IND_TYPE'
              +',:EV_IND_DATE_WRITEN'
              +',:EV_IND_DATE_YEAR'
              +',:EV_IND_DATE_MOIS'
              +',:EV_IND_DATE'
              +',:EV_IND_DATE_YEAR_FIN'
              +',:EV_IND_DATE_MOIS_FIN'
              +',:EV_IND_DATECODE'
              +',:EV_IND_DATECODE_TOT'
              +',:EV_IND_DATECODE_TARD'
              +',:EV_IND_DATE_JOUR'
              +',:EV_IND_DATE_JOUR_FIN'
              +',:EV_IND_TYPE_TOKEN1'
              +',:EV_IND_TYPE_TOKEN2'
              +',:EV_IND_CP'
              +',:EV_IND_VILLE'
              +',:EV_IND_DEPT'
              +',:EV_IND_PAYS'
              +',:EV_IND_COMMENT'
              +',:EV_IND_REGION'
              +',:EV_IND_SUBD'
              +',:EV_IND_INSEE'
              +',:EV_IND_LATITUDE'
              +',:EV_IND_LONGITUDE'
              +',:EV_IND_LIGNES_ADRESSE'
              +',:EV_IND_TEL'
              +',:EV_IND_MAIL'
              +',:EV_IND_WEB'
              +')returning EV_IND_CLEF';

            SQLQCible.Params.Modified;//needed to create params
            while not eof do
            begin
              inc(i);
              if (i=NbrEnr)or(i mod 10=0) then
              begin
                lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['ADRESSES_IND',IntToStr(I),IntToStr(NbrEnr)]);

              end;
              byName( IBQ_EV_IND_KLE_FICHE).AsInteger:=FieldByName(IBQ_ADR_KLE_IND).AsInteger;
              byName(IBQ_EV_IND_TYPE).AsString:='RESI';
              for p:=2 to Count-1 do
                 getSQLParam (p).Clear;

              if FieldByName(IBQ_ADR_ADRESSE).IsNull
              then byName( IBQ_EV_IND_LIGNES_ADRESSE ).IsNull:=True
              Else
                begin
                  tampon.Clear;
                  p_LoadFromStream ( SQLQSource, IBQ_ADR_ADRESSE);
                  if tampon.Size>0 Then
                    p_SaveToStream ( SQLQCible,IBQ_EV_IND_LIGNES_ADRESSE);
                end;

              if FieldByName(IBQ_ADR_CP).AsString=''
              then byName( IBQ_EV_IND_CP ).IsNull:=True
              Else byName( IBQ_EV_IND_CP ).AsString:=FieldByName(IBQ_ADR_CP).AsString;
              if FieldByName(IBQ_ADR_VILLE).AsString=''
              then byName( IBQ_EV_IND_VILLE ).IsNull:=True
              Else byName( IBQ_EV_IND_VILLE).AsString:=FieldByName(IBQ_ADR_VILLE).AsString;
              if FieldByName(IBQ_ADR_DEPT).AsString=''
              then byName( IBQ_EV_IND_DEPT ).IsNull:=True
              Else byName( IBQ_EV_IND_DEPT ).AsString:=FieldByName(IBQ_ADR_DEPT).AsString;
              if FieldByName(IBQ_ADR_REGION).AsString=''
              then byName( IBQ_EV_IND_REGION ).IsNull:=True
              Else byName( IBQ_EV_IND_REGION).AsString:=FieldByName(IBQ_ADR_REGION).AsString;
              if FieldByName(IBQ_ADR_PAYS).AsString=''
              then byName( IBQ_EV_IND_PAYS ).IsNull:=True
              Else byName( IBQ_EV_IND_PAYS ).AsString:=FieldByName(IBQ_ADR_PAYS).AsString;
              if FieldByName(IBQ_ADR_INSEE).AsString=''
              then byName( IBQ_EV_IND_INSEE ).IsNull:=True
              Else byName( IBQ_EV_IND_INSEE).AsString:=FieldByName(IBQ_ADR_INSEE).AsString;

              if FieldByName( IBQ_ADR_TEL ).IsNull
              then byName( IBQ_EV_IND_TEL ).IsNull:=True
              Else
                begin
                  tampon.Clear;
                  p_LoadFromStream ( SQLQSource, IBQ_ADR_TEL);
                  if tampon.Size>0  Then
                    p_SaveToStream ( SQLQCible,IBQ_EV_IND_TEL );
                end;

              if FieldByName(IBQ_ADR_MAIL).AsString=''
              then byName( IBQ_EV_IND_MAIL ).IsNull:=True
              Else byName( IBQ_EV_IND_MAIL).AsString:=FieldByName(IBQ_ADR_MAIL).AsString;
              try
                if FieldByName(IBQ_ADR_WEB).AsString=''
                 Then byName( IBQ_EV_IND_WEB).IsNull:=True
                 Else byName( IBQ_EV_IND_WEB).AsString:=FieldByName(IBQ_ADR_WEB).AsString;
              except//n'existe pas dans vielles bases
              end;

              if FieldByName(IBQ_ADR_DATE_WRITEN).AsString=''
              then
               Begin
                 byName( IBQ_EV_IND_DATE ).IsNull:=True;
                 byName( IBQ_EV_IND_DATECODE ).IsNull:=True;
                 byName( IBQ_EV_IND_DATECODE_TARD ).IsNull:=True;
                 byName( IBQ_EV_IND_DATECODE_TOT ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_JOUR ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_JOUR_FIN ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_MOIS ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_MOIS_FIN ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_WRITEN ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_YEAR ).IsNull:=True;
                 byName( IBQ_EV_IND_DATE_YEAR_FIN ).IsNull:=True;
               end
              Else  //AL2009 modif 2012
                begin
                  if MaDate.DecodeHumanDate(FieldByName(IBQ_ADR_DATE_WRITEN).AsString)
                  then
                  begin
                    if MaDate.ValidDateTime1
                     then
                      byName( IBQ_EV_IND_DATE).AsDateTime:=MaDate.DateTime1;
                    byName( IBQ_EV_IND_DATECODE).AsInteger:=MaDate.DateCode1;
                    byName( IBQ_EV_IND_DATECODE_TOT).AsInteger:=MaDate.DateCodeTot;
                    byName( IBQ_EV_IND_DATECODE_TARD).AsInteger:=MaDate.DateCodeTard;
                    byName( IBQ_EV_IND_DATE_YEAR).AsInteger:=MaDate.Year1;
                    if MaDate.Month1>0
                     then ByName( IBQ_EV_IND_DATE_MOIS).AsInteger:=MaDate.Month1;
                    if MaDate.Day1>0
                     then byName( IBQ_EV_IND_DATE_JOUR).AsInteger:=MaDate.Day1;
                    if MaDate.Type_Key1>0
                     then byName( IBQ_EV_IND_TYPE_TOKEN1).AsInteger:=MaDate.Type_Key1;
                    if MaDate.UseDate2
                    then
                    begin
                      byName( IBQ_EV_IND_DATE_YEAR_FIN).AsInteger:=MaDate.Year2;
                      if MaDate.Month2>0
                       then byName( IBQ_EV_IND_DATE_MOIS_FIN).AsInteger:=MaDate.Month2;
                      if MaDate.Day2>0
                       then byName( IBQ_EV_IND_DATE_JOUR_FIN).AsInteger:=MaDate.Day2;
                      if MaDate.Type_Key2>0
                       then byName( IBQ_EV_IND_TYPE_TOKEN2).AsInteger:=MaDate.Type_Key2;
                    end;
                  end;
                  s:=Trim(Copy(MaDate.HumanDate,1,100));
                  if Length(s)>0
                   then
                    byName( IBQ_EV_IND_DATE_WRITEN).AsString:=s;
                end;

              try
                if FieldByName(IBQ_ADR_MEMO).IsNull
                  then byName( IBQ_EV_IND_COMMENT ).IsNull:=True
                  Else
                    begin
                      tampon.Clear;
                      p_LoadFromStream ( SQLQSource, IBQ_ADR_MEMO );
                      if tampon.Size>0 Then
                        p_SaveToStream ( SQLQCible,IBQ_EV_IND_COMMENT);
                    end;
                  except
                  end;

              try
                if FieldByName(IBQ_ADR_SUBD).AsString=''
                  then byName( IBQ_EV_IND_SUBD ).IsNull:=True
                  Else byName( IBQ_EV_IND_SUBD).AsString:=FieldByName(IBQ_ADR_SUBD).AsString;
              except
              end;
              try
                if FieldByName(IBQ_ADR_LATITUDE).IsNull
                  then byName( IBQ_EV_IND_LATITUDE ).IsNull:=True
                  Else byName( IBQ_EV_IND_LATITUDE).AsDouble:=FieldByName(IBQ_ADR_LATITUDE).AsDouble;
              except
              end;
              try
                if FieldByName(IBQ_ADR_LONGITUDE).IsNull
                  then byName( IBQ_EV_IND_LONGITUDE ).IsNull:=True
                  Else byName( IBQ_EV_IND_LONGITUDE).AsDouble:=FieldByName(IBQ_ADR_LONGITUDE).AsDouble;
              except
              end;

              try
                SQLQCible.ExecQuery;
              except
                on E:EIBError do
                begin
                  MyMessageDlg(rs_Error_address_transfer
                    +FieldByName(IBQ_ADR_CLEF).AsString
                    +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
                  dm.IBT_base.RollbackRetaining;
                  exit;
                end;
              end;

              try//n'existe pas dans anciennes bases
                s:=FieldByName(IBQ_ADR_PHOTO).AsString;
                if s>''
                  then
                   begin
                    with qPhoto do
                    begin
                      close;
                      SQL.Text:='execute block('
                          +'photo varchar(255)='''+fs_stringDBQuote(s)+''''
                          +',dossier integer='+dossierc
                          +',indi integer='+FieldByName(IBQ_ADR_KLE_IND).AsString
                          +',clef_ev integer='+SQLQCible.Fields[0].AsString
                          +')returns(nouveau integer,clef_media integer)as'
                          +' begin '
                          +' clef_media=null;'
                          +' select first(1) multi_clef from multimedia'
                          +' where multi_dossier=:dossier and multi_path=:photo'
                          +' into :clef_media;'
                          +' if (clef_media is null) then'
                          +' begin'
                          +' nouveau=1;'
                          +'clef_media=gen_id(gen_multimedia,1);'
                          +'insert into multimedia'
                          +'(multi_clef'
                          +',multi_infos'
                          +',multi_dossier'
                          +',multi_date_modif'
                          +',multi_memo'
                          +',multi_image_rtf'
                          +',id_import_gedcom'
                          +',multi_path)'
                          +' values('
                          +':clef_media'
                          +',''Image domicile transférée le '+fs_DateTime2Str(now)+''''
                          +',:dossier'
                          +',current_timestamp'
                          +',''Image domicile transférée, import n°'+IntToStr(IG_ID)+''''
                          +',1'
                          +','+IntToStr(IG_ID)
                          +',:photo);'
                          +'end else nouveau=0;'
                          +'insert into media_pointeurs ('
                          +'mp_clef'
                          +',mp_media'
                          +',mp_cle_individu'
                          +',mp_pointe_sur'
                          +',mp_table'
                          +',mp_identite'
                          +',mp_kle_dossier'
                          +',mp_type_image'
                          +',mp_position)'
                          +'values('
                          +'gen_id(biblio_pointeurs_id_gen,1)'
                          +',:clef_media'
                          +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:indi)'
                          +',:clef_ev'
                          +',''I'''
                          +',0'
                          +',:dossier'
                          +',''A'''
                          +',0);'
                          +'suspend;'
                          +'end';
                      ExecQuery;
                      if Fields[0].AsInteger=1
                       then
                        begin
                          if FileExistsUTF8(s) { *Converted from FileExistsUTF8*  }
                          then
                            begin
                              QmajMedia.ParamByName( IBQ_multi_clef ).AsInteger:=Fields[1].AsInteger;
                              QmajMedia.ParamByName( IBQ_multi_image_rtf ).AsInteger:=1;
                              QmajMedia.ParamByName( IBQ_multi_reduite ).Clear;
                              QmajMedia.ParamByName( IBQ_multi_media ).Clear;
                              tampon.Clear;
                              tampon2.Clear;
                              p_FileToStream (s,tampon);
                              p_FileToStream (s,tampon2);
                              imagedata := fci_GetCustomImage;
                              p_StreamToCustomImage( tampon, ImageData, 140,120,True );
                              if tampon.Size > 0
                               then
                                begin

                                  p_SaveToStream(QmajMedia,'multi_reduite');
                                  if tampon2.Size>0
                                  then
                                    begin
                                      p_LoadFromStream2(QmajMedia,'multi_media');
                                      QmajMedia.ParamByName( IBQ_multi_image_rtf).AsInteger:=0;
                                    end;
                                  QmajMedia.ExecQuery;
                                  QmajMedia.Close;
                                end;
                            end;//de FileExistsUTF8(s)
                        end;//de Fields[0].AsInteger=1
                      close;
                    end;//de with qPhoto do
                  end;//de not FieldByName(IBQ_ADR_PHOTO').IsNull
                except
              end;
              SQLQCible.Close;
              Next;
            end;//de while not eof do
          end;// fin de If not Eof

          Close;
        end;//de si la table ADRESSES_IND existe

    //-- Table T_UNION-----------------------------------------------------------------------------------------
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['T_UNION']);
      
      SQL.Text:='select count(*)' +#10+
                  'from t_union u where (u.union_mari>0 and u.union_femme>0'  +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari'  +#10+
                  'and kle_dossier='+dossiers+')'  +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme'  +#10+
                  'and kle_dossier='+dossiers+'))'  +#10+
                  'or (u.union_mari>0 and (u.union_femme is null or u.union_femme=0)'  +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari'  +#10+
                  'and kle_dossier='+dossiers+'))'  +#10+
                  'or ((u.union_mari is null or u.union_mari=0) and u.union_femme>0'  +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme'  +#10+
                  'and kle_dossier='+dossiers+'))';
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Text:='select *' +#10+
                  'from t_union u where (u.union_mari>0 and u.union_femme>0' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+')' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or (u.union_mari>0 and (u.union_femme is null or u.union_femme=0)' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or ((u.union_mari is null or u.union_mari=0) and u.union_femme>0' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+'))';
      ExecQuery;

      if not Eof
        Then
      begin
        I:=0;
        Text:='insert into T_UNION('
          +'UNION_CLEF'
          +',UNION_MARI'
          +',UNION_FEMME'
          +',KLE_DOSSIER'
          +',union_type'//conservé pour récupération par PROC_MAJ_TAGS
          +',SOURCE'
          +',COMMENT'
          +')'
          +'values('
          +'gen_id(gen_t_union,1)'
          +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:UNION_MARI)'
          +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:UNION_FEMME)'
          +','+dossierc
          +',:union_type'
          +',:SOURCE'
          +',:COMMENT'
          +')returning UNION_CLEF';
        SQLQCible2.SQL.Text:='insert into tq_consang(id,indi,decujus)values(4,:UNION_CLEF,:decujus)';

        SQLQCible.Params.Modified;//needed to create params
        SQLQCible2.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['T_UNION',IntToStr(I),IntToStr(NbrEnr)]);

          byName( IBQ_UNION_CLEF ).AsInteger:=FieldByName(IBQ_UNION_CLEF).AsInteger;
          for p:=1 to Count-1 do
             getSQLParam (p).Clear;
          if FieldByName(IBQ_UNION_MARI).AsInteger=0
            then byName( IBQ_UNION_MARI ).IsNull:=True
            Else byName( IBQ_UNION_MARI).AsInteger:=FieldByName(IBQ_UNION_MARI).AsInteger;
          if FieldByName(IBQ_UNION_FEMME).AsInteger=0
            then byName( IBQ_UNION_FEMME ).IsNull:=True
            Else byName( IBQ_UNION_FEMME).AsInteger:=FieldByName(IBQ_UNION_FEMME).AsInteger;
          byName( IBQ_union_type).AsInteger:=FieldByName(IBQ_union_type).AsInteger;

          if FieldByName(IBQ_SOURCE).IsNull
            then byName( IBQ_SOURCE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_SOURCE);
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,IBQ_SOURCE);
              end;

          if FieldByName(IBQ_COMMENT).IsNull
            then byName( IBQ_COMMENT ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_COMMENT);
                if tampon.Size>0  Then
                  p_SaveToStream ( SQLQCible,IBQ_COMMENT);
              end;

          try
            SQLQCible.ExecQuery;
            SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
            SQLQCible2.ParamByName(IBQ_UNION_CLEF).Value:=FieldByName(IBQ_UNION_CLEF).Value;
            SQLQCible2.ExecQuery;//transfert individu
          except
            on E:EIBError do
            begin
              MyMessageDlg(rs_Error_union_transfer
                +FieldByName(IBQ_UNION_CLEF).AsString
                +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
              dm.IBT_base.RollbackRetaining;
              exit;
            end;
          end;

          Next;
        end;

        SQLQCible .Close;
        SQLQCible2.Close;
      end;// fin de If not Eof

      Close;

    //-- Table EVENEMENTS_FAM----------------------------------------------------------------------------------
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['EVENEMENTS_FAM']);
      
      SQL.Text:='select count(*)' +#10+
                  ' from evenements_fam f' +#10+
                  'inner join t_union u on u.union_clef=f.ev_fam_kle_famille' +#10+
                  'and ((u.union_mari>0 and u.union_femme>0' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+')' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or(u.union_mari>0 and (u.union_femme is null or u.union_femme=0)' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or(u.union_femme>0 and (u.union_mari is null or u.union_mari=0)' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+')))';
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Text:='select f.*' +#10+
                  ' from evenements_fam f' +#10+
                  'inner join t_union u on u.union_clef=f.ev_fam_kle_famille' +#10+
                  'and ((u.union_mari>0 and u.union_femme>0' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+')' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or(u.union_mari>0 and (u.union_femme is null or u.union_femme=0)' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_mari' +#10+
                  'and kle_dossier='+dossiers+'))' +#10+
                  'or(u.union_femme>0 and (u.union_mari is null or u.union_mari=0)' +#10+
                  'and exists (select * from individu where cle_fiche=u.union_femme' +#10+
                  'and kle_dossier='+dossiers+')))';
      ExecQuery;

      if not Eof Then
       begin
        I:=0;
        SQLQCible3.SQL.text:='select DECUJUS from TQ_CONSANG where ID=4 AND INDI=:EV_FAM_KLE_FAMILLE returning decujus';
        Text := 'insert into EVENEMENTS_FAM('
          +IBQ_EV_FAM_CLEF
          +',EV_FAM_KLE_FAMILLE'
          +',EV_FAM_KLE_DOSSIER'
          +',EV_FAM_TYPE'
          +',EV_FAM_DATE_WRITEN'
          +',EV_FAM_DATE_YEAR'
          +',EV_FAM_DATE_MOIS'
          +',EV_FAM_CALENDRIER1'
          +',EV_FAM_CALENDRIER2'
          +',EV_FAM_DATE'
          +',EV_FAM_DATE_YEAR_FIN'
          +',EV_FAM_DATE_MOIS_FIN'
          +',EV_FAM_DATECODE'
          +',EV_FAM_DATECODE_TOT'
          +',EV_FAM_DATECODE_TARD'
          +',EV_FAM_DATE_JOUR'
          +',EV_FAM_DATE_JOUR_FIN'
          +',EV_FAM_TYPE_TOKEN1'
          +',EV_FAM_TYPE_TOKEN2'
          +',EV_FAM_CP'
          +',EV_FAM_VILLE'
          +',EV_FAM_DEPT'
          +',EV_FAM_PAYS'
          +',EV_FAM_SOURCE'
          +',EV_FAM_COMMENT'
          +',EV_FAM_REGION'
          +',EV_FAM_SUBD'
          +',EV_FAM_ACTE'
          +',EV_FAM_INSEE'
          +',EV_FAM_ORDRE'
          +',EV_FAM_HEURE'
          +',EV_FAM_TITRE_EVENT'
          +',EV_FAM_LATITUDE'
          +',EV_FAM_LONGITUDE'
          +',EV_FAM_DESCRIPTION'
          +',EV_FAM_CAUSE'
          +')'
          +' values('
          +'gen_id(gen_ev_fam_clef,1)'
          +',:decujus'
          +','+dossierc
          +',:EV_FAM_TYPE'
          +',:EV_FAM_DATE_WRITEN'
          +',:EV_FAM_DATE_YEAR'
          +',:EV_FAM_DATE_MOIS'
          +',:EV_FAM_CALENDRIER1'
          +',:EV_FAM_CALENDRIER2'
          +',:EV_FAM_DATE'
          +',:EV_FAM_DATE_YEAR_FIN'
          +',:EV_FAM_DATE_MOIS_FIN'
          +',:EV_FAM_DATECODE'
          +',:EV_FAM_DATECODE_TOT'
          +',:EV_FAM_DATECODE_TARD'
          +',:EV_FAM_DATE_JOUR'
          +',:EV_FAM_DATE_JOUR_FIN'
          +',:EV_FAM_TYPE_TOKEN1'
          +',:EV_FAM_TYPE_TOKEN2'
          +',:EV_FAM_CP'
          +',:EV_FAM_VILLE'
          +',:EV_FAM_DEPT'
          +',:EV_FAM_PAYS'
          +',:EV_FAM_SOURCE'
          +',:EV_FAM_COMMENT'
          +',:EV_FAM_REGION'
          +',:EV_FAM_SUBD'
          +',:EV_FAM_ACTE'
          +',:EV_FAM_INSEE'
          +',:EV_FAM_ORDRE'
          +',:EV_FAM_HEURE'
          +',:EV_FAM_TITRE_EVENT'
          +',:EV_FAM_LATITUDE'
          +',:EV_FAM_LONGITUDE'
          +',:EV_FAM_DESCRIPTION'
          +',:EV_FAM_CAUSE'
          +')returning EV_FAM_CLEF';
        SQLQCible2.SQL.Text:='insert into tq_consang(id,indi,decujus)values(5,:EV_FAM_CLEF,:decujus)';

        SQLQCible .Params.Modified;//needed to create params
        SQLQCible2.Params.Modified;//needed to create params
        SQLQCible3.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0)
            then
              lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['EVENEMENTS_FAM',IntToStr(I),IntToStr(NbrEnr)]);
          SQLQCible3.ParamByName( IBQ_EV_FAM_KLE_FAMILLE).AsInteger:=FieldByName(IBQ_EV_FAM_KLE_FAMILLE).AsInteger;

          try
            SQLQCible3.ExecQuery;

            if SQLQCible3.Fields[0].AsInteger <= 0 Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_DECUJUS ).AsInteger:=SQLQCible3.Fields[0].AsInteger;//NouvCle;
          byName( IBQ_EV_FAM_CLEF).AsInteger:=FieldByName(IBQ_EV_FAM_CLEF).AsInteger;//NouvCle;
          for p:=2 to Count-1 do
             getSQLParam (p).Clear;
          if FieldByName(IBQ_EV_FAM_TYPE).AsString=''
            then byName( IBQ_EV_FAM_TYPE).IsNull:=True
            Else byName( IBQ_EV_FAM_TYPE).AsString:=FieldByName(IBQ_EV_FAM_TYPE).AsString;

          if bOrigAvecDateCode Then
           begin
            if FieldByName(IBQ_EV_FAM_DATE_YEAR).IsNull
              then annee1:=_AnMini
              else annee1:=FieldByName(IBQ_EV_FAM_DATE_YEAR).AsInteger;
            if FieldByName(IBQ_EV_FAM_DATE_YEAR_FIN).IsNull
              then annee2:=_AnMini
              else annee2:=FieldByName(IBQ_EV_FAM_DATE_YEAR_FIN).AsInteger;
            bContinuer:=MaDate.DecodeHumanDate(annee1,
              FieldByName(IBQ_EV_FAM_DATE_MOIS).AsInteger,
              FieldByName(IBQ_EV_FAM_DATE_JOUR).AsInteger,
              FieldByName(IBQ_EV_FAM_TYPE_TOKEN1).AsInteger,
              TCalendrier(FieldByName(IBQ_EV_FAM_CALENDRIER1).AsInteger),
              annee2,
              FieldByName(IBQ_EV_FAM_DATE_MOIS_FIN).AsInteger,
              FieldByName(IBQ_EV_FAM_DATE_JOUR_FIN).AsInteger,
              FieldByName(IBQ_EV_FAM_TYPE_TOKEN2).AsInteger,
              TCalendrier(FieldByName(IBQ_EV_FAM_CALENDRIER2).AsInteger));
           end
            else
             bContinuer:=(Length(FieldByName(IBQ_EV_FAM_DATE_WRITEN).AsString)>0)
              and MaDate.DecodeHumanDate(FieldByName(IBQ_EV_FAM_DATE_WRITEN).AsString);

          if Length(FieldByName(IBQ_EV_FAM_DATE_WRITEN).AsString)>0
            then byName( IBQ_EV_FAM_DATE_WRITEN ).IsNull:=True
            Else
              begin
                s:=Trim(Copy(MaDate.HumanDate,1,100));
                if Length(s)>0 Then
                  byName( IBQ_EV_FAM_DATE_WRITEN).AsString:=s;
              end;

          if bContinuer Then //AL2009 modif 2012
          begin
            if MaDate.ValidDateTime1
            then byName( IBQ_EV_FAM_DATE).AsDateTime:=MaDate.DateTime1;
            byName( IBQ_EV_FAM_DATECODE).AsInteger:=MaDate.DateCode1;
            byName( IBQ_EV_FAM_DATECODE_TOT).AsInteger:=MaDate.DateCodeTot;
            byName( IBQ_EV_FAM_DATECODE_TARD).AsInteger:=MaDate.DateCodeTard;
            byName( IBQ_EV_FAM_DATE_YEAR).AsInteger:=MaDate.Year1;
            byName( IBQ_EV_FAM_CALENDRIER1).AsInteger:=ord(MaDate.Calendrier1);
            if MaDate.Month1>0
            then byName( IBQ_EV_FAM_DATE_MOIS).AsInteger:=MaDate.Month1;
            if MaDate.Day1>0
            then byName( IBQ_EV_FAM_DATE_JOUR).AsInteger:=MaDate.Day1;
            if MaDate.Type_Key1>0
            then byName( IBQ_EV_FAM_TYPE_TOKEN1).AsInteger:=MaDate.Type_Key1;
            if MaDate.UseDate2
            then
            begin
              byName( IBQ_EV_FAM_DATE_YEAR_FIN).AsInteger:=MaDate.Year2;
              if MaDate.Month2>0 Then
                byName( IBQ_EV_FAM_DATE_MOIS_FIN).AsInteger:=MaDate.Month2;
              if MaDate.Day2>0 Then
                byName( IBQ_EV_FAM_DATE_JOUR_FIN).AsInteger:=MaDate.Day2;
              if MaDate.Type_Key2>0 Then
                byName( IBQ_EV_FAM_TYPE_TOKEN2).AsInteger:=MaDate.Type_Key2;
              byName( IBQ_EV_FAM_CALENDRIER2).AsInteger:=ord(MaDate.Calendrier2);
            end;
          end;

          if FieldByName(IBQ_EV_FAM_CP).AsString=''
            then byName( IBQ_EV_FAM_CP ).IsNull:=True
            Else byName( IBQ_EV_FAM_CP).AsString:=FieldByName(IBQ_EV_FAM_CP).AsString;
          if FieldByName(IBQ_EV_FAM_VILLE).AsString=''
            then byName( IBQ_EV_FAM_VILLE ).IsNull:=True
            Else byName( IBQ_EV_FAM_VILLE).AsString:=FieldByName(IBQ_EV_FAM_VILLE).AsString;
          if FieldByName(IBQ_EV_FAM_DEPT).AsString=''
            then byName( IBQ_EV_FAM_DEPT).IsNull:=True
            Else byName( IBQ_EV_FAM_DEPT).AsString:=FieldByName(IBQ_EV_FAM_DEPT).AsString;
          if FieldByName(IBQ_EV_FAM_PAYS).AsString=''
            then byName( IBQ_EV_FAM_PAYS).IsNull:=True
            Else byName( IBQ_EV_FAM_PAYS).AsString:=FieldByName(IBQ_EV_FAM_PAYS).AsString;
          if FieldByName(IBQ_EV_FAM_REGION).AsString=''
            then byName( IBQ_EV_FAM_REGION).IsNull:=True
            Else byName( IBQ_EV_FAM_REGION).AsString:=FieldByName(IBQ_EV_FAM_REGION).AsString;
          if FieldByName(IBQ_EV_FAM_SUBD).AsString=''
            then byName( IBQ_EV_FAM_SUBD).IsNull:=True
            Else byName( IBQ_EV_FAM_SUBD).AsString:=FieldByName(IBQ_EV_FAM_SUBD).AsString;

          byName( IBQ_EV_FAM_ACTE).AsInteger:=FieldByName(IBQ_EV_FAM_ACTE).AsInteger;

          if FieldByName(IBQ_EV_FAM_INSEE).AsString=''
            then byName( IBQ_EV_FAM_INSEE).IsNull:=True
            Else byName( IBQ_EV_FAM_INSEE).AsString:=FieldByName(IBQ_EV_FAM_INSEE).AsString;

          if FieldByName(IBQ_EV_FAM_SOURCE).IsNull
            then byName( IBQ_EV_FAM_SOURCE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_FAM_SOURCE);
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,IBQ_EV_FAM_SOURCE);
              end;

          if FieldByName(IBQ_EV_FAM_COMMENT).IsNull
            then byName( IBQ_EV_FAM_COMMENT ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, IBQ_EV_FAM_COMMENT);
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,IBQ_EV_FAM_COMMENT);
              end;

          try
            if FieldByName(IBQ_EV_FAM_ORDRE).IsNull
            then byName(  IBQ_EV_FAM_ORDRE ).IsNull:=True
            Else byName( IBQ_EV_FAM_ORDRE).AsInteger:=FieldByName(IBQ_EV_FAM_ORDRE).AsInteger;
          except
          end;
          try
            if FieldByName(IBQ_EV_FAM_HEURE).IsNull
            then byName( IBQ_EV_FAM_HEURE ).IsNull:=True
            Else byName( IBQ_EV_FAM_HEURE).AsDateTime:=FieldByName(IBQ_EV_FAM_HEURE).AsDateTime;
          except
          end;

          try
            if FieldByName(IBQ_EV_FAM_TITRE_EVENT).AsString=''
            then byName( IBQ_EV_FAM_TITRE_EVENT ).IsNull:=True
            Else byName( IBQ_EV_FAM_TITRE_EVENT).AsString:=FieldByName(IBQ_EV_FAM_TITRE_EVENT).AsString;
          except
          end;

          try
            if FieldByName(IBQ_EV_FAM_LATITUDE).IsNull
            then byName( IBQ_EV_FAM_LATITUDE ).IsNull:=True
            Else byName( IBQ_EV_FAM_LATITUDE ).AsDouble:=FieldByName(IBQ_EV_FAM_LATITUDE).AsDouble;
          except
          end;

          try
            if FieldByName(IBQ_EV_FAM_LONGITUDE).IsNull
            then byName( IBQ_EV_FAM_LONGITUDE ).IsNull:=True
            Else byName( IBQ_EV_FAM_LONGITUDE).AsDouble:=FieldByName(IBQ_EV_FAM_LONGITUDE).AsDouble;
          except
          end;

          try
            if FieldByName(IBQ_EV_FAM_DESCRIPTION).AsString=''
            then byName( IBQ_EV_FAM_DESCRIPTION ).IsNull:=True
            Else byName( IBQ_EV_FAM_DESCRIPTION).AsString:=FieldByName(IBQ_EV_FAM_DESCRIPTION).AsString;
          except
          end;

          try
            if FieldByName(IBQ_EV_FAM_CAUSE).AsString=''
            then byName( IBQ_EV_FAM_CAUSE ).IsNull:=True
            Else byName( IBQ_EV_FAM_CAUSE).AsString:=FieldByName(IBQ_EV_FAM_CAUSE).AsString;
          except
          end;

          try
            SQLQCible.ExecQuery;
            SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
            SQLQCible2.ParamByName(IBQ_EV_FAM_CLEF).Value:=FieldByName(IBQ_EV_FAM_CLEF).Value;
            SQLQCible2.ExecQuery;//transfert individu
          except
            on E:EIBError do
            begin
              MyMessageDlg(rs_Error_family_event_transfer
                +FieldByName(IBQ_EV_FAM_CLEF).AsString
                +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
              dm.IBT_base.RollbackRetaining;
              exit;
            end;
          end;

          Next;
        end;

        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
      end;// fin de If not Eof

      Close;

    //désactivation des paramètres spécifiques au décodage des dates.
    //inutiles après le transfert des événements familiaux
      sOrdreLIT:='';
      sOrdreNUM:='';
    finally
      tampon.Free;
      tampon2.Free;
      dm.InactiveTriggersLieuxFavoris(false);
    end;

  //-- Table T_ASSOCIATIONS 1-à événements individuels
    lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['T_ASSOCIATIONS '+rs_Caption_On_persons_events]);
    
    bNouvVersion:=TestTableChamp('T_ASSOCIATIONS','ASSOC_LIBELLE');
    if bNouvVersion
       then SQL.Text:='select count(*) FROM T_ASSOCIATIONS a'
       else  SQL.Text:='select count(*) FROM T_ASSOCIATIONS a' +#10+
                       'inner join ref_rela_temoins r on r.ref_rela_code=a.assoc_type';

    SQL.Add  (  'WHERE a.ASSOC_TABLE=''I''' +#10+
                'and exists(select * from individu' +#10+
                'where cle_fiche=a.assoc_kle_ind and kle_dossier='+dossiers+')' +#10+
                'and exists( select * from individu' +#10+
                'where cle_fiche=a.assoc_kle_associe and kle_dossier='+dossiers+')' +#10+
                'and exists(select * from evenements_ind e' +#10+
                'inner join individu i on i.cle_fiche=e.ev_ind_kle_fiche and i.kle_dossier='+dossiers +#10+
                'where e.ev_ind_clef=a.assoc_evenement)');
    ExecQuery;
    NbrEnr:=Fields[0].AsInteger;
    Close;

    if bNouvVersion
      Then SQL.Strings[0]:='select a.* FROM T_ASSOCIATIONS a'
      else SQL.Strings[0]:='select a.*,r.ref_rela_libelle as ASSOC_LIBELLE FROM T_ASSOCIATIONS a';
    ExecQuery;

    I:=0;
    if not Eof Then
    begin
      Text:='insert into T_ASSOCIATIONS ('
        +'ASSOC_CLEF'
        +',ASSOC_KLE_IND'
        +',ASSOC_KLE_ASSOCIE'
        +',ASSOC_KLE_DOSSIER'
        +',ASSOC_LIBELLE'
        +',ASSOC_EVENEMENT'
        +',ASSOC_TABLE'
        +')'
        +' values('
        +'gen_id(gen_assoc_clef,1)'
        +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:ASSOC_KLE_IND)'
        +',(select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:ASSOC_KLE_ASSOCIE)'
        +','+dossierc
        +',:ASSOC_LIBELLE'
        +',(select DECUJUS from TQ_CONSANG where ID=3 AND INDI=:ASSOC_EVENEMENT)'
        +',''I'''
        +')';

      SQLQCible.Params.Modified;//needed to create params
      while not eof do
      begin
        inc(i);
        if (i=NbrEnr)or(i mod 10=0)   Then
          lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['T_ASSOCIATIONS '+rs_Caption_On_persons_events,IntToStr(I),IntToStr(NbrEnr)]);
          
        byName( IBQ_ASSOC_KLE_IND).AsInteger:=FieldByName(IBQ_ASSOC_KLE_IND).AsInteger;
        byName( IBQ_ASSOC_KLE_ASSOCIE).AsInteger:=FieldByName(IBQ_ASSOC_KLE_ASSOCIE).AsInteger;
        if FieldByName(IBQ_ASSOC_LIBELLE).AsString=''
         then byName( IBQ_ASSOC_LIBELLE).AsString:=FieldByName(IBQ_ASSOC_LIBELLE).AsString
         else byName( IBQ_ASSOC_LIBELLE).AsString:='(inconnu)';
        byName( IBQ_ASSOC_EVENEMENT).AsInteger:=FieldByName(IBQ_ASSOC_EVENEMENT).AsInteger;

        try
          SQLQCible.ExecQuery;
        except
          on E:EIBError do
          begin
            MyMessageDlg(rs_Error_link_transfer
              +FieldByName(IBQ_ASSOC_CLEF).AsString
              +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
            dm.IBT_base.RollbackRetaining;
            exit;
          end;
        end;

        Next;
      end;

      SQLQCible.Close;
    end;// fin de If not Eof

    Close;

    //-- Table T_ASSOCIATIONS 2-à évènements familiaux---------------------------------------------------------
    lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['T_ASSOCIATIONS '+rs_Caption_On_family_events]);
    
    if bNouvVersion
     then SQL.Text:='select count(*) from t_associations a'
     else SQL.Text:='select count(*) from t_associations a' +#10+
                  'inner join ref_rela_temoins r on r.ref_rela_code=a.assoc_type';

    SQL.Add  (  'where a.assoc_table=''U''' +#10+
                'and exists(select * from individu' +#10+
                'where cle_fiche=a.assoc_kle_associe and kle_dossier='+dossiers+')');
    ExecQuery;
    NbrEnr:=Fields[0].AsInteger;
    Close;
    if bNouvVersion
     then SQL.Strings[0]:='select a.* from t_associations a'
     else SQL.Strings[0]:='select a.*,r.ref_rela_libelle as ASSOC_LIBELLE from t_associations a';

    ExecQuery;
    i:=0;
    if not Eof
     Then
    begin
      SQLQCible .Close;
      SQLQCible2.Close;
      SQLQCible3.Close;
      SQLQCible2.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:ASSOC_KLE_ASSOCIE returning decujus';
      SQLQCible3.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=5 AND INDI=:ASSOC_EVENEMENT returning decujus';

      Text := 'insert into T_ASSOCIATIONS('
        +'ASSOC_CLEF'
        +',ASSOC_KLE_IND'
        +',ASSOC_KLE_ASSOCIE'
        +',ASSOC_KLE_DOSSIER'
        +',ASSOC_LIBELLE'
        +',ASSOC_EVENEMENT'
        +',ASSOC_TABLE'
        +')'
        +'values('
        +'gen_id(gen_assoc_clef,1)'
        +',:ASSOC_EVENEMENT'
        +',:ASSOC_KLE_ASSOCIE'
        +','+dossierc
        +',:ASSOC_LIBELLE'
        +',:ASSOC_EVENEMENT'
        +',''U'''
        +')';

      SQLQCible .Params.Modified;//needed to create params
      SQLQCible2.Params.Modified;//needed to create params
      SQLQCible3.Params.Modified;//needed to create params
      while not eof do
      begin
        inc(i);
        if (i=NbrEnr)or(i mod 10=0)   Then
          lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['T_ASSOCIATIONS '+rs_Caption_On_family_events,IntToStr(I),IntToStr(NbrEnr)]);

        SQLQCible2.ParamByName( IBQ_ASSOC_KLE_ASSOCIE).AsInteger:=FieldByName(IBQ_ASSOC_KLE_ASSOCIE).AsInteger;
        SQLQCible3.ParamByName( IBQ_ASSOC_EVENEMENT).AsInteger:=FieldByName(IBQ_ASSOC_EVENEMENT).AsInteger;

        try
          SQLQCible2.ExecQuery;
          SQLQCible3.ExecQuery;

          if (SQLQCible3.Fields[0].AsInteger <= 0)
          or (SQLQCible2.Fields[0].AsInteger <= 0)
           Then
           Begin
            Next;
            continue;
           end;

        except
          Next;
          Continue;
        end;

        if FieldByName(IBQ_ASSOC_LIBELLE).AsString>''
          Then byName( IBQ_ASSOC_LIBELLE).AsString:=FieldByName(IBQ_ASSOC_LIBELLE).AsString
          else byName( IBQ_ASSOC_LIBELLE).AsString:='(inconnu)';

        try
          SQLQCible.ExecQuery;
        except
          on E:EIBError do
          begin
            MyMessageDlg(rs_Error_link_transfer
              +FieldByName(IBQ_ASSOC_CLEF).AsString
              +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
            dm.IBT_base.RollbackRetaining;
            exit;
          end;
        end;
        Next;
      end;//de while not eof
      SQLQCible .Close;
      SQLQCible2.Close;
      SQLQCible3.Close;
    end;// fin de If not Eof

    Close;

    if TestTableChamp('SOURCES_RECORD','TYPE_TABLE')
    Then
    begin//récupération impossible dans la structure actuelle des anciens SOURCES_RECORD sans TYPE_TABLE
      tampon:=TMemoryStream.Create;
      try
    // -- Table SOURCES_RECORD 1-d'évènements familiaux----
        lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['SOURCES_RECORD '+rs_Caption_On_families]);
        
        SQL.Text := 'select count(*)' +#10+
                    'FROM SOURCES_RECORD WHERE TYPE_TABLE=''F''' +#10+
                    'AND KLE_DOSSIER='+dossiers;
        ExecQuery;
        NbrEnr:=Fields[0].AsInteger;
        Close;
        SQL.Strings[0]:='select *';
        ExecQuery;
        I:=0;

        if not Eof Then
        begin
         SQLQCible .close;
         SQLQCible3.close;
         SQLQCible3.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=5 AND INDI=:DATA_ID returning decujus';

         Text := 'select ID from SOURCES_RECORD' +#10+
                      'where DATA_ID=:data_id AND TYPE_TABLE=''F''' +#10+
                      'into :decujus;' +#10+
                      'insert into tq_consang(id,indi,decujus)values(6,:id,:decujus +#10+' +#10+
                      'update SOURCES_RECORD set' +#10+
                      'SOURCE_PAGE=:SOURCE_PAGE' +#10+
                      ',EVEN=:EVEN' +#10+
                      ',EVEN_ROLE=:EVEN_ROLE' +#10+
                      ',DATA_EVEN=:DATA_EVEN' +#10+
                      ',DATA_EVEN_PERIOD=:DATA_EVEN_PERIOD' +#10+
                      ',DATA_EVEN_PLAC=:DATA_EVEN_PLAC' +#10+
                      ',DATA_AGNC=:DATA_AGNC' +#10+
                      ',QUAY=:QUAY' +#10+
                      ',AUTH=:AUTH' +#10+
                      ',TITL=:TITL' +#10+
                      ',ABR=:ABR' +#10+
                      ',PUBL=:PUBL' +#10+
                      ',TEXTE=:TEXTE' +#10+
                      ',USER_REF=:USER_REF' +#10+
                      ',RIN=:RIN' +#10+
                      ',CHANGE_NOTE=:CHANGE_NOTE' +#10+
                      'where ID=:decujus AND TYPE_TABLE=''F'';';

          SQLQCible.Params.Modified;//needed to create params
          while not Eof do
          begin
            inc(i);
            if (i=NbrEnr)or(i mod 10=0) Then
              lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['SOURCES_RECORD '+rs_Caption_On_families,IntToStr(I),IntToStr(NbrEnr)]);

            SQLQCible3.ParamByName(IBQ_DATA_ID).AsInteger:=FieldByName(IBQ_data_id).AsInteger;
            try
              SQLQCible3.ExecQuery;

              if (SQLQCible3.Fields[0].AsInteger <= 0)
               Then
               Begin
                Next;
                continue;
               end;

            except
              Next;
              Continue;
            end;

            byName( IBQ_id).AsInteger:=FieldByName(IBQ_id).AsInteger;
            byName( IBQ_data_id).AsInteger:=SQLQCible3.ParamByName(IBQ_DATA_ID).AsInteger;

            for p:=2 to  Count-1 do
               getSQLParam (p).Clear;

            if FieldByName(IBQ_SOURCE_PAGE).AsString=''
            then byName( IBQ_SOURCE_PAGE ).IsNull:=True
            Else byName( IBQ_SOURCE_PAGE ).AsString:=FieldByName(IBQ_SOURCE_PAGE).AsString;
            if FieldByName(IBQ_EVEN).AsString=''
            then byName( IBQ_EVEN ).IsNull:=True
            Else byName( IBQ_EVEN).AsString:=FieldByName(IBQ_EVEN).AsString;
            if FieldByName(IBQ_EVEN_ROLE).AsString=''
            then byName( IBQ_EVEN_ROLE ).IsNull:=True
            Else byName( IBQ_EVEN_ROLE).AsString:=FieldByName(IBQ_EVEN_ROLE).AsString;
            if FieldByName(IBQ_DATA_EVEN).AsString=''
            then byName( IBQ_DATA_EVEN ).IsNull:=True
            Else byName( IBQ_DATA_EVEN).AsString:=FieldByName(IBQ_DATA_EVEN).AsString;
            if FieldByName(IBQ_DATA_EVEN_PERIOD).AsString=''
            then byName( IBQ_DATA_EVEN_PERIOD ).IsNull:=True
            Else byName( IBQ_DATA_EVEN_PERIOD).AsString:=FieldByName(IBQ_DATA_EVEN_PERIOD).AsString;
            if FieldByName(IBQ_DATA_EVEN_PLAC).AsString=''
            then byName( IBQ_DATA_EVEN_PLAC ).IsNull:=True
            Else byName( IBQ_DATA_EVEN_PLAC).AsString:=FieldByName(IBQ_DATA_EVEN_PLAC).AsString;
            if FieldByName(IBQ_DATA_AGNC).AsString=''
            then byName( IBQ_DATA_AGNC ).IsNull:=True
            Else byName( IBQ_DATA_AGNC).AsString:=FieldByName(IBQ_DATA_AGNC).AsString;
            if FieldByName(IBQ_QUAY).IsNull
            then byName( IBQ_QUAY ).IsNull:=True
            Else byName( IBQ_QUAY).AsInteger:=FieldByName(IBQ_QUAY).AsInteger;

            if FieldByName(IBQ_AUTH).IsNull
            then byName( IBQ_AUTH ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_AUTH);
              if tampon.Size>0  Then
                p_SaveToStream ( SQLQCible,IBQ_AUTH);
            end;

            if FieldByName(IBQ_TITL).IsNull
            then byName( IBQ_TITL ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_TITL);
              if tampon.Size>0 Then
                p_SaveToStream ( SQLQCible,IBQ_TITL);
            end;

            if FieldByName(IBQ_ABR).AsString=''
            then byName( IBQ_ABR ).IsNull:=True
            Else byName( IBQ_ABR).AsString:=FieldByName(IBQ_ABR).AsString;

            if FieldByName(IBQ_PUBL).IsNull
            then byName( IBQ_PUBL ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_PUBL);
              if tampon.Size>0 Then
                p_SaveToStream ( SQLQCible,IBQ_PUBL);
            end;

            if FieldByName(IBQ_TEXTE).IsNull
            then byName( IBQ_TEXTE ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_TEXTE);
              if tampon.Size>0 Then
                p_SaveToStream ( SQLQCible,IBQ_TEXTE);
            end;

            if FieldByName(IBQ_USER_REF).IsNull
            then byName( IBQ_USER_REF ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, IBQ_USER_REF);
              if tampon.Size>0 Then
                p_SaveToStream ( SQLQCible,IBQ_USER_REF);
            end;

            if FieldByName(IBQ_RIN).AsString=''
            then byName( IBQ_RIN ).IsNull:=True
            Else byName( IBQ_RIN ).AsString:=FieldByName(IBQ_RIN).AsString;

            if FieldByName(IBQ_CHANGE_NOTE).IsNull
            then byName( IBQ_CHANGE_NOTE ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, 'CHANGE_NOTE');
              if tampon.Size>0 Then
                p_SaveToStream ( SQLQCible,'CHANGE_NOTE');
            end;

            try
              SQLQCible.ExecQuery;
              SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
              SQLQCible2.ParamByName(IBQ_EV_FAM_CLEF).Value:=FieldByName(IBQ_EV_FAM_CLEF).Value;
              SQLQCible2.ExecQuery;//transfert individu
            except
              on E:EIBError do
              begin
                MyMessageDlg(rs_Error_source_transfer
                  +FieldByName(IBQ_ID).AsString
                  +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
                dm.IBT_base.RollbackRetaining;
                exit;
              end;
            end;

            Next;
          end;//de while not Eof
          SQLQCible .Close;
          SQLQCible2.Close;
          SQLQCible3.Close;
        end;// fin de If not Eof
        Close;

    //-- Table SOURCES_RECORD 2-d'événements individuels
        lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['SOURCES_RECORD '+rs_Caption_On_persons]);
        
        SQL.Text:='select count(*)';
        SQL.Add('from sources_record s where s.type_table=''I''');
        SQL.Add('and exists(select * from evenements_ind e');
        SQL.Add('inner join individu i on i.cle_fiche=e.ev_ind_kle_fiche');
        SQL.Add('and i.kle_dossier='+dossiers);
        SQL.Add('where e.ev_ind_clef=s.data_id)');
        ExecQuery;
        NbrEnr:=Fields[0].AsInteger;
        Close;
        SQL.Strings[0]:='select s.*';
        ExecQuery;
        i:=0;
        if not Eof Then
        begin
          SQLQCible3.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=3 AND INDI=:DATA_ID returning decujus';

          Text:='insert into SOURCES_RECORD ('
            +'ID'
            +',DATA_ID'
            +',SOURCE_PAGE'
            +',EVEN'
            +',EVEN_ROLE'
            +',DATA_EVEN'
            +',DATA_EVEN_PERIOD'
            +',DATA_EVEN_PLAC'
            +',DATA_AGNC'
            +',QUAY'
            +',AUTH'
            +',TITL'
            +',ABR'
            +',PUBL'
            +',TEXTE'
            +',USER_REF'
            +',RIN'
            +',CHANGE_DATE'
            +',CHANGE_NOTE'
            +',KLE_DOSSIER'
            +',TYPE_TABLE'
            +')'
            +' values('
            +'gen_id(sources_record_id_gen,1)'
            +',:DATA_ID'
            +',:SOURCE_PAGE'
            +',:EVEN'
            +',:EVEN_ROLE'
            +',:DATA_EVEN'
            +',:DATA_EVEN_PERIOD'
            +',:DATA_EVEN_PLAC'
            +',:DATA_AGNC'
            +',:QUAY'
            +',:AUTH'
            +',:TITL'
            +',:ABR'
            +',:PUBL'
            +',:TEXTE'
            +',:USER_REF'
            +',:RIN'
            +',''now'''
            +',:CHANGE_NOTE'
            +','+dossierc
            +',''I'''
            +')returning id';
         SQLQCible2.SQL.Text:='insert into tq_consang(id,indi,decujus)values(6,:id,:decujus)';

         SQLQCible .Params.Modified;//needed to create params
         SQLQCible2.Params.Modified;//needed to create params
          while (not eof) do
          begin
            inc(i);
            if (i=NbrEnr)or(i mod 10=0) then
              lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['SOURCES_RECORD '+rs_Caption_On_persons,IntToStr(I),IntToStr(NbrEnr)]);
              
            SQLQCible3.ParamByName( IBQ_DATA_ID).AsInteger:=FieldByName( IBQ_DATA_ID).AsInteger;

            try
              SQLQCible3.ExecQuery;

              if (SQLQCible3.Fields[0].AsInteger <= 0)
               Then
               Begin
                Next;
                continue;
               end;

            except
              Next;
              Continue;
            end;

            byName( IBQ_ID).AsInteger:=FieldByName(IBQ_ID).AsInteger;
            byName( IBQ_DATA_ID).AsInteger:=SQLQCible3.Fields[0].AsInteger;
            for p:=2 to  Count-1 do
               getSQLParam (p).Clear;
            if FieldByName(IBQ_SOURCE_PAGE).AsString=''
            then byName( IBQ_SOURCE_PAGE ).IsNull:=True
            Else byName( IBQ_SOURCE_PAGE).AsString:=FieldByName(IBQ_SOURCE_PAGE).AsString;
            if FieldByName(IBQ_EVEN).AsString=''
            then byName( IBQ_EVEN ).IsNull:=True
            Else byName( IBQ_EVEN ).AsString:=FieldByName(IBQ_EVEN).AsString;
            if FieldByName(IBQ_EVEN_ROLE).AsString=''
            then byName( IBQ_EVEN_ROLE ).IsNull:=True
            Else byName( IBQ_EVEN_ROLE).AsString:=FieldByName(IBQ_EVEN_ROLE).AsString;
            if FieldByName(IBQ_DATA_EVEN).AsString=''
            then byName( IBQ_DATA_EVEN ).IsNull:=True
            Else byName( IBQ_DATA_EVEN).AsString:=FieldByName(IBQ_DATA_EVEN).AsString;
            if FieldByName(IBQ_DATA_EVEN_PERIOD).AsString=''
            then byName( IBQ_DATA_EVEN_PERIOD ).IsNull:=True
            Else byName( IBQ_DATA_EVEN_PERIOD).AsString:=FieldByName(IBQ_DATA_EVEN_PERIOD).AsString;
            if FieldByName(IBQ_DATA_EVEN_PLAC).AsString=''
            then byName( IBQ_DATA_EVEN_PLAC ).IsNull:=True
            Else byName( IBQ_DATA_EVEN_PLAC).AsString:=FieldByName(IBQ_DATA_EVEN_PLAC).AsString;
            if FieldByName(IBQ_DATA_AGNC).AsString=''
            then byName( IBQ_DATA_AGNC ).IsNull:=True
            Else byName( IBQ_DATA_AGNC).AsString:=FieldByName(IBQ_DATA_AGNC).AsString;
            if FieldByName(IBQ_QUAY).IsNull
            then byName( IBQ_QUAY ).IsNull:=True
            Else byName( IBQ_QUAY).AsInteger:=FieldByName(IBQ_QUAY).AsInteger;

            if FieldByName(IBQ_AUTH).IsNull
            then byName( IBQ_AUTH ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'AUTH');
                if tampon.Size>0   Then
                  p_SaveToStream ( SQLQCible,'AUTH');
              end;

            if FieldByName(IBQ_TITL).IsNull
            then byName( IBQ_TITL ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'TITL');
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,'TITL');
              end;

            if FieldByName(IBQ_ABR).AsString=''
            then byName( IBQ_ABR ).IsNull:=True
            Else byName( IBQ_ABR).AsString:=FieldByName(IBQ_ABR).AsString;
            if FieldByName(IBQ_PUBL).IsNull
            then byName( IBQ_PUBL ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'PUBL');
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,'PUBL');
              end;

            if FieldByName(IBQ_TEXTE).IsNull
            then byName( IBQ_TEXTE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'TEXTE');
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,'TEXTE');
              end;

            if FieldByName(IBQ_USER_REF).IsNull
            then byName( IBQ_USER_REF ).IsNull:=True
            Else
            begin
              tampon.Clear;
              p_LoadFromStream ( SQLQSource, 'USER_REF');
              if tampon.Size>0  Then
                p_SaveToStream ( SQLQCible,'USER_REF');
            end;

            if FieldByName(IBQ_RIN).AsString=''
            then byName( IBQ_RIN ).IsNull:=True
            Else byName( IBQ_RIN ).AsString:=FieldByName(IBQ_RIN).AsString;

            if FieldByName(IBQ_CHANGE_NOTE).IsNull
            then byName( IBQ_CHANGE_NOTE ).IsNull:=True
            Else
              begin
                tampon.Clear;
                p_LoadFromStream ( SQLQSource, 'CHANGE_NOTE');
                if tampon.Size>0 Then
                  p_SaveToStream ( SQLQCible,'CHANGE_NOTE');
              end;

            try
              SQLQCible .ExecQuery;
              SQLQCible2.ParamByName(IBQ_DECUJUS).Value:=SQLQCible.Fields[0].Value;
              SQLQCible2.ParamByName(IBQ_ID).Value:=FieldByName(IBQ_ID).Value;
              SQLQCible2.ExecQuery;//transfert individu
            except
              on E:EIBError do
              begin
                MyMessageDlg(rs_Error_source_transfer
                  +FieldByName(IBQ_ID).AsString
                  +_CRLF+_CRLF+E.Message,mmtError, [mmbCancel],Self);
                dm.IBT_base.RollbackRetaining;
                exit;
              end;
            end;

            Next;
          end;

          SQLQCible .Close;
          SQLQCible2.Close;
          SQLQCible3.Close;
        end;// fin de If not Eof

        Close;
      finally
        tampon.Free;
      end;
    end
    else
    begin
      MyMessageDlg(rs_Error_sources_transfer,mmtError, [mmbCancel],Self);
    end;

  //test pour erreurs dues à table MEDIA_POINTEURS absente
    if TestTableChamp('MEDIA_POINTEURS','MP_CLEF') Then
    begin
      bNouvVersion:=TestTableChamp('MEDIA_POINTEURS','MP_POSITION');
    //-- Table MEDIA_POINTEURS 1-sur individus
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['MEDIA_POINTEURS '+rs_Caption_On_persons]);
      
      SQL.Clear;
      SQL.Text:='select count(*)';
      SQL.Add('FROM MEDIA_POINTEURS p WHERE p.MP_TYPE_IMAGE=''I''');
      SQL.Add('OR p.MP_TYPE_IMAGE IS NULL');
      SQL.Add('and exists(SELECT * FROM INDIVIDU where cle_fiche=p.mp_cle_individu');
      SQL.Add('and KLE_DOSSIER='+dossiers+')');
      SQL.Add('and exists(select * from multimedia where multi_clef=p.mp_media');
      SQL.Add('and MULTI_DOSSIER='+dossiers+')');
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Strings[0]:='select p.*';
      ExecQuery;

      if not Eof Then
      begin
        I:=0;
        SQLQCible2.SQL.Text:=' select DECUJUS from TQ_CONSANG where ID=2 AND INDI=:MP_MEDIA returning decujus';
        SQLQCible3.SQL.Text:=' select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:MP_CLE_INDIVIDU returning decujus';

        Text:='insert into MEDIA_POINTEURS ('
          +'MP_CLEF'
          +',MP_MEDIA'
          +',MP_CLE_INDIVIDU'
          +',MP_POINTE_SUR'
          +',MP_TABLE'
          +',MP_IDENTITE'
          +',MP_KLE_DOSSIER'
          +',MP_TYPE_IMAGE'
          +',MP_POSITION'
          +')'
          +'values('
          +'gen_id(biblio_pointeurs_id_gen,1)'
          +',:MP_MEDIA'
          +',:MP_CLE_INDIVIDU'
          +',:MP_CLE_INDIVIDU'
          +',''I'''
          +',:MP_IDENTITE'
          +','+dossierc
          +',''I'''
          +',:MP_POSITION'
          +');'
          +'end'
          +' end';

        SQLQCible.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['MEDIA_POINTEURS '+rs_Caption_On_persons,IntToStr(I),IntToStr(NbrEnr)]);
            
          SQLQCible2.ParamByName( IBQ_MP_MEDIA).AsInteger:=FieldByName(IBQ_MP_MEDIA).AsInteger;
          SQLQCible3.ParamByName( IBQ_MP_CLE_INDIVIDU).AsInteger:=FieldByName(IBQ_MP_CLE_INDIVIDU).AsInteger;

          try
            SQLQCible2.ExecQuery;
            SQLQCible3.ExecQuery;

            if (SQLQCible3.Fields[0].AsInteger <= 0)
            or (SQLQCible2.Fields[0].AsInteger <= 0)
             Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_MP_MEDIA).AsInteger:=SQLQCible2.Fields[0].AsInteger;
          byName( IBQ_MP_CLE_INDIVIDU).AsInteger:=SQLQCible3.Fields[0].AsInteger;

          if FieldByName(IBQ_MP_IDENTITE).AsInteger=0
            then byName( IBQ_MP_IDENTITE ).IsNull:=True
            Else byName( IBQ_MP_IDENTITE).AsInteger:=FieldByName(IBQ_MP_IDENTITE).AsInteger;

          if bNouvVersion
            then byName( IBQ_MP_POSITION).AsInteger:=FieldByName(IBQ_MP_POSITION).AsInteger
            else byName( IBQ_MP_POSITION).AsInteger:=0;

          SQLQCible.ExecQuery;
          Next;
        end;//de while not eof
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
      end;//de If not Eof

      Close;

    //-- Table MEDIA_POINTEURS 2-sur actes d'événements individuels
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['MEDIA_POINTEURS '+rs_Caption_On_persons_events]);
      
      SQL.Clear;
      SQL.Add('select count(*)');
      SQL.Add('FROM MEDIA_POINTEURS p WHERE p.MP_TYPE_IMAGE=''A''');
      SQL.Add('AND p.MP_TABLE=''I''');
      SQL.Add('and exists(SELECT * FROM INDIVIDU where cle_fiche=p.mp_cle_individu');
      SQL.Add('and KLE_DOSSIER='+dossiers+')');
      SQL.Add('and exists(select * from multimedia where multi_clef=p.mp_media');
      SQL.Add('and MULTI_DOSSIER='+dossiers+')');
      SQL.Add('and exists(select * from evenements_ind e');
      SQL.Add('inner join individu i on i.cle_fiche=e.ev_ind_kle_fiche');
      SQL.Add('and i.kle_dossier='+dossiers);
      SQL.Add('where e.ev_ind_clef=p.MP_POINTE_SUR)');
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Strings[0]:='select p.*';
      ExecQuery;

      if not Eof
        Then
      begin
        SQLQCible2.SQL.Text:=' select DECUJUS from TQ_CONSANG where ID=2 AND INDI=:MP_MEDIA returning decujus';
        SQLQCible3.SQL.Text:=' select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:MP_CLE_INDIVIDU returning decujus';
        SQLQCible4.SQL.Text:=' select DECUJUS from TQ_CONSANG where ID=3 AND INDI=:MP_POINTE_SUR returning decujus';
        Text:='insert into MEDIA_POINTEURS ('
          +'MP_CLEF'
          +',MP_MEDIA'
          +',MP_CLE_INDIVIDU'
          +',MP_POINTE_SUR'
          +',MP_TABLE'
          +',MP_IDENTITE'
          +',MP_KLE_DOSSIER'
          +',MP_TYPE_IMAGE'
          +',MP_POSITION'
          +')'
          +' values('
          +'gen_id(biblio_pointeurs_id_gen,1)'
          +',:MP_MEDIA'
          +',:MP_CLE_INDIVIDU'
          +',:MP_POINTE_SUR'
          +',''I'''
          +',:MP_IDENTITE'
          +','+dossierc
          +',''A'''
          +',:MP_POSITION'
          +')';
        i:=0;

        SQLQCible.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['MEDIA_POINTEURS '+rs_Caption_On_persons_events,IntToStr(I),IntToStr(NbrEnr)]);

          SQLQCible2.ParamByName( IBQ_MP_MEDIA).AsInteger:=FieldByName(IBQ_MP_MEDIA).AsInteger;
          SQLQCible3.ParamByName( IBQ_MP_CLE_INDIVIDU).AsInteger:=FieldByName(IBQ_MP_CLE_INDIVIDU).AsInteger;
          SQLQCible4.ParamByName( IBQ_MP_POINTE_SUR).AsInteger:=FieldByName(IBQ_MP_POINTE_SUR).AsInteger;

          try
            SQLQCible2.ExecQuery;
            SQLQCible3.ExecQuery;
            SQLQCible4.ExecQuery;

            if (SQLQCible4.Fields[0].AsInteger <= 0)
            or (SQLQCible3.Fields[0].AsInteger <= 0)
            or (SQLQCible2.Fields[0].AsInteger <= 0)
             Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_MP_MEDIA).AsInteger:=SQLQCible2.Fields[0].AsInteger;
          byName( IBQ_MP_CLE_INDIVIDU).AsInteger:=SQLQCible3.Fields[0].AsInteger;
          byName( IBQ_MP_POINTE_SUR).AsInteger:=SQLQCible4.Fields[0].AsInteger;

          if FieldByName(IBQ_MP_IDENTITE).AsInteger=0
            then byName( IBQ_MP_IDENTITE ).IsNull:=True
            Else byName( IBQ_MP_IDENTITE).AsInteger:=FieldByName(IBQ_MP_IDENTITE).AsInteger;

          if bNouvVersion
            then byName( IBQ_MP_POSITION).AsInteger:=FieldByName(IBQ_MP_POSITION).AsInteger
            else byName( IBQ_MP_POSITION).AsInteger:=0;

          SQLQCible.ExecQuery;
          Next;
        end;//de while not eof
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
        SQLQCible4.Close;
      end;// fin de If not Eof
      Close;

    //-- Table MEDIA_POINTEURS 3-sur actes d'événements familiaux
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['MEDIA_POINTEURS '+rs_Caption_On_family_events]);
      
      SQL.Clear;
      SQL.Add('select count(*)');
      SQL.Add('FROM MEDIA_POINTEURS p WHERE p.MP_TYPE_IMAGE=''A''');
      SQL.Add('AND p.MP_TABLE=''F''');
      SQL.Add('and exists(SELECT * FROM INDIVIDU where cle_fiche=p.mp_cle_individu');
      SQL.Add('and KLE_DOSSIER='+dossiers+')');
      SQL.Add('and exists(select * from multimedia where multi_clef=p.mp_media');
      SQL.Add('and MULTI_DOSSIER='+dossiers+')');
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Strings[0]:='select p.*';
      ExecQuery;

      if not Eof
        Then
      begin
        SQLQCible2.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=2 AND INDI=:MP_MEDIA returning decujus';
        SQLQCible3.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:MP_CLE_INDIVIDU returning decujus';
        SQLQCible4.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=5 AND INDI=:MP_POINTE_SUR returning decujus';
        Text:='insert into MEDIA_POINTEURS ('
          +'MP_CLEF'
          +',MP_MEDIA'
          +',MP_CLE_INDIVIDU'
          +',MP_POINTE_SUR'
          +',MP_TABLE'
          +',MP_IDENTITE'
          +',MP_KLE_DOSSIER'
          +',MP_TYPE_IMAGE'
          +',MP_POSITION'
          +')'
          +' values('
          +'gen_id(biblio_pointeurs_id_gen,1)'
          +',:MP_MEDIA'
          +',:MP_CLE_INDIVIDU'
          +',:MP_POINTE_SUR'
          +',''F'''
          +',:MP_IDENTITE'
          +','+dossierc
          +',''A'''
          +',:MP_POSITION'
          +')';
        i:=0;

        SQLQCible.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['MEDIA_POINTEURS '+rs_Caption_On_family_events,IntToStr(I),IntToStr(NbrEnr)]);
            
          SQLQCible2.ParamByName( IBQ_MP_MEDIA).AsInteger:=FieldByName(IBQ_MP_MEDIA).AsInteger;
          SQLQCible3.ParamByName( IBQ_MP_CLE_INDIVIDU).AsInteger:=FieldByName(IBQ_MP_CLE_INDIVIDU).AsInteger;
          SQLQCible4.ParamByName( IBQ_MP_POINTE_SUR).AsInteger:=FieldByName(IBQ_MP_POINTE_SUR).AsInteger;

          try
            SQLQCible2.ExecQuery;
            SQLQCible3.ExecQuery;
            SQLQCible4.ExecQuery;

            if (SQLQCible4.Fields[0].AsInteger <= 0)
            or (SQLQCible3.Fields[0].AsInteger <= 0)
            or (SQLQCible2.Fields[0].AsInteger <= 0)
             Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_MP_MEDIA).AsInteger:=SQLQCible2.Fields[0].AsInteger;
          byName( IBQ_MP_CLE_INDIVIDU).AsInteger:=SQLQCible3.Fields[0].AsInteger;
          byName( IBQ_MP_POINTE_SUR).AsInteger:=SQLQCible4.Fields[0].AsInteger;

          if FieldByName(IBQ_MP_IDENTITE).AsInteger=0
            then byName( IBQ_MP_IDENTITE ).IsNull:=True
            Else byName( IBQ_MP_IDENTITE).AsInteger:=FieldByName(IBQ_MP_IDENTITE).AsInteger;

          if bNouvVersion
           then byName( IBQ_MP_POSITION).AsInteger:=FieldByName(IBQ_MP_POSITION).AsInteger
           else byName( IBQ_MP_POSITION).AsInteger:=0;

          SQLQCible.ExecQuery;
          Next;
        end;//de while not eof
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
        SQLQCible4.Close;
      end;// fin de If not Eof
      Close;

    //-- Table MEDIA_POINTEURS 4-sur sources
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['MEDIA_POINTEURS '+rs_Caption_On_sources]);
      
      SQL.Clear;
      SQL.Add('select count(*)');
      SQL.Add(' FROM MEDIA_POINTEURS p WHERE p.MP_TYPE_IMAGE=''F''');
      SQL.Add('and exists(SELECT * FROM INDIVIDU where cle_fiche=p.mp_cle_individu');
      SQL.Add('and KLE_DOSSIER='+dossiers+')');
      SQL.Add('and exists(select * from multimedia where multi_clef=p.mp_media');
      SQL.Add('and MULTI_DOSSIER='+dossiers+')');
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Strings[0]:='select p.*';
      ExecQuery;

      if not Eof Then
      begin
        SQLQCible2.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=2 AND INDI=:MP_MEDIA returninq decujus';
        SQLQCible3.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=1 AND INDI=:MP_CLE_INDIVIDU returninq decujus';
        SQLQCible4.SQL.Text:='select DECUJUS from TQ_CONSANG where ID=6 AND INDI=:MP_POINTE_SUR returninq decujus';
        Text:='insert into MEDIA_POINTEURS ('
          +'MP_CLEF'
          +',MP_MEDIA'
          +',MP_CLE_INDIVIDU'
          +',MP_POINTE_SUR'
          +',MP_TABLE'
          +',MP_IDENTITE'
          +',MP_KLE_DOSSIER'
          +',MP_TYPE_IMAGE'
          +',MP_POSITION'
          +')'
          +' values('
          +'gen_id(biblio_pointeurs_id_gen,1)'
          +',:MP_MEDIA'
          +',:MP_CLE_INDIVIDU'
          +',:MP_POINTE_SUR'
          +',''F'''
          +',:MP_IDENTITE'
          +','+dossierc
          +',''F'''
          +',:MP_POSITION'
          +');'
          +'end'
          +' end';
        i:=0;

        SQLQCible.Params.Modified;//needed to create params
        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['MEDIA_POINTEURS '+rs_Caption_On_sources,IntToStr(I),IntToStr(NbrEnr)]);
            

          SQLQCible2.ParamByName( IBQ_MP_MEDIA).AsInteger:=FieldByName(IBQ_MP_MEDIA).AsInteger;
          SQLQCible3.ParamByName( IBQ_MP_CLE_INDIVIDU).AsInteger:=FieldByName(IBQ_MP_CLE_INDIVIDU).AsInteger;
          SQLQCible4.ParamByName( IBQ_MP_POINTE_SUR).AsInteger:=FieldByName(IBQ_MP_POINTE_SUR).AsInteger;

          try
            SQLQCible2.ExecQuery;
            SQLQCible3.ExecQuery;
            SQLQCible4.ExecQuery;

            if (SQLQCible4.Fields[0].AsInteger <= 0)
            or (SQLQCible3.Fields[0].AsInteger <= 0)
            or (SQLQCible2.Fields[0].AsInteger <= 0)
             Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_MP_MEDIA).AsInteger:=SQLQCible2.Fields[0].AsInteger;
          byName( IBQ_MP_CLE_INDIVIDU).AsInteger:=SQLQCible3.Fields[0].AsInteger;
          byName( IBQ_MP_POINTE_SUR).AsInteger:=SQLQCible4.Fields[0].AsInteger;

          if FieldByName(IBQ_MP_IDENTITE).AsInteger=0
            then byName( IBQ_MP_IDENTITE ).IsNull:=True
            Else byName( IBQ_MP_IDENTITE).AsInteger:=FieldByName(IBQ_MP_IDENTITE).AsInteger;

          if bNouvVersion
            then byName( IBQ_MP_POSITION).AsInteger:=FieldByName(IBQ_MP_POSITION).AsInteger
            else byName( IBQ_MP_POSITION).AsInteger:=0;

          SQLQCible.ExecQuery;
          Next;
        end;//de while not eof
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
        SQLQCible4.Close;
      end;// fin de If not Eof
      Close;
    end
    else
      MyMessageDlg(rs_Error_Table_MEDIA_POINTEURS,mmtWarning, [mmbOk],Self);

  //mise en test pour erreurs dues à table NOM_ATTACHEMENT absente
    if TestTableChamp('NOM_ATTACHEMENT','ID') Then
    begin
    //Table NOM_ATTACHEMENT
      lImport.Caption:=fs_RemplaceMsg(rs_Caption_Preparing_to_import_on_table,['NOM_ATTACHEMENT']);
      
      SQL.Text:='select count(*)';
      SQL.Add('from nom_attachement t');
      SQL.Add('inner join individu i on i.cle_fiche=t.id_indi');
      SQL.Add('and i.kle_dossier='+dossiers);
      ExecQuery;
      NbrEnr:=Fields[0].AsInteger;
      Close;
      SQL.Strings[0]:='select t.id_indi,t.nom,t.nom_indi';
      ExecQuery;
      if not Eof Then
      begin
        I:=0;
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
        SQLQCible2.SQL.Text:='select decujus from tq_consang where id=1 and indi=:id_indi returning decujus';
        SQLQCible3.SQL.Text:='select nom from individu where cle_fiche=:id_indi returning nom';
        Text:='insert into NOM_ATTACHEMENT ('
          +'id_indi'
          +',nom'
          +',nom_indi'
          +',kle_dossier'
          +')'
          +' values('
          +':id_indi'
          +',:nom'
          +',:nom_indi'
          +','+dossierc
          +')';

        SQLQCible.Params.Modified;//needed to create params

        while not eof do
        begin
          inc(i);
          if (i=NbrEnr)or(i mod 10=0) Then
            lImport.Caption:=fs_RemplaceMsg(rs_Caption_Importing_table_of_records_in_progress,['NOM_ATTACHEMENT',IntToStr(I),IntToStr(NbrEnr)]);
            
          SQLQCible2.ParamByName( IBQ_ID_INDI).AsInteger:=FieldByName(IBQ_ID_INDI).AsInteger;
          SQLQCible3.ParamByName( IBQ_ID_INDI).AsInteger:=FieldByName(IBQ_ID_INDI).AsInteger;

          try
            SQLQCible2.ExecQuery;
            SQLQCible3.ExecQuery;

            if (SQLQCible3.Fields[0].AsString = '')
            or (SQLQCible2.Fields[0].AsInteger <= 0)
             Then
             Begin
              Next;
              continue;
             end;

          except
            Next;
            Continue;
          end;

          byName( IBQ_ID_INDI).AsInteger:=SQLQCible2.Fields[0].AsInteger;

          if FieldByName(IBQ_NOM).AsString=''
           then byName( IBQ_NOM ).IsNull:=True
           Else byName( IBQ_NOM).AsString:=fs_FormatText(FieldByName(IBQ_NOM).AsString,mftUpper);

          if FieldByName(IBQ_nom_indi).AsString=''
           then byName( IBQ_NOM_INDI ).IsNull:=True
           Else byName( IBQ_nom_indi).AsString:=FieldByName(IBQ_nom_indi).AsString;

          SQLQCible.ExecQuery;

          Next;
        end;//de while not eof
        SQLQCible .Close;
        SQLQCible2.Close;
        SQLQCible3.Close;
      end;//de If not Eof
      Close;
    end;

  //effacement de TQ_CONSANG
    lImport.Caption:=rs_Suppressing_temp_table;
    
    SQLQCible.Close;
    Text:='DELETE FROM TQ_CONSANG';
    try
      SQLQCible.ExecQuery;
    except
      on E:EIBError do
      begin
        MyShowMessage(rs_Error_TQ_CONSANG_deleting+_CRLF+_CRLF+E.Message);
      end;
    end;
    SQLQCible.Close;

  //Mise à jour des étiquettes d'événements
    lImport.Caption:=rs_Updating_deprecated_events_sticks;
    
    Text:='execute procedure PROC_MAJ_TAGS';
    try
      SQLQCible.ExecQuery;
    except
      on E:EIBError do
      begin
        MyShowMessage(rs_Error_updating_old_tags+_CRLF+_CRLF+E.Message);
      end;
    end;
    SQLQCible.Close;

  //clôture des dataset et mise à jour de l'affichage des Individus

    dm.doMAJTableJournal(rs_Log_Import_from_a_folder_from_base+lbEmplacementbdd.Text);

    lImport.Caption:=rs_Confirm_update;
    
    dm.IBT_base.CommitRetaining;
    if dm.NumDossier=StrToInt(dossierc) then
      dm.doInitLieuxFavoris;
    qIndiDestination.close;
    qIndiDestination.Open;
    gbDestination.Caption:=fs_RemplaceMsg(rs_Destination_Persons_count,[NbrIndiDossier(qIndiDestination)]);

    lImport.Caption:=rs_Import_finished;

  finally
    free;
    SQLQCible .Destroy;
    SQLQCible2.Destroy;
    SQLQCible3.Destroy;
    SQLQCible4.Destroy;
    pAnime.Visible:=False;
    Animate.Hide(Canvas,ClientRect);
    btnClose.Enabled:=True;
    screen.Cursor:=crDefault;
  end;
end;

function TFMutationBase.NbrIndiDossier(Req:TIBQuery):string;
var
  q:TIBSQL;
begin
  q:=TIBSQL.Create(self);
  try
    q.Database:=Req.Database;
    q.Transaction:=Req.Transaction;
    q.SQL.Text:='select count(*) from individu where kle_dossier=:dossier';
    q.Params[0].AsInteger:=Req.Params[0].AsInteger;
    q.ExecQuery;
    Result:=q.Fields[0].AsString;
    q.Close;
  finally
    q.Free;
  end;
end;

destructor TFMutationBase.Destroy;
begin
  inherited;
  MaDate.Free;
  MotsClesDecode.Free;
end;

end.

