unit U_AncestroWeb;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2011 to 2016 (LAZARUS),             }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
{$R *.lfm}
{$mode objfpc}{$H+}
{$ELSE}
{$R *.dfm}
{$ENDIF}

////////////////////////////////////////////////////////////////////////////////
// AncestroWeb
// Free web plugin to create a genealogy web site in HTML or PHP
// Plugin libre de création d'un site web généalogique statique en HTML et PHP
// Pour Freelogy et Ancestromania
// Licence : GPL
// LIBERLOG 2011
// Auteur : Matthieu GIROUX
// Descriptions
// Création d'un arbre complet, d'une page de contact en PHP, de fiches, etc.
// Historique
// 1.1.4.1 : Gestion de versions
// 1.1.4.0 : Plus de TIBSQL, copie de l'archive originale fonctionnel, moins de bugs
// 1.1.3.1 : Professions dans la fiche de l'individu, Possibilité de descendre son arbre familial
// 1.1.1.2 : Plus de tests
// 1.1.1.1 : Métiers et âges
// 1.0.0.0 : Intégration dans Freelogy
// 0.9.9.0 : première version publiée
////////////////////////////////////////////////////////////////////////////////

interface

uses
{$ifdef unix}
{$endif}

{$IFNDEF FPC}
  Mask,  rxToolEdit, JvExControls,  Windows,
{$ELSE}
  EditBtn,LazFileUtils,
{$ENDIF}
  fonctions_string,
{$ifdef windows}
  Windows,
{$endif}
{$IFDEF WIN32}
  Registry,
{$ENDIF}
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  U_DMWeb, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, DB,
  IBQuery, ExtCtrls, ComCtrls, DBGrids,
  lazutf8classes,
  functions_html, ExtJvXPCheckCtrls, Spin, U_OnFormInfoIni,
  U_ExtImage, u_buttons_appli, IBSQL, U_ExtFileCopy,
  JvXPButtons, u_buttons_defs, IniFiles,
  u_common_ancestro, u_ancestroweboptions,
  u_extabscopy, u_extsearchedit,
  U_FormAdapt, u_scrollclones, U_ExtImages;

const
  CST_INNER_LANG_SEPARATOR : Char = '_' ;
  CST_LANGUAGE_FILE = '.properties';
{$IFDEF VERSIONS}
  gVer_AncestroWeb : T_Version = ( Component : 'Application Ancestroweb' ;
                                   FileUnit : 'U_AncestroWeb' ;
                                   Owner : 'Matthieu Giroux' ;
                                   Comment : 'Composant de copie multi-platformes.' ;
                                   BugsStory : '1.4.1.0 : AncestrowebOptions.' +#13#10
                                             + '1.4.0.1 : Warning on invalid Postal Cards directory.' +#13#10
                                             + '1.4.0.0 : Postal Cards.' +#13#10
                                             + '1.3.3.0 : No original media, updating leaflet.' +#13#10
                                             + '1.3.2.0 : shadow box.' +#13#10
                                             + '1.3.1.0 : No border on ie.' +#13#10
                                             + '1.3.0.7 : Tree spaces.' +#13#10
                                             + '1.3.0.6 : No union files bug.' +#13#10
                                             + '1.3.0.5 : Correct special chars links.' +#13#10
                                             + '1.3.0.4 : Correct jobs images.' +#13#10
                                             + '1.3.0.3 : Restoring Ancestromania integration.' +#13#10
                                             + '1.3.0.2 : Better splitted tree and better progress.' +#13#10
                                             + '1.3.0.0 : Restructure, Finalizing files.' +#13#10
                                             + '1.2.7.1 : Large database.' +#13#10
                                             + '1.2.7.0 : Map in HTML only.' +#13#10
                                             + '1.2.6.0 : Splitted map.' +#13#10
                                             + '1.2.5.0 : Splitted tree.' +#13#10
                                             + '1.2.4.0 : Adding searchedit' +#13#10
                                             + '1.2.3.0 : Confidential persons' +#13#10
                                             + '1.2.2.6 : No Flat Combo' +#13#10
                                             + '1.2.2.5 : Delphi compatible' +#13#10
                                             + '1.2.2.1 : Link to jobs'' base' +#13#10
                                             + '1.2.2.0 : Link to cities, names, surnames base' +#13#10
                                             + '1.2.1.1 : Hide dates lesser than 100 years' +#13#10
                                             + '1.2.1.0 : Better look and interactivity' +#13#10
                                             + '1.2.0.0 : Adding Map' +#13#10
                                             + '1.1.5.0 : Adding versioning' +#13#10
                                             + '1.1.4.0 : More of TIBSQL, copy original media, less bugs' +#13#10
                                             + '1.1.3.1 : Jobs in Person''s file, Tree descending' +#13#10
                                             + '1.1.1.2 : More tests' +#13#10
                                             + '1.1.1.1 : Jobs and ages' +#13#10
                                             + '1.0.0.0 : Integrating in Freelogy' +#13#10
                                             + '0.9.9.0 :?First published version' ;
                                   UnitType : CST_TYPE_UNITE_APPLI ;
                                   Major : 1 ; Minor : 4 ; Release : 1 ; Build : 0 );

{$ENDIF}

type

  { TF_AncestroWeb }

  TF_AncestroWeb = class(TF_FormAdapt)
    btnSelectBase: TFWLoad;
    bt_export: TFWSaveAs;
    bt_gen: TFWSaveAs;
    cbDossier: TComboBox;
    cb_Base: TComboBox;
    cb_CityAccents: TComboBox;
    cb_Files: TComboBox;
    cb_ImagesJobsAccents: TComboBox;
    cb_JobsAccents: TComboBox;
    cb_NamesAccents: TComboBox;
    cb_SurnamesAccents: TComboBox;
    cb_Themes: TComboBox;
    ch_ancestors: TJvXPCheckbox;
    ch_CitiesLink: TJvXPCheckbox;
    ch_Filtered: TJvXPCheckbox;
    ch_HideLessThan100: TJvXPCheckbox;
    ch_JobsImages: TJvXPCheckbox;
    ch_JobsLink: TJvXPCheckbox;
    ch_NamesLink: TJvXPCheckbox;
    ch_nooriginalphoto: TJvXPCheckbox;
    ch_Comptage: TJvXPCheckBox;
    ch_Images: TJvXPCheckBox;
    ch_ShowMainFile: TJvXPCheckBox;
    ch_SurnamesLink: TJvXPCheckbox;
    DBGrid1: TDBGrid;
    ds_Individu: TDatasource;
    ed_Author: TEdit;
    ed_BaseCities: TCaptionCombo;
    ed_BaseJobs: TCaptionCombo;
    ed_BaseNames: TCaptionCombo;
    ed_BaseSurnames: TCaptionCombo;
    ed_FileBeginName: TEdit;
    ed_ImagesJobs: TCaptionCombo;
    ed_IndexName: TEdit;
    ed_ListsBeginName: TEdit;
    ExtImage1: TExtImage;
    ExtImage2: TExtImage;
    ExtImage3: TExtImage;
    fne_Export: TFileNameEdit;
    FWEraseGedcom: TFWErase;
    FWPreview1: TFWPreview;
    GedcomEdit: TFileNameEdit;
    FileCopy: TExtFileCopy;
    fne_import: TFileNameEdit;
    FWEraseImage: TFWErase;
    FWEraseImage2: TFWErase;
    FWEraseImage3: TFWErase;
    FWClose1: TFWClose;
    ImageEdit1: TFileNameEdit;
    ImageEdit2: TFileNameEdit;
    ImageEdit3: TFileNameEdit;
    JvXPButton1: TJvXPButton;
    Label1: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label3: TLabel;
    Label31: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label52: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label9: TLabel;
    lb_Images: TLabel;
    L_thema: TLabel;
    Label56: TLabel;
    Label6: TLabel;
    LabelBase: TLabel;
    lb_Comments: TLabel;
    me_Bottom: TMemo;
    me_Description: TMemo;
    me_FilesHead: TMemo;
    OnFormInfoIni: TOnFormInfoIni;
    PanelOptions: TPanel;
    Panel42: TPanel;
    Panel45: TPanel;
    Panel46: TPanel;
    Panel47: TPanel;
    Panel48: TPanel;
    Panel49: TPanel;
    Panel50: TPanel;
    Panel51: TPanel;
    Panel52: TPanel;
    Panel53: TPanel;
    Panel54: TPanel;
    Panel55: TPanel;
    Panel56: TPanel;
    Panel57: TPanel;
    Panel58: TPanel;
    Panel59: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    Panel3: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel32: TPanel;
    Panel33: TPanel;
    Panel34: TPanel;
    Panel35: TPanel;
    Panel36: TPanel;
    Panel37: TPanel;
    Panel38: TPanel;
    Panel39: TPanel;
    Panel40: TPanel;
    Panel41: TPanel;
    Panel7: TPanel;
    pc_needed: TPageControl;
    Panel10: TPanel;
    Panel8: TPanel;
    PCPrincipal: TPageControl;
    Pa_filter: TPanel;
    pa_About: TScrollbox;
    pa_base: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    pb_ProgressInd: TProgressBar;
    pb_ProgressAll: TProgressBar;
    SelectDirectoryDialog: TSelectDirectoryDialog;
    se_Nom: TExtSearchEdit;
    Splitter1: TSplitter;
    spSkinPanel1: TPanel;
    ts_global: TTabSheet;
    ts_options: TTabSheet;
    ts_Files: TTabSheet;
    ts_home: TTabSheet;
    ts_needed: TTabSheet;
    ts_about: TTabSheet;
    ts_Gen: TTabSheet;
    de_ExportWeb: TDirectoryEdit;
    procedure btnSelectBaseClick(Sender: TObject);
    procedure bt_exportClick(Sender: TObject);
    procedure bt_genClick(Sender: TObject);
    procedure cbDossierChange(Sender: TObject);
    procedure ch_FilteredClick(Sender: TObject);
    procedure ClonedP_LinksCloningControl(const Sender: TExtClonedPanel;
      const ASource, ADestination: TControl);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure de_ExportWebAcceptDirectory(Sender: TObject;{$IFDEF FPC} var Value: string{$ELSE} var Name: string;
    var Action: Boolean{$ENDIF});
    procedure cb_BaseChange(Sender: TObject);
    procedure ed_BaseCitiesChange(Sender: TObject);
    procedure ed_BaseCitiesEnter(Sender: TObject);
    procedure ed_BaseCitiesExit(Sender: TObject);
    procedure ed_BaseJobsChange(Sender: TObject);
    procedure ed_BaseJobsEnter(Sender: TObject);
    procedure ed_BaseJobsExit(Sender: TObject);
    procedure ed_BaseNamesChange(Sender: TObject);
    procedure ed_BaseNamesEnter(Sender: TObject);
    procedure ed_BaseNamesExit(Sender: TObject);
    procedure ed_BaseSurnamesChange(Sender: TObject);
    procedure ed_BaseSurnamesEnter(Sender: TObject);
    procedure ed_BaseSurnamesExit(Sender: TObject);
    procedure ed_ImagesJobsChange(Sender: TObject);
    procedure ed_ImagesJobsEnter(Sender: TObject);
    procedure ed_ImagesJobsExit(Sender: TObject);
    procedure OnFormInfoIniReadWriteComponent(const AComponent: TComponent;
      const ATypeEditInProgress: TSaveEdit; const AInifile: TCustomInifile;
      var KeepOnComponent: Boolean);
    procedure p_BaseOpen;
    procedure FileCopyDoEraseDir(Sender: TObject; var Continue: boolean);
    procedure FileCopyFailure(Sender: TObject; const ErrorCode: integer;
      var ErrorMessage: string; var ContinueCopy: boolean);
    procedure fne_ExportAcceptFileName(Sender: TObject; var Value: String);
    procedure fne_importAcceptFileName(Sender: TObject; var Value: String);
    procedure FWEraseImage3Click(Sender: TObject);
    procedure FWEraseImage2Click(Sender: TObject);
    procedure FWEraseImageClick(Sender: TObject);
    procedure FWPreview1Click(Sender: TObject);
    procedure ImageEdit2Change(Sender: TObject);
    procedure ImageEdit3Change(Sender: TObject);
    procedure ImageEdit1Change(Sender: TObject);
    procedure JvXPButton1Click(Sender: TObject);
    procedure OnFormInfoIniIniLoad(const AInifile: TCustomInifile;
      var Continue: Boolean);
    procedure OnFormInfoIniIniWrite(const AInifile: TCustomInifile;
      var Continue: Boolean);
    procedure se_NomSet(Sender: TObject);
    procedure TraduceImageFailure(Sender: TObject; const ErrorCode: integer;
      var ErrorMessage: string; var ContinueCopy: boolean);
  private
    { Déclarations privées }
    PremiereOuverture:boolean;
    AnIndex : Integer;
    FOptions : TF_AncestroWebOptions;
    procedure AddText(const ACombo: TCaptionCombo);
    procedure InitIndex(const ACombo: TCaptionCombo);
    procedure DoAfterInit( const ab_Ini : Boolean = True );
    function DoOpenBase(sBase: string):boolean;
    function fb_OpenMedias( const ai_CleFiche: Longint;
                            const ai_Type: integer;
                            const ab_Identite: Boolean = False;
                            const ach_table : Char = MEDIAS_TABLE_ARCHIV): Boolean;
    function fs_AddPhoto( const ai_cleFiche: longint;
                          const as_FileAltName, as_ImagesDir: string ;
                          const ai_ResizeWidth : Integer = 180 ): string;
    procedure p_CopyStructure;
    procedure p_CreateAHtmlFile(const astl_Destination: TStringlistUTF8;
      const as_BeginingFile, as_Describe, as_Title, as_SelectedTitle, as_LongTitle: string;
      as_BottomHTML: string;
      const as_Subdir: string = '';
      const as_ExtFile: string = CST_EXTENSION_HTML;
      const as_BeforeHTML: string = ''; const astl_Body : TStringlistUTF8 = nil );
    function fi_CreateHTMLTree(const IBQ_Tree: TIBQuery;
      const astl_HTMLTree: TStrings;
      const ai_Clefiche: longint;
      const ab_Div: boolean = True;
      const ab_Link: boolean = True;
      const ab_Progress: boolean = True;
      const ab_NotFirst: boolean = False;
      const as_IdSosa: string = IBQ_TQ_SOSA;
      const ab_Asc: boolean = True): longint;
    function fi_CreateSheets: integer;
    procedure p_createLettersSheets (var at_SheetsLetters : TAHTMLULTabSheet;
                                     const IBQ_FilesFiltered: TIBQuery;
                                     const ai_PerPage : Integer;
                                     const as_BeginFile : String);
    procedure p_genHtmlFiles(const IBQ_FilesFiltered: TIBQuery);
    procedure p_genHtmlList(const IBQ_FilesFiltered: TIBQuery);
    procedure p_genHtmlHome;
    procedure p_genHTMLTitle;
    procedure p_ImageEditChange(const aei_Image: TExtImage; const Sender: TObject);
    procedure p_ImageEditErase(const afne_EditImage: TFileNameEdit);
    function fb_OpenTree(const AIBQ_Tree: TIBQuery; const ai_Cle: longint;
      const ai_Niveau: integer = 0;const ai_Sexe: integer = 0): boolean; overload; virtual;
    function fb_OpenTree(const AIBQ_Tree: TIBSQL; const ai_Cle: longint;
      const ai_Niveau: integer = 0;const ai_Sexe: integer = 0): boolean; overload; virtual;
    procedure p_setBaseToIniFile ( const as_Base : String );
    procedure ListerDossiers;
  public
    { Déclarations publiques }
    gstl_Labels : TStringListUTF8;
    constructor Create ( AOwner : TComponent ); override;
    destructor Destroy; override;
    procedure Loaded; override;
    procedure Activate; override;
    procedure Deactivate; override;
    procedure DoShow; override;
    function DoInit(const sBase: string):Boolean;
    function DoInitBase(const AedNomBase: TCustomComboBox):Boolean;
    procedure p_iniReadKey;
    procedure p_iniWriteKey;
    function fs_getLinkedBase(const as_ShowedText, as_Texte: String;
      const as_Link: String; const ai_ComboIndex: Integer ; const ab_StopMore : Boolean = False): String;
    function fs_getLinkedCity(const as_Texte: String ): String;
    function fs_getLinkedJob(const as_Texte: String; const ai_counter : Integer): String;
    function fs_getLinkedName(const as_Texte: String; var aa_listWords : TUArray ; const av_confidential : Integer): String;
    function fs_getLinkedSurName(const as_Texte: String ): String;
    function fs_GetNameLink( as_name : String ; const as_key, as_Showed : String ; const as_SubDir : String = ''):String ;
    function fs_GetSOSA(const IBQuery: TIBQuery): String;
    function fb_Showdate(const adt_Date: TDateTime; const ai_confidentiel : Integer ): Boolean;
    function fb_ShowYear(const ai_Year : Integer ; const ai_confidentiel : Integer): Boolean;
    function fs_GetTitleTree(const as_NameOfTree: String;
                             const ai_generations: Longint): String;
    function fi_ImageEditCount(const as_FileName: string): integer;
    function fs_AddImage(const as_ImageFile: string): string;
    function fs_AddImageTable(const as_HtmlImage: string; const as_alt: string=''
      ): string;
    function fs_CreatePrevNext ( const ai_PreviousNext: Longint;
                                 const as_PreviousNext: String=CST_PAGE_PREVIOUS;
                                 const as_Subdir: String='';
                                       as_BeginLinkFiles: String=CST_SUBDIR_HTML_FILES_DIR;
                                 const ab_noNumber : Boolean = False ): String;
    procedure p_IncProgressBar;
    procedure p_IncProgressInd;
    procedure p_Setcomments(const as_Comment: String);
  end;

function fb_IsCreatedPerson ( const ai_Key : Int64 ):Boolean;
function fi_findName ( const as_Name : string ): Integer;

var
  F_AncestroWeb: TF_AncestroWeb;
  gs_HTMLTitle: string = '';
  gb_EraseExport: boolean = True;
  gb_Generate : boolean = False;
  {$IFDEF WINDOWS}
  gb_Logie : Boolean ;
  gs_Ancestro : String;
  {$ENDIF}
  gi_PagesCount : Longint;
  gi_CleFiche: integer = 0;
  gs_LinkGedcom: string;
  gs_RootPathForExport: string;
  gt_SheetsMapGroup,
  gt_SheetsLinks,
  gt_SheetsLetters: TAHTMLULTabSheet;
  gDat_Existing_Persons : TDataset = nil;
  // for map
  gt_Surnames : Array of Record
                          Name : String;
                          Minlatitude  ,
                          Minlongitude ,
                          Maxlatitude  ,
                          Maxlongitude : Double;
                          MaxCounter   : Int64;
                        end;

implementation

uses  fonctions_ini,
  functions_html_tree,
  StrUtils,
  BGRABitmap,
  BGRADefaultBitmap,
  BGRABitmapTypes,
  LazUTF8,
  u_firebird_functions,
  fonctions_dialogs,
  fonctions_components,
  Variants,
  u_common_functions,
  u_common_const,
  u_dm,
{$IFNDEF FPC}
  AncestroWeb_strings_delphi,
  ShellApi, ShlObj,
  //windirs,
{$ELSE}
  AncestroWeb_strings,
{$ENDIF}
{$IFDEF WIN32}
//  windirs,
{$ENDIF}
  fonctions_system,
  fonctions_dbobjects,
  fonctions_languages,
  fonctions_images,
  fonctions_objects,
  u_common_ancestro_functions,
  fonctions_file;


var lw_CurrentYear  : Word = 0;
    ldt_100YearData : TDateTime = 0;

//  function fi_findName
// search a name in the array gt_Surnames
function fi_findName ( const as_Name : string ): Integer;
var li_i : LongInt;
Begin
  for li_i := 0 to high ( gt_Surnames ) do
   if gt_Surnames [ li_i ].Name = as_Name Then
    Begin
      Result := li_i;
      Exit;
    end;
  Result := -1;
End;


// function GetCurrentYear
// Get?Current Year
function GetCurrentYear: word;
var
  d,m,y: word;
begin
  if lw_CurrentYear = 0 Then
    DecodeDate(Now, lw_CurrentYear, m, d);
  Result := lw_CurrentYear;
end;

// function Get100YearDated
// Get now -?100 Year
function Get100YearDated: TDateTime;
var
  d,m,y: word;
begin
  if ldt_100YearData = 0 Then
    ldt_100YearData := EncodeDate(GetCurrentYear-100,1,1);
  Result:=ldt_100YearData;
end;

// function TF_AncestroWeb.fb_ShowYear
// show date or not
function TF_AncestroWeb.fb_ShowYear ( const ai_Year : Integer ; const ai_confidentiel : Integer ): Boolean ;
Begin
  Result :=  (( ai_confidentiel < 1 ) or ( ai_confidentiel > 2 )) and ( not ch_HideLessThan100.Checked
    or ( ai_Year <  GetCurrentYear - 100 ));
end;

// function TF_AncestroWeb.fb_Showdate
// show date or not
function TF_AncestroWeb.fb_Showdate ( const adt_Date : TDateTime; const ai_confidentiel : Integer ): Boolean ;
Begin
  Result := (( ai_confidentiel < 1 ) or ( ai_confidentiel > 2 )) and ( not ch_HideLessThan100.Checked
    or ( adt_Date < Get100YearDated ));
end;
// destructor TF_AncestroWeb.Destroy
// Freeing data objects on destroy event
destructor TF_AncestroWeb.Destroy;
begin
  if Assigned(FIniFile) Then
    OnFormInfoIni.p_ExecuteEcriture(Self);
  inherited;
  FreeAndNil(gstl_Labels);
  p_FreeKeyWords;
  FreeAndNil(FIniFile);
  f_GetMemIniFile();
end;


// procedure TF_AncestroWeb.p_clonePersonVerify
// creating a HTML list of persons
procedure p_clonePersonVerify (const IBQ_FilesFiltered: TIBQuery );
Begin
  gDat_Existing_Persons := fdat_CloneDatasetWithSQL ( IBQ_FilesFiltered, DMWeb );
  try
    gDat_Existing_Persons.open;
  Except
    MyShowMessage ( gs_ANCESTROWEB_cantOpenData ) ;
  end;
end;

// function fb_IsCreatedPerson
// verify if person is in the list or in the files
function fb_IsCreatedPerson ( const ai_Key : Int64 ):Boolean;
var li_i : Longint;
Begin
  Result := not Assigned(gDat_Existing_Persons);
  if not Result Then
    with gDat_Existing_Persons do
      try
         Result := Locate(IBQ_CLE_FICHE,ai_Key,[]);
      Except
        MyShowMessage ( gs_ANCESTROWEB_cantOpenData ) ;
      end;
end;


// procedure TF_AncestroWeb.DBGrid1CellClick
// Writeng ini on dbgrid click
procedure TF_AncestroWeb.DBGrid1CellClick(Column: TColumn);
begin
  p_iniWriteKey;
end;

// procedure TF_AncestroWeb.p_iniWriteKey
// Writing the DBGrid ini key
procedure TF_AncestroWeb.p_iniWriteKey;
begin
  with DMWeb do
   if IBQ_Individu.Active Then
    fCleFiche := IBQ_Individu.FieldByName(IBQ_CLE_FICHE).AsInteger;
  p_IniWriteSectionInt(CST_INI_ANCESTROWEB_SECTION, IBQ_CLE_FICHE, fCleFiche);
end;

// procedure TF_AncestroWeb.p_iniReadKey
// Reading the DBGrid ini key
procedure TF_AncestroWeb.p_iniReadKey;
begin
  fCleFiche := f_IniReadSectionInt(CST_INI_ANCESTROWEB_SECTION, IBQ_CLE_FICHE, fCleFiche);
  with DMWeb do
   if IBQ_Individu.Active Then
    IBQ_Individu.Locate(IBQ_CLE_FICHE,fCleFiche,[]);
end;

// procedure TF_AncestroWeb.de_ExportWebAcceptDirectory
// Web site export :?Simplifying user's interactivity
procedure TF_AncestroWeb.de_ExportWebAcceptDirectory(Sender: TObject;
 {$IFDEF FPC} var Value: string{$ELSE} var Name: string;
    var Action: Boolean{$ENDIF});
begin
  gb_EraseExport := False;
end;

procedure TF_AncestroWeb.p_setBaseToIniFile ( const as_Base : String );
Begin
  if ( as_Base > '' ) Then
   Begin
    fbddpath := as_Base;
   end;
end;

procedure TF_AncestroWeb.cb_BaseChange(Sender: TObject);
begin
  p_setBaseToIniFile ( cb_Base.Text );
  p_BaseOpen;
end;

procedure TF_AncestroWeb.ed_BaseCitiesChange(Sender: TObject);
begin
  InitIndex(ed_BaseCities);
end;

procedure TF_AncestroWeb.ed_BaseCitiesEnter(Sender: TObject);
begin
  InitIndex(ed_BaseCities);
end;

procedure TF_AncestroWeb.ed_BaseCitiesExit(Sender: TObject);
begin
  AddText(ed_BaseCities);
end;

procedure TF_AncestroWeb.ed_BaseJobsChange(Sender: TObject);
begin
  InitIndex(ed_BaseJobs);
end;

procedure TF_AncestroWeb.ed_BaseJobsEnter(Sender: TObject);
begin
  InitIndex(ed_BaseJobs);
end;

procedure TF_AncestroWeb.ed_BaseJobsExit(Sender: TObject);
begin
  AddText(ed_BaseJobs);
end;

procedure TF_AncestroWeb.ed_BaseNamesChange(Sender: TObject);
begin
  InitIndex(ed_BaseNames);
end;

procedure TF_AncestroWeb.ed_BaseNamesEnter(Sender: TObject);
begin
  InitIndex(ed_BaseNames);
end;

procedure TF_AncestroWeb.ed_BaseNamesExit(Sender: TObject);
begin
  AddText(ed_BaseNames);
end;

procedure TF_AncestroWeb.ed_BaseSurnamesChange(Sender: TObject);
begin
  InitIndex(ed_BaseSurnames);
end;

procedure TF_AncestroWeb.ed_BaseSurnamesEnter(Sender: TObject);
begin
  InitIndex(ed_BaseSurnames);
end;

procedure TF_AncestroWeb.ed_BaseSurnamesExit(Sender: TObject);
begin
  AddText(ed_BaseSurnames);
end;

procedure TF_AncestroWeb.ed_ImagesJobsChange(Sender: TObject);
begin
  InitIndex(ed_ImagesJobs);
end;

procedure TF_AncestroWeb.ed_ImagesJobsEnter(Sender: TObject);
begin
  InitIndex(ed_ImagesJobs);
end;

procedure TF_AncestroWeb.ed_ImagesJobsExit(Sender: TObject);
begin
  AddText(ed_ImagesJobs);
end;


procedure TF_AncestroWeb.Activate;
begin
  inherited;
  if PremiereOuverture Then
   Begin
    PremiereOuverture:=False;
    Exit;
   end;
  if assigned ( FIniFile ) Then
   Begin
    fb_iniWriteFile(FIniFile);
    FreeAndNil(FIniFile);
   end;
  f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
end;

procedure TF_AncestroWeb.Deactivate;
begin
  inherited;
  OnFormInfoIni.p_ExecuteEcriture(Self);
  fb_iniWriteFile(FIniFile,False);
  FreeAndNil(FIniFile);
end;

procedure TF_AncestroWeb.DoShow;
begin
  inherited;
  FOptions:=TF_AncestroWebOptions.Create(Self);
  FOptions.ShowIncrust(PanelOptions);
  OnFormInfoIni.p_ExecuteLecture(Self);
end;


procedure TF_AncestroWeb.OnFormInfoIniReadWriteComponent(
  const AComponent: TComponent; const ATypeEditInProgress: TSaveEdit;
  const AInifile: TCustomInifile; var KeepOnComponent: Boolean);
begin
  if ( ATypeEditInProgress = feTComboBox ) and (AComponent.Tag = -1 ) Then
   KeepOnComponent:=False;
end;

// procedure TF_AncestroWeb.edNomBaseExit
// Database's folder opening on Nombaseedit's Exit
procedure TF_AncestroWeb.p_BaseOpen;
var
  NumDossier:Integer;
begin
  if  DoInitBase(cb_Base)
  and fb_AutoComboInit(cbDossier)
   then
    begin
      NumDossier:=StrToInt(trim(copy(cbDossier.Text,1,2)));
      if DMWeb.OuvreDossier(NumDossier,PremiereOuverture,fCleFiche,fNomIndi,fPrenomIndi) then
      begin
       fNom_Dossier:=fs_getCorrectString(copy(cbDossier.Text,5,250));
       DoAfterInit ( False );
      end;
    end;
end;

// procedure TF_AncestroWeb.FileCopyDoEraseDir
// Erasing directory :?event
procedure TF_AncestroWeb.FileCopyDoEraseDir(Sender: TObject; var Continue: boolean);
begin
  Continue := gb_EraseExport or
    (MyMessageDlg({$IFDEF FPC}CST_AncestroWeb_WithLicense,{$ENDIF}
    fs_getCorrectString ( gs_AnceSTROWEB_DoEraseOldExport ) +
    dm.FileCopy.Destination + ' ?', mmtWarning, mmbYesNo, 0) = mrYes);
end;

// procedure TF_AncestroWeb.FileCopyFailure
// Failure on copy : Event
procedure TF_AncestroWeb.FileCopyFailure(Sender: TObject;
  const ErrorCode: integer; var ErrorMessage: string; var ContinueCopy: boolean);
begin
  MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ExportErrorCreate ) + dm.FileCopy.Source + CST_ENDOFLINE + ErrorMessage);
  Abort;
end;

// procedure TF_AncestroWeb.fne_ExportAcceptFileName
// Exporting ini on filename's accept
procedure TF_AncestroWeb.fne_ExportAcceptFileName(Sender: TObject;
  var Value: String);
begin
  bt_exportClick(bt_export);
end;

// procedure TF_AncestroWeb.fne_importAcceptFileName
// Importing ini on filename's accept
procedure TF_AncestroWeb.fne_importAcceptFileName(Sender: TObject;
  var Value: String);
var ls_FileImport, ls_filenameMemos : String;
begin
  if not FormActivated Then Exit;
  ls_FileImport := {$IFDEF FPC}Value{$ELSE}fne_import.Text{$ENDIF};
  if not DirectoryExistsUTF8(ls_FileImport) { *Converted from DirectoryExistsUTF8*  }
    and FileExistsUTF8(ls_FileImport) { *Converted from FileExistsUTF8*  } Then
  Begin
   FreeAndNil(FIniFile);
    try
      FIniFile:=TIniFile.Create(ls_FileImport);
      DoAfterInit;
      FreeAndNil(FIniFile);
      f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
      OnFormInfoIni.p_ExecuteEcriture(Self);
      FOptions.OnFormInfoIni.p_ExecuteEcriture(Self);
      ls_filenameMemos := copy ( ls_FileImport, 1, posex ( '.', ls_FileImport, length ( ls_FileImport ) - 5 )-1)+CST_INI_MEMOS+CST_EXTENSION_INI;
      with FOptions.i_postalcards do
        Begin
          IniFileMemos.Free;
          IniFileMemos:=TIniFile.Create(ls_filenameMemos);
          ShowDirectory;
        end;
    Except
      On E:Exception do
        MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantOpenFile ) +CST_ENDOFLINE+e.Message);
    end;
  end;
end;

// procedure TF_AncestroWeb.FWEraseImage3Click
// filename's edit erase's button event
procedure TF_AncestroWeb.FWEraseImage3Click(Sender: TObject);
begin
  p_ImageEditErase(ImageEdit3);
end;

// procedure TF_AncestroWeb.FWEraseImage2Click
// filename's edit erase's button event
procedure TF_AncestroWeb.FWEraseImage2Click(Sender: TObject);
begin
  p_ImageEditErase(ImageEdit2);
end;

// procedure TF_AncestroWeb.FWEraseImageClick
// filename's edit erase's button event
procedure TF_AncestroWeb.FWEraseImageClick(Sender: TObject);
begin
  p_ImageEditErase(ImageEdit1);
end;

procedure TF_AncestroWeb.FWPreview1Click(Sender: TObject);
begin
  p_OpenFileOrDirectory(de_ExportWeb.Directory);
end;

// procedure TF_AncestroWeb.ImageEdit2Change
// filename's edit change event
procedure TF_AncestroWeb.ImageEdit2Change(Sender: TObject);
begin
  p_ImageEditChange(ExtImage2, Sender);

end;
// procedure TF_AncestroWeb.ImageEdit3Change
// filename's edit change event

procedure TF_AncestroWeb.ImageEdit3Change(Sender: TObject);
begin
  p_ImageEditChange(ExtImage3, Sender);

end;
// procedure TF_AncestroWeb.ImageEdit1Change
// filename's edit change event
procedure TF_AncestroWeb.ImageEdit1Change(Sender: TObject);
begin
  p_ImageEditChange(ExtImage1, Sender);
end;

// procedure TF_AncestroWeb.p_ImageEditChange
// setting image from Filename edit
procedure TF_AncestroWeb.p_ImageEditChange(const aei_Image: TExtImage;
  const Sender: TObject);
var
  ls_FileName: string;
begin
  ls_FileName := (Sender as TFileNameEdit).FileName;
  if not DirectoryExistsUTF8(ls_FileName) { *Converted from DirectoryExistsUTF8*  } and FileExistsUTF8(ls_FileName) { *Converted from FileExistsUTF8*  }
    then aei_Image.LoadFromFile(ls_FileName)
    else aei_Image.Picture.Assign(nil);
end;

// function TF_AncestroWeb.fi_ImageEditCount
// Progress bar counter increment
function TF_AncestroWeb.fi_ImageEditCount(const as_FileName: string): integer;
begin
  if not DirectoryExistsUTF8(as_FileName) { *Converted from DirectoryExistsUTF8*  } and FileExistsUTF8(as_FileName) { *Converted from FileExistsUTF8*  }
    then Result := 1
    else Result := 0;
end;

// procedure TF_AncestroWeb.p_ImageEditErase
// Generic Image's edit erasing
procedure TF_AncestroWeb.p_ImageEditErase(const afne_EditImage: TFileNameEdit);
begin
  afne_EditImage.FileName := '';
end;

// procedure TF_AncestroWeb.bt_genClick
// Main Web Site Generation
procedure TF_AncestroWeb.bt_genClick(Sender: TObject);
begin
  //  verifying
  if not DMWeb.IBQ_Individu.Active Then
  begin
    MyShowMessage(fs_getCorrectString ( gs_ANCESTROWEB_BaseNotOpened ));
    Exit;
  end;
  if length(de_ExportWeb.Directory) < 6 then
  begin
    MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ExportMoreThan5Chars));
    Exit;
  end;
  if (cb_Files.Items.Count = 0) then
  begin
    MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ErrorFiles ) + gs_Root + CST_SUBDIR_SOURCES);
    Exit;
  end;
  if gb_Generate then
   Exit;
  if (cb_Files.ItemIndex = -1) then
    cb_Files.ItemIndex := 0;
  gs_html_source_file := CST_SUBDIR_SOURCES+DirectorySeparator+cb_files.Items[cb_files.ItemIndex]+DirectorySeparator;
  if not fb_LoadProperties(gstl_Labels,gs_Root + gs_html_source_file,
    UTF8LowerCase(CST_AncestroWeb), gs_Lang, CST_INNER_LANG_SEPARATOR, CST_LANGUAGE_FILE, True)
  or DMWeb.IBQ_Individu.IsEmpty
   Then
    Exit;
  gb_Generate := True;
  with DMWeb do
   try // starting work

    // going to work for a time : freezing options to protect work and options
    ts_needed .Enabled:=False;
    ts_options.Enabled:=False;
    Pa_filter .Enabled:=False;
    pa_base   .Enabled:=False;
    if not ch_Filtered.Checked Then
     ch_ancestors.Checked:=True;
    IBQ_Individu.DisableControls;
    p_CreateKeyWords;
    gs_RootPathForExport := de_ExportWeb.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} + DirectorySeparator;
    if not DirectoryExistsUTF8(gs_RootPathForExport) Then
     Begin
      SelectDirectoryDialog.InitialDir:=GetUserDir;
      if SelectDirectoryDialog.Execute Then
       gs_RootPathForExport:=SelectDirectoryDialog.FileName;
     end;
    pb_ProgressAll.Position := 0;
    pb_ProgressInd.Position := 0; // initing not needed user value
    pb_ProgressAll.Max := CST_PROGRESS_COUNTER_COPY + CST_PROGRESS_COUNTER_TITLE + fi_CreateSheets;
    p_CopyStructure;
    p_genHTMLTitle;
    Application.ProcessMessages;
    p_genHtmlHome;
    Application.ProcessMessages;
    if ch_Filtered.Checked then
    begin
      with DmWeb do
       if ch_ancestors.Checked Then
        Begin
          if fb_OpenTree(IBQ_TreeBysurnames, gi_CleFiche )
             then
               Begin
                p_createLettersSheets( gt_SheetsLetters, IBQ_TreeBysurnames, gi_FilesPerPage, ed_FileBeginName.Text);
                p_clonePersonVerify ( IBQ_TreeBysurnames );
               end;
        end
       Else
        Begin
         if fb_OpenTree(IBQ_TreeDescBysurnames, gi_CleFiche ) then
           Begin
             p_createLettersSheets( gt_SheetsLetters, IBQ_TreeDescBysurnames, gi_FilesPerPage, ed_FileBeginName.Text);
             p_clonePersonVerify ( IBQ_TreeDescBySurnames );
           end;
        end;
    end
    else
     Begin
      IBQ_Individu.First;
      p_createLettersSheets( gt_SheetsLetters, IBQ_Individu, gi_FilesPerPage, ed_FileBeginName.Text);
     end;

    with FOptions do
     Begin
        if ch_genTree.Checked then
          if ch_ancestors.Checked
           Then p_genHTMLTree ( DMWeb.IBQ_TreeAsc , ch_SplittedTree.Checked, sp_gentree.Value )
           Else p_genHTMLTree ( DMWeb.IBQ_TreeDesc, ch_SplittedTree.Checked, sp_gentree.Value );
        Application.ProcessMessages;
        if ch_genages.Checked then
          p_genHtmlAges;
        Application.ProcessMessages;
        if ch_genlinks.Checked then
          p_genHtmlLinks;
        Application.ProcessMessages;
        if ch_genjobs.Checked then
          p_genHtmlJobs;
        Application.ProcessMessages;
        if ch_genSearch.Checked then
          p_genHtmlSearch;
        Application.ProcessMessages;
        if ch_Filtered.Checked
        then
          begin
            if ch_ancestors.Checked
              Then p_genHtmlFiles(DmWeb.IBQ_TreeBySurnames)
              Else p_genHtmlFiles(DmWeb.IBQ_TreeDescBySurnames);
          end
        else p_genHtmlFiles(IBQ_Individu);
        Application.ProcessMessages;
        if ch_genSurnames.Checked then
        with DmWeb do
         begin
          if ch_Filtered.Checked
          then
            Begin
             if ch_ancestors.Checked Then
               Begin
                 if fb_OpenTree(IBS_TreeSurnames,gi_CleFiche) Then
                   p_genHtmlSurnames(IBS_TreeSurnames,IBQ_TreeBysurnames);
               end
              else
               Begin
                 if fb_OpenTree(IBS_TreeSurnamesDesc, gi_CleFiche) Then
                   p_genHtmlSurnames(IBS_TreeSurnamesDesc, IBQ_TreedescBysurnames);
               end;
           end
          else
           try
             IBS_Surnames.Close;
             IBS_Surnames.ParamByName(I_DOSSIER).AsInteger:=CleDossier;
             IBS_Surnames.ExecQuery;
             p_genHtmlSurnames(IBS_Surnames,IBQ_Individu); // ibq_individu in this form
           Except
             on E : Exception do
               Begin
                MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Surnames + '(' + IntToStr ( CleDossier ) + ')' + #13#10 + #13#10 + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
                Exit;
               End;
           End;
          Application.ProcessMessages;
         end;
        if ch_genContact.Checked then
          p_genPhpContact;
        Application.ProcessMessages;
        if ch_genpostalc.Checked then
          p_genHtmlPostalCards;

     end;
    Application.ProcessMessages;
    if assigned ( gDat_Existing_Persons ) Then
      gDat_Existing_Persons.Close ;
    p_Setcomments ( gs_AnceSTROWEB_Finished ); // finished for user
   finally
    pb_ProgressAll.Position := pb_ProgressAll.Max;
    Pa_filter .Enabled:=True;
    pa_base   .Enabled:=True;
    ts_needed .Enabled:=True;
    ts_options.Enabled:=True;
    gDat_Existing_Persons.Free;
    gDat_Existing_Persons := nil;
    IBQ_Individu.Locate(IBQ_CLE_FICHE, fCleFiche, []);
    IBQ_Individu.EnableControls;
    Finalize(gt_SheetsMapGroup);
    Finalize(gt_SheetsLetters);
    Finalize(gt_TabSheets);
    Finalize(gt_Surnames);
    gb_Generate := False;
   end;
end;

// procedure TF_AncestroWeb.cbDossierChange
// database's folder change event
procedure TF_AncestroWeb.cbDossierChange(Sender: TObject);
var
  NumDossier:integer;
begin
  NumDossier:=StrToInt(trim(copy(cbDossier.Text,1,2)));
  if NumDossier<>DMWeb.CleDossier then
    if DMWeb.OuvreDossier(NumDossier,PremiereOuverture,fCleFiche,fNomIndi,fPrenomIndi) then
    begin
      fNom_Dossier:=fs_getCorrectString(copy(cbDossier.Text,5,250));
      DoAfterInit;
    end;
end;

// procedure TF_AncestroWeb.bt_exportClick
// Export ini click event
procedure TF_AncestroWeb.bt_exportClick(Sender: TObject);
begin
  f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
  OnFormInfoIni.p_ExecuteEcriture(Self);
  FOptions.OnFormInfoIni.p_ExecuteEcriture(Self);
  if fb_iniWriteFile(FIniFile,True)
   Then
    with FileCopy do
     try
       Destination:=fne_Export.FileName;
       Source:=FIniFile.FileName;
       if Destination=Source Then Exit;
       CopySourceToDestination;
       FOptions.i_postalcards.SaveIniMemos;
       Destination := copy ( Destination, 1, posex ( '.', Destination, length ( Destination ) - 5 )-1)+CST_INI_MEMOS+CST_EXTENSION_INI;
       Source := copy ( Source, 1, posex ( '.', Source, length ( Source ) - 5 )-1)+CST_INI_MEMOS+CST_EXTENSION_INI;
       if FileExistsUTF8(source) Then
         CopySourceToDestination;
     Except
       On E:Exception do
         MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantSaveFile )+CST_ENDOFLINE+e.Message);
     end;
end;

// procedure TF_AncestroWeb.btnSelectBaseClick
// Database select on button's click event
procedure TF_AncestroWeb.btnSelectBaseClick(Sender: TObject);
begin
  with dm.OpenFirebird do
   Begin
    FileName:='';
    //préparation de la boite mOpenDialog
    if DirectoryExistsUTF8(cb_Base.Text) then
    begin
      InitialDir:=cb_Base.Text;
    end
    else
    begin
      if DirectoryExistsUTF8(ExtractFilePath(cb_Base.Text)) then
      begin
        InitialDir:=ExtractFilePath(cb_Base.Text);
        if FileExistsUTF8(cb_Base.Text) then
          FileName:=cb_Base.Text;
      end;
    end;

    if Execute then
    begin
      fb_AddToCombo(cb_base,FileName);
      p_writeComboBoxItems(cb_Base,cb_Base.Items);
      p_BaseOpen;
      p_setBaseToIniFile(FileName);
    end;
   end;
end;

// procedure TF_AncestroWeb.ch_FilteredClick
// "Filter from name" checkbox click event
procedure TF_AncestroWeb.ch_FilteredClick(Sender: TObject);
begin
  p_iniWriteKey;
end;

procedure TF_AncestroWeb.ClonedP_LinksCloningControl(
  const Sender: TExtClonedPanel; const ASource, ADestination: TControl);
begin
  if ADestination is TComboBox Then
   (ADestination as TComboBox).Items.AddStrings((ASource as TComboBox).Items);
end;

// function TF_AncestroWeb.fi_CreateSheets
// creating sheets from external options
// setting the main Position bar total
function TF_AncestroWeb.fi_CreateSheets: integer;

  procedure p_setCorrectFileName(const aed_NameFile: TEdit;
  const as_NameFile: string);
  begin
    if aed_NameFile.Text = '' then
      aed_NameFile.Text := as_NameFile;
  end;

begin
  Result := CST_PROGRESS_COUNTER_HOME+fi_ImageEditCount(ImageEdit1.FileName)+fi_ImageEditCount(ImageEdit2.FileName)+fi_ImageEditCount(ImageEdit3.FileName);
  Finalize(gt_TabSheets);
  p_setCorrectFileName(ed_IndexName, CST_FILE_Home);
  p_AddTabSheet(gt_TabSheets, gs_AnceSTROWEB_Home, ed_IndexName.Text +
    CST_EXTENSION_HTML);
  with FOptions do
   Begin
      if ch_genTree.Checked then
      begin
        p_setCorrectFileName(ed_TreeName, CST_FILE_TREE);
        if ch_SplittedTree.Checked
         then
          Begin
           p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_FullTree ), CST_FILE_TREE +
               DirectorySeparator + ed_TreeName.Text + '0' + CST_EXTENSION_HTML);
           Inc ( Result, sp_gentree.Value );
          end
         else
          Begin
            p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_FullTree ), CST_FILE_TREE +
               DirectorySeparator + ed_TreeName.Text + CST_EXTENSION_HTML);
            Inc(Result, CST_PROGRESS_COUNTER_TREE);
          end;
      end;
      if ch_genSurnames.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_Surnames);
        p_setCorrectFileName(ed_SurnamesFileName, CST_FILE_Surnames);
        p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_Surnames ), ed_SurnamesFileName.Text + CST_EXTENSION_HTML);
        if ch_genMap.Checked then
        begin
          p_setCorrectFileName(ed_MapFileName, CST_FILE_MAP);
          if ch_SplittedMap.Checked
           Then
            Begin
             p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Map ), ed_MapFileName.Text + '0' + CST_EXTENSION_HTML);
             inc ( Result, sp_groupMap.value );
            end
           Else
            Begin
              p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Map ), ed_MapFileName.Text +       CST_EXTENSION_HTML);
              Inc(Result, CST_PROGRESS_COUNTER_MAP);
            end;
        end;
      end;
      Inc(Result, CST_PROGRESS_COUNTER_FILES+CST_PROGRESS_COUNTER_LIST);
      p_setCorrectFileName(ed_FileBeginName, CST_FILE_FILES);
      p_setCorrectFileName(ed_ListsBeginName, CST_FILE_LIST);
      p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_List ), CST_SUBDIR_HTML_LISTS + '/' + ed_ListsBeginName.Text + '0' + CST_EXTENSION_HTML);
      if ch_ShowMainFile.Checked Then
        p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_Files ), ed_FileBeginName.Text +       CST_EXTENSION_HTML);
      if ch_genages.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_AGES);
        p_setCorrectFileName(ed_AgesName, CST_FILE_AGES);
        p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Ages ), ed_AgesName.Text + CST_EXTENSION_HTML);
      end;
     if ch_genlinks.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_LINKS);
        p_setCorrectFileName(ed_LinkName, CST_FILE_LINK);
        p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Links ), ed_LinkName.Text + 's' + CST_EXTENSION_HTML);
      end;
      if ch_genpostalc.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_POSTAL);
        p_setCorrectFileName(ed_PostalName, CST_FILE_AGES);
        p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_PostalCards ), ed_PostalName.Text + DirectorySeparator + ed_PostalName.Text + CST_EXTENSION_HTML);
      end;
      if ch_genjobs.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_JOBS);
        p_setCorrectFileName(ed_JobsName, CST_FILE_JOBS);
        p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Jobs ), ed_JobsName.Text + CST_EXTENSION_HTML);
      end;
      if ch_genSearch.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_SEARCH);
        p_setCorrectFileName(ed_SearchName, CST_FILE_SEARCH);
        p_AddTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Search ), ed_SearchName.Text + CST_EXTENSION_HTML);
      end;
      if ch_genContact.Checked then
      begin
        Inc(Result, CST_PROGRESS_COUNTER_CONTACT);
        p_setCorrectFileName(ed_ContactName, CST_FILE_Contact);
        p_AddTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_Contact ),
          ed_ContactName.Text + CST_EXTENSION_PHP);
      end;

   end;
end;

// procedure TF_AncestroWeb.p_CopyStructure
// Copy default structure from options
procedure TF_AncestroWeb.p_CopyStructure;
var
  ls_Destination: string;
  lt_arg : array [0..0] of string;
begin
  with dm.FileCopy do
   Begin
    Destination := gs_RootPathForExport;
    ls_Destination := Destination;
   end;
  if DirectoryExistsUTF8(ls_Destination ) { *Converted from DirectoryExistsUTF8*  } Then
   Begin
    lt_arg [0] := ls_Destination;
    if ( MyMessageDlg(fs_RemplaceMsg(gs_ANCESTROWEB_ExportDelete, lt_arg), mmtWarning, mmbYesNo) = mrYes ) then
     with FOptions do
      try
        DeleteDirUTF8(ls_Destination, ddoDeleteFirstFiles);
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_CSS, ddoDeleteAll);
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_LINKS, ddoDeleteAll);
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_IMAGES, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_LISTS , ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + ed_PostalName.Text , ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_MAILER, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_SCRIPTS, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_ARCHIVE, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_FILES, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination + CST_SUBDIR_HTML_MAPS, ddoDeleteAll );
        DeleteDirUTF8(ls_Destination+ CST_SUBDIR_HTML_TREE, ddoDeleteAll );
      except
        on E: Exception do
        begin
          MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ExportErrorErase ) + ls_Destination + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end
    Else
     Abort;
    End;
  p_IncProgressBar;   // growing the counter
  if (cb_Themes.Items.Count = 0) then
  begin
    MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ErrorThemes ) + gs_Root + CST_SUBDIR_THEMES);
    Abort;
  end;
  if (cb_Themes.ItemIndex = -1) then
    cb_Themes.ItemIndex := 0;
  with dm.FileCopy do
   try
    FileOptions:=FileOptions-[cpDestinationIsFile];
    if DirectoryExistsUTF8(fSoftUserPath + CST_SUBDIR_THEMES +DirectorySeparator+cb_Themes.Items[cb_Themes.ItemIndex])
     Then Source := fSoftUserPath + CST_SUBDIR_THEMES +DirectorySeparator+cb_Themes.Items[cb_Themes.ItemIndex]
     Else Source := gs_Root + CST_SUBDIR_THEMES +DirectorySeparator+cb_Themes.Items[cb_Themes.ItemIndex];
    Destination := gs_RootPathForExport;
    CopySourceToDestination;
    Source := gs_Root + CST_SUBDIR_CLASSES;
    CopySourceToDestination;
    if fi_ImageEditCount(GedcomEdit.FileName) > 0 then
    begin
      Source := GedcomEdit.FileName;
      CopySourceToDestination;
      gs_LinkGedcom := ExtractFileName(GedcomEdit.FileName);
    end
    else
      gs_LinkGedcom := '';
  finally
    FileOptions:=FileOptions+[cpDestinationIsFile];
   end;
end;

// procedure TF_AncestroWeb.p_IncProgressBar
// increments main Position bar
procedure TF_AncestroWeb.p_IncProgressBar;
begin
  pb_ProgressAll.Position := pb_ProgressAll.Position + 1; // growing
  
end;

// procedure TF_AncestroWeb.p_IncProgressInd
// increments specialized Position bar
procedure TF_AncestroWeb.p_IncProgressInd;
begin
  pb_ProgressInd.Position := pb_ProgressInd.Position + 1; // growing
  
end;

// function TF_AncestroWeb.fs_GetTitleTree
// Title of HTML trees
function TF_AncestroWeb.fs_GetTitleTree ( const as_NameOfTree : String ; const ai_generations : Longint ): String;
Begin
  Result := as_NameOfTree + ' (' + IntToStr(ai_generations) ;
  if ai_generations <= 1
    Then AppendStr(Result, ( gs_AnceSTROWEB_Generation  ) + ')')
    Else AppendStr(Result, ( gs_AnceSTROWEB_Generations ) + ')');
end;

// procedure TF_AncestroWeb.p_CreateHTMLTree
// Cr?ation de l'arbre dans une TStringlistUTF8 puis Sauvegarde
function TF_AncestroWeb.fi_CreateHTMLTree(const IBQ_Tree: TIBQuery;
  const astl_HTMLTree: TStrings;
  const ai_Clefiche: longint;
  const ab_Div: boolean = True;
  const ab_Link: boolean = True;
  const ab_Progress: boolean = True;
  const ab_NotFirst: boolean = False;
  const as_IdSosa: string = IBQ_TQ_SOSA;
  const ab_Asc: boolean = True): longint;
var
  li_LocalLevel, li_LevelOrigin, li_LocalPreLevel, li_Clefiche: integer;
  ls_Tempo, ls_Barres, ls_NodeLink, ls_NameSurname, ls_Image: string;
  lb_foundARecord : Boolean;

  function fs_getText: string;
  begin
    Result := '';
    with IBQ_Tree do
      Begin
        if not FieldByName(IBQ_DATE_NAISSANCE).IsNull
        and fb_ShowYear(FieldByName(IBQ_ANNEE_NAISSANCE).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)  then
          AppendStr(Result, ' ' + fs_Create_Image ( '..'+CST_HTML_DIR_SEPARATOR+CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_BIRTH, gs_AnceSTROWEB_EXPORT_WEB_BORN ) +
          ' ' + FieldByName( IBQ_DATE_NAISSANCE).AsString);
        if not FieldByName(IBQ_DATE_DECES).IsNull
        and fb_ShowYear(FieldByName(IBQ_ANNEE_DECES).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)  then
          AppendStr(Result, ' ' + fs_Create_Image ( '..'+CST_HTML_DIR_SEPARATOR+CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_DEATH, gs_AnceSTROWEB_EXPORT_WEB_DIED ) +
            ' ' + FieldByName(IBQ_DATE_DECES).AsString);
        if not FieldByName(IBQ_AGE_AU_DECES).IsNull then
          AppendStr(Result, fs_AddComma( FieldByName(IBQ_AGE_AU_DECES).AsString + gs_AnceSTROWEB_Years ));
        AppendStr(Result, fs_AddComma(FieldByName( as_idSosa   ).AsString ));
        p_addKeyWord(FieldByName(IBQ_NOM).AsString, '-'); // adding a head's meta keyword
        p_addKeyWord(FieldByName(IBQ_PRENOM).AsString); // adding a head's meta keyword
      end;
  end;


  procedure p_AddLine ( const ai_Key : Longint ; const ab_IsTheEnd, ab_OldNext, ab_IsFirst : boolean );
  Begin
    if not ch_Filtered.Checked
    or ( ab_IsFirst )
    or ( ab_Asc = ch_ancestors.Checked )
    or fb_IsCreatedPerson(ai_Key)
    Then
      Begin
        if ab_Link
         Then ls_Image := fs_GetNameLink ( fs_RemplaceEspace ( ls_NameSurname, '_' ),IntToStr(ai_key),ls_Image, '../' + CST_SUBDIR_HTML_FILES + CST_HTML_DIR_SEPARATOR )
         else ls_Image := fs_GetNameLink ( fs_RemplaceEspace ( ls_NameSurname, '_' ),IntToStr(ai_key),ls_Image );
      end;
    p_setEndLine(ls_Tempo, ls_Image, ls_NodeLink, ab_OldNext,
      ab_IsTheEnd, li_LocalPreLevel, li_LocalLevel, ab_Link, ab_div);

    astl_HTMLTree.Add(ls_Tempo);
  end;

  procedure p_CreateChilds(const af_Sosa: double; const as_Aboville: string; const ab_HasNext, ab_OldNext, ab_IsFirst, ab_IsSecond, ab_IsSisBrother: boolean );
  var
    li_Sexe : integer;
    lf_SosaPere, lf_SosaMere, lf_NewSosa: double;
    ls_newAboville: string;
  begin
   with IBQ_Tree do
    if (ab_Asc and Locate(as_IdSosa, af_Sosa, [])) or
      (not ab_Asc and Locate(as_IdSosa, as_Aboville, [])) then
    begin
      if not ab_NotFirst
      or not ab_IsFirst
      or ab_IsSecond
       Then
        Begin
          li_LocalPreLevel := li_LocalLevel;
          li_LocalLevel := abs(FieldByName(IBQ_NIVEAU).AsInteger)-li_levelOrigin;
          if ab_NotFirst then
            Dec(li_LocalLevel);
          if ( li_LocalLevel > Result )
           Then
            Result := li_LocalLevel;

          lb_foundARecord := True;
          if li_LocalPreLevel <> -1 then
            p_AddLine ( li_Clefiche, False, ab_OldNext, ab_IsFirst or ab_IsSecond );

          li_Clefiche := FieldByName(IBQ_CLE_FICHE).AsInteger;
          if ab_Progress then
            p_IncProgressInd; // growing the second counter
          // Nommage des noeuds
          if li_LocalPreLevel <> li_LocalLevel Then  // a div by level
            ls_NodeLink := fs_GetNodeLink(ls_NodeLink, li_LocalLevel);

          // Cr?ation du d?but de Division
          p_setLevel(astl_HTMLTree, ls_NodeLink, ab_IsFirst or ab_IsSecond and ab_NotFirst, li_LocalLevel, li_LocalPreLevel, ab_div);

          li_Sexe := FieldByName(IBQ_SEXE).AsInteger;

          ls_NameSurname:=fs_getNameAndSurName(IBQ_Tree);

          ls_Image := ls_NameSurname +  fs_getText;
          ls_Barres := fs_NewLineImages(ls_Barres, ab_HasNext, li_LocalLevel);
          ls_Tempo := fs_CreateLineImages(ls_Barres, li_LocalLevel);
          case li_sexe of
            IBQ_SEXE_MAN   : ls_Image := fs_Create_Tree_Image('g' + CST_TREE_GIF_EXT) + ls_Image;
            IBQ_SEXE_WOMAN : ls_Image := fs_Create_Tree_Image('f' + CST_TREE_GIF_EXT) + ls_Image;
          end;
        end;
      lf_NewSosa := 0;
      if ab_Asc then
      begin    // next parents
        lf_SosaPere := af_Sosa * 2;
        lf_SosaMere := af_Sosa * 2 + 1;
        p_CreateChilds(lf_SosaPere, as_aboville, Locate(
          as_IdSosa, lf_SosaMere, []), ab_HasNext, False, ab_IsFirst, False );
        p_CreateChilds(lf_SosaMere, as_aboville, False, ab_HasNext, False, False, False );
      end
      else
      begin
        Next;  // next record for next tests
        ls_newAboville :=
          copy(as_aboville, 1, Length(as_aboville) - 1) + chr(
          Ord(as_aboville[Length(as_aboville)]) + 1);
        if FieldByName(as_IdSosa).AsString = ls_newAboville then // next record of sister or brother
        begin
          p_CreateChilds(lf_NewSosa, ls_newAboville,
            Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
            ab_HasNext, False, False, True );
        end
        else
        begin
          ls_newAboville := as_aboville + '1';
          if FieldByName(as_IdSosa).AsString = ls_newAboville then  // next record of childs
            begin
              p_CreateChilds(lf_NewSosa, ls_newAboville,
                 Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
                 ab_HasNext, False, ab_IsFirst, False );
              // verify if there is another sister or brother
              ls_newAboville :=
                copy(as_aboville, 1, length ( as_Aboville ) - 1) + chr(
                Ord(as_aboville[length ( as_Aboville )]) + 1);
              if Locate(as_IdSosa,ls_newAboville,[]) then
              begin
                p_CreateChilds(lf_NewSosa, ls_newAboville,
                  Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
                  ab_HasNext, False, False, True );
              end
           End;
        end;
      end;
    end;
  end;

begin
  li_LocalLevel := -1;
  Result := -1;
  ls_NodeLink := '';
  ls_Tempo := '';
  ls_NameSurname := '';
  ls_Image  := '';
  gs_HTMLTreeNodeLink := '';
  ls_Barres := '';
  With IBQ_Tree do
    try
     if ab_Progress Then
      Begin
        pb_ProgressInd.Position:=0;
        pb_ProgressInd.Max:=RecordCount;
      end;
      // first node
      Locate(IBQ_CLE_FICHE, ai_Clefiche, []);
      li_LevelOrigin := abs(FieldByName(IBQ_NIVEAU).AsInteger);
  //    if ( li_levelOrigin > 0 ) then
  //     dec ( li_levelOrigin );
      li_Clefiche:=ai_Clefiche;
      lb_foundARecord := False;
      // create the tree
      p_CreateChilds(FieldByName(as_IdSosa).AsFloat,
        FieldByName(as_IdSosa).AsString, False, False, True, False, False);
      if lb_foundARecord then
        p_AddLine ( li_Clefiche, True, False, False );
    except
      On E: Exception do
        MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantCreateATree ) + CST_ENDOFLINE + E.Message);
    end;
  Inc(Result);

end;

// procedure TF_AncestroWeb.p_genHTMLTitle
// HTML?Main title
procedure TF_AncestroWeb.p_genHTMLTitle;
var
  li_ClePere, li_CleMere: integer;
  gf_Sosa: double;
begin
  p_IncProgressBar; // growing the counter
  if ch_Filtered.Checked then
    gi_CleFiche := fCleFiche
  else
  begin
    gf_Sosa := 1;
    with DMWeb do
     if IBQ_Individu.Locate(IBQ_SOSA, gf_Sosa, []) then
      gi_CleFiche := IBQ_Individu.FieldByName(IBQ_CLE_FICHE).AsInteger
    else
    begin
      MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_ErrorCreateSOSA ));
      Abort;
    end;
  end;

  gs_HTMLTitle := '';
  with DMWeb do
   if IBQ_Individu.Locate(IBQ_CLE_FICHE, gi_CleFiche, []) then
    begin //AL il serait pr?f?rable de laisser le titre ? l'initiative de l'utilisateur! Ce n'est pas forc?ment les noms du p?re et de la m?re de l'individu s?lectionner, surtout s'il n'y a pas de filtrage
      li_ClePere := IBQ_Individu.FieldByName(IBQ_CLE_PERE).AsInteger;
      li_CleMere := IBQ_Individu.FieldByName(IBQ_CLE_MERE).AsInteger;
      if IBQ_Individu.Locate(IBQ_CLE_FICHE, li_ClePere, []) then
        AppendStr(gs_HTMLTitle, ' ' + IBQ_Individu.FieldByName(IBQ_NOM).AsString);
      if IBQ_Individu.Locate(IBQ_CLE_FICHE, li_CleMere, []) then
        AppendStr(gs_HTMLTitle, ' & ' + IBQ_Individu.FieldByName(IBQ_NOM).AsString);
    end;
  gs_HTMLTitle := StringReplace( ( gs_AnceSTROWEB_HTMLTitle ), '@ARG',
    gs_HTMLTitle, [rfReplaceAll]);
end;

// function TF_AncestroWeb.fb_OpenTree
// open a tree from parameters
function TF_AncestroWeb.fb_OpenTree(const AIBQ_Tree: TIBQuery;
  const ai_Cle: longint; const ai_Niveau: integer = 0;
  const ai_Sexe: integer = 0): boolean;
begin
  Result := False;
  with AIBQ_Tree.Params do
    try
      AIBQ_Tree.Close;
      ParamByName(I_CLEF).AsInteger := ai_Cle;
      ParamByName(I_NIVEAU).AsInteger := ai_Niveau;
      if (FindParam(I_PARQUI) <> nil) Then
        ParamByName(I_PARQUI).AsInteger := ai_Sexe;
      if (FindParam(I_DOSSIER) <> nil) Then
        ParamByName(I_DOSSIER).AsInteger := DMWeb.CleDossier;
      AIBQ_Tree.Open;
      Result := not AIBQ_Tree.IsEmpty;
    except
      On E: Exception do
        MyShowMessage( gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_FullTree + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
    end;
end;

// function TF_AncestroWeb.fb_OpenTree
// open a tree from parameters
function TF_AncestroWeb.fb_OpenTree(const AIBQ_Tree: TIBSQL;
  const ai_Cle: longint; const ai_Niveau: integer = 0;
  const ai_Sexe: integer = 0): boolean;
begin
  Result := False;
  with AIBQ_Tree do
    try
      Close;
      ParamByName(I_CLEF).AsInteger := ai_Cle;
      ParamByName(I_NIVEAU).AsInteger := ai_Niveau;
      ParamByName(I_PARQUI).AsInteger := ai_Sexe;
      ExecQuery;
      Result := not Eof;
    except
      On E: Exception do
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_FullTree + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
    end;
end;


// function TF_AncestroWeb.fs_AddImage
// creating a HTML image from image's path
function TF_AncestroWeb.fs_AddImage(const as_ImageFile: string): string;
var
  ls_Destination, ls_HtmlFileName: string;
begin
  Result := '';
  p_IncProgressBar; // growing the counter
  if fi_ImageEditCount(as_ImageFile) = 0 then
    Exit;
  ls_HtmlFileName := ExtractFileName(as_ImageFile);
  ls_HtmlFileName := fs_TextToFileName(Copy(ls_HtmlFileName, 1, Length(ls_HtmlFileName) -
    Length(ExtractFileExt(ls_HtmlFileName)))) + CST_EXTENSION_JPEG;
  // saving the picture
  ls_destination := gs_RootPathForExport +
    CST_SUBDIR_HTML_IMAGES + DirectorySeparator + ls_HtmlFileName;
  with dm.TraduceImage do
   Begin
    FileSource := as_ImageFile;
    FileDestination := ls_Destination;
    CopySourceToDestination;
   end;
  AppendStr ( Result, ' ' + fs_AddImageTable(fs_Create_Image(CST_SUBDIR_HTML_IMAGES + CST_HTML_DIR_SEPARATOR + ls_HtmlFileName)));
end;

// function TF_AncestroWeb.fs_AddImageTable
// add an image in the current HTML?TABLE
function TF_AncestroWeb.fs_AddImageTable(const as_HtmlImage : string ; const as_alt: string = ''): string;
begin
  if as_HtmlImage = ''
   Then Result := ''
   Else Result := CST_HTML_TD_BEGIN + '<' + CST_HTML_TABLE +
    CST_HTML_ID_EQUAL + '"image">' + CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN +
    as_HtmlImage + CST_HTML_TD_END + CST_HTML_TR_END +
    CST_HTML_TABLE_END + CST_HTML_TD_END + ' ';
end;

// procedure TF_AncestroWeb.p_genHtmlHome
// Default HTML page
procedure TF_AncestroWeb.p_genHtmlHome;
var
  lstl_HTMLHome: TStringlistUTF8;
  ls_destination: string;
  ls_Images: string;
  li_Count: integer;


  // stats
  procedure p_AddCounting ( const astl_HTML : TStringlistUTF8  );
  Begin
   if ch_Comptage.Checked then
    try
      // loading the request
      DMWeb.IBS_Compte.Close;
      DMWeb.IBS_Compte.ParamByName ( I_DOSSIER    ).AsInteger:=DMWeb.CleDossier;
      DMWeb.IBS_Compte.ExecQuery;
      if not DMWeb.IBS_Compte.Eof Then
        Begin
         // stats' title
         astl_HTML.Add ( CST_HTML_BR + fs_CreateElementWithId ( CST_HTML_H3    ,CST_FILE_COUNTING));
         astl_HTML.Add (( gs_AnceSTROWEB_Statistics   ));
         astl_HTML.Add ( CST_HTML_H3_END );
         // stats' table
         astl_HTML.Add ( fs_CreateElementWithId ( CST_HTML_TABLE, CST_FILE_COUNTING));
         while not DMWeb.IBS_Compte.EOF do
          Begin    // adding the stats
           astl_HTML.Add (CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN  + CST_HTML_H4_BEGIN +
                         fs_GetStringValue ( gstl_Labels,DMWeb.IBS_Compte.FieldByName(COUNTING_LABEL).AsString ) +
                         CST_HTML_H4_END  + CST_HTML_TD_END + CST_HTML_TD_BEGIN +
                         DMWeb.IBS_Compte.FieldByName(COUNTING_COUNTING).AsString +
                         CST_HTML_TD_END + CST_HTML_TR_END);
           DMWeb.IBS_Compte.Next;
          end;

         astl_HTML.Add ( CST_HTML_TABLE_END );
        end;
    Except
      MyShowMessage(gs_ANCESTROWEB_Unset_Stats);
    end;
  end;


  function fs_AddImages(const as_Image1, as_Image2, as_Image3: string): string;
  begin
    Result := '';
    li_Count := fi_ImageEditCount(as_Image1) + fi_ImageEditCount(
      as_Image2) + fi_ImageEditCount(as_Image3);
    if li_Count = 0 then
      Exit;
    dm.TraduceImage.ResizeWidth := 630 div li_Count;
    Result := fs_AddImage(ImageEdit1.FileName);
    AppendStr(Result, fs_AddImage(ImageEdit2.FileName));
    AppendStr(Result, fs_AddImage(ImageEdit3.FileName));

  end;

begin
  p_Setcomments ( gs_AnceSTROWEB_Home ); // advert for user
  lstl_HTMLHome := TStringlistUTF8.Create;
  try
    lstl_HTMLHome.Text := CST_HTML_CENTER_BEGIN + '<' + CST_HTML_Paragraph +
      CST_HTML_ID_EQUAL + '"head">' + fs_html_Lines(
      me_Description.Text) + CST_HTML_Paragraph_END;

    ls_Images := fs_AddImages(ImageEdit1.FileName, ImageEdit2.FileName,
      ImageEdit3.FileName);
    if ls_Images > '' then
      lstl_HTMLHome.Add(' <' + CST_HTML_TABLE + CST_HTML_ID_EQUAL +
        '"images">' + CST_HTML_TR_BEGIN + ls_Images + CST_HTML_TR_END + CST_HTML_TABLE_END  + CST_HTML_BR);
    p_AddCounting ( lstl_HTMLHome );
    lstl_HTMLHome.Add(CST_HTML_CENTER_END);
    p_CreateKeyWords;
    pb_ProgressInd.Position := 0; // initing not needed user value
    p_CreateAHtmlFile(lstl_HTMLHome, CST_FILE_Home, me_Description.Lines.Text,
      ( gs_AnceSTROWEB_Home ), ( gs_AnceSTROWEB_Home ), gs_ANCESTROWEB_Welcome, gs_LinkGedcom);
    p_IncProgressBar; // growing the counter
    // saving the page
    ls_destination := gs_RootPathForExport + ed_IndexName.Text +
      CST_EXTENSION_HTML;
    try
      lstl_HTMLHome.SaveToFile(ls_destination);
    except
      On E: Exception do
      begin
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Home + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
        Abort;
      end;
    end;
  finally
    lstl_HTMLHome.Free;
  end;
end;

// procedure TF_AncestroWeb.p_Setcomments
// infos for user
procedure TF_AncestroWeb.p_Setcomments (const as_Comment : String);
Begin
  if as_Comment = ''
    Then lb_Comments.Caption:= ''
    Else lb_Comments.Caption:= fs_getCorrectString ( gs_AnceSTROWEB_Generating ) + as_Comment;

end;

// function TF_AncestroWeb.fb_OpenMedias
// Open a media data stream
function TF_AncestroWeb.fb_OpenMedias(const ai_CleFiche: Longint;
                                      const ai_Type: integer;
                                      const ab_Identite: Boolean = False;
                                      const ach_table : Char = MEDIAS_TABLE_ARCHIV):Boolean;
Begin
  Result := False;
  with DMWeb.IBQ_Medias do
  try
    Close;
    ParamByName(IBQ_CLE_FICHE     ).AsInteger := ai_CleFiche;
    ParamByName(MEDIAS_TYPE       ).AsInteger := ai_Type ;
    ParamByName(MEDIAS_TABLE      ).AsString  := ach_table ;
    ParamByName(MEDIAS_MP_IDENTITE).AsInteger := Integer ( ab_Identite ) ;
    Open;
    Result := not Eof;

  Except
    on E : Exception do
     Begin
       MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData + gs_AnceSTROWEB_The_Medias ) +CST_ENDOFLINE+e.Message);
     end;
  end;
end;

// function TF_AncestroWeb.fs_CreatePrevNext
// // creating previous or next image link
function TF_AncestroWeb.fs_CreatePrevNext ( const ai_PreviousNext : Longint ;
                                            const as_PreviousNext : String = CST_PAGE_PREVIOUS;
                                            const as_Subdir : String = '';
                                                  as_BeginLinkFiles : String = CST_SUBDIR_HTML_FILES + '/' ;
                                            const ab_noNumber : Boolean = False ) : String;
Begin
  if ab_NoNumber Then
    Result := CST_HTML_AHREF + as_BeginLinkFiles + CST_EXTENSION_HTML + '">'
                  + fs_Create_Image( as_Subdir + CST_SUBDIR_HTML_IMAGES + CST_HTML_DIR_SEPARATOR+as_PreviousNext + CST_EXTENSION_GIF, as_PreviousNext ) + CST_HTML_A_END
   Else
    Result := CST_HTML_AHREF + as_BeginLinkFiles + IntToStr(ai_PreviousNext) + CST_EXTENSION_HTML + '">'
                  + fs_Create_Image( as_Subdir + CST_SUBDIR_HTML_IMAGES + CST_HTML_DIR_SEPARATOR+as_PreviousNext + CST_EXTENSION_GIF, as_PreviousNext ) + CST_HTML_A_END
End;

// procedure TF_AncestroWeb.p_createLettersSheets
// creating a HTML list of letters
procedure TF_AncestroWeb.p_createLettersSheets ( var at_SheetsLetters : TAHTMLULTabSheet;
                                                 const IBQ_FilesFiltered: TIBQuery;
                                                 const ai_PerPage : Integer;
                                                 const as_BeginFile : String );
var li_Counter, li_OldCounterPages,  li_i: Longint;
    lch_i, lch_j : char;
Begin
  li_Counter := 0;
  li_OldCounterPages := 0;
  gi_PagesCount:=0;
  Finalize(at_SheetsLetters);
  lch_i := CST_HTML_BEGIN_LETTER;
  with IBQ_FilesFiltered do
   for lch_i := CST_HTML_BEGIN_LETTER to CST_HTML_END_LETTER do
     if Locate(IBQ_NOM, lch_i,[loPartialKey, loCaseInsensitive]) then
       begin
        if li_i > 0 Then
          li_OldCounterPages := RecNo div ai_PerPage;
        lch_j := chr ( ord ( lch_i ) + 1 );
        while not  Locate(IBQ_NOM, lch_j,
        [loPartialKey, loCaseInsensitive]) and ( UTF8UpperCase ( lch_j ) [ 1 ] <= CST_HTML_END_LETTER )
         do lch_j := chr ( ord ( lch_j ) + 1 );
        if UTF8UpperCase ( lch_j ) > 'Z'
          then Last;

        li_counter := RecNo div ai_PerPage;
        {
        if li_counter > li_OldCounterPages Then
          with FieldByName(IBQ_NOM) do
           if  ( AsString > '' )
           and ( AsString [1] = lch_j ) Then
            Begin
             IBQ_FilesFiltered.RecNo:= li_counter * ( ai_PerPage + 1 );
             if  ( AsString > '' )
             and ( AsString [1] < lch_j ) Then
              Begin
               p_AddTabSheetPage(at_SheetsLetters, high ( at_SheetsLetters ), as_BeginFile + IntToStr(li_Counter+1) + CST_EXTENSION_HTML, fs_RemplaceEspace (fs_getNameAndSurName(IBQ_FilesFiltered), '_' ));
              end
            End;
         }
        p_AddTabSheet(at_SheetsLetters, lch_i,
          as_BeginFile + IntToStr(li_OldCounterPages) + CST_EXTENSION_HTML );
        if li_OldCounterPages < li_Counter Then
          for li_i := li_OldCounterPages to li_Counter do
           Begin
            IBQ_FilesFiltered.RecNo:= li_i * ai_PerPage + 1 ;
            p_AddTabSheetPage(at_SheetsLetters, high ( at_SheetsLetters ), as_BeginFile + IntToStr(li_i) + CST_EXTENSION_HTML, fs_RemplaceEspace (fs_getNameAndSurName(IBQ_FilesFiltered), '_' ));
           end;
       end;
  gi_PagesCount := round ( IBQ_FilesFiltered.RecordCount / ai_PerPage+0.5);
end;

// function fs_GetNameLink
// Creates a link from a name and a showed info
function TF_AncestroWeb.fs_GetNameLink ( as_name : String ; const as_key, as_Showed : String ; const as_SubDir : String = ''):String ;
Begin
  as_name := StringReplace( StringReplace(as_name, '"', '\"',[rfReplaceAll]), '\', '\\',[rfReplaceAll]);
  if as_name > '' Then
   Begin
    Result := CST_HTML_AHREF + as_SubDir + fs_GetSheetLink ( gt_SheetsLetters, as_name[1], as_name ) + '#' + fs_exchange_special_chars(as_name) ;
    if as_key > '' Then
     AppendStr ( Result, '_' + as_key );
    AppendStr ( Result, '">' + as_Showed + CST_HTML_A_END );
   end;
End;

function TF_AncestroWeb.fs_GetSOSA(const IBQuery: TIBQuery): String;
begin
  with IBQuery do
   if ch_Filtered.Checked
    Then
     if ch_ancestors.Checked
       Then Result := fs_RemplaceMsgIfExists(gs_ANCESTROWEB_SOSA    ,FieldByName(IBQ_TQ_SOSA    ).AsString)
       Else Result := fs_RemplaceMsgIfExists(gs_ANCESTROWEB_Aboville,FieldByName(IBQ_TQ_NUM_SOSA).AsString)
    Else    Result := fs_RemplaceMsgIfExists(gs_ANCESTROWEB_SOSA    ,FieldByName(IBQ_SOSA       ).AsString);
end;


// procedure TF_AncestroWeb.p_genHtmlList
// creating persons' list
procedure TF_AncestroWeb.p_genHtmlList(const IBQ_FilesFiltered: TIBQuery);
var
  ls_ASurnameOrName, ls_destination: string;
  lt_SheetsLists : TAHTMLULTabSheet;
  ls_ImagesDir: string;
  li_CounterPages : Longint;

  function fs_addYear ( const as_yearField, as_CityField : String ) : String;
  Begin
    with IBQ_FilesFiltered do
      if fb_ShowYear(FieldByName(as_yearField).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)
       then
        Begin
          Result := FieldByName(as_yearField).AsString+fs_AddComma ( fs_getLinkedCity ( Trim (  FieldByName(as_CityField).AsString )));
        end
       Else Result := '';
  end;

  procedure p_AddAList;
  var
    lstl_HTMLAList: TStringlistUTF8;
    ls_NewSurname, ls_Sexe, ls_ASurnameBegin, ls_ASurnameEnd: string;
    li_i, li_CleFiche: longint;
    lb_next, lb_show : Boolean ;
  begin
    p_CreateKeyWords;
    lstl_HTMLAList := TStringlistUTF8.Create;
    ls_ASurnameBegin := IBQ_FilesFiltered.FieldByName(IBQ_NOM).AsString;
    if (ls_ASurnameBegin > '') then
      p_SelectTabSheet(lt_SheetsLists,ls_ASurnameBegin[1],ls_ASurnameBegin); // current letter sheet
    lstl_HTMLAList.Text :=
      fs_CreateULTabsheets(lt_SheetsLists, '', CST_HTML_SUBMENU)+CST_HTML_DIV_BEGIN;
    if (ls_ASurnameBegin > '') then
      p_SelectTabSheet(lt_SheetsLists,ls_ASurnameBegin[1],ls_ASurnameBegin, False);  // reiniting for next page
    lb_next := True;
    lstl_HTMLAList.Add( CST_HTML_CENTER_BEGIN + fs_CreateElementWithId ( CST_HTML_TABLE , 'list' ));
    lstl_HTMLAList.Add( fs_CreateElementWithId ( CST_HTML_TR , CST_TABLE_TITLE )+
                         fs_Create_TD ( CST_FILE_PERSON, CST_HTML_ID_EQUAL, 2 )+CST_HTML_TD_END+
                         fs_Create_TD ( CST_FILE_PERSON, CST_HTML_ID_EQUAL )+CST_HTML_H2_BEGIN+ ( gs_AnceSTROWEB_Person ) +CST_HTML_H2_END+CST_HTML_TD_END+
                        CST_HTML_TD_BEGIN+CST_HTML_H2_BEGIN+ ( gs_AnceSTROWEB_Born ) +CST_HTML_H2_END+CST_HTML_TD_END+
                        CST_HTML_TD_BEGIN+CST_HTML_H2_BEGIN+ ( gs_AnceSTROWEB_Died ) +CST_HTML_H2_END+CST_HTML_TD_END+
                        CST_HTML_TR_END);
    for li_i := 1 to gi_FilesPerList do
    with IBQ_FilesFiltered do
      begin
        p_IncProgressInd; // growing the second counter
        p_addKeyWord( FieldByName(IBQ_NOM).AsString, '-'); // adding a head's meta keyword
        lb_show := fb_ShowYear( FieldByName(IBQ_ANNEE_NAISSANCE).AsInteger, FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger );
        if lb_show then
          p_addKeyWord( FieldByName(IBQ_PRENOM).AsString); // adding a head's meta keyword
        li_CleFiche :=  FieldByName(IBQ_CLE_FICHE).AsInteger;
        ls_NewSurname :=  FieldByName(IBQ_NOM).AsString;
        case  FieldByName(IBQ_SEXE).AsInteger of
         IBQ_SEXE_MAN   : ls_Sexe := CST_FILE_MAN;
         IBQ_SEXE_WOMAN : ls_Sexe := CST_FILE_WOMAN;
         else
           ls_Sexe := 'file';
        end;

        lstl_HTMLAList.Add( fs_CreateElementWithId ( CST_HTML_TR, ls_Sexe + CST_FILE_Number + IntToStr(li_i), CST_HTML_CLASS_EQUAL ) + CST_HTML_TD_BEGIN );
        if (ls_NewSurname <> ls_ASurnameOrName) Then
         Begin
          if (ls_ASurnameOrName = '') or ((length(ls_NewSurname) > 0) and
            (ls_NewSurname[1] <> ls_ASurnameOrName[1])) then
            lstl_HTMLAList.Add(CST_HTML_A_BEGIN + CST_HTML_NAME_EQUAL + '"' + ls_NewSurname[1] + '" />');
         end;
        ls_ASurnameOrName:= fs_getNameAndSurName( lb_show, ls_NewSurname, FieldByName(IBQ_PRENOM).AsString ); // showed name
        if lb_show then
          lstl_HTMLAList.Add( fs_AddPhoto(li_CleFiche, fs_getaltPhoto(IBQ_FilesFiltered), ls_ImagesDir, 24));   // mini photo
        lstl_HTMLAList.Add(   CST_HTML_TD_END + CST_HTML_TD_BEGIN +
                              CST_HTML_IMAGE_SRC + '../' + CST_SUBDIR_HTML_IMAGES + '/' + ls_Sexe + CST_EXTENSION_GIF + '" />' +
                              CST_HTML_TD_END + CST_HTML_TD_BEGIN +
                              fs_GetNameLink ( fs_RemplaceChar ( ls_ASurnameOrName, ' ', '_' ),IntToStr(li_CleFiche), ls_ASurnameOrName, '../' + CST_SUBDIR_HTML_FILES + '/' ) +
                              CST_HTML_TD_END + fs_Create_TD(CST_TABLE_CENTER) +  fs_addYear (IBQ_ANNEE_NAISSANCE,IBQ_VILLE_NAISSANCE) + // birth
                              CST_HTML_TD_END + fs_Create_TD(CST_TABLE_CENTER) +  fs_addYear (IBQ_ANNEE_DECES,IBQ_VILLE_DECES)+   // death
                              CST_HTML_TR_END); // city of death
        ls_ASurnameEnd :=  FieldByName(IBQ_NOM).AsString;
         Next;
        if  EOF then
         Begin
          lb_next:=False;
          Break;
         end ;
      end;
    lstl_HTMLAList.Add( CST_HTML_TABLE_END + CST_HTML_BR);
    if li_CounterPages - 1 > 0 Then
      lstl_HTMLAList.Add ( fs_CreatePrevNext ( li_CounterPages - 1, CST_PAGE_PREVIOUS, '../', ed_ListsBeginName.Text ));
    if lb_next Then
      lstl_HTMLAList.Add ( fs_CreatePrevNext ( li_CounterPages + 1, CST_PAGE_NEXT, '../', ed_ListsBeginName.Text ));
    lstl_HTMLAList.Add ( CST_HTML_CENTER_END );
    lstl_HTMLAList.Add(CST_HTML_DIV_END);
    p_CreateAHtmlFile(lstl_HTMLAList, CST_FILE_SUBFILES, me_Description.Lines.Text,
      ( gs_AnceSTROWEB_List ) + ' - ' + ls_ASurnameBegin +
      ( gs_AnceSTROWEB_At ) + ls_ASurnameEnd, '', '', gs_LinkGedcom, '..' + CST_HTML_DIR_SEPARATOR);
    // saving the page
    ls_destination := gs_RootPathForExport +
      CST_SUBDIR_HTML_LISTS + DirectorySeparator + ed_ListsBeginName.Text + IntToStr(
      li_CounterPages) + CST_EXTENSION_HTML;
    try
      lstl_HTMLAList.SaveToFile(ls_destination);
    except
      On E: Exception do
      begin
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_List + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
        Abort;
      end;
    end;
    lstl_HTMLAList.Free;
    Inc(li_CounterPages);
  end;

begin
  if IBQ_FilesFiltered.IsEmpty then
   Begin
    MyMessageDlg({$IFDEF FPC}CST_AncestroWeb_WithLicense,{$ENDIF}
    gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_List + CST_ENDOFLINE + CST_ENDOFLINE +  gs_ANCESTROWEB_Noone_to_show, mmtError, [mmbOk], 0);
    Abort;
   end;
  p_Setcomments ( gs_AnceSTROWEB_List ); // advert for user
  Finalize ( lt_SheetsLists );
  p_createLettersSheets ( lt_SheetsLists, IBQ_FilesFiltered, gi_FilesPerList, ed_ListsBeginName.Text );
  li_CounterPages := 0;
  pb_ProgressInd.Position := 0; // initing user value
  ls_ImagesDir := gs_RootPathForExport + CST_SUBDIR_HTML_LISTS + DirectorySeparator + CST_SUBDIR_HTML_IMAGES + DirectorySeparator ;
  fb_CreateDirectoryStructure(ls_ImagesDir);
  fb_CreateDirectoryStructure(gs_RootPathForExport + CST_SUBDIR_HTML_LISTS);
  try
    pb_ProgressInd.Max := IBQ_FilesFiltered.RecordCount;
    IBQ_FilesFiltered.First;
  Except
    MyMessageDlg({$IFDEF FPC}CST_AncestroWeb_WithLicense,{$ENDIF}
    gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_List + CST_ENDOFLINE + CST_ENDOFLINE +  gs_ANCESTROWEB_cantOpenData, mmtError, [mmbOk], 0);
    Exit;
  end;
  p_SelectTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_List ), ''); // current page sheet
  ls_ASurnameOrName := '';
  p_IncProgressBar; // growing the counter
  while not IBQ_FilesFiltered.EOF do
    p_AddAList;
  p_SelectTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_List ), '', False);  // reiniting for next page
end;
// procedure TF_AncestroWeb.p_genHtmlList
// creating persons' list

function TF_AncestroWeb.fs_AddPhoto( const ai_cleFiche: longint;
const as_FileAltName, as_ImagesDir: string; const ai_ResizeWidth : Integer = 180 ): string;
var li_i : Integer;
begin
  Result := '';

  if not fb_OpenMedias(ai_cleFiche, MEDIAS_TYPE_IMAGE, True, MEDIAS_TABLE_PERSON )
  or DMWeb.IBQ_Medias.FieldByName(MEDIAS_MULTI_MEDIA).IsNull
   then
    Exit;

  Result := fs_getBackupFileName ( as_ImagesDir+ fs_TextToFileName(as_FileAltName+ '-' + IntToStr ( ai_cleFiche )), CST_EXTENSION_JPEG );
  {$IFDEF WINDOWS}
  if ( pos ( ':', Result ) <> 2 )
  {$ELSE}
  if ( pos ( '/', Result ) > 1 )
  {$ENDIF}
   Then
    Result :=  as_ImagesDir + Result;

  if not fb_ImageFieldToFile(DMWeb.IBQ_Medias.FieldByName(MEDIAS_MULTI_MEDIA),
     Result, ai_ResizeWidth)
   then
    Exit;

  Result := fs_Create_Image ( CST_SUBDIR_HTML_IMAGES + CST_HTML_DIR_SEPARATOR + Result, as_FileAltName);
end;

// procedure TF_AncestroWeb.p_genHtmlFiles
// HTML persons'?Files generation
procedure TF_AncestroWeb.p_genHtmlFiles(const IBQ_FilesFiltered: TIBQuery);
var
  lstl_HTMLPersons: TStringlistUTF8;
  ls_ASurname, ls_destination: string;
  ls_ImagesDir, ls_ArchivesDir: string;
  li_CounterPages : Longint;
  lstl_listWords, lstl_listSeparat : TUArray;

  // Marriages with source
  function fs_CreateMarried ( const ab_showdate : Boolean; const as_Date, as_dateWriten : String ; const ai_ClefUnion : Longint ): String;
  var ls_FileName, ls_FileNameBegin : String ;
      li_i : Integer ;
  Begin
    if not ( ab_showdate ) Then
      Begin
        Result := '';
        Exit;
      end;
    // getting source
    with DMWeb,IBQ_ConjointSources do
     Begin
      try
        Close;
        ParamByName ( I_CLEF_UNION  ).AsInteger:=ai_ClefUnion;
        Open;
      except
        On E: Exception do
         Begin
          MyShowMessage( gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Union + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
          Exit;
         end;
      end;
      Result := ' (' ;
      AppendStr ( Result, gs_ANCESTROWEB_Family_On + as_dateWriten );
      if ch_Images.Checked
      and not EOF Then
        Begin
           // adding source
          if IBS_Conjoint.FieldByName(IBQ_SEXE).AsInteger = IBQ_SEXE_WOMAN
          Then ls_FileNameBegin := fs_getNameAndSurName (IBQ_FilesFiltered )+'&'+fs_getNameAndSurName (IBS_Conjoint)
          Else ls_FileNameBegin := fs_getNameAndSurName (IBS_Conjoint)+'&'+fs_getNameAndSurName (IBQ_FilesFiltered);
          ls_FileNameBegin := as_Date + '_ID'+fs_TextToFileName(IBS_Conjoint.FieldByName(IBQ_CLE_FICHE).AsString + '_' + ls_FileNameBegin+'_'+
                              IBS_Conjoint.FieldByName(UNION_CP).AsString+'_'+IBS_Conjoint.FieldByName(UNION_CITY).AsString )+ '_';
          li_i := 1 ;

          // medias
          while not EOF do
            Begin
              ls_FileName := ls_FileNameBegin + IntToStr(li_i);
              if fb_getMediaFile ( IBQ_ConjointSources, dm.FileCopy, gs_RootPathForExport + CST_SUBDIR_HTML_ARCHIVE + DirectorySeparator,fFolderBasePath, ls_FileName, ch_nooriginalphoto.Checked ) Then
                Begin
                  AppendStr( Result, ' - ' +fs_Create_Link ( CST_HTML_OUTDIR_SEPARATOR + CST_SUBDIR_HTML_ARCHIVE + CST_HTML_DIR_SEPARATOR + ls_FileName +CST_EXTENSION_JPEG,
                                                             gs_ANCESTROWEB_ArchiveLinkBegin + IntToStr(li_i), CST_HTML_TARGET_BLANK, CST_HTML_SHADOWBOX ));
                  inc ( li_i );
                End;

              Next;
            End
        end;
     end;
    AppendStr( Result, ')' );
  end;

  // add an event date with city
  function fs_addDateAndCity ( const IBQ_FicheInfos : TIBSQL ; const as_date,as_year, as_City, as_manon, as_womanon : String ):String ;
  begin

    // is there an info
    with IBQ_FicheInfos do
    if not FieldByName(as_date).IsNull and fb_ShowYear(FieldByName(as_year).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger) Then
      Begin
        if FieldByName(IBQ_SEXE).AsInteger = IBQ_SEXE_WOMAN
         Then Result := as_womanon
         Else Result := as_manon   ;
        AppendStr ( Result, FieldByName(as_date).AsString ) ;
        if FieldByName(as_City).AsString > '' Then
          AppendStr ( Result, ( gs_AnceSTROWEB_At ) + fs_getLinkedCity(FieldByName(as_City).AsString));
        AppendStr ( Result, CST_HTML_BR );
        End
       Else Result := '';
  end;

  // person's infos
  procedure p_AddJobs ( const astl_HTMLAFolder : TStringlistUTF8 ; const ai_CleFiche, ai_NoInPage : LongInt  );
  var ls_Line : String ;
  Begin
    with DMWeb.IBS_JobsInd do
     Begin
      try
        Close;
        ParamByName ( IBQ_CLE_FICHE ).AsInteger:=ai_CleFiche;
        ExecQuery;
      except
        On E: Exception do
         Begin
          MyShowMessage( gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Job + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
          Exit;
         end;
      end;
      if not Eof Then  // Job(s) ?
        Begin
          // title
         astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_H3    , CST_FILE_JOBS
                                                            + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL));
         if RecordCount = 1  // 1 or more jobs ?
          Then astl_HTMLAFolder.Add (( gs_ANCESTROWEB_Job   ))
          else astl_HTMLAFolder.Add (( gs_ANCESTROWEB_Jobs  ));
         astl_HTMLAFolder.Add ( CST_HTML_H3_END );  // title end
         astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_UL, CST_FILE_JOBS
                                                            + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL));
         while not EOF do  // adding all jobs
          Begin
           astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_LI, CST_FILE_JOB + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL)
                                + fs_getLinkedJob( FieldByName(IBQ_EV_IND_DESCRIPTION).AsString, ai_CleFiche ));
           if FieldByName(IBQ_EV_IND_VILLE).AsString > '' Then
           astl_HTMLAFolder.Add ( ' ' + gs_ANCESTROWEB_At + ' '
                                + fs_getLinkedCity(FieldByName(IBQ_EV_IND_VILLE).AsString));
           if ( FieldByName(IBQ_EV_IND_PAYS).AsString > '' )
           or (( FieldByName(IBQ_EV_IND_DATE).AsString > '' ) and fb_Showdate(FieldByName(IBQ_EV_IND_DATE).AsDateTime,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger))
             Then
              Begin
               ls_Line := '(' ;
               if FieldByName(IBQ_EV_IND_PAYS).AsString > '' Then
                AppendStr ( ls_line, FieldByName(IBQ_EV_IND_PAYS).AsString );
               if  ( FieldByName(IBQ_EV_IND_PAYS).AsString > '' )
               and (( FieldByName(IBQ_EV_IND_DATE).AsString > '' ) and fb_Showdate(FieldByName(IBQ_EV_IND_DATE).AsDateTime,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)) Then
                 AppendStr ( ls_line,  ' - ' );
               if not FieldByName(IBQ_EV_IND_DATE).IsNull and fb_Showdate(FieldByName(IBQ_EV_IND_DATE).AsDateTime,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger) Then
                AppendStr ( ls_line, FormatDateTime(gs_ANCESTROWEB_LittleDateFormat,FieldByName(IBQ_EV_IND_DATE).AsDateTime));
               astl_HTMLAFolder.Add ( ls_line + ')' );
              end;
           astl_HTMLAFolder.Add ( CST_HTML_LI_END);
           Next;
          end;

         astl_HTMLAFolder.Add ( CST_HTML_UL_END );  // list end
        end;
     end;
  End;
  procedure p_AddInfos ( const astl_HTMLAFolder : TStringlistUTF8 ; const ai_CleFiche, ai_NoInPage : LongInt  );
  var ls_NameSurname : String ;
  Begin
   with DMWeb,IBS_Conjoint do
    try
      // Married ?
      Close;
      ParamByName ( I_CLEF    ).AsInteger:=ai_CleFiche;
      ExecQuery;
      // getting file
      IBS_Fiche.Close;
      IBS_Fiche.ParamByName(I_CLEF).AsInteger := ai_CleFiche;
      IBS_Fiche.ExecQuery;
      // birthday
      astl_HTMLAFolder.Add ( fs_addDateAndCity ( IBS_Fiche, IBQ_DATE_NAISSANCE, IBQ_ANNEE_NAISSANCE, IBQ_LIEU_NAISSANCE, ( gs_ANCESTROWEB_ManBornOn ), ( gs_ANCESTROWEB_WomanBornOn )));
      // deathday
      astl_HTMLAFolder.Add ( fs_addDateAndCity ( IBS_Fiche, IBQ_DATE_DECES, IBQ_ANNEE_DECES, IBQ_LIEU_DECES, ( gs_ANCESTROWEB_ManDiedOn ), ( gs_ANCESTROWEB_WomanDiedOn )) + CST_HTML_BR);
      // Jobs ?
      p_AddJobs ( astl_HTMLAFolder, ai_CleFiche, ai_NoInPage );
      if not Eof Then  // Husband
        Begin
          // title
         astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_H3    , CST_FILE_UNION + 's'
                                                            + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL));
         if DMWeb.IBS_Conjoint.RecordCount = 1  // 1 or more husbands and ex ?
          Then astl_HTMLAFolder.Add (( gs_AnceSTROWEB_Union   ))
          else astl_HTMLAFolder.Add (( gs_AnceSTROWEB_Unions  ));
         astl_HTMLAFolder.Add ( CST_HTML_H3_END );  // title end
         astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_UL, CST_FILE_UNION + 's'
                                                            + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL));
         while not EOF do  // adding all husbands
          Begin
           ls_NameSurname := fs_getNameAndSurName ( IBS_Conjoint );
           astl_HTMLAFolder.Add ( fs_CreateElementWithId ( CST_HTML_LI, CST_FILE_UNION + CST_FILE_Number + IntToStr( ai_NoInPage ),CST_HTML_CLASS_EQUAL));
           if not ch_Filtered.Checked
           or fb_IsCreatedPerson(FieldByName(IBQ_CLE_FICHE).AsInt64)
            Then astl_HTMLAFolder.Add ( fs_GetNameLink ( fs_RemplaceChar(ls_NameSurname,' ', '_'), FieldByName(IBQ_CLE_FICHE).AsString, ls_NameSurname))
            Else astl_HTMLAFolder.Add ( ls_NameSurname );
           astl_HTMLAFolder.Add ( fs_CreateMarried ( not FieldByName(UNION_DATE_MARIAGE).IsNull ,
                                                     fs_RemplaceChar ( FieldByName(UNION_DATE_MARIAGE).AsString, '/', '-' ) ,
                                                     FieldByName(UNION_MARIAGE_WRITEN).AsString ,
                                                     FieldByName(UNION_CLEF).AsInteger));
           astl_HTMLAFolder.Add ( CST_HTML_LI_END);
           Next;
          end;

         astl_HTMLAFolder.Add ( CST_HTML_UL_END );  // list end
        end;
    except
      On E: Exception do
       Begin
        MyShowMessage( gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Jobs + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
        Exit;
       end;
    end;
  end;
  // ancestry and descent trees
  procedure p_AddTrees ( const astl_HTMLAFolder : TStringlistUTF8 ; const ai_CleFiche, ai_NoInPage : LongInt ; const ab_show : Boolean );
  var
    lstl_Tree: TStringlistUTF8;
    li_generations: longint;
    lb_AddAncestry : Boolean ;
  begin
   // adding a line and cell in the table
    astl_HTMLAFolder.Add(CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN );
    lstl_Tree := TStringlistUTF8.Create;
    if fb_OpenTree(DMWeb.IBQ_TreeAsc, ai_CleFiche, 3)
     Then lb_AddAncestry := not DMWeb.IBQ_TreeAsc.EOF
     Else lb_AddAncestry := False;
     // descent
    if ab_show
    and fb_OpenTree(DMWeb.IBQ_TreeDesc, ai_CleFiche, 3)
    and ( not DMWeb.IBQ_TreeDesc.EOF ) then
    begin
      li_generations :=
        fi_CreateHTMLTree(DMWeb.IBQ_TreeDesc, lstl_Tree, ai_CleFiche,
        False, False, False, True, IBQ_TQ_NUM_SOSA, False);
      lstl_Tree.Insert(0, fs_Create_DIV('descent' + CST_FILE_Number + IntToStr(ai_NoInPage), CST_HTML_CLASS_EQUAL) + fs_GetTitleTree (( gs_AnceSTROWEB_Descent ), li_generations ));
      astl_HTMLAFolder.AddStrings(lstl_Tree);
      astl_HTMLAFolder.Add(CST_HTML_DIV_End);
      if lb_AddAncestry then
        astl_HTMLAFolder.Add(CST_HTML_BR);
    end;
    // ancestry
    if lb_AddAncestry then
    begin
      lstl_Tree.Clear;
      li_generations :=
        fi_CreateHTMLTree(DMWeb.IBQ_TreeAsc, lstl_Tree, ai_CleFiche, False, False, False);
      lstl_Tree.Insert(0, fs_Create_DIV('ancestry' + CST_FILE_Number + IntToStr(ai_NoInPage),CST_HTML_CLASS_EQUAL) + fs_GetTitleTree (( gs_AnceSTROWEB_Ancestry ), li_generations ));
      astl_HTMLAFolder.AddStrings(lstl_Tree);
      astl_HTMLAFolder.Add(CST_HTML_DIV_End);
    end;
    // line end
    astl_HTMLAFolder.Add(CST_HTML_TD_END + CST_HTML_TR_END);
    lstl_Tree.Free;
  end;

  // procedure p_AddAFolder
  // adding persons' folder page
  procedure p_AddAFolder;
  var
    lstl_HTMLAFolder: TStringlistUTF8;
    ls_NewSurname, ls_ASurnameBegin, ls_ASurnameSurname, ls_ASurnameEnd: string;
    li_CleFiche: longint;
    lb_next, lb_show : Boolean ;
    procedure p_ScrollAPage;
    var li_i : integer;
    Begin
      with IBQ_FilesFiltered do
      for li_i := 1 to gi_FilesPerPage do
      begin
        p_IncProgressInd; // growing the second counter
        li_CleFiche := FieldByName(IBQ_CLE_FICHE).AsInteger;
        ls_ASurnameSurname := fs_RemplaceEspace ( fs_getNameAndSurName(IBQ_FilesFiltered) + '_' + IntToStr(li_CleFiche), '_' );
        // adding html head's meta-keywords
        p_addKeyWord(FieldByName(IBQ_NOM).AsString, '-'); // adding a head's meta keyword
        lb_show := fb_ShowYear( FieldByName(IBQ_ANNEE_NAISSANCE).asinteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger );
        if lb_show then
          p_addKeyWord(FieldByName(IBQ_PRENOM).AsString); // adding a head's meta keyword
        ls_NewSurname := FieldByName(IBQ_NOM).AsString;
        if (ls_NewSurname <> ls_ASurname) Then
         Begin
          if (ls_ASurname = '') or ((length(ls_NewSurname) > 0) and
            (ls_NewSurname[1] <> ls_ASurname[1])) then
            lstl_HTMLAFolder.Add(fs_create_anchor ( ls_NewSurname[1] ))
          else if (ls_ASurname = '') then
            lstl_HTMLAFolder.Add(CST_HTML_A_BEGIN + CST_HTML_NAME_EQUAL + '"A" />');
          if length ( ls_NewSurname ) > 1 Then
            lstl_HTMLAFolder.Add(fs_create_anchor ( ls_NewSurname ));
         end;
        ls_ASurname := ls_NewSurname;
        case FieldByName(IBQ_SEXE).AsInteger of
         IBQ_SEXE_MAN   : ls_NewSurname := CST_FILE_MAN;
         IBQ_SEXE_WOMAN : ls_NewSurname := CST_FILE_WOMAN;
         else
           ls_NewSurname := 'file';
        end;
        lstl_HTMLAFolder.Add(fs_create_anchor ( ls_ASurnameSurname ));
        lstl_HTMLAFolder.Add(CST_HTML_BR + fs_CreateElementWithId ( CST_HTML_TABLE , ls_NewSurname + CST_FILE_Number + IntToStr(li_i) , CST_HTML_CLASS_EQUAL ) +
          CST_HTML_TR_BEGIN + fs_Create_TD ( ls_NewSurname + CST_FILE_Number + IntToStr(li_i), CST_HTML_CLASS_EQUAL, 2 ));
        lstl_HTMLAFolder.Add( CST_HTML_DIV_BEGIN + '<' + CST_HTML_H2 + CST_HTML_ID_EQUAL +'"subtitle">' + CST_HTML_IMAGE_SRC + '../'
                             + CST_SUBDIR_HTML_IMAGES + '/' + ls_NewSurname + CST_EXTENSION_GIF + '" />' + fs_getLinkedSurName ( ls_ASurname ) +
          ' ' + fs_getLinkedName ( FieldByName(IBQ_PRENOM).AsString, lstl_listWords,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger ) + fs_AddComma(fs_GetSOSA(IBQ_FilesFiltered)) + CST_HTML_H2_BEGIN + CST_HTML_DIV_END);
        lstl_HTMLAFolder.Add(CST_HTML_TD_END + CST_HTML_TR_END  + CST_HTML_TR_BEGIN  + CST_HTML_TD_BEGIN);
        if lb_show then
         Begin
          p_AddInfos ( lstl_HTMLAFolder, li_CleFiche, li_i );
          lstl_HTMLAFolder.Add(CST_HTML_TD_END);
          lstl_HTMLAFolder.Add( fs_AddImageTable(fs_AddPhoto( li_CleFiche, fs_getaltPhoto(IBQ_FilesFiltered), ls_ImagesDir)));
         end
        Else
          lstl_HTMLAFolder.Add(CST_HTML_TD_END);
        lstl_HTMLAFolder.Add( CST_HTML_TR_END );
        p_AddTrees ( lstl_HTMLAFolder, li_CleFiche, li_i, lb_show );
        lstl_HTMLAFolder.Add( CST_HTML_TABLE_END + CST_HTML_BR);
        ls_ASurnameEnd := FieldByName(IBQ_NOM).AsString;
        Next;
        if EOF then
         Begin
          lb_next:=False;
          Break;
         end ;
        Application.ProcessMessages;
      end;
    end;

  begin
    p_CreateKeyWords;
    lstl_HTMLAFolder := TStringlistUTF8.Create;
    try
      ls_ASurnameBegin := IBQ_FilesFiltered.FieldByName(IBQ_NOM).AsString;
      ls_ASurnameSurname := fs_RemplaceEspace ( fs_getNameAndSurName(IBQ_FilesFiltered), '_' );
      if (ls_ASurnameBegin > '') and ( ls_ASurnameSurname > '' ) then
        p_SelectTabSheet(gt_SheetsLetters,ls_ASurnameSurname[1],ls_ASurnameSurname); // current letter sheet
      lstl_HTMLAFolder.Text := fs_CreateULTabsheets(gt_SheetsLetters, '', CST_HTML_SUBMENU)+CST_HTML_DIV_BEGIN; // Creating the letters' sheets
      if (ls_ASurnameBegin > '') and ( ls_ASurnameSurname > '' ) then
        p_SelectTabSheet(gt_SheetsLetters,ls_ASurnameSurname[1],ls_ASurnameSurname, False);  // reiniting for next page
      lb_next := True;
      lstl_HTMLAFolder.Add( CST_HTML_CENTER_BEGIN );
      lstl_HTMLAFolder.Add(CST_HTML_CENTER_BEGIN + fs_RemplaceMsg(gs_ANCESTROWEB_Page_of,[IntToStr(li_CounterPages+1),IntToStr(gi_PagesCount)])+ CST_HTML_CENTER_END );
      p_ScrollAPage;
      if li_CounterPages > 0 Then
        lstl_HTMLAFolder.Add ( fs_CreatePrevNext ( li_CounterPages - 1, CST_PAGE_PREVIOUS, '../', ed_FileBeginName.Text ));
      if lb_next Then
        lstl_HTMLAFolder.Add ( fs_CreatePrevNext ( li_CounterPages + 1, CST_PAGE_NEXT, '../', ed_FileBeginName.Text ));
      lstl_HTMLAFolder.Add ( CST_HTML_CENTER_END );
      lstl_HTMLAFolder.Add(CST_HTML_DIV_END);
      p_CreateAHtmlFile(lstl_HTMLAFolder, CST_FILE_SUBFILES, me_Description.Lines.Text,
        ( gs_AnceSTROWEB_Files ) + ' - ' + ls_ASurnameBegin +
        ( gs_AnceSTROWEB_At ) + ls_ASurnameEnd, '', '', gs_LinkGedcom, '..' + CST_HTML_DIR_SEPARATOR);

      // saving the page
      ls_destination := gs_RootPathForExport +
        CST_SUBDIR_HTML_FILES + DirectorySeparator + ed_FileBeginName.Text + IntToStr(
        li_CounterPages) + CST_EXTENSION_HTML;
      try
        lstl_HTMLAFolder.SaveToFile(ls_destination);
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Files + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
    finally
      lstl_HTMLAFolder.Free;
      Inc(li_CounterPages);
    end;
  end;

begin
  p_Setcomments ( gs_AnceSTROWEB_Files ); // advert for user
  li_CounterPages := 0;
  pb_ProgressInd.Position := 0; // initing not needed user value
  ls_ImagesDir := gs_RootPathForExport + CST_SUBDIR_HTML_FILES +
    DirectorySeparator + CST_SUBDIR_HTML_IMAGES + DirectorySeparator;
  ls_ArchivesDir := gs_RootPathForExport + CST_SUBDIR_HTML_ARCHIVE +
    DirectorySeparator ;
  fb_CreateDirectoryStructure(ls_ImagesDir);
  fb_CreateDirectoryStructure(ls_ArchivesDir);
  pb_ProgressInd.Max := IBQ_FilesFiltered.RecordCount;
  IBQ_FilesFiltered.First;
  p_SelectTabSheet(gt_TabSheets, ( gs_AnceSTROWEB_Files ), '', False); // current page sheet
  ls_ASurname := '';
  with FileCopy do
    Begin
      FileOptions:=FileOptions+[cpDestinationIsFile];
      while not IBQ_FilesFiltered.EOF do
        p_AddAFolder;
      FileOptions:=FileOptions-[cpDestinationIsFile];
    end;
  lstl_HTMLPersons := TStringlistUTF8.Create;
  lstl_HTMLPersons.Text := fs_CreateULTabsheets(gt_SheetsLetters,
    CST_SUBDIR_HTML_FILES + CST_HTML_DIR_SEPARATOR, CST_HTML_SUBMENU)
    +CST_HTML_DIV_BEGIN+
    CST_HTML_CENTER_BEGIN + '<' + CST_HTML_Paragraph +
    CST_HTML_ID_EQUAL + '"head">' + fs_html_Lines(
    me_FilesHead.Text) + CST_HTML_Paragraph_END;
  lstl_HTMLPersons.Add(CST_HTML_CENTER_END);
  p_CreateKeyWords;
  pb_ProgressInd.Position := 0; // initing not needed user value
  lstl_HTMLPersons.Add(CST_HTML_DIV_END);
  p_CreateAHtmlFile(lstl_HTMLPersons, CST_FILE_FILES, me_FilesHead.Lines.Text,
    ( gs_AnceSTROWEB_Files ), gs_AnceSTROWEB_Files, gs_ANCESTROWEB_Files_Long, gs_LinkGedcom);
  p_IncProgressBar; // growing the counter

  // saving the page
  ls_destination := gs_RootPathForExport +
    ed_FileBeginName.Text + CST_EXTENSION_HTML;
  try
    lstl_HTMLPersons.SaveToFile(ls_destination);
  except
    On E: Exception do
    begin
      MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Files + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
      Abort;
    end;
  end;
  lstl_HTMLPersons.Free;
  p_genHtmlList(IBQ_FilesFiltered);
end;


// function TF_AncestroWeb.fs_getLinkedBase
// Optional link to external site
function TF_AncestroWeb.fs_getLinkedBase ( const as_ShowedText, as_Texte : String; const as_Link : String; const ai_ComboIndex : Integer ; const ab_StopMore : Boolean = False) : String;
var li_pos : Integer;
Begin
 Result:=fs_Create_Link(fs_getLinkedBaseImage ( as_Texte, as_Link, ai_ComboIndex, ab_StopMore ), as_ShowedText, CST_HTML_TARGET_BLANK, CST_HTML_SHADOWBOX );
End;


// function TF_AncestroWeb.fs_getLinkedName
// Optional link to Name site
function TF_AncestroWeb.fs_getLinkedName ( const as_Texte : String ; var aa_listWords : TUArray ; const av_confidential : Integer ) :  String;
var
    li_i : Integer;
    ls_Text : String;
Begin
  if  ( av_confidential > 0 )
  and ( as_Texte > '' ) Then
   Begin
    Result := as_Texte [1] + '.';
    Exit;
   end;
  if not ch_NamesLink.Checked
  or ( Trim ( as_Texte ) = '' ) Then
   Begin
    Result := as_Texte;
    Exit;
   end;
  Result := '';
  Finalize ( aa_listWords );
  fb_stringConstruitListe(as_texte,aa_listWords);
  for li_i := 0 to high ( aa_listWords ) do
   Begin
     ls_Text := Trim ( copy ( as_Texte, aa_listWords [ li_i ][0], aa_listWords [ li_i ][1] ));
     AppendStr ( Result, fs_getLinkedBase ( ls_Text, ls_Text, ed_BaseNames.Text, cb_NamesAccents.ItemIndex ));
//       if pos ( 'Fran', copy ( as_Texte, aa_listWords [ li_i ][0], aa_listWords [ li_i ][1] ) ) > 0 Then
//       MyShowMessage( copy ( as_Texte, aa_listWords [ li_i ][0], aa_listWords [ li_i ][1] ));
     if  ( aa_listWords [ li_i ][2] <> 0 )
      Then AppendStr(Result, '-' )
      Else AppendStr(Result, ' ' );
   end;
End;

// function TF_AncestroWeb.fs_getLinkedSurName
// Optional link to SurName site
function TF_AncestroWeb.fs_getLinkedSurName ( const as_Texte : String ) : String;
var ls_Text : String ;
Begin
  ls_Text := Trim ( as_Texte );
  if not ch_SurNamesLink.Checked
  or ( ls_Text = '' ) Then
   Begin
    Result := ls_Text;
    Exit;
   end;
  Result := fs_getLinkedBase ( ls_Text, ls_Text, ed_BaseSurnames.Text, cb_SurnamesAccents.ItemIndex );
End;

// function TF_AncestroWeb.fs_getLinkedCity
// Optional link to City site
function TF_AncestroWeb.fs_getLinkedCity ( const as_Texte : String ) : String;
var ls_Text : String ;
Begin
  ls_Text := Trim ( as_Texte );
  if not ch_CitiesLink.Checked
  or ( ls_Text = '' ) Then
   Begin
    Result := ls_Text;
    Exit;
   end;
  Result := fs_getLinkedBase ( ls_Text , ls_Text , ed_BaseCities.Text, cb_CityAccents.ItemIndex, True );
End;

// function TF_AncestroWeb.fs_getLinkedJob
// Optional link to job site
function TF_AncestroWeb.fs_getLinkedJob ( const as_Texte : String; const ai_counter : Integer ) : String;
var ls_Text : String ;
Begin
  ls_Text := Trim ( as_Texte );
  Result := '' ;
  if ls_Text = ''
   Then Exit; // rien donc rien en retour

  if ch_JobsImages.Checked // image
   Then Result := fs_getLinkedImage( ls_Text, ed_ImagesJobs.Text,'', cb_ImagesJobsAccents.ItemIndex, ai_counter ) + ' ' ;

  if ch_JobsLink.Checked // lien
   Then Result := fs_getLinkedBase ( Result + ls_Text, ls_Text, ed_BaseJobs.Text, cb_JobsAccents.ItemIndex, True )
   Else Result := as_Texte;

End;


// procedure TF_AncestroWeb.p_CreateAHtmlFile
// Creating a HTML page from parameters
procedure TF_AncestroWeb.p_CreateAHtmlFile(const astl_Destination: TStringlistUTF8;
  const as_BeginingFile,
  as_Describe, as_Title, as_SelectedTitle, as_LongTitle: string;
  as_BottomHTML: string;
  const as_Subdir: string = '';
  const as_ExtFile: string =
  CST_EXTENSION_HTML;
  const as_BeforeHTML: string = ''; const astl_Body : TStringlistUTF8 = nil );
begin
  if not assigned ( gstl_HeadKeyWords ) Then
    Abort;       // can quit while creating
  if as_BottomHTML > '' then
    as_BottomHTML := '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"gedcom">' +
      CST_HTML_AHREF + as_Subdir + as_BottomHTML + '">' + ( gs_AnceSTROWEB_DownloadGedcom ) +
      CST_HTML_A_END + CST_HTML_Paragraph_END;
  as_BottomHTML := '<' + CST_HTML_DIV + CST_HTML_ID_EQUAL + '"bottomDIV">' +
    '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"bottom">' +
    me_Bottom.Lines.Text + CST_HTML_Paragraph_END +
    as_BottomHTML + '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"bottom">' +
    ( gs_AnceSTROWEB_CreatedBy ) + ' ' + CST_HTML_STRONG_BEGIN +
    CST_AncestroWeb_WithLicense + ' - ' + CST_HTML_AHREF +
    'http://www.liberlog.fr">' + CST_AUTHOR +
    CST_HTML_A_END + CST_HTML_STRONG_END + CST_HTML_Paragraph_END + CST_HTML_DIV_End;
  if as_SelectedTitle > '' then
    p_SelectTabSheet(gt_TabSheets, as_SelectedTitle); // current page sheet
  p_CreateHTMLFile(gt_TabSheets, astl_Destination, as_BottomHTML,
    as_Describe, gstl_HeadKeyWords.Text, gs_HTMLTitle + ' - ' +
    as_Title, as_LongTitle, as_BeginingFile + '1' + as_ExtFile, as_BeginingFile + '2' +
    as_ExtFile, as_BeginingFile + '3' + as_ExtFile, as_BeginingFile +
    '4' + as_ExtFile, as_Subdir, as_BeforeHTML, gs_ANCESTROWEB_Language, astl_Body );
  if as_SelectedTitle > '' then
    p_SelectTabSheet(gt_TabSheets, as_SelectedTitle, '', False);  // reiniting for next page
end;

// procedure TF_AncestroWeb.DoInit
// creating database objects and initing
function TF_AncestroWeb.DoInit(const sBase: string):Boolean;
var
  Save_Cursor: TCursor;
begin
  Result := False;
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourGlass; { Affiche le curseur en forme de sablier }
  try
    if not Assigned(DMWeb) then
    begin
      DMWeb := TDMWeb.Create(self);
    end;
    ds_Individu.DataSet:=DMWeb.IBQ_Individu;
    Result:=True;
    Result:=DoOpenBase(sBase);
    if Result then
      Result:=DMWeb.OuvreDossier(DMWeb.CleDossier,PremiereOuverture,fCleFiche,fNomIndi,fPrenomIndi);
    if Result then
      DoAfterInit;
  finally
    Screen.Cursor := Save_Cursor; { Revient toujours ? normal }
  end;
end;

function TF_AncestroWeb.DoInitBase(const AedNomBase: TCustomComboBox): Boolean;
var li_i : Integer;
    ls_bddpath : String ;
begin
  Result := False;
  if fb_AutoComboInit(AedNomBase)
  and (   (DMWeb=nil)
       or ((aedNomBase.ItemIndex > 0 ) and (aedNomBase.ItemIndex < aedNomBase.items.Count ) and (aedNomBase.Items [ aedNomBase.ItemIndex ]<>DMWeb.ibd_BASE.DatabaseName))
       or (DMWeb.ibd_BASE.Connected=false)) Then
   try
    ls_bddpath := aedNomBase.Items [ aedNomBase.ItemIndex ];
    if FileExistsUTF8(ls_bddpath)
     Then Result := DoInit(ls_bddpath)
     Else for li_i := 0 to AedNomBase.Items.Count - 1 do
      if AedNomBase.Items [ li_i ] = ls_bddpath Then
       AedNomBase.Items.Delete(li_i);
   except
   end;
end;

// function TF_AncestroWeb.DoOpenBase
// database opening
function TF_AncestroWeb.DoOpenBase(sBase: string):boolean;
var //ouvre la base, liste les dossiers et s?lectionne le premier ou celui de la table dll ? la premi?re ouverture
  s:string;
begin
  Result:=DMWeb.doOpenDatabase(sBase);
  if Result then
  begin
    ListerDossiers;
    if PremiereOuverture then
    begin
      Result:=DMWeb.LitDllDossier;
      if Result then
      begin
        s:=IntToStr(DMWeb.CleDossier);
        if Length(s)<2 then
          s:=s+' ';
        cbDossier.Text:=s+', '+fNom_Dossier;
      end;
    end;
  end;
end;

// procedure TF_AncestroWeb.DoAfterInit
// initing components and ini
procedure TF_AncestroWeb.DoAfterInit( const ab_Ini : Boolean = True );
begin
  fNom_Dossier:=fs_TextToFileName(fNom_Dossier);
  {$IFNDEF FPC}
  de_ExportWeb.InitialDir:=GetWindir(CSIDL_DESKTOPDIRECTORY);
  {$ENDIF}
  with dm.FileCopy do
   Begin
    Destination := fSoftUserPath+ fNom_Dossier + DirectorySeparator + CST_SUBDIR_EXPORT ;
    fb_CreateDirectoryStructure( Destination );
   end;
  fb_CreateDirectoryStructure( fSoftUserPath+ fNom_Dossier + DirectorySeparator + CST_SUBDIR_SAVE );
  de_ExportWeb.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF}:= fSoftUserPath+ fNom_Dossier+DirectorySeparator+CST_SUBDIR_EXPORT;
  fne_import.FileName := fSoftUserPath+ fNom_Dossier + DirectorySeparator + CST_SUBDIR_SAVE ;
  fne_Export.FileName := fSoftUserPath+ fNom_Dossier + DirectorySeparator + CST_SUBDIR_SAVE ;

  // Reading ini
  if not ab_Ini Then
    Exit;
  f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
  if FormActivated Then
    OnFormInfoIni.p_ExecuteLecture(Self);
end;


procedure TF_AncestroWeb.OnFormInfoIniIniLoad(const AInifile: TCustomInifile;
  var Continue: Boolean);
begin
  {$IFDEF WINDOWS}
  if gb_logie Then
  {$ENDIF}
  p_ReadComboBoxItems(cb_Base,cb_Base.Items);
  p_iniReadKey;
  {$IFNDEF WINDOWS}
  if fbddpath <> f_IniReadSectionStr(CST_INI_PATH,CST_INI_PATH_BDD, fbddpath) Then
    Begin
      fbddpath := f_IniReadSectionStr(CST_INI_PATH,CST_INI_PATH_BDD, fbddpath); // on linux
      fb_AddToCombo(cb_Base,fbddpath);
      DoInitBase(cb_Base);
    end;
  {$ENDIF}
  if Assigned(FOptions)
   Then
    FOptions.OnFormInfoIni.p_ExecuteLecture(FOptions);
end;

procedure TF_AncestroWeb.OnFormInfoIniIniWrite(const AInifile: TCustomInifile;
  var Continue: Boolean);
begin
  p_writeComboBoxItems(cb_Base,cb_Base.Items);
  p_iniWriteKey;
  p_IniWriteSectionStr(CST_INI_PATH,CST_INI_PATH_BDD,fbddpath);
  AInifile.WriteInteger(Self.Name,cb_CityAccents    .Name,cb_CityAccents    .ItemIndex);
  AInifile.WriteInteger(Self.Name,cb_JobsAccents    .Name,cb_JobsAccents    .ItemIndex);
  AInifile.WriteInteger(Self.Name,cb_NamesAccents   .Name,cb_NamesAccents   .ItemIndex);
  AInifile.WriteInteger(Self.Name,cb_SurnamesAccents.Name,cb_SurnamesAccents.ItemIndex);
end;


// procedure TF_AncestroWeb.FormCreate
// initializing software and form
procedure TF_AncestroWeb.Loaded;
var ls_Path : String ;
begin
  fb_iniWriteFile(FIniFile);
  FreeAndNil(FIniFile);
  gstl_Labels:=nil;
  OnFormInfoIni.PlaceForm;
  ImageEdit1.Filter:=rs_Filter_images_web;
  ImageEdit2.Filter:=rs_Filter_images_web;
  ImageEdit3.Filter:=rs_Filter_images_web;
  f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
  fSoftUserPath := GetUserDir;
  fSoftUserPath:=fSoftUserPath+CST_AncestroWeb+DirectorySeparator;
  gs_Root:=ExtractFilePath(Application.ExeName);
  gs_Root:=gs_Root+CST_AncestroWeb+DirectorySeparator;//pas dans plugins pour l'exe
{  {$IFDEF FPC}//? faire une version Delphi
  if InstanceRunning(CST_AncestroWeb) then
  begin
    MyShowMessage('Vous ne devez ex?cuter qu''une seule session d''AncestroWeb');
    {$ifdef unix}
    FpKill(FpGetpid, 9);
    {$endif}
    {$ifdef windows}
    TerminateProcess(GetCurrentProcess, 0);
    {$endif}
  end;
{$ENDIF}}
  PremiereOuverture:=True;
  ls_Path:=fSoftUserPath + CST_SUBDIR_THEMES;
  L_Thema    .Hint:=fs_RemplaceMsg(rs_Caption_Create_your_thema_in,[ls_Path]);
  cb_Themes  .Hint:=fs_RemplaceMsg(rs_Caption_Create_your_thema_in,[ls_Path]);
  fbddpath := f_IniReadSectionStr(CST_INI_PATH,CST_INI_PATH_BDD, ''); // on linux

  try
    cb_Themes.Items.Clear;
    fb_FindFiles(cb_Themes.Items, gs_Root + CST_SUBDIR_THEMES, False);
    if not DirectoryExistsUTF8(ls_Path)
     Then
      fb_CreateDirectoryStructure(ls_Path);
    fb_FindFiles(cb_Themes.Items, ls_Path, False);

  except

  end;
  try
    cb_Files.Items.Clear;
    fb_FindFiles(cb_Files.Items, gs_Root + CST_SUBDIR_SOURCES, False);
  except

  end;

  // ici mettre la taille initiale car avec les skins, les fenetres se resize
  Width := 640;
  Height := 400;
  PCPrincipal.ActivePage:=ts_Gen;
  Caption := fs_getCorrectString(CST_AncestroWeb_WithLicense+' : '+gs_AnceSTROWEB_FORM_CAPTION);
  if fbddpath > '' Then
    Begin
      fb_AddToCombo(cb_Base,fbddpath);
      DoInitBase(cb_Base);
      fb_AddToCombo(cb_Base,fbddpath, False);
    end;
   inherited;
end;

procedure TF_AncestroWeb.JvXPButton1Click(Sender: TObject);
begin
  {$IFDEF VERSIONS}
  fb_AfficheApropos ( True, CST_AncestroWeb, '' );
  {$ENDIF}
end;

procedure TF_AncestroWeb.se_NomSet(Sender: TObject);
begin
  p_iniWriteKey;
end;

// procedure TF_AncestroWeb.TraduceImageFailure
// Failure on picture's convert
procedure TF_AncestroWeb.TraduceImageFailure(Sender: TObject;
  const ErrorCode: integer; var ErrorMessage: string; var ContinueCopy: boolean);
begin
  MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantCreateImage ) + ErrorMessage);
end;

//  Procedure TF_AncestroWeb.ListerDossiers
// Database Folder list
procedure TF_AncestroWeb.ListerDossiers;
var
  s:string;
begin
  with DMWeb.IBQ_Dossier do
  begin
    try
      Open;
      First;
      cbDossier.Items.Clear;
      while not EOF do
      begin
        s:=Fields[0].AsString;
        if Length(s)<2 then
          s:=s+' ';
        cbDossier.Items.Add(s+', '+fs_getCorrectString(Fields[1].AsString));
        if cbDossier.Items.Count=1 then
        begin
          DMWeb.CleDossier:=Fields[0].AsInteger;
          with cbDossier do
            Caption:=Items[0];
        end;
        Next;
      end;
      Close;
    except
      On E: Exception do
        MyShowMessage( fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
    end;
  end;
end;

constructor TF_AncestroWeb.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOptions:=nil;
end;


procedure TF_AncestroWeb.InitIndex(const ACombo : TCaptionCombo );
var li_i : Integer;
    SelectText : String;
begin
  with Acombo do
   Begin
     SelectText:=RealGetText;
     for li_i := 0 to Items.Count - 1 do
      if SelectText = Items [ li_i ] Then
       Begin
        AnIndex := li_i;
        Exit;
       end;
   end;
  if SelectText <> '' Then
   AnIndex := -1;
end;

procedure TF_AncestroWeb.AddText(const ACombo : TCaptionCombo );
var
  LinkDomain:string;
  li_i : Integer;
begin
  with ACombo do
   Begin
    if  ( Text = '' ) Then
     Begin
      if  ( AnIndex > -1 )
      and ( AnIndex < Items.Count ) Then
       Begin
        Items.Delete(AnIndex);
       end;
      Exit;
     end;
    LinkDomain := fs_link_www ( fs_link_http ( Text, False, False ), False, False );
    for li_i := 0 to Items.Count - 1 do
     if pos ( LinkDomain , Items [ li_i ] ) > 0 Then
      Begin
       ACombo.Items [li_i]:=Text;
       Exit;
      end;
    ACombo.Items.Add(Text);
   end;
end;


{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_AncestroWeb );
{$ENDIF}
end.

