unit u_ancestroweboptions;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2011 to 2016 (LAZARUS),             }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{$IFDEF FPC}
{$R *.lfm}
{$mode Delphi}
{$ELSE}
{$R *.lfm}
{$ENDIF}

////////////////////////////////////////////////////////////////////////////////
// AncestroWeb
// Free web plugin to create a genealogy web site in HTML or PHP
// Plugin libre de création d'un site web généalogique statique en HTML et PHP
// Pour Freelogy et Ancestromania
// Licence : GPL
// LIBERLOG 2011
// Auteur : Matthieu GIROUX
// Descriptions
// Création d'un arbre complet, d'une page de contact en PHP, de fiches, etc.
// Historique
// 1.1.4.1 : Gestion de versions
// 1.1.4.0 : Plus de TIBSQL, copie de l'archive originale fonctionnel, moins de bugs
// 1.1.3.1 : Professions dans la fiche de l'individu, Possibilité de descendre son arbre familial
// 1.1.1.2 : Plus de tests
// 1.1.1.1 : Métiers et âges
// 1.0.0.0 : Intégration dans Freelogy
// 0.9.9.0 : première version publiée
////////////////////////////////////////////////////////////////////////////////

interface

uses
{$ifdef unix}
{$endif}

{$IFNDEF FPC}
  Mask,  rxToolEdit, JvExControls,  Windows,
{$ELSE}
  EditBtn,LazFileUtils,
{$ENDIF}
  fonctions_string,
{$ifdef windows}
  Windows,
{$endif}
{$IFDEF WIN32}
  Registry,
{$ENDIF}
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  U_DMWeb, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, DB,
  IBQuery, ExtCtrls, ComCtrls, DBGrids,
  lazutf8classes, u_extdbnavigator,
  functions_html, ExtJvXPCheckCtrls, Spin, U_OnFormInfoIni,
  u_buttons_appli, IBSQL, U_ExtFileCopy,
  JvXPButtons, u_buttons_defs, IniFiles,
  u_common_ancestro,
  u_extsearchedit,
  U_FormAdapt, u_scrollclones, U_ExtImages, u_extresbutton;

{$IFDEF VERSIONS}
const
  gVer_AncestroWebOptions : T_Version = ( Component : 'Application Ancestroweb' ;
                                   FileUnit : 'U_AncestroWeb' ;
                                   Owner : 'Matthieu Giroux' ;
                                   Comment : 'Composant de copie multi-platformes.' ;
                                   BugsStory : '1.0.0.0 : Integrating in Ancestromania' +#13#10
                                             + '0.9.9.0 :?First published version' ;
                                   UnitType : CST_TYPE_UNITE_APPLI ;
                                   Major : 1 ; Minor : 0 ; Release : 0 ; Build : 0 );

{$ENDIF}

type

  { TCaptionCombo }

  TCaptionCombo = class ( TComboBox )
  public
    function RealGetText: TCaption;override;
  end;

  { TF_AncestroWebOptions }

  TF_AncestroWebOptions = class(TF_FormAdapt)
    cb_LinkPanel: TComboBox;
    cb_treeWithoutJavascript: TJvXPCheckbox;
    cb_ContactSecurity: TComboBox;
    cb_ContactTool: TComboBox;
    EditLink: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label4: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label5: TLabel;
    Label50: TLabel;
    Label51:TLabel;
    ch_ContactIdentify: TJvXPCheckbox;
    ch_genages: TJvXPCheckbox;
    ch_genContact: TJvXPCheckbox;
    ch_genjobs: TJvXPCheckbox;
    ch_genlinks: TJvXPCheckbox;
    ch_genMap: TJvXPCheckbox;
    ch_genpostalc: TJvXPCheckbox;
    ch_genSearch: TJvXPCheckbox;
    ch_genSurnames: TJvXPCheckbox;
    ch_genTree: TJvXPCheckbox;
    ch_Comptage: TJvXPCheckBox;
    ch_postalincludesubdirs: TJvXPCheckbox;
    ch_SmartTree: TJvXPCheckbox;
    ch_SplittedMap: TJvXPCheckbox;
    ch_SplittedTree: TJvXPCheckbox;
    de_Images: TDirectoryEdit;
    ds_Individu: TDatasource;
    ed_AgesName: TEdit;
    ed_BaseCities: TCaptionCombo;
    ed_BaseJobs: TCaptionCombo;
    ed_BaseNames: TCaptionCombo;
    ed_BaseSurnames: TCaptionCombo;
    ed_ContactAuthor: TEdit;
    ed_ContactHost: TEdit;
    ed_ContactMail: TEdit;
    ed_ContactMot: TEdit;
    ed_ContactMotTrouve: TEdit;
    ed_ContactName: TEdit;
    ed_ContactPassword: TEdit;
    ed_ContactPassword2: TEdit;
    ed_ContactUser: TEdit;
    ed_JobsName: TEdit;
    ed_LinkName: TEdit;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lb_DescribeMap: TLabel;
    me_HeadLinks: TMemo;
    Panel1: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel2: TPanel;
    Panel43: TPanel;
    Panel44: TPanel;
    Panel60: TPanel;
    Panel61: TPanel;
    Panel62: TPanel;
    Panel63: TPanel;
    Panel64: TPanel;
    Panel65: TPanel;
    Panel66: TPanel;
    Panel67: TPanel;
    Panel68: TPanel;
    Panel69: TPanel;
    Panel70: TPanel;
    Panel71: TPanel;
    Panel72: TPanel;
    Panel73: TPanel;
    Panel74: TPanel;
    Panel75: TPanel;
    Panel76: TPanel;
    Panel77: TPanel;
    Panel78: TPanel;
    Panel79: TPanel;
    Panel80: TPanel;
    Panel81: TPanel;
    Panel82: TPanel;
    Panel83: TPanel;
    Panel84: TPanel;
    Panel85: TPanel;
    Panel86: TPanel;
    Panel87: TPanel;
    Panel88: TPanel;
    Panel89: TPanel;
    Panel9: TPanel;
    Panel90: TPanel;
    Panel91: TPanel;
    Panel92: TPanel;
    Panel93: TPanel;
    Panel94: TPanel;
    Panel95: TPanel;
    se_LinksCount: TSpinEdit;
    ed_MapFileName: TEdit;
    ed_PostalName: TEdit;
    ed_SearchName: TEdit;
    ed_SearchQuery: TEdit;
    ed_SearchSite: TEdit;
    ed_SearchTool: TEdit;
    ed_SurnamesFileName: TEdit;
    ed_TreeName: TEdit;
    ClonedP_Links: TExtClonedPanel;
    lb_MovePrev: TExtResButton;
    ExtResButton2: TExtResButton;
    FWEraseGedcom: TFWErase;
    FWPreview1: TFWPreview;
    FW_showdirectory: TFWRefresh;
    GedcomEdit: TFileNameEdit;
    i_postalcards: TExtImages;
    FileCopy: TExtFileCopy;
    FWEraseImage: TFWErase;
    FWEraseImage2: TFWErase;
    FWEraseImage3: TFWErase;
    FWClose1: TFWClose;
    FWXPButton2: TFWXPButton;
    IBQ_Individu: TIBQuery;
    lb_postalinimages: TMemo;
    Memo_LinkText: TMemo;
    me_ContactHead: TMemo;
    me_MapHead: TMemo;
    me_HeadAges: TMemo;
    me_HeadJobs: TMemo;
    me_HeadTree: TMemo;
    me_surnamesHead: TMemo;
    me_searchHead: TMemo;
    OnFormInfoIni: TOnFormInfoIni;
    PanelLinksCloned: TPanel;
    pg_web: TPageControl;
    pc_needed: TPageControl;
    PCPrincipal: TPageControl;
    pa_About: TScrollbox;
    SelectDirectoryDialog: TSelectDirectoryDialog;
    se_ContactPort: TSpinEdit;
    se_imageHeight: TSpinEdit;
    se_imagespercol: TSpinEdit;
    se_imagesperline: TSpinEdit;
    se_imageWidth: TSpinEdit;
    se_Nom: TExtSearchEdit;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    spSkinPanel1: TPanel;
    sp_gentree: TSpinEdit;
    sp_groupMap: TSpinEdit;
    ts_links: TTabSheet;
    ts_cards: TTabSheet;
    ts_global: TTabSheet;
    ts_ages: TTabSheet;
    ts_jobs: TTabSheet;
    ts_contact: TTabSheet;
    ts_tree: TTabSheet;
    ts_search: TTabSheet;
    ts_surnames: TTabSheet;
    ts_options: TTabSheet;
    ts_Files: TTabSheet;
    procedure cb_LinkPanelExit(Sender: TObject);
    procedure ClonedP_LinksCloningControl(const Sender: TExtClonedPanel;
      const ASource, ADestination: TControl);
    procedure de_ImagesAcceptDirectory(Sender: TObject; var Value: String);
    procedure de_ImagesChange(Sender: TObject);
    procedure ch_postalincludesubdirsClick(Sender: TObject);
    procedure ExtResButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FWXPButton2Click(Sender: TObject);
    procedure FW_showdirectoryClick(Sender: TObject);
    procedure lb_MovePrevClick(Sender: TObject);
    procedure OnFormInfoIniIniLoad(const AInifile: TCustomInifile;
      var KeepOn: Boolean);
    procedure OnFormInfoIniIniLoaded(const AInifile: TCustomInifile;
      var KeepOn: Boolean);
    procedure OnFormInfoIniReadWriteComponent(const AComponent: TComponent;
      const ATypeEditInProgress: TSaveEdit; const AInifile: TCustomInifile;
      var KeepOnComponent: Boolean);
    procedure pg_webChange(Sender: TObject);
    procedure OnFormIniWrite(const AInifile: TCustomInifile; var KeepOn: Boolean );
    procedure JvXPButton1Click(Sender: TObject);
    procedure se_imageWidthChange(Sender: TObject);
    procedure se_imagesperlineChange(Sender: TObject);
    procedure se_LinksCountChange(Sender: TObject);
    procedure se_NomSet(Sender: TObject);
    procedure TraduceImageFailure(Sender: TObject; const ErrorCode: integer;
      var ErrorMessage: string; var ContinueCopy: boolean);
  private
    { Déclarations privées }
    function fb_CanApplyToEveryLinkPanel(const ACombo: TComboBox): Boolean;
    function fs_AddImage(const as_ImageFile: string): string;
    function fs_AddImageTable(const as_HtmlImage: string; const as_alt: string=''
      ): string;
    procedure p_ApplyToEveryLinkPanel(const ACombo: TComboBox);
    procedure p_CreateAHtmlFile(const astl_Destination: TStringlistUTF8;
      const as_BeginingFile, as_Describe, as_Title, as_SelectedTitle, as_LongTitle: string;
      as_BottomHTML: string;
      const as_Subdir: string = '';
      const as_ExtFile: string = CST_EXTENSION_HTML;
      const as_BeforeHTML: string = ''; const astl_Body : TStringlistUTF8 = nil );
    function fi_CreateHTMLTree(const IBQ_Tree: TIBQuery;
      const astl_HTMLTree: TStrings;
      const ai_Clefiche: longint;
      const ab_Div: boolean = True;
      const ab_Link: boolean = True;
      const ab_Progress: boolean = True;
      const ab_NotFirst: boolean = False;
      const as_IdSosa: string = IBQ_TQ_SOSA;
      const ab_Asc: boolean = True): longint;
    function fb_OpenTree(const AIBQ_Tree: TIBQuery; const ai_Cle: longint;
      const ai_Niveau: integer = 0;const ai_Sexe: integer = 0): boolean; overload; virtual;
    function fb_OpenTree(const AIBQ_Tree: TIBSQL; const ai_Cle: longint;
      const ai_Niveau: integer = 0;const ai_Sexe: integer = 0): boolean; overload; virtual;
    procedure p_ExchangePanels(const Apanel1,Apanel2:TWinControl); overload;
    procedure p_ExchangePanels(const ACombo1, ACombo2: TComboBox; const AEdit1,
      AEdit2: TEdit; const AMemo1, AMemo2: TMemo); overload;
    procedure p_GetControlsFromPanel(const APanel:TWinControl;var AMemo:TMemo;var AEdit:TEdit;var ACombo:TComboBox);
  public
    { Déclarations publiques }
    constructor Create ( AOwner : TComponent ); override;
    procedure Loaded; override;
    procedure Deactivate; override;
    procedure DoShow; override;

    procedure p_genHtmlAges;
    procedure p_genHtmlJobs;
    procedure p_genHtmlPostalCards;
    procedure p_genHtmlLinks;
    procedure p_genHtmlsurnames(const IBS_FilesFiltered: TIBSQL;const IBQ_Names: TIBQuery);
    procedure p_genHtmlSearch;
    procedure p_genPhpContact;
    procedure p_genHTMLTree ( const IBQ_tree : TIBQuery  ; const ab_Splitted : Boolean ; const ai_generationSplitted : Integer );
  end;

implementation

uses  fonctions_ini,
  functions_html_tree,
  unite_messages,
  StrUtils,
  BGRABitmap,
  BGRADefaultBitmap,
  BGRABitmapTypes,
  LazUTF8,
  u_firebird_functions,
  fonctions_dialogs,
  fonctions_components,
  Variants,
  u_common_functions,
  u_common_const,
  u_dm,
{$IFNDEF FPC}
  AncestroWeb_strings_delphi,
  ShellApi, ShlObj,
  //windirs,
{$ELSE}
  AncestroWeb_strings,
{$ENDIF}
{$IFDEF WIN32}
//  windirs,
{$ENDIF}
  fonctions_system,
  fonctions_dbobjects,
  fonctions_languages,
  fonctions_images,
  fonctions_objects,
  U_AncestroWeb,
  u_common_ancestro_functions,
  fonctions_file;

const  CST_HTML_LINK             = 'Link';
       CST_UNIQUE_LINK = 'Lien unique';
var FAncestroWeb : TF_AncestroWeb;
{ TCaptionCombo }

function TCaptionCombo.RealGetText: TCaption;
begin
  Result:=inherited RealGetText;
end;

{ TF_AncestroWebOptions }
procedure TF_AncestroWebOptions.de_ImagesAcceptDirectory(Sender: TObject;
  var Value: String);
begin
  if DirectoryExistsUTF8(de_Images.Directory)
   Then
    ch_genpostalc.Checked:=True;
end;

procedure TF_AncestroWebOptions.de_ImagesChange(Sender: TObject);
begin
  i_postalcards.Directory:=de_Images.Directory;
end;

procedure TF_AncestroWebOptions.ch_postalincludesubdirsClick(Sender: TObject);
begin
  i_postalcards.SubDirs := ch_postalincludesubdirs.Checked;
end;

procedure TF_AncestroWebOptions.ExtResButton2Click(Sender: TObject);
var li_index : Integer;
begin
  li_index:=fi_getPanelIndex ((Sender as TControl).Parent);
  if li_index<ClonedP_Links.ControlCount-1
   Then p_ExchangePanels(ClonedP_Links.Controls[li_index] as TWinControl,ClonedP_Links.Controls[li_index+1] as TWinControl)
   Else (Sender as TControl).Enabled:=False;
end;

procedure TF_AncestroWebOptions.FormShow(Sender: TObject);
begin
  p_ReadComboBoxItems(cb_LinkPanel,cb_LinkPanel.Items);
end;

procedure TF_AncestroWebOptions.Deactivate;
begin
  inherited;
  OnFormInfoIni.p_ExecuteEcriture(Self);
end;

procedure TF_AncestroWebOptions.DoShow;
begin
  inherited;
  OnFormInfoIni.p_ExecuteLecture(Self);
  i_postalcards.Visible := pg_web.ActivePage = ts_cards;
end;

procedure TF_AncestroWebOptions.FWXPButton2Click(Sender: TObject);
begin
  if MyMessageDlg(gs_ANCESTROWEB_DeleteResumes,mmtConfirmation,mmbYesNo)=mrYes Then
   i_postalcards.DeleteIniMemos;
end;

procedure TF_AncestroWebOptions.FW_showdirectoryClick(Sender: TObject);
begin
  i_postalcards.ShowDirectory;
end;

procedure TF_AncestroWebOptions.p_GetControlsFromPanel(const APanel:TWinControl;var AMemo:TMemo;var AEdit:TEdit;var ACombo:TComboBox);
var li_i: Integer;
    lcon_control : TControl;
Begin
  with APanel do
    for li_i := 0 to ControlCount - 1 do
     Begin
       lcon_control := Controls[li_i];
       if lcon_control is TEdit Then
         AEdit:=lcon_control as TEdit;
       if lcon_control is TMemo Then
         AMemo:=lcon_control as TMemo;
       if lcon_control is TComboBox Then
         ACombo:=lcon_control as TComboBox;
     end;
end;

procedure TF_AncestroWebOptions.p_ExchangePanels(const Apanel1,Apanel2:TWinControl);
var LMemo1,LMemo2:TMemo;
    LEdit1,LEdit2:TEdit;
    LCombo1,LCombo2:TComboBox;
    li_i: Integer;
Begin
  p_GetControlsFromPanel ( Apanel1, LMemo1, LEdit1, LCombo1 );
  p_GetControlsFromPanel ( Apanel2, LMemo2, LEdit2, LCombo2 );
  p_ExchangePanels(LCombo1,LCombo2,LEdit1,LEdit2,LMemo1,LMemo2);
end;

procedure TF_AncestroWebOptions.lb_MovePrevClick(Sender: TObject);
var li_index : Integer;
begin
  li_index:=fi_getPanelIndex ((Sender as TControl).Parent);
  if li_index>0
   Then p_ExchangePanels(ClonedP_Links.Controls[li_index] as TWinControl,ClonedP_Links.Controls[li_index-1] as TWinControl)
   Else (Sender as TControl).Enabled:=False;

end;

procedure TF_AncestroWebOptions.OnFormInfoIniIniLoad(
  const AInifile: TCustomInifile; var KeepOn: Boolean);
begin

end;

procedure TF_AncestroWebOptions.OnFormInfoIniIniLoaded(const AInifile: TCustomInifile;
  var KeepOn: Boolean);
begin
  ch_postalincludesubdirsClick ( Self );
  if i_postalcards.ExtensionsIn.count>0 Then
    lb_postalinimages.Lines.Assign ( i_postalcards.ExtensionsIn );
end;

procedure TF_AncestroWebOptions.OnFormInfoIniReadWriteComponent(
  const AComponent: TComponent; const ATypeEditInProgress: TSaveEdit;
  const AInifile: TCustomInifile; var KeepOnComponent: Boolean);
begin
  if ( ATypeEditInProgress = feTComboBox ) and (AComponent.Tag = -1 ) Then
   KeepOnComponent:=False;
end;

procedure TF_AncestroWebOptions.pg_webChange(Sender: TObject);
begin
  i_postalcards.Visible := pg_web.ActivePage = ts_cards;
end;


procedure TF_AncestroWebOptions.OnFormIniWrite( const AInifile : TCustomInifile ; var KeepOn : Boolean );
begin
  i_postalcards.ExtensionsIn := lb_postalinimages.Lines;
  p_writeComboBoxItems(cb_LinkPanel,cb_LinkPanel.Items);
end;

// Search if can apply combo to links' combos
function TF_AncestroWebOptions.fb_CanApplyToEveryLinkPanel( const ACombo : TComboBox ): Boolean;
var li_i, li_j : Integer;
    lEdit : TEdit;
Begin
  Result := True;
  lEdit := nil;
  with ClonedP_Links do
   for li_i := 0 to ControlCount - 1 do
    if  (Controls[li_i] is TPanel) Then
    With Controls[li_i] do
     for li_j := 0 to ControlCount - 1 do
      Begin
        if  (Controls[li_j] is TEdit) Then
         lEdit:=Controls[li_j] as TEdit;
        if  (Controls[li_j] is TComboBox)
        and (Controls[li_j] <> ACombo)
        and ((Controls[li_j] as TComboBox).ItemIndex <> ACombo.ItemIndex) Then
           Begin
            MyMessageDlg(fs_RemplaceMsg(gs_ANCESTROWEB_The_Page_You_Want_To_Erase_Is_Already_Used_by,[lEdit.Text]));
            Result:=False;
           end;

      end;
end;

// Applay Items of combo to every links' combo
procedure TF_AncestroWebOptions.p_ApplyToEveryLinkPanel( const ACombo : TComboBox );
var li_i, li_j : Integer;
    lcon_control : TControl;
Begin
  with ClonedP_Links do
   for li_i := 0 to ControlCount - 1 do
    if  (Controls[li_i] is TPanel) Then
    With Controls[li_i] as TWinControl do
     for li_j := 0 to ControlCount - 1 do
      Begin
        lcon_control := Controls[li_j];
        if  (lcon_control is TComboBox)
        and (lcon_control <> ACombo) Then
         (lcon_control as TComboBox).Items.Text:=ACombo.Items.Text;
      end;
end;

procedure TF_AncestroWebOptions.cb_LinkPanelExit(Sender: TObject);
begin
  with Sender as TComboBox do
    if ItemIndex = 0
     Then Items [0]:=CST_UNIQUE_LINK // Need first Element
     Else
      if fb_AddToCombo(sender as TComboBox, Text,True) Then
       // ovewise, apply text to every combo
        p_ApplyToEveryLinkPanel(Sender as TComboBox);
end;

procedure TF_AncestroWebOptions.ClonedP_LinksCloningControl(
  const Sender: TExtClonedPanel; const ASource, ADestination: TControl);
begin
  if ADestination is TComboBox Then
  with ADestination as TComboBox do
   Begin
    Items.Text := (ASource as TComboBox).Items.Text;
    OnExit:=cb_LinkPanelExit;
   end;
  if ADestination is TJvXPButton Then
  with ADestination as TJvXPButton do
   Begin
    Glyph.Assign((ASource as TJvXPButton).Glyph);
    OnClick:=(ASource as TJvXPButton).OnClick;
   end;
end;

// procedure TF_AncestroWebOptions.p_CreateHTMLTree
// Création de l'arbre dans une TStringlistUTF8 puis Sauvegarde
function TF_AncestroWebOptions.fi_CreateHTMLTree(const IBQ_Tree: TIBQuery;
  const astl_HTMLTree: TStrings;
  const ai_Clefiche: longint;
  const ab_Div: boolean = True;
  const ab_Link: boolean = True;
  const ab_Progress: boolean = True;
  const ab_NotFirst: boolean = False;
  const as_IdSosa: string = IBQ_TQ_SOSA;
  const ab_Asc: boolean = True): longint;
var
  li_LocalLevel, li_LevelOrigin, li_LocalPreLevel, li_Clefiche: integer;
  ls_Tempo, ls_Barres, ls_NodeLink, ls_NameSurname, ls_Image: string;
  lb_foundARecord : Boolean;

  function fs_getText: string;
  begin
    Result := '';
    with IBQ_Tree,FAncestroWeb do
      Begin
        if not FieldByName(IBQ_DATE_NAISSANCE).IsNull
        and fb_ShowYear(FieldByName(IBQ_ANNEE_NAISSANCE).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)  then
          AppendStr(Result, ' ' + fs_Create_Image ( '..'+CST_HTML_DIR_SEPARATOR+CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_BIRTH, gs_AnceSTROWEB_EXPORT_WEB_BORN ) +
          ' ' + FieldByName( IBQ_DATE_NAISSANCE).AsString);
        if not FieldByName(IBQ_DATE_DECES).IsNull
        and fb_ShowYear(FieldByName(IBQ_ANNEE_DECES).AsInteger,FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger)  then
          AppendStr(Result, ' ' + fs_Create_Image ( '..'+CST_HTML_DIR_SEPARATOR+CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_DEATH, gs_AnceSTROWEB_EXPORT_WEB_DIED ) +
            ' ' + FieldByName(IBQ_DATE_DECES).AsString);
        if not FieldByName(IBQ_AGE_AU_DECES).IsNull then
          AppendStr(Result, fs_AddComma( FieldByName(IBQ_AGE_AU_DECES).AsString + gs_AnceSTROWEB_Years ));
        AppendStr(Result, fs_AddComma(FieldByName( as_idSosa   ).AsString ));
        p_addKeyWord(FieldByName(IBQ_NOM).AsString, '-'); // adding a head's meta keyword
        p_addKeyWord(FieldByName(IBQ_PRENOM).AsString); // adding a head's meta keyword
      end;
  end;


  procedure p_AddLine ( const ai_Key : Longint ; const ab_IsTheEnd, ab_OldNext, ab_IsFirst : boolean );
  Begin
   with FAncestroWeb do
    if not ch_Filtered.Checked
    or ( ab_IsFirst )
    or ( ab_Asc = FAncestroWeb.ch_ancestors.Checked )
    or fb_IsCreatedPerson(ai_Key)
    Then
      Begin
        if ab_Link
         Then ls_Image := fs_GetNameLink ( fs_RemplaceEspace ( ls_NameSurname, '_' ),IntToStr(ai_key),ls_Image, '../' + CST_SUBDIR_HTML_FILES + CST_HTML_DIR_SEPARATOR )
         else ls_Image := fs_GetNameLink ( fs_RemplaceEspace ( ls_NameSurname, '_' ),IntToStr(ai_key),ls_Image );
      end;
    p_setEndLine(ls_Tempo, ls_Image, ls_NodeLink, ab_OldNext,
      ab_IsTheEnd, li_LocalPreLevel, li_LocalLevel, ab_Link, ab_div);

    astl_HTMLTree.Add(ls_Tempo);
  end;

  procedure p_CreateChilds(const af_Sosa: double; const as_Aboville: string; const ab_HasNext, ab_OldNext, ab_IsFirst, ab_IsSecond, ab_IsSisBrother: boolean );
  var
    li_Sexe : integer;
    lf_SosaPere, lf_SosaMere, lf_NewSosa: double;
    ls_newAboville: string;
  begin
   with IBQ_Tree do
    if (ab_Asc and Locate(as_IdSosa, af_Sosa, [])) or
      (not ab_Asc and Locate(as_IdSosa, as_Aboville, [])) then
    begin
      if not ab_NotFirst
      or not ab_IsFirst
      or ab_IsSecond
       Then
        with FAncestroWeb do
        Begin
          li_LocalPreLevel := li_LocalLevel;
          li_LocalLevel := abs(FieldByName(IBQ_NIVEAU).AsInteger)-li_levelOrigin;
          if ab_NotFirst then
            Dec(li_LocalLevel);
          if ( li_LocalLevel > Result )
           Then
            Result := li_LocalLevel;

          lb_foundARecord := True;
          if li_LocalPreLevel <> -1 then
            p_AddLine ( li_Clefiche, False, ab_OldNext, ab_IsFirst or ab_IsSecond );

          li_Clefiche := FieldByName(IBQ_CLE_FICHE).AsInteger;
          if ab_Progress then
            p_IncProgressInd; // growing the second counter
          // Nommage des noeuds
          if li_LocalPreLevel <> li_LocalLevel Then  // a div by level
            ls_NodeLink := fs_GetNodeLink(ls_NodeLink, li_LocalLevel);

          // Cr?ation du d?but de Division
          p_setLevel(astl_HTMLTree, ls_NodeLink, ab_IsFirst or ab_IsSecond and ab_NotFirst, li_LocalLevel, li_LocalPreLevel, ab_div);

          li_Sexe := FieldByName(IBQ_SEXE).AsInteger;

          ls_NameSurname:=fs_getNameAndSurName(IBQ_Tree);

          ls_Image := ls_NameSurname +  fs_getText;
          ls_Barres := fs_NewLineImages(ls_Barres, ab_HasNext, li_LocalLevel);
          ls_Tempo := fs_CreateLineImages(ls_Barres, li_LocalLevel);
          case li_sexe of
            IBQ_SEXE_MAN   : ls_Image := fs_Create_Tree_Image('g' + CST_TREE_GIF_EXT) + ls_Image;
            IBQ_SEXE_WOMAN : ls_Image := fs_Create_Tree_Image('f' + CST_TREE_GIF_EXT) + ls_Image;
          end;
        end;
      lf_NewSosa := 0;
      if ab_Asc then
      begin    // next parents
        lf_SosaPere := af_Sosa * 2;
        lf_SosaMere := af_Sosa * 2 + 1;
        p_CreateChilds(lf_SosaPere, as_aboville, Locate(
          as_IdSosa, lf_SosaMere, []), ab_HasNext, False, ab_IsFirst, False );
        p_CreateChilds(lf_SosaMere, as_aboville, False, ab_HasNext, False, False, False );
      end
      else
      begin
        Next;  // next record for next tests
        ls_newAboville :=
          copy(as_aboville, 1, Length(as_aboville) - 1) + chr(
          Ord(as_aboville[Length(as_aboville)]) + 1);
        if FieldByName(as_IdSosa).AsString = ls_newAboville then // next record of sister or brother
        begin
          p_CreateChilds(lf_NewSosa, ls_newAboville,
            Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
            ab_HasNext, False, False, True );
        end
        else
        begin
          ls_newAboville := as_aboville + '1';
          if FieldByName(as_IdSosa).AsString = ls_newAboville then  // next record of childs
            begin
              p_CreateChilds(lf_NewSosa, ls_newAboville,
                 Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
                 ab_HasNext, False, ab_IsFirst, False );
              // verify if there is another sister or brother
              ls_newAboville :=
                copy(as_aboville, 1, length ( as_Aboville ) - 1) + chr(
                Ord(as_aboville[length ( as_Aboville )]) + 1);
              if Locate(as_IdSosa,ls_newAboville,[]) then
              begin
                p_CreateChilds(lf_NewSosa, ls_newAboville,
                  Locate(as_IdSosa,copy(ls_newAboville, 1, Length(ls_newAboville) - 1) + chr(Ord(ls_newAboville[Length(ls_newAboville)]) + 1),[]),
                  ab_HasNext, False, False, True );
              end
           End;
        end;
      end;
    end;
  end;

begin
  li_LocalLevel := -1;
  Result := -1;
  ls_NodeLink := '';
  ls_Tempo := '';
  ls_NameSurname := '';
  ls_Image  := '';
  gs_HTMLTreeNodeLink := '';
  ls_Barres := '';
  With IBQ_Tree, FAncestroWeb do
    try
     if ab_Progress Then
      Begin
        pb_ProgressInd.Position:=0;
        pb_ProgressInd.Max:=RecordCount;
      end;
      // first node
      Locate(IBQ_CLE_FICHE, ai_Clefiche, []);
      li_LevelOrigin := abs(FieldByName(IBQ_NIVEAU).AsInteger);
  //    if ( li_levelOrigin > 0 ) then
  //     dec ( li_levelOrigin );
      li_Clefiche:=ai_Clefiche;
      lb_foundARecord := False;
      // create the tree
      p_CreateChilds(FieldByName(as_IdSosa).AsFloat,
        FieldByName(as_IdSosa).AsString, False, False, True, False, False);
      if lb_foundARecord then
        p_AddLine ( li_Clefiche, True, False, False );
    except
      On E: Exception do
        MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantCreateATree ) + CST_ENDOFLINE + E.Message);
    end;
  Inc(Result);

end;


// function TF_AncestroWebOptions.fb_OpenTree
// open a tree from parameters
function TF_AncestroWebOptions.fb_OpenTree(const AIBQ_Tree: TIBQuery;
  const ai_Cle: longint; const ai_Niveau: integer = 0;
  const ai_Sexe: integer = 0): boolean;
begin
  Result := False;
  with AIBQ_Tree.Params do
    try
      AIBQ_Tree.Close;
      ParamByName(I_CLEF).AsInteger := ai_Cle;
      ParamByName(I_NIVEAU).AsInteger := ai_Niveau;
      if (FindParam(I_PARQUI) <> nil) Then
        ParamByName(I_PARQUI).AsInteger := ai_Sexe;
      if (FindParam(I_DOSSIER) <> nil) Then
        ParamByName(I_DOSSIER).AsInteger := DMWeb.CleDossier;
      AIBQ_Tree.Open;
      Result := not AIBQ_Tree.IsEmpty;
    except
      On E: Exception do
        MyShowMessage( gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_FullTree + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
    end;
end;

// function TF_AncestroWebOptions.fb_OpenTree
// open a tree from parameters
function TF_AncestroWebOptions.fb_OpenTree(const AIBQ_Tree: TIBSQL;
  const ai_Cle: longint; const ai_Niveau: integer = 0;
  const ai_Sexe: integer = 0): boolean;
begin
  Result := False;
  with AIBQ_Tree do
    try
      Close;
      ParamByName(I_CLEF).AsInteger := ai_Cle;
      ParamByName(I_NIVEAU).AsInteger := ai_Niveau;
      ParamByName(I_PARQUI).AsInteger := ai_Sexe;
      ExecQuery;
      Result := not Eof;
    except
      On E: Exception do
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_FullTree + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
    end;
end;

constructor TF_AncestroWebOptions.Create(AOwner: TComponent);
begin
  FAncestroWeb:=AOwner as TF_AncestroWeb;
  inherited Create(AOwner);
  with cb_LinkPanel.Items do
   if Count = 0
    Then Add ( CST_UNIQUE_LINK )
    Else Strings[0]:=CST_UNIQUE_LINK;
end;

// procedure TF_AncestroWebOptions.p_genHTMLTree
// creating the main interactive HTML?Tree
procedure TF_AncestroWebOptions.p_genHTMLTree ( const IBQ_tree : TIBQuery ; const ab_Splitted : Boolean ; const ai_generationSplitted : Integer  );
var
  lstl_HTMLTree, lstl_HTMLTree2: TStringlistUTF8;
  ls_destination,ls_idSosa: string;
  li_counter   : longint;
  lt_SheetsGen : TAHTMLULTabSheet;
  procedure p_CreateSheets(const ai_generation : Integer ; const af_Sosa: double ; const as_aboville : String );
  var
    lf_SosaPere, lf_SosaMere: double;
    ls_newAboville: string;
    ls_ancestry: string;
    procedure p_CreateAscSheet;
    var
      li_i : integer;
    Begin
      with IBQ_tree do
        case ai_generation of
          1 : Begin
                if trunc(af_Sosa) mod 2 = 0
                 Then p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg(gs_ANCESTROWEB_Father, [FieldByName(IBQ_NOM).AsString]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString )
                 Else p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg(gs_ANCESTROWEB_Mother, [FieldByName(IBQ_NOM).AsString]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString );
              End;
          2 : Begin
                if trunc(af_Sosa) mod 2 = 0
                 Then p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg(gs_ANCESTROWEB_Old_Father, [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString )
                 Else p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg(gs_ANCESTROWEB_Old_Mother, [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString );
              End;
          3 : Begin
                if trunc(af_Sosa) mod 2 = 0
                 Then p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg ( gs_ANCESTROWEB_Ancestry_Man, [fs_RemplaceMsg( gs_ANCESTROWEB_old_father_minus , [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))])]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString )
                 Else p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg ( gs_ANCESTROWEB_Ancestry_Woman, [fs_RemplaceMsg(gs_ANCESTROWEB_old_mother_minus, [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))])]),
                        ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString );
              End;
          else
            Begin
              if trunc(af_Sosa) mod 2 = 0
               Then ls_ancestry := fs_RemplaceMsg( gs_ANCESTROWEB_old_father_minus , [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))])
               Else ls_ancestry := fs_RemplaceMsg( gs_ANCESTROWEB_old_mother_minus , [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa))]);
              for li_i := 4 to ai_generation do
                if trunc(af_Sosa) mod 2 = 0
                 Then ls_ancestry := fs_RemplaceMsg( gs_ANCESTROWEB_ancestry_man_minus   , [ls_ancestry])
                 Else ls_ancestry := fs_RemplaceMsg( gs_ANCESTROWEB_ancestry_woman_minus , [ls_ancestry]);
              if trunc(af_Sosa) mod 2 = 0
               Then p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg ( gs_ANCESTROWEB_Ancestry_Man, [ls_ancestry]),
                      ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString )
               Else p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg ( gs_ANCESTROWEB_Ancestry_Woman, [ls_ancestry]),
                      ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString );
            End;
        End;
    End;
  begin
    with IBQ_Tree, FAncestroWeb do
    if (ch_ancestors.Checked and Locate(ls_IdSosa, af_Sosa, [])) or
      (not ch_ancestors.Checked and Locate(ls_IdSosa, as_Aboville, [])) then
        begin
          if ai_generation = ai_generationSplitted Then
           Begin
             if ch_ancestors.Checked then
              Begin
                p_CreateAscSheet;
              End
             Else
              Begin
                p_AddTabSheet(lt_SheetsGen, fs_RemplaceMsg ( gs_ANCESTROWEB_generation_child, [FieldByName(IBQ_NOM).AsString,IntToStr(trunc(af_Sosa)),FieldByName(IBQ_PRENOM).AsString]),
                                ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML, FieldByName(IBQ_CLE_FICHE).AsString )
              End;
             inc (li_counter);
            End;
           if ch_ancestors.Checked then
            Begin
             if ai_generation < ai_generationSplitted Then
              begin    // next parents
                lf_SosaPere := af_Sosa * 2;
                lf_SosaMere := af_Sosa * 2 + 1;
                p_CreateSheets(ai_generation+1,lf_SosaPere, '' );
                p_CreateSheets(ai_generation+1,lf_SosaMere, '' );
              end;
            end
           else
            begin
              Next;  // next record for next tests
              ls_newAboville :=
                copy(as_aboville, 1, Length(as_aboville) - 1) + chr(
                Ord(as_aboville[Length(as_aboville)]) + 1);
              if FieldByName(ls_IdSosa).AsString = ls_newAboville then // next record of sister or brother
                p_CreateSheets(ai_generation,af_Sosa, ls_newAboville )
              else
                begin
                  ls_newAboville := as_aboville + '1';
                  if FieldByName(ls_IdSosa).AsString = ls_newAboville then  // next record of childs
                    begin
                     if ai_generation < ai_generationSplitted Then
                       p_CreateSheets(ai_generation+1,af_Sosa, ls_newAboville );
                      // verify if there is another sister or brother
                      ls_newAboville :=
                        copy(as_aboville, 1, length ( as_Aboville ) - 1) + chr(
                        Ord(as_aboville[length ( as_Aboville )]) + 1);
                      if Locate(ls_IdSosa,ls_newAboville,[]) then
                        p_CreateSheets(ai_generation,af_Sosa, ls_newAboville );
                   End;
                end;
            end;
       End;
  end;
  procedure p_prepareSplitted;
  var li_i : Integer;
  Begin
    if ab_Splitted Then
     Begin
       if FAncestroWeb.ch_ancestors.Checked
        Then ls_idSosa := IBQ_TQ_SOSA
        Else ls_idSosa := IBQ_TQ_NUM_SOSA;
       lstl_HTMLTree2 := TStringlistUTF8.Create;
       li_counter := 0 ;
       if IBQ_Tree.Locate(IBQ_CLE_FICHE, gi_CleFiche, []) then
         p_CreateSheets ( 0, IBQ_tree.FieldByName(ls_IdSosa).AsFloat, IBQ_Tree.FieldByName(ls_IdSosa).AsString);
       lstl_HTMLTree.Text := fs_CreateULTabsheets(lt_SheetsGen,
         '', CST_HTML_SUBMENU)+CST_HTML_DIV_BEGIN;
       for li_i := 1 to sp_gentree.value - 1 do // why to do that ? do not know exactly
         lstl_HTMLTree.Add ( CST_HTML_BR + CST_HTML_BR );
       lstl_HTMLTree.Add ( CST_HTML_BR + CST_HTML_BR );
     end;

  end;
  var li_generation : Longint;
begin
  gs_TreeLetterBegin := chr(ord(CST_TREE_LETTER_BEGIN)-1);
  with FAncestroWeb do
   Begin
    p_Setcomments ( gs_AnceSTROWEB_FamilyTree ); // advert for user
    lstl_HTMLTree := TStringlistUTF8.Create;
    lstl_HTMLTree2 := nil;
    p_ClearKeyWords;
    try
      if fb_OpenTree(IBQ_Tree, gi_CleFiche)
       then
        try
          p_prepareSplitted;
          pb_ProgressInd.Max := IBQ_Tree.RecordCount;
          if not ch_Filtered.Checked and not
            IBQ_Tree.Locate(IBQ_CLE_FICHE, gi_CleFiche, []) then
            Exit;
          if ab_Splitted Then
           Begin
             for li_counter := 0 to high ( lt_SheetsGen ) do
              Begin
                with lt_SheetsGen [ li_counter ] do
                if IBQ_Tree.Locate(IBQ_CLE_FICHE, StrToInt ( s_info ),[]) then
                 if s_info > '' Then
                 Begin
                   lstl_HTMLTree2.Text:='';
                   if ch_ancestors.Checked
                     Then li_generation := fi_CreateHTMLTree(IBQ_Tree, lstl_HTMLTree2, StrToInt ( s_info ),not cb_treeWithoutJavascript.Checked)
                     Else li_generation := fi_CreateHTMLTree(IBQ_Tree, lstl_HTMLTree2, StrToInt ( s_info ),not cb_treeWithoutJavascript.Checked,True,True,False,IBQ_TQ_NUM_SOSA,False);
                   lstl_HTMLTree2.Insert(0, fs_html_Lines(me_HeadTree.Lines.Text));
                   lstl_HTMLTree2.Insert(0,lstl_HTMLTree.Text);
                   lstl_HTMLTree2.Add(CST_HTML_DIV_END);
                   p_CreateAHtmlFile(lstl_HTMLTree2, CST_SUBDIR_HTML_TREE, me_Description.Lines.Text,
                     ( gs_AnceSTROWEB_FamilyTree ), gs_AnceSTROWEB_FullTree, fs_GetTitleTree ( gs_AnceSTROWEB_Ancestry, li_generation), gs_LinkGedcom, '../');
                   ls_destination := gs_RootPathForExport +
                     CST_SUBDIR_HTML_TREE + DirectorySeparator + ed_TreeName.Text + IntToStr(li_counter) + CST_EXTENSION_HTML;
                   try
                     if fb_CreateDirectoryStructure(gs_RootPathForExport + CST_SUBDIR_HTML_TREE) Then
                       lstl_HTMLTree2.SaveToFile(ls_destination);
                   except
                     On E: Exception do
                     begin
                       MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantSaveTree ) + ls_destination + CST_ENDOFLINE + E.Message);
                       Abort;
                     end;
                   end;
                 End;
                p_IncProgressBar;
              end;
           End
          else
           Begin
            if ch_ancestors.Checked
              Then li_generation := fi_CreateHTMLTree(IBQ_Tree, lstl_HTMLTree, gi_CleFiche,not cb_treeWithoutJavascript.Checked)
              Else li_generation := fi_CreateHTMLTree(IBQ_Tree, lstl_HTMLTree, gi_CleFiche,not cb_treeWithoutJavascript.Checked,True,True,False,IBQ_TQ_NUM_SOSA,False);
            lstl_HTMLTree.Insert(0, fs_html_Lines(me_HeadTree.Lines.Text));
            p_CreateAHtmlFile(lstl_HTMLTree, CST_SUBDIR_HTML_TREE, me_Description.Lines.Text,
              ( gs_AnceSTROWEB_FamilyTree ), gs_AnceSTROWEB_FullTree, fs_GetTitleTree ( gs_AnceSTROWEB_Ancestry, li_generation), gs_LinkGedcom, '../');
            // saving the page
            ls_destination := gs_RootPathForExport +
              CST_SUBDIR_HTML_TREE + DirectorySeparator + ed_TreeName.Text + CST_EXTENSION_HTML;
            try
              if fb_CreateDirectoryStructure(gs_RootPathForExport + CST_SUBDIR_HTML_TREE + DirectorySeparator) then
                lstl_HTMLTree.SaveToFile(ls_destination);
            except
              On E: Exception do
              begin
                MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantSaveTree ) + ls_destination + CST_ENDOFLINE + E.Message);
                Abort;
              end;
            end;
            p_IncProgressBar;
           End;
        except
          On E: Exception do
            MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_FullTree + #13#10 + #13#10 + fs_getCorrectString ( gs_AnceSTROWEB_cantUseData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
        end;
    finally
      lstl_HTMLTree.Free;
      lstl_HTMLTree2.Free;
    end;
   end;
end;

// function TF_AncestroWebOptions.fs_AddImage
// creating a HTML image from image's path
function TF_AncestroWebOptions.fs_AddImage(const as_ImageFile: string): string;
var
  ls_Destination, ls_HtmlFileName: string;
begin
  Result := '';
  with FAncestroWeb do
   Begin
    p_IncProgressBar; // growing the counter
    if fi_ImageEditCount(as_ImageFile) = 0 then
      Exit;
   end;

  ls_HtmlFileName := ExtractFileName(as_ImageFile);
  ls_HtmlFileName := fs_TextToFileName(Copy(ls_HtmlFileName, 1, Length(ls_HtmlFileName) -
    Length(ExtractFileExt(ls_HtmlFileName)))) + CST_EXTENSION_JPEG;
  // saving the picture
  ls_destination := gs_RootPathForExport +
    CST_SUBDIR_HTML_IMAGES + DirectorySeparator + ls_HtmlFileName;
  with dm.TraduceImage do
   Begin
    FileSource := as_ImageFile;
    FileDestination := ls_Destination;
    CopySourceToDestination;
   end;
  AppendStr ( Result, ' ' + fs_AddImageTable(fs_Create_Image(CST_SUBDIR_HTML_IMAGES + CST_HTML_DIR_SEPARATOR + ls_HtmlFileName)));
end;

// function TF_AncestroWebOptions.fs_AddImageTable
// add an image in the current HTML?TABLE
function TF_AncestroWebOptions.fs_AddImageTable(const as_HtmlImage : string ; const as_alt: string = ''): string;
begin
  if as_HtmlImage = ''
   Then Result := ''
   Else Result := CST_HTML_TD_BEGIN + '<' + CST_HTML_TABLE +
    CST_HTML_ID_EQUAL + '"image">' + CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN +
    as_HtmlImage + CST_HTML_TD_END + CST_HTML_TR_END +
    CST_HTML_TABLE_END + CST_HTML_TD_END + ' ';
end;


// procedure TF_AncestroWebOptions.p_genHtmlSurnames
// generating HTML Surnames' page
procedure TF_AncestroWebOptions.p_genHtmlsurnames(const IBS_FilesFiltered: TIBSQL;
  const IBQ_Names: TIBQuery);
var
  lstl_HTMLAFolder: TStringlistUTF8;
  ls_NewSurname, ls_ASurname, ls_destination: string;


const CST_DUMMY_COORD = 2000000;
      CST_NB_DOTS     = 5;
  procedure p_getCityInfos ( as_codepostal, as_Pays : String ; var as_City : String; var ad_latitude , ad_longitude : Double);
  Begin
    ad_latitude :=CST_DUMMY_COORD;
    ad_longitude:=CST_DUMMY_COORD;
    as_City := '' ;
    if ( as_codepostal = '' )
    or ( Length(as_codepostal)>8) Then
      Begin
        FAncestroWeb.p_Setcomments(gs_ANCESTROWEB_MapProblemNoPostalCode);
        Exit;
      end;
    if ( as_pays = '' ) Then
     as_pays := gs_ANCESTROWEB_MapCountry;
    with DMWeb.IBS_City do
      Begin
        Close;
        ParamByName(I_CP  ).AsString:=as_codepostal;
        ParamByName(I_PAYS).AsString:=as_Pays;
        ExecQuery;
        if EOF and BOF Then
         if as_Pays = gs_ANCESTROWEB_MapCountry
          Then Exit
          Else p_getCityInfos ( as_codepostal, gs_ANCESTROWEB_MapCountry, as_City, ad_latitude, ad_longitude );
        if FieldByName(IBQ_CP_LATITUDE ).IsNull or FieldByName(IBQ_CP_LONGITUDE ).IsNull Then
         Exit;
        ad_latitude := FieldByName(IBQ_CP_LATITUDE ).AsFloat;
        ad_longitude:= FieldByName(IBQ_CP_LONGITUDE).AsFloat;
        as_City     := FieldByName(IBQ_CP_VILLE    ).AsString;
        Close;
      end;
  end;

  // procedure p_getGlobalMinMax
  // Min and max for global map
  procedure p_getGlobalMinMax (var ad_Minlatitude, ad_Maxlatitude, ad_Minlongitude , ad_Maxlongitude : Double ; var ai_MaxCounter  : Int64 );
  var li_i : LongInt;
  Begin
    for li_i := 0 to high ( gt_Surnames ) do
     with gt_Surnames [ li_i ] do
      Begin
        if Minlatitude < ad_Minlatitude Then
          ad_Minlatitude := Minlatitude;
        if Maxlatitude > ad_Maxlatitude Then
          ad_Maxlatitude := Maxlatitude;
        if Minlongitude < ad_Minlongitude Then
          ad_Minlongitude := Minlongitude;
        if Maxlongitude > ad_Maxlongitude Then
          ad_Maxlongitude := Maxlongitude;
        if MaxCounter > ai_MaxCounter Then
          ai_MaxCounter := MaxCounter;
      end;
  End;

    // procedure p_createMinMaxMap
    // creating min and max on Surnames
    procedure p_createMinMaxMap ( const IBS_MapFiltered :TIBSQL);
    var
        li_i : LongInt;
        ld_latitude  ,
        ld_longitude : Double;
        ld_counter   : Int64;
        ls_City ,
        ls_AName : String;
    Begin
      ld_longitude := 0;
      ld_latitude  := 0;
      ls_City      := '';
      with IBS_MapFiltered do
      while not Eof do
        Begin
          ls_AName := FieldByName(IBQ_NOM).AsString;
          ls_City:= Trim ( FieldByName(IBQ_EV_IND_VILLE).AsString );
          if  ( ls_AName > '' ) Then
           if ( FieldIndex [ IBQ_EV_IND_LATITUDE ] >= 0 )
           and not FieldByName(IBQ_EV_IND_LATITUDE ).IsNull and not FieldByName(IBQ_EV_IND_LONGITUDE ).IsNull Then
            Begin
              ld_latitude :=FieldByName(IBQ_EV_IND_LATITUDE ).AsDouble;
              ld_longitude:=FieldByName(IBQ_EV_IND_LONGITUDE).AsDouble;
              ld_counter :=  FieldByName(IBQ_COUNTER ).AsInt64;
              if  ( ld_latitude <> CST_DUMMY_COORD ) Then
                begin
                  li_i := fi_findName ( ls_AName );
                  if li_i > -1 Then
                   with gt_Surnames [ li_i ] do
                   // mise ? jour des max
                    Begin
                      if ld_latitude  < Minlatitude then
                       Minlatitude:= ld_latitude;
                      if ld_latitude  > Maxlatitude then
                       Maxlatitude:= ld_latitude;
                      if ld_longitude  < Minlongitude then
                       Minlongitude:= ld_longitude;
                      if ld_longitude  > Maxlongitude then
                        Maxlongitude:= ld_longitude;
                      if ld_counter  > MaxCounter then
                        MaxCounter:=ld_counter;
                    end
                  else
                   Begin
                     SetLength(gt_Surnames, high ( gt_Surnames ) + 2);
                     with gt_Surnames [ high ( gt_Surnames )] do
                      Begin
                        Name := ls_AName;
                        Minlatitude :=ld_latitude;
                        Maxlatitude :=ld_latitude;
                        Minlongitude:=ld_longitude;
                        Maxlongitude:=ld_longitude;
                        MaxCounter := ld_counter;
                      end;
                   end;
                end;
             End
            Else
             Begin
               p_getCityInfos ( FieldByName(IBQ_EV_IND_CP).AsString, FieldByName(IBQ_EV_IND_PAYS).AsString, ls_City, ld_latitude, ld_longitude );
               ld_counter :=  FieldByName(IBQ_COUNTER ).AsInt64;
               if ls_City > '' Then
                 begin
                   li_i := fi_findName ( ls_AName );
                   if li_i <> -1 Then
                    with gt_Surnames [ li_i ] do
                    // mise ? jour des max
                     Begin
                       if ld_latitude  < Minlatitude then
                        Minlatitude:= ld_latitude;
                       if ld_latitude  > Maxlatitude then
                        Maxlatitude:= ld_latitude;
                       if ld_longitude  < Minlongitude then
                        Minlongitude:= ld_longitude;
                       if ld_longitude  > Maxlongitude then
                         Maxlongitude:= ld_longitude;
                       if ld_counter  > MaxCounter then
                         MaxCounter:=ld_counter;
                     end
                   else
                    Begin
                      SetLength(gt_Surnames, high ( gt_Surnames ) + 2);
                      with gt_Surnames [ high ( gt_Surnames )] do
                       Begin
                         Name := ls_AName;
                         Minlatitude :=ld_latitude;
                         Maxlatitude :=ld_latitude;
                         Minlongitude:=ld_longitude;
                         Maxlongitude:=ld_longitude;
                         MaxCounter := ld_counter;
                       end;
                    end;
                 End;
            end;
          Next;
        end;
    end;

  // function fs_MapZoom
  // creating zoom for map
  function fs_MapZoom ( const ad_Minlatitude, ad_Maxlatitude, ad_Minlongitude , ad_Maxlongitude  : Double ): String;
  var ld_Longitude, ld_Zoom : Double;
  Begin
    ld_Zoom      := 90  + ad_Maxlatitude  - ad_Minlatitude  ;
    ld_Longitude := ( 180 + ad_Maxlongitude - ad_Minlongitude ) / 2 ;
    if ld_Longitude > ld_Zoom Then
     ld_Zoom:=ld_Longitude;
    ld_Zoom := 1.25 - ld_Zoom / 180;
    try
      // adapting initial zoom to max lattitud and longitud
      Result := IntToStr ( trunc ( StrToInt(gs_ANCESTROWEB_MapMaxZoom) * ld_Zoom ));
    except
    end;
  End;
  // procedure p_setACase
  // creating a now switching case
  procedure p_setACase ( const astl_ACaseFile : TStringlistUTF8; const ai_Name : Integer );
  Begin
    if ( ai_Name > -1 ) Then
     //set a surname line
      with gt_Surnames [ ai_Name ] do
        Begin
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_LATITUD , FloatToStr((Maxlatitude  + MinLatitude ) /2),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_LONGITUD, FloatToStr((MinLongitude + Maxlongitude) /2),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_MIN_LATITUD , FloatToStr(MinLatitude ),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_MIN_LONGITUD, FloatToStr(MinLongitude),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_MAX_LATITUD , FloatToStr(MaxLatitude ),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_MAX_LONGITUD, FloatToStr(MaxLongitude),[rfReplaceAll]);
          p_ReplaceLanguageString ( astl_ACaseFile, CST_MAP_ZOOM    , fs_MapZoom ( Minlatitude, Maxlatitude, Minlongitude , Maxlongitude ),[rfReplaceAll]);
        end;
    ls_ASurname := ls_NewSurname;

  end;

  // procedure p_setAline
  // creating a new case line
  procedure p_setAline ( const astl_FileLines, astl_Line : TStringlistUTF8; const IBS_MapFiltered :TIBSQL; const ai_MaxCounter : Int64 ; const ab_IsNamedMap : Boolean ; const ai_counter : Longint );
  var li_i, li_dot : Integer ;
      ld_latitude, ld_longitude : Double;
      li_counter : Int64;
      ls_City, ls_CitySurname, ls_Surname, ls_link : String;
      lvar_Search : variant;
  Begin
    with IBS_MapFiltered,FAncestroWeb do
     Begin
       ls_City:=FieldByName(IBQ_EV_IND_VILLE).AsString;
       ls_CitySurname:=Trim(ls_City);
       if ( FieldIndex [ IBQ_EV_IND_LATITUDE ] > -1 )
       and ( not FieldByName(IBQ_EV_IND_LATITUDE ).IsNull ) then
        Begin
         ld_latitude :=FieldByName(IBQ_EV_IND_LATITUDE ).AsDouble;
         ld_longitude:=FieldByName(IBQ_EV_IND_LONGITUDE).AsDouble;
        End
        Else
         p_getCityInfos ( FieldByName(IBQ_EV_IND_CP).AsString,
                          FieldByName(IBQ_EV_IND_PAYS).AsString,
                          ls_CitySurname,
                          ld_latitude, ld_longitude );
       if ab_IsNamedMap
        Then // just set the link
         ls_CitySurname:=fs_getLinkedCity(ls_CitySurname)
        else // adding keywords and set the link
         Begin
           p_addKeyWord(ls_CitySurname); // adding a head's meta keywords
           p_addKeyWord(FieldByName(IBQ_NOM).AsString); // adding a head's meta keywords
           ls_CitySurname:=fs_getLinkedSurName(FieldByName(IBQ_NOM).AsString) + ' - ' + fs_getLinkedCity(ls_CitySurname);
         end;
       li_counter:= FieldByName(IBQ_COUNTER).AsInt64;
     end;
    if ( ld_latitude  = CST_DUMMY_COORD) Then
     Exit; // si mauvaises coordonn?es on n'ajoute pas de ligne
    astl_FileLines.Append ( astl_Line.Text );
    astl_FileLines.BeginUpdate;
    ls_CitySurname:=StringReplace(ls_CitySurname, '''', '\''',[rfReplaceAll]);
    p_ReplaceLanguageString ( astl_FileLines, CST_MAP_N, IntToStr(ai_counter),[rfReplaceAll] );
    ls_CitySurname := ls_CitySurname + ' - ' ;
    ls_link := IntToStr(li_counter) + ' ' ;
    if li_counter > 1
     Then AppendStr ( ls_link, gs_ANCESTROWEB_FamilyPersons )
     Else AppendStr ( ls_link, gs_ANCESTROWEB_FamilyPerson  );
    lvar_Search := VarArrayCreate([ 0, 2 ],varvariant);
    lvar_Search[0]:=IBS_MapFiltered.FieldByName(IBQ_NOM).AsString;
    lvar_Search[1]:=ls_City;
    lvar_Search[2]:=IBS_MapFiltered.FieldByName(IBQ_EV_IND_PAYS).AsString;
    if IBQ_Names.Locate('NOM;VILLE_BIRTH;PAYS_BIRTH',lvar_Search,[])
     Then // if have found this name in person list
      with IBQ_Names,FAncestroWeb do
        Begin
         // get precise anchor of page file
         ls_Surname:= fs_RemplaceChar(
                      fs_getNameAndSurName ( fb_ShowYear(FieldByName(IBQ_ANNEE_NAISSANCE ).AsInteger,
                                                         FieldByName(IBQ_IND_CONFIDENTIEL).AsInteger),
                                            FieldByName(IBQ_NOM).AsString,
                                            FieldByName(IBQ_PRENOM).AsString), ' ', '_' );
         // ls_city available, use it for key of person
         ls_City:=FieldByName(IBQ_CLE_FICHE).AsString;
        end
     Else
      Begin
        // get anchor of page file
        ls_Surname:=IBS_MapFiltered.FieldByName(IBQ_NOM).AsString;
        ls_City:='';
      end;
    // cr?er l'infobulle pour un nom de la carte
    p_ReplaceLanguageString ( astl_FileLines, CST_MAP_NAME_CITY ,
                              StringReplace ( ls_CitySurname + StringReplace ( FAncestroWeb.fs_GetNameLink ( ls_Surname
                              , ls_City, ls_link, CST_SUBDIR_HTML_FILES + CST_HTML_DIR_SEPARATOR), '''', '\''',[rfReplaceAll])
                              , '"', '\"',[rfReplaceAll]));
    p_ReplaceLanguageString ( astl_FileLines, CST_MAP_LATITUD   , FloatToStr(ld_latitude ),[rfReplaceAll]);
    p_ReplaceLanguageString ( astl_FileLines, CST_MAP_LONGITUD  , FloatToStr(ld_longitude),[rfReplaceAll]);
    li_dot := CST_NB_DOTS;
    for li_i := 1 to CST_NB_DOTS do
      if li_counter <= ai_MaxCounter / li_i Then
       li_dot := CST_NB_DOTS - li_i + 1;
    case li_dot of
     1 :  p_ReplaceLanguageString ( astl_FileLines, CST_MAP_ICON, CST_MAP_LITTLE_DOT  ,[rfReplaceAll]);
     2 :  p_ReplaceLanguageString ( astl_FileLines, CST_MAP_ICON, CST_MAP_LI_MID_DOT  ,[rfReplaceAll]);
     3 :  p_ReplaceLanguageString ( astl_FileLines, CST_MAP_ICON, CST_MAP_MIDDLE_DOT  ,[rfReplaceAll]);
     4 :  p_ReplaceLanguageString ( astl_FileLines, CST_MAP_ICON, CST_MAP_BIG_MID_DOT ,[rfReplaceAll]);
     else p_ReplaceLanguageString ( astl_FileLines, CST_MAP_ICON, CST_MAP_BIG_DOT     ,[rfReplaceAll]);
    end;
    astl_FileLines.EndUpdate;
  end;

  // procedure p_createAMap
  // creating a map with persons frpm IBS_MapFiltered
  procedure p_createAMap ( const IBS_MapFiltered :TIBSQL; IBQ_CountMap :TIBQuery);
  var ld_MinLatitude, ld_MaxLatitude, ld_MinLongitude, ld_MaxLongitude : Double;
    li_MaxCounter : Int64;
    lstl_AllSurnames ,
    lstl_ACase    ,
    lstl_EndCase    ,
    lstl_AFile    ,
    lstl_ALine    : TStringlistUTF8;
    li_Name       ,
    li_i, li_j, li_MapFileJS          : Integer ;
    li_recno, li_recordcount : Int64;
    lch_decimalSep : Char;
    // scroll on a dataset
    procedure p_scroll ( var ai_recno : Int64 ; const ai_recordtogo : Int64 );
    Begin
      while ai_recno < ai_recordtogo do
       Begin
        inc ( ai_recno );
        IBS_MapFiltered.Next;
       end;
    end;

    // create grouped surnames sheets
    procedure p_CreateSheets;
    var
      ls_from : string;
      li_counter : Integer;
    begin
      li_recno := 0;
      Finalize(gt_SheetsMapGroup);
      with IBS_MapFiltered do
       if not ( BOF and EOF ) Then
        for li_counter := sp_groupMap.Value - 1 downto 0 do
          begin
            if li_counter < sp_groupMap.Value Then
              Next;
            ls_from:= FieldByName(IBQ_nom).AsString;
            if li_counter = 0
             Then p_scroll( li_recno, li_recordcount - 1 )
             Else p_scroll( li_recno, li_recordcount div (li_counter*2));
            with FieldByName(IBQ_NOM) do
               p_AddTabSheet(gt_SheetsMapGroup, fs_RemplaceMsg ( gs_ANCESTROWEB_From_to_persons, [ls_from,AsString]),
                             ed_MapFileName.Text + IntToStr(sp_groupMap.Value - 1-li_counter) + CST_EXTENSION_HTML, AsString );
          End;
    end;

    //creating a map js file
    procedure p_createFileCaseMap ( const astl_AFile : TStringlistUTF8; const ai_counter : Integer);
    Begin

      // saving the page
      ls_destination := gs_RootPathForExport + CST_SUBDIR_HTML_MAPS + DirectorySeparator + ed_MapFileName.Text + CST_FILE_FILE + IntToStr(ai_counter) + CST_EXTENSION_JS;
      try
        astl_AFile.SaveToFile(ls_destination);
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Map + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
     End;

    //creating and initing a map js file
    procedure p_createACase ( const astl_Case : TStringlistUTF8; const as_Name : String );
    Begin
      p_ReplaceLanguageString ( lstl_EndCase, CST_MAP_N, IntToStr(li_i) );
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_CASE, lstl_ACase.Text );
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_FILE, StringReplace ( CST_SUBDIR_HTML_MAPS +'/'+ ed_MapFileName.Text + CST_FILE_FILE + IntToStr(li_MapFileJS)+CST_EXTENSION_JS, '''', '\''',[rfReplaceAll]));
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_NAME, StringReplace ( StringReplace ( as_Name, '"', '\"', [rfReplaceAll] ), '''', '\''', [rfReplaceAll] ) ,[rfReplaceAll]);
      if as_Name > '' Then
        p_setACase(astl_Case, li_Name); //  load case file and set html var files
      astl_Case.AddStrings(lstl_EndCase);
      p_createFileCaseMap ( astl_Case, li_MapFileJS );
      p_LoadStringList(astl_Case      , CST_MAP_FILE     + CST_EXTENSION_JS);
      p_LoadStringList(lstl_EndCase   , CST_MAP_CASE_END + CST_EXTENSION_JS);
      inc ( li_MapFileJS );
      if as_Name = ''
       Then p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_CASE, '' );
    end;

    // creating a map htm file
    procedure p_createFileMap(const li_page : Integer);
    Begin
      // create map file
      p_createACase ( lstl_AllSurnames, '' );
      // creating PHP?file
      if ch_SplittedMap.Checked Then
       Begin
        lstl_HTMLAFolder.Insert(0,fs_CreateULTabsheets(gt_SheetsMapGroup, '', CST_HTML_SUBMENU)+CST_HTML_DIV_BEGIN);
        lstl_HTMLAFolder.Add(CST_HTML_DIV_END);
       end;
      p_CreateAHtmlFile(lstl_HTMLAFolder, CST_FILE_MAP, me_MapHead.Lines.Text,
         gs_ANCESTROWEB_Map, '', gs_ANCESTROWEB_Map_Long, gs_LinkGedcom,'',CST_EXTENSION_HTML);
      // saving the page
      if li_page > -1
       Then ls_destination := gs_RootPathForExport + ed_MapFileName.Text + IntToStr(li_page) + CST_EXTENSION_HTML
       Else ls_destination := gs_RootPathForExport + ed_MapFileName.Text + CST_EXTENSION_HTML;
      try
        lstl_HTMLAFolder.SaveToFile(ls_destination);
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Map + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
      lstl_HTMLAFolder.Clear;
      FAncestroWeb.p_IncProgressBar;
     End;
    // initing a map
    procedure p_initFileCase( const astl_strings : TStrings );
     Begin
      p_ReplaceLanguageString ( astl_strings, CST_MAP_LATITUD , FloatToStr(ld_MinLatitude ),[rfReplaceAll]);
      p_ReplaceLanguageString ( astl_strings, CST_MAP_LONGITUD, FloatToStr(ld_MinLongitude),[rfReplaceAll]);
      p_ReplaceLanguageString ( astl_strings, CST_MAP_MAX_ZOOM, gs_ANCESTROWEB_MapMaxZoom,[rfReplaceAll]);
      p_ReplaceLanguageString ( astl_strings, CST_MAP_ZOOM    , fs_MapZoom ( ld_Minlatitude, ld_Maxlatitude, ld_Minlongitude , ld_Maxlongitude ),[rfReplaceAll]);
     End;
    procedure p_initFileMap;
     Begin
      ls_NewSurname := '';
      li_i := 0;
      ls_ASurname := IBS_MapFiltered.FieldByName(IBQ_NOM).AsString;
      p_LoadStringList(lstl_HTMLAFolder, CST_FILE_MAP     + CST_EXTENSION_HTML);
      p_LoadStringList(lstl_AllSurnames, CST_MAP_FILE     + CST_EXTENSION_JS);
      p_LoadStringList(lstl_ACase      , CST_FILE_MapCase + CST_EXTENSION_JS);
      p_LoadStringList(lstl_EndCase    , CST_MAP_CASE_END + CST_EXTENSION_JS);
      p_LoadStringList(lstl_AFile      , CST_MAP_FILE     + CST_EXTENSION_JS);
      p_LoadStringList(lstl_ALine      , CST_FILE_MapLine + CST_EXTENSION_JS);
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_HTML_CAPTION, gs_ANCESTROWEB_Map_Long,[rfReplaceAll] );
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_CAPTIONS, gs_ANCESTROWEB_MapCaptions ,[rfReplaceAll]);
      p_ReplaceLanguageString ( lstl_HTMLAFolder, CST_MAP_TO      , gs_ANCESTROWEB_Map_To      ,[rfReplaceAll]);
      p_initFileCase(lstl_AllSurnames);
     End;
  Begin
    if not IBQ_CountMap.EOF then
      IBQ_CountMap.Last;
    li_recordcount := IBQ_CountMap.RecordCount;
    fb_CreateDirectoryStructure(gs_RootPathForExport + CST_SUBDIR_HTML_MAPS);
    Finalize ( gt_Surnames );
    p_createMinMaxMap ( IBS_MapFiltered );
    with IBS_MapFiltered do
      try
        Close;
        ExecQuery;
      Except
         on E : Exception do
           Begin
            MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Map  + #13#10 + #13#10 + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
            Exit;
           End;
       End;
    if ch_SplittedMap.Checked Then
     with IBS_MapFiltered do
       Begin
         p_CreateSheets;
         Close;
         ExecQuery;
       end;
    // initing global values
    ld_Minlatitude := CST_DUMMY_COORD;
    ld_Maxlatitude := -CST_DUMMY_COORD;
    ld_Minlongitude  := CST_DUMMY_COORD;
    ld_Maxlongitude  := -CST_DUMMY_COORD;
    li_MaxCounter  := 0;
    p_getGlobalMinMax ( ld_Minlatitude, ld_Maxlatitude, ld_Minlongitude , ld_Maxlongitude, li_MaxCounter );
    p_ClearKeyWords;
    li_Name := -1;
    with FAncestroWeb do
     Begin
      pb_ProgressInd.Position:=0;  // initing user value
      pb_ProgressInd.Max:=li_recordcount;
     end;
    lstl_AllSurnames := TStringlistUTF8.Create;
    lstl_ACase    := TStringlistUTF8.Create;
    lstl_EndCase  := TStringlistUTF8.Create;
    lstl_AFile    := TStringlistUTF8.Create;
    lstl_ALine    := TStringlistUTF8.Create;
    // loading files
    // Full Map
    with IBS_MapFiltered do
     try
      lch_decimalSep:={$IFDEF FPC}DefaultFormatSettings.{$ENDIF}DecimalSeparator;
      {$IFDEF FPC}DefaultFormatSettings.{$ENDIF}DecimalSeparator:='.';
      p_initFileMap;
      li_recno := 0;
      li_j := sp_groupMap.Value;
      li_MapFileJS := 0;
      while not EOF do
        begin
          inc ( li_recno );
          ls_NewSurname := FieldByName(IBQ_NOM).AsString;
          li_Name := fi_findName(ls_NewSurname);
          if  ( li_Name > -1 )
          and ( ls_NewSurname > '' ) Then
           Begin  // adding lines in the full and named map
             inc (li_i);
             p_setAline(lstl_AllSurnames, lstl_ALine,IBS_MapFiltered,li_MaxCounter,False, li_i);
             p_setAline(lstl_AFile, lstl_ALine,IBS_MapFiltered,gt_Surnames [ li_Name ].MaxCounter,True, li_i);
             p_addKeyWord(ls_ASurname, '-'); // adding a head's meta keywords
           end;
          if  ( ls_NewSurname <> ls_ASurname )
           Then // Setting new case for a new named map
            Begin
             p_createACase (lstl_AFile, ls_NewSurname);
             p_initFileCase(lstl_AFile);
            end;
          if ch_SplittedMap.Checked
          and ( li_j > 1) and ( li_recno = li_recordcount div ( li_j * 2 )) Then
           Begin
            p_createFileMap ( sp_groupMap.Value-li_j );
            dec ( li_j );
            p_ClearKeyWords;
            p_initFileMap;
           End;
          Next;

        end;
      if ch_SplittedMap.Checked
       Then p_createFileMap ( sp_groupMap.Value-1 )
       Else p_createFileMap (-1);
     finally
     {$IFDEF FPC}DefaultFormatSettings.{$ENDIF}DecimalSeparator:=lch_decimalSep;
      lstl_AllSurnames.Destroy;
      lstl_ACase      .Destroy;
      lstl_EndCase    .Destroy;
      lstl_AFile      .Destroy;
      lstl_ALine      .Destroy;
     end;
  end;

  // procedure p_createMap
  // create filtered map ?
  procedure p_createMap;
  Begin
   with FAncestroWeb do
    if ch_genMap.Checked Then
    begin
      if ch_Filtered.Checked
      then
       Begin
         if ch_ancestors.Checked Then
           Begin
             if  fb_OpenTree(DmWeb.IBS_TreeMap,gi_CleFiche)
             and fb_OpenTree(DmWeb.IBQ_TreeMapCount,gi_CleFiche)
              Then
               p_createAMap (DmWeb.IBS_TreeMap,DmWeb.IBQ_TreeMapCount);
           end
          else
           Begin
             if  fb_OpenTree(DmWeb.IBS_TreeMapDes, gi_CleFiche)
             and fb_OpenTree(DmWeb.IBQ_TreeDescCount, gi_CleFiche) Then
               p_createAMap (DmWeb.IBS_TreeMapDes,DmWeb.IBQ_TreeDescCount);
           end;
       end
      else
       Begin
         try
           with DmWeb.IBS_MapAll do
            Begin
             Close;
             ParamByName(I_DOSSIER).AsInteger:=DMWeb.CleDossier;
             ExecQuery;
            End;
           with DmWeb.IBQ_CountMapAll do
            Begin
             Close;
             ParamByName(I_DOSSIER).AsInteger:=DMWeb.CleDossier;
             Open;
            End;
         Except
           on E : Exception do
             Begin
              MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Map + '(' + IntToStr ( DMWeb.CleDossier ) + ')' + #13#10 + #13#10 + fs_getCorrectString ( gs_AnceSTROWEB_cantOpenData ) + sDataBaseName + CST_ENDOFLINE + E.Message);
              Exit;
             End;
         End;
         p_createAMap (DmWeb.IBS_MapAll,DmWeb.IBQ_CountMapAll);

       end;
    end;
  end;
  var li_i : Integer;
begin
  lstl_HTMLAFolder := TStringlistUTF8.Create;
  with FAncestroWeb do
   try
    p_createMap;
    p_ClearKeyWords;
    ls_ASurname := '';
    pb_ProgressInd.Position:=0;  // initing user value
    pb_ProgressInd.Max:=IBS_FilesFiltered.RecordCount;
    lstl_HTMLAFolder.Add ( fs_CreateULTabsheets ( gt_SheetsLetters, '', CST_HTML_SUBMENU, False, True )+CST_HTML_DIV_BEGIN);
    lstl_HTMLAFolder.Add ( fs_CreateElementWithId(CST_HTML_TABLE, 'Surnames') + CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN  );
    while not IBS_FilesFiltered.EOF do
     begin
      p_IncProgressInd; // growing the second counter
      ls_NewSurname := IBS_FilesFiltered.FieldByName(IBQ_NOM).AsString;
      if (ls_NewSurname <> ls_ASurname) Then
       Begin
        if (length(ls_NewSurname) = 0) Then
          ls_NewSurname:=' ';
        if ((length(ls_ASurname) = 0) or
          (ls_NewSurname[1] <> ls_ASurname[1])) then // Anchor
          lstl_HTMLAFolder.Add ( CST_HTML_TD_END +CST_HTML_TR_END + CST_HTML_TR_BEGIN + CST_HTML_TD_BEGIN +
                                 CST_HTML_A_BEGIN + CST_HTML_NAME_EQUAL + '"' + ls_NewSurname[1] + '" />'+
                                 CST_HTML_H4_BEGIN + ls_NewSurname[1] + CST_HTML_H4_END + CST_HTML_TD_END +CST_HTML_TD_BEGIN)
          Else lstl_HTMLAFolder.Add ( ' - ' );
        // Name and its link
        lstl_HTMLAFolder.Add ( fs_GetNameLink ( ls_NewSurname,'', ls_NewSurname, CST_SUBDIR_HTML_FILES + CST_HTML_DIR_SEPARATOR ) +' ( '+ IBS_FilesFiltered.FieldByName( IBQ_COUNTER ).AsString );
        if  ch_genMap.Checked // Creating optionnal map button
        and ( fi_findName(ls_NewSurname)>-1)
        Then if ch_SplittedMap.Checked Then
         Begin
          for li_i := 0 to high ( gt_SheetsMapGroup ) do
           if ls_NewSurname <= gt_SheetsMapGroup [ li_i ].s_info Then
            Begin
             lstl_HTMLAFolder.Add ( ' - ' + fs_Create_Link(ed_MapFileName.Text+IntToStr(li_i)+ CST_EXTENSION_HTML + '?name=' +ls_NewSurname,
                                    fs_Create_Image(CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_MAP
                                    +CST_HTML_DIR_SEPARATOR+CST_FILE_MAP+CST_FILE_Button+CST_EXTENSION_GIF,gs_ANCESTROWEB_Map)));
             Break;
            End;
          End
         Else
           lstl_HTMLAFolder.Add ( ' - ' + fs_Create_Link(ed_MapFileName.Text+CST_EXTENSION_HTML + '?name=' +ls_NewSurname,
                                  fs_Create_Image(CST_SUBDIR_HTML_IMAGES+CST_HTML_DIR_SEPARATOR+CST_FILE_MAP
                                  +CST_HTML_DIR_SEPARATOR+CST_FILE_MAP+CST_FILE_Button+CST_EXTENSION_GIF,gs_ANCESTROWEB_Map)));
        lstl_HTMLAFolder.Add ( ')' );
       end;
      ls_ASurname := IBS_FilesFiltered.FieldByName(IBQ_NOM).AsString;
      p_addKeyWord(ls_ASurname, '-'); // adding a head's meta keyword
      IBS_FilesFiltered.Next;

     end;
    lstl_HTMLAFolder.Add ( CST_HTML_TD_END +CST_HTML_TR_END + CST_HTML_TABLE_END );
    lstl_HTMLAFolder.Add(CST_HTML_DIV_END);
    p_CreateAHtmlFile(lstl_HTMLAFolder, CST_FILE_Surnames, me_SurnamesHead.Lines.Text,
       ( gs_AnceSTROWEB_Surnames ), gs_AnceSTROWEB_Surnames, gs_ANCESTROWEB_Surnames_Long, gs_LinkGedcom);
    // saving the page
    ls_destination := gs_RootPathForExport + ed_SurnamesFileName.Text + CST_EXTENSION_HTML;
    try
      lstl_HTMLAFolder.SaveToFile(ls_destination);
    except
      On E: Exception do
      begin
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Surnames + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
        Abort;
      end;
    end;
   finally
    lstl_HTMLAFolder.Destroy;
   end;
end;

// procedure TF_AncestroWebOptions.p_genHtmlList
// creating persons' list
procedure TF_AncestroWebOptions.p_genHtmlPostalCards;
var
  ls_ASurnameOrName, ls_destination: string;
  lt_SheetsLists : TAHTMLULTabSheet;
  ls_ImagesDir,ls_ImagesHtmlDir,ls_ImagesMiniDir: string;
  li_CounterPages : Longint;
  FUnusedExtensions,
  lstl_Memo : TStringList;
  gb_NoToAll : Boolean;
  FLastToUse : Boolean;
  li_filecounter ,
  li_pagecounter : Integer;

  // Add an image file to columns and panels
  procedure SaveHtmlFile(const astl_HTMLADir : TStringListUTF8; const astl_HTMLSubDirs : TStringList;const ab_next, ab_root : Boolean; const ai_pageDir, ai_CounterPages : Integer);
  var li_i : Integer;
  Begin
    astl_HTMLADir.Add( CST_HTML_TABLE_END + CST_HTML_BR);
    with FAncestroWeb do
     Begin
      if not ab_root Then
       Begin
        if ai_CounterPages > 0 Then
          astl_HTMLADir.Add ( fs_CreatePrevNext ( ai_CounterPages -1  , CST_PAGE_PREVIOUS, '../', ed_PostalName.Text, ai_CounterPages = 2 ));
        astl_HTMLADir.Add(fs_CreatePrevNext ( ai_PageDir    , CST_PAGE_UP, '../', ed_PostalName.Text, ai_PageDir = 1 ));
       end;
      if ab_next Then
        astl_HTMLADir.Add ( fs_CreatePrevNext ( ai_CounterPages + 1, CST_PAGE_NEXT, '../', ed_PostalName.Text ));
     end;
    astl_HTMLADir.Add ( CST_HTML_CENTER_END );
    astl_HTMLADir.Add(CST_HTML_DIV_END);
    for li_i := astl_HTMLSubDirs.Count -1 downto 0 do
      astl_HTMLADir.Insert (0,astl_HTMLSubDirs[li_i]+CST_HTML_BR);
    p_CreateAHtmlFile(astl_HTMLADir, CST_FILE_POSTAL, FAncestroWeb.me_Description.Lines.Text,
      ( gs_ANCESTROWEB_PostalCards ) + ' (' +IntToStr(ai_CounterPages)+')',
      '', '', gs_LinkGedcom, '..' + CST_HTML_DIR_SEPARATOR);
    // saving the page
    if ab_root Then
     ls_destination := gs_RootPathForExport +
       ed_PostalName.Text + DirectorySeparator + ed_PostalName.Text + CST_EXTENSION_HTML
     Else
        ls_destination := gs_RootPathForExport +
          ed_PostalName.Text + DirectorySeparator + ed_PostalName.Text + IntToStr(
          ai_CounterPages) + CST_EXTENSION_HTML;
    try
      astl_HTMLADir.SaveToFile(ls_destination);
    except
      On E: Exception do
      begin
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_PostalCards + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
        Abort;
      end;
    end;
    astl_HTMLADir.Clear;
    astl_HTMLADir.Add( CST_HTML_CENTER_BEGIN + fs_CreateElementWithId ( CST_HTML_TABLE , 'postal' ));
    astl_HTMLADir.Add( fs_CreateElementWithId ( CST_HTML_TR , CST_TABLE_TITLE )+
                         fs_Create_TD ( CST_FILE_IMAGE, CST_HTML_ID_EQUAL, i_postalcards.ImagesPerLine )+CST_HTML_H2_BEGIN+ ( gs_ANCESTROWEB_PostalCards ) +CST_HTML_H2_END+CST_HTML_TD_END+
                        CST_HTML_TR_END);
  end;

  // Add an image file to columns and panels
  function fb_AddFile(const as_SourceFile, as_subdir: String; const astl_HTMLADir : TStringListUTF8; const astl_HTMLSubDirs : TStringList; const ai_PageDir : Integer):boolean;
  var li_iposext, li_i : Integer;
      ls_ext : String;
      ABitmapMini : TBGRACustomBitmap;
      ABitmap : TBGRACustomBitmap;
      AFileStream : TFileStreamUTF8;
      ARect : TRect;
      ls_imageName ,
      ls_imageNameJpeg : String;
  Begin
    Result := False;
    if not fileexistsUTF8 ( as_SourceFile ) Then
     Exit;
    // unused extensions verify
    if not i_postalcards.IsValidFile ( as_SourceFile ) Then
      Exit;
    // must keep li_iposext until except
    li_iposext := posex ( '.', as_SourceFile, Length(as_SourceFile)-6);
    if li_iposext = 0 Then
     Exit;
    if li_filecounter = se_imagespercol.Value * se_imagesperline.value Then
      Begin
       SaveHtmlFile(astl_HTMLADir, astl_HTMLSubDirs,True, False, ai_PageDir, li_counterPages); // Increasing li_counterPages inside
       inc(li_counterPages);
      end;
    ls_ext := copy ( as_SourceFile, li_iposext, Length(as_SourceFile) - li_iposext + 1 );
    ls_imageName :=  ExtractFileName(as_SourceFile);
    inc ( li_filecounter );
    ABitmapMini := nil;
    AFileStream := nil;
    with i_postalcards do
    try
      // do we need to create a column ?
       ABitmap:=fci_FileToCustomImage ( as_SourceFile, False );
       if Assigned ( abitmap ) Then
        with ABitmap do
        try
          Result := True;
          if Width>Height
           Then ABitmapMini := ABitmap.Resample(PanelWidth,Round( PanelWidth / Width * Height ) )
           Else
            Begin
             ABitmapMini := ABitmap.Resample(Round( PanelHeight / Height * Width * ImageRatio ),Round(PanelHeight * ImageRatio));
             ARect.Top:=Round((ABitmapMini.height-ABitmapMini.Width)/2);
             ARect.Bottom:=Round((ABitmapMini.height+ABitmapMini.Width)/2);
             ARect.Left  :=0;
             ARect.Right  :=ABitmapMini.Width;
             ABitmapMini.PutImagePart( 0, 0 , ABitmapMini, ARect, dmSet );
             ABitmapMini.SetSize(ABitmapMini.Width,Round(ABitmapMini.Width/ImageRatio));
            end;
          ls_imageNameJpeg := copy(ls_imageName,1,length(ls_imageName)-length(ls_ext))+CST_EXTENSION_JPEG;
          li_i := 1;
          while FileExistsUTF8 ( ls_ImagesMiniDir+as_subdir+ls_imageNameJpeg ) do
           Begin
             ls_imageNameJpeg := copy(ls_imageName,1,length(ls_imageName)-length(ls_ext))+inttostr(li_i)+CST_EXTENSION_JPEG;
             inc ( li_i );
           end;
          CopyFileUtf8 ( as_SourceFile, ls_ImagesHtmlDir+as_subdir+ls_imageNameJpeg );
          AFileStream := TFileStreamUTF8.Create(ls_ImagesMiniDir+as_subdir+ls_imageNameJpeg,fmCreate);
          p_ImageToStreamJpeg(ABitmapMini,AFileStream);
          astl_HTMLADir.Add(CST_HTML_TD_BEGIN+fs_Create_Link(CST_SUBDIR_HTML_IMAGES+'/'+
                                           {$IFDEF WINDOWS}fs_RemplaceChar({$ENDIF}as_subdir{$IFDEF WINDOWS},'\','/'){$ENDIF}
                                           +ls_imageName,
                                           (fs_Create_Image(CST_SUBDIR_HTML_THUMB+'/'+
                                           {$IFDEF WINDOWS}fs_RemplaceChar({$ENDIF}as_subdir{$IFDEF WINDOWS},'\','/'){$ENDIF}
                                           +ls_imageNameJpeg)),'',' rel="shadowbox"')+CST_HTML_BR);
          FLastToUse := False;
          if assigned(IniFileMemos)
           Then
            Begin
             lstl_Memo.Clear;
             LitTstringsDeIni ( IniFileMemos, copy(as_SourceFile,1,posex(ls_ext,as_SourceFile,length(as_SourceFile)-6)-1),lstl_Memo);
             astl_HTMLADir.Add(CST_HTML_Paragraph_BEGIN
                              +lstl_Memo.Text
                              +CST_HTML_Paragraph_END);
            end;
          astl_HTMLADir.Add(CST_HTML_TD_END);
          if li_filecounter mod se_imagespercol.Value = 0 Then
            astl_HTMLADir.Add(CST_HTML_TR_END+CST_HTML_TR_BEGIN);

          Application.ProcessMessages;
        Finally
          ABitmapMini.Free;
          AFileStream.Free;
          ABitmap.Destroy;
        end;

    except
      on e:Exception do
      Begin
       if not gb_NoToAll Then
         case MyMessageDlg(e.Message+#13#10+GS_Cancel+' ?',mmtWarning,[mmbNo,mmbNoToAll,mmbYes,mmbRetry]) of
          mrYes:Abort;
          mrNoToAll:gb_NoToAll:=True;
          mrRetry:p_OpenFileOrDirectory(as_SourceFile);
         end;
      end;
    end;
  end;

  function fb_AddADirectory ( const as_Directory : String ; as_SubDir : String ; const ai_pageDir : Integer; const ab_root : Boolean = False):Boolean;
  var
    lstl_HTMLADir: TStringlistUTF8;
    lstl_HTMLSubDirs,lstl_Files: TStringlist;
    li_i, li_page : longint;
  begin
    Result := False;
    li_page := li_counterpages;
    inc ( li_counterpages );
    fb_CreateDirectoryStructure(ls_ImagesHtmlDir+as_subdir);
    fb_CreateDirectoryStructure(ls_ImagesMiniDir+as_subdir);
    lstl_HTMLADir     := TStringlistUTF8.Create;
    lstl_HTMLSubDirs  := TStringlist.Create;
    lstl_Files        := TStringList.create;
    lstl_HTMLSubDirs.Add( CST_HTML_CENTER_BEGIN + fs_CreateElementWithId ( CST_HTML_TABLE , 'postal_title' ));
    lstl_HTMLSubDirs.Add( fs_CreateElementWithId ( CST_HTML_TR, CST_TABLE_TITLE )+
                         fs_Create_TD ( CST_FILE_IMAGE, CST_HTML_ID_EQUAL, i_postalcards.ImagesPerLine )+CST_HTML_H2_BEGIN+ ( gs_ANCESTROWEB_PostalCards ) +CST_HTML_H2_END+CST_HTML_TD_END+
                        CST_HTML_TR_END+CST_HTML_TABLE_END+ fs_CreateElementWithId ( CST_HTML_TABLE , 'postal' )+CST_HTML_TR_BEGIN);
    p_CreateKeyWords;
    p_addKeyWord( ExtractDirName(as_Directory), '-'); // adding a head's meta keyword
    with FAncestroWeb do
    try
      if ch_postalincludesubdirs.Checked Then
        if fb_FindFiles ( lstl_Files, as_Directory, False, True, False, '*' ) Then
          Begin
           lstl_HTMLADir.Add( CST_HTML_TR_BEGIN);
           if ab_root Then
            Begin
              pb_ProgressInd.Max:=lstl_Files.Count;
            End;
           lstl_Files.Sort;
           for li_i := 0 to lstl_Files.count-1 do
             try
                if ab_root Then
                  p_IncProgressInd;

                if DirectoryExistsUTF8 ( as_Directory + lstl_Files [ li_i ] ) Then
                 Begin
                   lstl_HTMLSubDirs.Add ( fs_Create_Link( ed_PostalName.text+IntToStr(li_counterpages)+CST_EXTENSION_HTML, lstl_Files [ li_i ] ));
                   fb_AddADirectory ( as_Directory + lstl_Files [ li_i ] + DirectorySeparator, as_SubDir + lstl_Files [ li_i ] + DirectorySeparator, li_page );
                 end;
             finally
             end;

           lstl_HTMLADir.Add( CST_HTML_TR_END);
          end;
       li_filecounter := 0;
       if fb_FindFiles ( lstl_Files, as_Directory, True, False, False, '*' ) Then
         Begin
          lstl_HTMLADir.Add( CST_HTML_TR_BEGIN);
          if ab_root and not ch_postalincludesubdirs.Checked Then
           Begin
             pb_ProgressInd.Max:=lstl_Files.Count;
           End;
          lstl_Files.Sort;
           for li_i := 0 to lstl_Files.count-1 do
            Begin
               if ab_root and not ch_postalincludesubdirs.Checked Then
                 p_IncProgressInd;
               if FileExistsUTF8 ( as_Directory + lstl_Files [ li_i ] ) Then
                 if fb_AddFile(as_directory+lstl_Files [ li_i ],as_subdir,lstl_HTMLADir,lstl_HTMLSubDirs,ai_pageDir) Then
                  Result := True;
            end;

           lstl_HTMLADir.Add( CST_HTML_TR_END);
         end;
        if ab_root
         then // if root it is that we are on the page
          p_SelectTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_PostalCards ), ''); // current page sheet
        SaveHtmlFile(lstl_HTMLADir,lstl_HTMLSubDirs,False,ab_root,ai_pageDir,li_page);
    finally
      lstl_HTMLADir.Destroy;
      lstl_HTMLSubDirs.Destroy;
      lstl_Files.Destroy;
    end;
  end;
var lstl_HTMLADir : TStringlistUTF8;
begin
  gb_NoToAll := False;
  ls_ImagesDir := i_postalcards.Directory;
  if not DirectoryExistsUTF8(ls_ImagesDir)
   Then
    Begin
      if MyShowMessage(gs_ANCESTROWEB_NoPostalCardsDirectory,mmbOKCancel,mmtWarning,Self)=mrCancel Then
        Abort;
      Exit;
    end;
  ls_ImagesDir := IncludeTrailingPathDelimiter ( ls_ImagesDir );
  li_pagecounter := 0;
  FUnusedExtensions := TStringList.Create;
  lstl_Memo  := TStringList.Create;
  FLastToUse := False;
  with FAncestroWeb do
   try
    LitTstringsDeIni(FIniFile,Owner.Name+'.'+Name+CST_INI_EXT_OUT,FUnusedExtensions);
    p_Setcomments ( gs_ANCESTROWEB_PostalCards ); // advert for user
    li_CounterPages := 1;
    pb_ProgressInd.Position := 0; // initing user value
    ls_ImagesHtmlDir := gs_RootPathForExport + ed_PostalName.Text + DirectorySeparator + CST_SUBDIR_HTML_IMAGES + DirectorySeparator ;
    ls_ImagesMiniDir := gs_RootPathForExport + ed_PostalName.Text + DirectorySeparator + CST_SUBDIR_HTML_THUMB  + DirectorySeparator ;
    ls_ASurnameOrName := '';
    p_IncProgressBar; // growing the counter
    fb_AddADirectory(ls_ImagesDir,'',0,True);
    p_SelectTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_PostalCards ), '', False);  // reiniting for next page

   finally
    FUnusedExtensions.Destroy;
    lstl_Memo .Destroy;
   end;
end;

procedure TF_AncestroWebOptions.p_ExchangePanels(const ACombo1, ACombo2 : TComboBox;const AEdit1, AEdit2:TEdit; const AMemo1,AMemo2 : TMemo );
var li_Temp : Integer;
    ls_temp: String;
Begin
  li_Temp:=ACombo1.ItemIndex;
  ACombo1.ItemIndex:=ACombo2.ItemIndex;
  ACombo2.ItemIndex:=li_Temp;
  ls_temp:=AEdit1.Text;
  AEdit1.Text:=AEdit2.Text;
  AEdit2.Text:=ls_temp;
  ls_temp:=AMemo1.Text;
  AMemo1.Text:=AMemo2.Text;
  AMemo2.Text:=ls_temp;
end;

procedure TF_AncestroWebOptions.p_genHtmlLinks;

type TRLink = Record
                ALink : String;
                AMemo : String;
              End;
     TALinks = Record
                 ALinks : Array of TRLink;
                 APage : String;
               End;
     TALinksPerPage = Array of TALinks;
var
  ls_ASurnameOrName, ls_destination: string;
  lt_SheetsLists : TAHTMLULTabSheet;
  ls_ImagesDir,ls_HtmlDir,ls_ImagesMiniDir: string;
  li_CounterPages : Longint;
  lb_FoundLink : Boolean;
  li_filecounter ,
  li_imageno ,
  li_pagecounter : Integer;
  lstl_BodyLinks,
  lstl_HTMLLinks: TStringlistUTF8;
  LPageLinks:TALinksPerPage;

  function fi_GetPageLinks ( const APage : String; const APageLinks : TALinksPerPage ):Integer;
  var li_i : Integer;
  Begin
    Result := -1;
    for li_i := 0 to high ( APageLinks ) do
     if APageLinks [ li_i ].APage = APage Then
      result := li_i;
  End;

  function fb_AddALink ( const acloned_Panel : TPanel):Boolean;
  var
    li_i, li_page : longint;
    LLink:TEdit;
    LPage:TComboBox;
    LMemo:TMemo;
  begin
    Result := False;
    with acloned_Panel do
      for li_i := 0 to ControlCount - 1 do
       Begin
          if Controls[li_i] is TComboBox Then
           LPage:=Controls[li_i] as TComboBox
          else if Controls[li_i] is TEdit Then
           LLink:=Controls[li_i] as TEdit
          else if Controls[li_i] is TMemo Then
           LMemo:=Controls[li_i] as TMemo;
       end;
    if (Lpage.ItemIndex = 0)
    or (LPage.Text=CST_UNIQUE_LINK) Then
       li_page := 0
     Else
      Begin
        li_page := fi_GetPageLinks ( Lpage.Text, LPageLinks );
        if li_page = -1 Then
         Begin
           setlength ( LPageLinks, high ( LPageLinks ) + 2 );
           LPageLinks [ high ( LPageLinks ) ].Apage := LPage.Text ;
           li_page := high ( LPageLinks );
         End;
      End;
    with LPageLinks [ li_page ] do
     Begin
      SetLength(ALinks,High(ALinks)+2);
      with ALinks [ high ( ALinks ) ] do
       Begin
        ALink:=LLink.Text;
        AMemo:=LMemo.Lines.Text;
      End;
    End;
  end;
  procedure p_initPage;
  Begin
    lstl_HTMLLinks.Clear;
    li_imageno:=0;
  end;

  procedure p_AddPageLink ( const ALink:TRLink; const ai_counter : Integer; const ab_root :boolean);
    Begin
     if ab_root
       then // if root it is that we are on the page
        p_SelectTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Links ), ''); // current page sheet
     with ALink do
      Begin
       lb_FoundLink := True;
       p_initPage;
       p_LoadStringList(lstl_BodyLinks,CST_FILE_LINK+'3'+CST_EXTENSION_HTML);
       p_ReplaceLanguageString(lstl_BodyLinks,CST_HTML_CAPTION,AMemo);
       p_ReplaceLanguageString(lstl_BodyLinks,CST_HTML_LINK,ALink);
       p_CreateKeyWords;
       p_SelectTabSheet(gt_SheetsLinks, AMemo); // current page sheet
       lstl_BodyLinks.Insert(0,fs_CreateULTabsheets(gt_SheetsLinks, '', CST_HTML_SUBMENU));
       // finishing creating the page
       p_CreateAHtmlFile(lstl_HTMLLinks, CST_FILE_LINK, AMemo,
         AMemo, AMemo, AMemo, gs_LinkGedcom,
         '..' + CST_HTML_DIR_SEPARATOR,CST_EXTENSION_HTML,'',lstl_BodyLinks);
       ls_destination := gs_RootPathForExport + CST_SUBDIR_HTML_LINKS + DirectorySeparator +
                         ed_LinkName.Text + IntToStr(ai_counter) + CST_EXTENSION_HTML;
       p_SelectTabSheet(gt_SheetsLinks, '', ''); // erase current page sheet
        try
          lstl_HTMLLinks.SaveToFile(ls_destination);
        except
          On E: Exception do
          begin
            MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Links + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
            Abort;
          end;
        end;
       p_SelectTabSheet(gt_SheetsLinks, AMemo, '', False); // current page sheet
      end;
   End;
  procedure p_AddLinkToPage ( const ALink:TRLink );
    Begin
      lstl_BodyLinks.Add( fs_CreateElementWithId ( CST_HTML_TR, CST_TABLE_TITLE )+
                            fs_Create_TD ( CST_FILE_IMAGE, CST_HTML_ID_EQUAL ));
      with ALink do
       Begin
        if fb_IsRootLink(ALink)
         Then
          Begin
           lstl_BodyLinks.Add( fs_getLinkedImage('',IncludeTrailingBackslash(ALink)+'ascreen.','jpg'',''jpeg'',''png'',''JPG'',''JPEG'',''PNG',0,li_imageno,0,200,True));
           inc ( li_imageno );
          end;
        lstl_BodyLinks.Add ( CST_HTML_TD_END+
                              fs_Create_TD ( CST_FILE_IMAGE, CST_HTML_ID_EQUAL )+CST_HTML_H2_BEGIN+ fs_Create_Link(ALink,AMemo,CST_HTML_TARGET_BLANK) +CST_HTML_H2_END+CST_HTML_TD_END+
                              CST_HTML_TR_END);
       end;
   End;
  procedure p_AddPage ( const APage:TALinks ; const ai_counter : Integer ;const ab_root : Boolean);
  var li_i : Integer;
    Begin
     with APage do
      Begin
       p_LoadStringList(lstl_BodyLinks,CST_FILE_LINKS+'3'+CST_EXTENSION_HTML);
       p_initPage;
       p_CreateKeyWords;
       p_SelectTabSheet(gt_SheetsLinks, APage, ''); // current page sheet
       p_ReplaceLanguageString(lstl_BodyLinks,CST_HTML_CAPTION,APage);
       lstl_BodyLinks.Insert(0,fs_CreateULTabsheets(gt_SheetsLinks, '', CST_HTML_SUBMENU));
       lstl_BodyLinks.Add( CST_HTML_CENTER_BEGIN + fs_CreateElementWithId ( CST_HTML_TABLE , 'link_title' ));
       for li_i:=0 to High(ALinks) do
        p_AddLinkToPage(ALinks[li_i]);
       lstl_BodyLinks.Add( CST_HTML_TABLE_END + CST_HTML_CENTER_END);
       // finishing creating the page
       p_CreateAHtmlFile(lstl_HTMLLinks, CST_FILE_LINKS, APage,
         APage, APage, APage,gs_LinkGedcom,
         '..' + CST_HTML_DIR_SEPARATOR,CST_EXTENSION_HTML,'',lstl_BodyLinks);
       ls_destination := gs_RootPathForExport + CST_SUBDIR_HTML_LINKS + DirectorySeparator +
                         ed_LinkName.Text+ 's' + IntToStr(ai_counter) + CST_EXTENSION_HTML;
       p_SelectTabSheet(gt_SheetsLinks, APage, '', False); // erase current page sheet
        try
          lstl_HTMLLinks.SaveToFile(ls_destination);
        except
          On E: Exception do
          begin
            MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Links + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
            Abort;
          end;
        end;
      end;
   End;
  procedure p_AddPageUniqueLink ( const APage:TALinks ;const ab_root : Boolean);
  var li_i : Integer;
   Begin
    with APage do
     for li_i:=0 to High(ALinks) do
       p_AddPageLink ( ALinks [ li_i ], li_i + 1, ab_root );
   End;
      // create grouped surnames sheets
    procedure p_CreateSheets (const as_BeginLinks : String = '' );
    var
      li_counter, li_link : Integer;
    begin
      Finalize(gt_SheetsLinks);
      for li_counter := 0 to high ( LPageLinks ) do
       with LPageLinks [ li_counter ] do
        begin
         if li_counter = 0 Then
          Begin
           for li_link := 0 to High(ALinks) do
            with ALinks [ li_link ] do
             p_AddTabSheet(gt_SheetsLinks, AMemo,
                           as_BeginLinks+ed_LinkName.Text + IntToStr(li_link+1) + CST_EXTENSION_HTML, AMemo );
          end
         Else
          p_AddTabSheet(gt_SheetsLinks, APage,
               as_BeginLinks+ed_LinkName.Text + 's' + IntToStr(li_counter) + CST_EXTENSION_HTML, APage );

        End;
    end;
    // creating a map htm file
    procedure p_createFileLinks(const li_page : Integer);
    var li_i,li_j:Integer;
    Begin
     // create map file
     p_LoadStringList(lstl_BodyLinks,CST_FILE_LINKS_HEAD+'3'+CST_EXTENSION_HTML);
     p_SelectTabSheet(gt_TabSheets,gs_ANCESTROWEB_Links);
     p_initPage;
     // creating PHP?file
     lstl_BodyLinks.Insert(0,fs_CreateULTabsheets(gt_SheetsLinks, '', CST_HTML_SUBMENU));
     if not lb_FoundLink
     and ( high ( LPageLinks ) = 1 ) Then
      with LPageLinks [ 1 ] do
        Begin
          lstl_BodyLinks.Add( CST_HTML_CENTER_BEGIN + fs_CreateElementWithId ( CST_HTML_TABLE , 'link_title' ));
          for li_i:=0 to High(ALinks) do
           p_AddLinkToPage(ALinks[li_i]);
          lstl_BodyLinks.Add( CST_HTML_TABLE_END + CST_HTML_CENTER_END);
        End;
     p_ReplaceLanguageString(lstl_BodyLinks,CST_HTML_CAPTION,gs_ANCESTROWEB_Links);
     p_ReplaceLanguageString(lstl_BodyLinks,CST_HTML_HEAD_DESCRIBE,me_HeadLinks.Lines.Text);
     p_CreateAHtmlFile(lstl_HTMLLinks, CST_FILE_LINKS_HEAD, '',
         gs_ANCESTROWEB_Links, '', gs_ANCESTROWEB_Links_Long,gs_LinkGedcom,'',CST_EXTENSION_HTML,'',lstl_BodyLinks);
     p_SelectTabSheet(gt_TabSheets,gs_ANCESTROWEB_Links,'',False);

     // saving the page
     ls_destination := gs_RootPathForExport + ed_LinkName.Text+ 's' + CST_EXTENSION_HTML;
      try
        lstl_HTMLLinks.SaveToFile(ls_destination);
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Links + #13#10 + #13#10 + fs_getCorrectString ( gs_ANCESTROWEB_cantCreateHere ) + ls_destination + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
      p_initPage;
      FAncestroWeb.p_IncProgressBar;
     End;
  var lb_found : Boolean;
      ls_item : String;
begin
  li_pagecounter := 0;
  SetLength(LPageLinks,1);
  lstl_HTMLLinks  := TStringListUTF8.Create;
  lstl_BodyLinks  := TStringListUTF8.Create;
  with FAncestroWeb do
   try
    p_CreateKeyWords;
    p_Setcomments ( gs_ANCESTROWEB_Links ); // advert for user
    li_CounterPages := 1;
    pb_ProgressInd.Position := 0; // initing user value
    ls_HtmlDir := gs_RootPathForExport + CST_SUBDIR_HTML_LINKS + DirectorySeparator  ;
    fb_CreateDirectoryStructure(ls_HtmlDir);
    ls_ASurnameOrName := '';
    p_IncProgressBar; // growing the counter
    with ClonedP_Links do
     for li_CounterPages:=0 to ControlCount - 1 do
       fb_AddALink(Controls[li_CounterPages] as TPanel);

    p_CreateSheets;
    if High(LPageLinks[0].ALinks)>-1
     Then li_filecounter:=1
     Else li_filecounter:=0;
    with cb_LinkPanel.Items do
    if Count > High(LPageLinks)+li_filecounter Then
     Begin
      for li_CounterPages:=Count-1 downto 1  do
         Begin
          lb_found:=False;
          ls_item:=Strings[li_CounterPages];
          for li_filecounter:=1 to High(LPageLinks) do
           with LPageLinks [ li_filecounter ] do
             if  (APage = ls_item)
             and (High(ALinks)>-1) Then
              Begin
               lb_found:=True;
               Break;
              end;
          // delete if no text
          if not lb_found Then
            Delete(li_CounterPages);
         end;
       p_ApplyToEveryLinkPanel( cb_LinkPanel );
     end;
    lb_FoundLink:=False;
    for li_CounterPages:=0 to high ( LPageLinks )  do
      if li_CounterPages = 0
       Then p_AddPageUniqueLink(LPageLinks [ li_CounterPages ],False)
       Else
        if lb_FoundLink
        or (high(LPageLinks [ li_CounterPages ].ALinks)>0)
         then p_AddPage(LPageLinks [ li_CounterPages ], li_CounterPages, False );
    p_SelectTabSheet(gt_TabSheets, ( gs_ANCESTROWEB_Links ), '', False);  // reiniting for next page
    p_CreateSheets ( CST_SUBDIR_HTML_LINKS+CST_HTML_DIR_SEPARATOR );
    p_createFileLinks(0);
   finally
    lstl_HTMLLinks.Destroy;
    lstl_BodyLinks.Destroy;
   end;
end;

// procedure TF_AncestroWebOptions.p_genPhpContact
// HTML page form sending mail
procedure TF_AncestroWebOptions.p_genPhpContact;
var
  lstl_HTMLContact: TStringlistUTF8;
  lstl_HTMLContactBeforeHTML: TStringlistUTF8;
  ls_destination: string;
begin
  with FAncestroWeb do
   Begin
    p_Setcomments ( gs_AnceSTROWEB_Contact ); // advert for user
    lstl_HTMLContact := TStringlistUTF8.Create;
    lstl_HTMLContactBeforeHTML := TStringlistUTF8.Create;
    p_LoadStringList(lstl_HTMLContact, CST_FILE_ContactInBody + CST_EXTENSION_PHP);

    // setting begining HTML page values
    p_ReplaceLanguageString(lstl_HTMLContact,CST_HTML_CAPTION,gs_ANCESTROWEB_MailCaption);
    p_ReplaceLanguageString(lstl_HTMLContact,CST_HTML_HEAD_DESCRIBE,StringReplace (me_ContactHead.Lines.Text, CST_ENDOFLINE, CST_HTML_BR, [rfReplaceAll]));
    p_ReplaceLanguageString(lstl_HTMLContact,CST_CONTACT_MAILMOT,ed_ContactMotTrouve.Text,[rfReplaceAll]);
    p_ReplaceLanguagesStrings ( lstl_HTMLContact, gstl_Labels, CST_HTML_CONTACT_IN_LANG );
    // loading PHP page
    p_LoadStringList(lstl_HTMLContactBeforeHTML, CST_FILE_ContactBefore + CST_EXTENSION_PHP);

    // setting PHP?page
    if cb_ContactSecurity.ItemIndex >= 0 Then
      p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_SECURITY,cb_ContactSecurity.Items[cb_ContactSecurity.ItemIndex]);
    if cb_ContactTool.ItemIndex >= 0 Then
      p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_MAILER,cb_ContactTool.Items[cb_ContactTool.ItemIndex]);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_HOST,ed_ContactHost.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_FILE,ed_ContactName.Text+CST_EXTENSION_PHP);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_LANG,gs_Lang);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_PASSWORD,ed_ContactPassword.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_AUTHOR,ed_ContactAuthor.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_IDENTIFY,UTF8LowerCase(BoolToStr(ch_ContactIdentify.Checked)));
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_MAIL,ed_ContactMail.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_MAILMOT,ed_ContactMotTrouve.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_MOT,ed_ContactMot.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_USERNAME,ed_ContactUser.Text);
    p_ReplaceLanguageString(lstl_HTMLContactBeforeHTML,CST_CONTACT_PORT,se_ContactPort.Text);
    // Head key words
    p_CreateKeyWords;
    pb_ProgressInd.Position := 0; // initing not needed user value

    // finishing creating the page
    p_CreateAHtmlFile(lstl_HTMLContact, CST_FILE_Contact, me_ContactHead.Lines.Text,
      ( gs_AnceSTROWEB_Contact ), gs_AnceSTROWEB_Contact, gs_ANCESTROWEB_MailCaption, gs_LinkGedcom,
      '', CST_EXTENSION_PHP, lstl_HTMLContactBeforeHTML.Text);

    // growing the counter
    p_IncProgressBar; // growing the counter
   end;


  // saving the page
  ls_destination := gs_RootPathForExport + ed_ContactName.Text + CST_EXTENSION_PHP;
  try
    lstl_HTMLContact.SaveToFile(ls_destination);
  except
    On E: Exception do
    begin
      MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Contact + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_AnceSTROWEB_cantCreateContact ) + ls_destination + CST_ENDOFLINE + E.Message);
      Abort;
    end;
  end;
  lstl_HTMLContact.Free;
  lstl_HTMLContactBeforeHTML.Free;
end;

// procedure TF_AncestroWebOptions.p_genHtmlSearch
// Search engine HTML page request
procedure TF_AncestroWebOptions.p_genHtmlSearch;
var
  lstl_HTMLSearch: TStringlistUTF8;
  ls_destination: string;
begin
  with FAncestroWeb do
   Begin
    p_Setcomments ( gs_AnceSTROWEB_Search ); // advert for user
    pb_ProgressInd.Position := 0; // initing not needed user value
    lstl_HTMLSearch := TStringlistUTF8.Create;
    p_CreateAHtmlFile(lstl_HTMLSearch, CST_FILE_SEARCH, me_searchHead.Lines.Text,
          ( gs_AnceSTROWEB_Search ), gs_AnceSTROWEB_Search, gs_ANCESTROWEB_SearchLong, gs_LinkGedcom, '');

    // setting page values from Tabsheet
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_HTML_HEAD_DESCRIBE, StringReplace(me_searchHead.Text,CST_ENDOFLINE,'<BR />',[]));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_HTML_SEND      , ( gs_AnceSTROWEB_Send  ));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_HTML_RESET     , ( gs_AnceSTROWEB_Reset ));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_SEARCH_DOMAIN  ,Trim(ed_SearchSite.Text));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_SEARCH_SEARCH  , ( gs_AnceSTROWEB_Search ));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_SEARCH_SEARCH  , ( gs_AnceSTROWEB_Search ));
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_SEARCH_SEARCH_QUER  ,ed_SearchQuery.Text);
    p_ReplaceLanguageString(lstl_HTMLSearch,CST_SEARCH_SEARCH_TOOL  ,ed_SearchTool.Text);
   end;

  // saving the page
  ls_destination := gs_RootPathForExport + ed_SearchName.Text  + CST_EXTENSION_HTML;
  try
    lstl_HTMLSearch.SaveToFile(ls_destination);
  except
    On E: Exception do
    begin
      MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantCreateContact ) + ls_destination + CST_ENDOFLINE + E.Message);
      Abort;
    end;
  end;
  lstl_HTMLSearch.Free;
end;


// procedure TF_AncestroWebOptions.p_genHtmlAges
// Ages : HTML page creating
procedure TF_AncestroWebOptions.p_genHtmlAges;
var
  lstl_HTMLAges ,
  lstl_HTMLAges2,
  lstl_HTMLLines: TStringlistUTF8;
  ls_destination: string;

  procedure p_addLines;
    var
      li_Age, li_Linecounter, li_countTotal, li_MenTotal, li_WomenTotal : Longint;

      // Setting not replaced values
      procedure p_setHtmlReplaceValues;
      Begin
        p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_COUNT      , IntToStr(li_Linecounter),[]);
        p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_MEN_COUNT  , CST_ZERO          ,[]);
        p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_WOMEN_COUNT, CST_ZERO          ,[]);
      end;
      procedure p_setLine;
      begin
        with DMWeb.IBS_Ages do
          Begin
          // first and next line
          if li_Age <> FieldByName(IBQ_AGE_AU_DECES).AsInteger Then
            Begin
              p_setHtmlReplaceValues ;
              p_ReplaceLanguageString(lstl_HTMLAges,CST_AGES_LINES  ,lstl_HTMLLines.Text+'['+CST_AGES_LINES+']');
              li_Age:= FieldByName(IBQ_AGE_AU_DECES).AsInteger ;
              p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_AN_AGE, IntToStr(li_Age)  ,[]);
              li_Linecounter := 0;
            end;
          // growing
          inc ( li_Linecounter, FieldByName ( IBQ_COUNTER ).AsInteger );
          inc ( li_countTotal, li_Linecounter );
          // men or women
          if FieldByName(IBQ_SEXE).AsInteger = IBQ_SEXE_MAN Then
           Begin
             p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_MEN_COUNT  , FieldByName ( IBQ_COUNTER ).AsString,[]);
             inc ( li_MenTotal, FieldByName ( IBQ_COUNTER ).AsInteger );
           end
          Else
           if FieldByName(IBQ_SEXE).AsInteger = IBQ_SEXE_WOMAN Then
             Begin
               p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_WOMEN_COUNT  , FieldByName ( IBQ_COUNTER ).AsString,[]);
               inc ( li_WomenTotal, FieldByName ( IBQ_COUNTER ).AsInteger );
             end;
          end;
      end;

  Begin
    li_Age := -1;
    li_countTotal :=0;
    li_MenTotal   :=0;
    li_WomenTotal :=0;

    // setting data
    with DMWeb.IBS_Ages do
      try
        Close;
        ParamByName(I_DOSSIER).Value:=DMWeb.CleDossier;
        ExecQuery;
        while not Eof do
          Begin
            if FieldByName(IBQ_AGE_AU_DECES).IsNull Then
              Begin
               Next;
               Continue;
              end;

            p_setLine;

            Next;
          end;
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Ages + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantOpenData ) + DMWeb.IBS_Ages.Database.DatabaseName + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
    p_setHtmlReplaceValues;

    // adding last line
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_LINES      ,lstl_HTMLLines.Text);
    // last total line
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_AN_AGE     , gs_ANCESTROWEB_TotalAgeDead,[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_COUNT      , IntToStr(li_countTotal),[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_MEN_COUNT  , IntToStr(li_MenTotal)  ,[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_WOMEN_COUNT, IntToStr(li_WomenTotal),[]);
    DMWeb.IBS_Ages.Close;
  end;

begin
  with FAncestroWeb do
   Begin
    p_Setcomments ( gs_ANCESTROWEB_Ages ); // advert for user
    pb_ProgressInd.Position := 0; // initing not needed user value
    // strings from files
    lstl_HTMLAges  := TStringlistUTF8.Create;
    lstl_HTMLAges2 := TStringlistUTF8.Create;
    lstl_HTMLLines := TStringlistUTF8.Create;
    p_CreateKeyWords;
    // loading a simple not inited line
    p_LoadStringList ( lstl_HTMLLines, CST_FILE_AGES_LINE + CST_EXTENSION_HTML );
    p_LoadStringList ( lstl_HTMLAges , CST_FILE_AGES + '3' + CST_EXTENSION_HTML );
    // Customizing the page
    p_ReplaceLanguageString(lstl_HTMLAges,CST_HTML_HEAD_DESCRIBE, StringReplace(me_HeadAges.Text,CST_ENDOFLINE,'<BR />',[]));

    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_AN_AGE     , gs_ANCESTROWEB_AnAge         ,[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_COUNT      , gs_ANCESTROWEB_Persons_Count ,[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_MEN_COUNT  , gs_ANCESTROWEB_Men_Count     ,[]);
    p_ReplaceLanguageString ( lstl_HTMLAges, CST_AGES_WOMEN_COUNT, gs_ANCESTROWEB_Women_Count   ,[]);

    p_addLines;

    // creating and initing the ages page
    p_CreateAHtmlFile(lstl_HTMLAges2, CST_FILE_AGES, me_HeadAges.Lines.Text,
          ( gs_ANCESTROWEB_Ages ), gs_ANCESTROWEB_Ages, gs_ANCESTROWEB_Ages_Long, gs_LinkGedcom, '', CST_EXTENSION_HTML, '', lstl_HTMLAges);
    p_IncProgressBar;// ages growing
   end;


  // saving the page
  ls_destination := gs_RootPathForExport + ed_AgesName.Text  + CST_EXTENSION_HTML;
  try
    lstl_HTMLAges2.SaveToFile(ls_destination);
  except
    On E: Exception do
    begin
      MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Ages + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantSaveFile ) + ls_destination + CST_ENDOFLINE + E.Message);
      Abort;
    end;
  end;
  // freeing
  lstl_HTMLAges .Free;
  lstl_HTMLAges2.Free;
  lstl_HTMLLines.Free;
end;
// procedure TF_AncestroWebOptions.p_genHtmlJobs
// Jobs : HTML page creating
procedure TF_AncestroWebOptions.p_genHtmlJobs;
var
  lstl_HTMLJobs ,
  lstl_HTMLJobs2,
  lstl_HTMLLines: TStringlistUTF8;
  ls_destination: string;
  // Setting not replaced values
  procedure p_setHtmlReplaceValues;
  Begin
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_CITY      , '',[]);
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_COUNT  , CST_ZERO          ,[]);
  end;

  // procedure p_CreateLines
  // setting a job line
  procedure p_CreateLines ;
  var
    ls_City,ls_Job: string;
    li_Linecounter, li_countTotal, li_CitiesTotal : Longint;
    procedure p_setline;
    Begin
      with DMWeb.IBS_Jobs,FAncestroWeb do
        Begin
          p_setHtmlReplaceValues;
          p_ReplaceLanguageString(lstl_HTMLJobs,CST_JOBS_LINES  ,lstl_HTMLLines.Text+'['+CST_JOBS_LINES+']');
          if FieldByName(IBQ_EV_IND_DESCRIPTION).AsString <> ls_Job Then
             Begin
              ls_Job := FieldByName(IBQ_EV_IND_DESCRIPTION).AsString ;
              p_addKeyWord(ls_Job); // adding a head's meta keyword
             end;
          ls_City:= FieldByName(IBQ_EV_IND_VILLE      ).AsString ;
          if ls_City > '' Then
            Begin
              p_addKeyWord(ls_City); // adding a head's meta keyword
              ls_City:=fs_getLinkedCity(ls_city);
            end;
          // growing
          li_Linecounter := FieldByName ( IBQ_COUNTER ).AsInteger ;
          ls_Job:=fs_getLinkedJob(ls_Job,li_countTotal);
          // showing job ant city
          p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_A_JOB, ls_Job ,[]);
          p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_CITY , ls_City ,[]);
          // showing jobs'count
          p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_COUNT , IntToStr(li_Linecounter),[]);
          inc ( li_countTotal, li_Linecounter );
          if ( ls_City > '' ) Then
            inc ( li_CitiesTotal, li_Linecounter );
          Application.ProcessMessages;
        end;
    end;

  Begin
    ls_City := '';
    ls_Job  := '';
    li_countTotal :=0;
    li_CitiesTotal:=0;

    // setting data
    with DMWeb.IBS_Jobs do
      try
        Close;
        ParamByName(I_DOSSIER).Value:=DMWeb.CleDossier;
        ExecQuery;
        while not Eof do
          Begin
            if FieldByName(IBQ_EV_IND_DESCRIPTION).AsString = '' Then
              Begin
               Next;
               Continue;
              end;
            // setting a line
            p_setline;
            Next;
          end;
      except
        On E: Exception do
        begin
          MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Jobs + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantOpenData ) + DMWeb.IBS_Ages.Database.DatabaseName + CST_ENDOFLINE + E.Message);
          Abort;
        end;
      end;
    p_setHtmlReplaceValues;

    // adding last line
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_LINES      ,lstl_HTMLLines.Text);
    // last total line
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_A_JOB      , gs_ANCESTROWEB_Jobs_Total,[]);
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_COUNT      , IntToStr(li_countTotal),[]);
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_CITY       , IntToStr(li_CitiesTotal)  ,[]);
    DMWeb.IBS_Ages.Close;
  end;

begin
  // strings from files
  lstl_HTMLJobs  := TStringlistUTF8.Create;
  lstl_HTMLJobs2 := TStringlistUTF8.Create;
  lstl_HTMLLines := TStringlistUTF8.Create;
  with FAncestroWeb do
   try
    p_Setcomments ( gs_ANCESTROWEB_Jobs ); // advert for user
    pb_ProgressInd.Position := 0; // initing not needed user value
    p_CreateKeyWords;
    // loading a simple not inited line
    p_LoadStringList ( lstl_HTMLLines, CST_FILE_JOBS_LINE + CST_EXTENSION_HTML );
    p_LoadStringList ( lstl_HTMLJobs , CST_FILE_JOBS + '3' + CST_EXTENSION_HTML );

    // Customizing the page
    p_ReplaceLanguageString(lstl_HTMLJobs,CST_HTML_HEAD_DESCRIBE, StringReplace(me_HeadJobs.Text,CST_ENDOFLINE,'<BR />',[]));

    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_A_JOB  , gs_ANCESTROWEB_A_Job        ,[]);
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_COUNT  , gs_ANCESTROWEB_Jobs_Count   ,[]);
    p_ReplaceLanguageString ( lstl_HTMLJobs, CST_JOBS_CITY   , gs_ANCESTROWEB_Jobs_Cities  ,[]);

    p_CreateLines;

    // creating and initing the ages page
    p_CreateAHtmlFile(lstl_HTMLJobs2, CST_FILE_JOBS, me_HeadJobs.Lines.Text,
          gs_ANCESTROWEB_Jobs, gs_ANCESTROWEB_Jobs, gs_ANCESTROWEB_Jobs_Long, gs_LinkGedcom, '',CST_EXTENSION_HTML,'',lstl_HTMLJobs);

    // saving the page
    ls_destination := gs_RootPathForExport + ed_JobsName.Text  + CST_EXTENSION_HTML;
    try
      lstl_HTMLJobs2.SaveToFile(ls_destination);
    except
      On E: Exception do
      begin
        MyShowMessage(gs_ANCESTROWEB_Phase + gs_ANCESTROWEB_Jobs + CST_ENDOFLINE + CST_ENDOFLINE + fs_getCorrectString ( gs_ANCESTROWEB_cantSaveFile ) + ls_destination + CST_ENDOFLINE + E.Message);
        Abort;
      end;
    end;
    p_IncProgressBar;// jobs growing
   finally
    // Destroying
    lstl_HTMLJobs .Destroy;
    lstl_HTMLJobs2.Destroy;
    lstl_HTMLLines.Destroy;
   End;
end;

// procedure TF_AncestroWebOptions.p_CreateAHtmlFile
// Creating a HTML page from parameters
procedure TF_AncestroWebOptions.p_CreateAHtmlFile(const astl_Destination: TStringlistUTF8;
  const as_BeginingFile,
  as_Describe, as_Title, as_SelectedTitle, as_LongTitle: string;
  as_BottomHTML: string;
  const as_Subdir: string = '';
  const as_ExtFile: string =
  CST_EXTENSION_HTML;
  const as_BeforeHTML: string = ''; const astl_Body : TStringlistUTF8 = nil );
begin
  if not assigned ( gstl_HeadKeyWords ) Then
    Abort;       // can quit while creating
  if as_BottomHTML > '' then
    as_BottomHTML := '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"gedcom">' +
      CST_HTML_AHREF + as_Subdir + as_BottomHTML + '">' + ( gs_AnceSTROWEB_DownloadGedcom ) +
      CST_HTML_A_END + CST_HTML_Paragraph_END;
  as_BottomHTML := '<' + CST_HTML_DIV + CST_HTML_ID_EQUAL + '"bottomDIV">' +
    '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"bottom">' +
    FAncestroWeb.me_Bottom.Lines.Text + CST_HTML_Paragraph_END +
    as_BottomHTML + '<' + CST_HTML_Paragraph + CST_HTML_ID_EQUAL + '"bottom">' +
    ( gs_AnceSTROWEB_CreatedBy ) + ' ' + CST_HTML_STRONG_BEGIN +
    CST_AncestroWeb_WithLicense + ' - ' + CST_HTML_AHREF +
    'http://www.liberlog.fr">' + CST_AUTHOR +
    CST_HTML_A_END + CST_HTML_STRONG_END + CST_HTML_Paragraph_END + CST_HTML_DIV_End;
  if as_SelectedTitle > '' then
    p_SelectTabSheet(gt_TabSheets, as_SelectedTitle); // current page sheet
  p_CreateHTMLFile(gt_TabSheets, astl_Destination, as_BottomHTML,
    as_Describe, gstl_HeadKeyWords.Text, gs_HTMLTitle + ' - ' +
    as_Title, as_LongTitle, as_BeginingFile + '1' + as_ExtFile, as_BeginingFile + '2' +
    as_ExtFile, as_BeginingFile + '3' + as_ExtFile, as_BeginingFile +
    '4' + as_ExtFile, as_Subdir, as_BeforeHTML, gs_ANCESTROWEB_Language, astl_Body );
  if as_SelectedTitle > '' then
    p_SelectTabSheet(gt_TabSheets, as_SelectedTitle, '', False);  // reiniting for next page
end;

// procedure TF_AncestroWebOptions.FormCreate
// initializing software and form
procedure TF_AncestroWebOptions.Loaded;
begin
  f_GetMainMemIniFile(nil,nil,nil,False,CST_AncestroWeb);
  inherited;
end;

procedure TF_AncestroWebOptions.JvXPButton1Click(Sender: TObject);
begin
  {$IFDEF VERSIONS}
  fb_AfficheApropos ( True, CST_AncestroWeb, '' );
  {$ENDIF}
end;

procedure TF_AncestroWebOptions.se_imageWidthChange(Sender: TObject);
begin
  i_postalcards.ImageRatio:=se_imageWidth.Value / se_imageHeight.Value;
end;

procedure TF_AncestroWebOptions.se_imagesperlineChange(Sender: TObject);
begin
  i_postalcards.ImagesPerLine:=se_imagesperline.Value;
end;

procedure TF_AncestroWebOptions.se_LinksCountChange(Sender: TObject);
begin
  ClonedP_Links.Rows:=se_LinksCount.Value;
end;

procedure TF_AncestroWebOptions.se_NomSet(Sender: TObject);
begin
  FAncestroWeb.p_iniWriteKey;
end;

// procedure TF_AncestroWebOptions.TraduceImageFailure
// Failure on picture's convert
procedure TF_AncestroWebOptions.TraduceImageFailure(Sender: TObject;
  const ErrorCode: integer; var ErrorMessage: string; var ContinueCopy: boolean);
begin
  MyShowMessage(fs_getCorrectString ( gs_AnceSTROWEB_cantCreateImage ) + ErrorMessage);
end;

{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_AncestroWebOptions );
{$ENDIF}
end.

