{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Liste_Mails;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  jpeg, TPanelUnit, Windows,
{$ELSE}
{$ENDIF}
  U_FormAdapt,Forms,SysUtils,
  Dialogs,Menus,DB,IBCustomDataSet,IBQuery,
  StdCtrls,Controls,ExtCtrls,U_ExtDBGrid,Classes,
  u_buttons_appli,PrintersDlgs,
  Variants, u_reports_components, u_ancestropictimages, U_OnFormInfoIni, Grids, DBGrids;

type

  { TFListeMails }

  TFListeMails=class(TF_FormAdapt)
    OnFormInfoIni: TOnFormInfoIni;
    pBorder:TPanel;
    pGeneral:TPanel;
    pGlobal:TPanel;
    pBottom:TPanel;
    IBQMails:TIBQuery;
    DSMails:TDataSource;
    IBQMailsMAIL_CLE:TLongintField;
    IBQMailsINDI_CLE:TLongintField;
    IBQMailsNOM:TIBStringField;
    IBQMailsPRENOM:TIBStringField;
    IBQMailsADRESSE:TIBStringField;
    IBQMailsADRESSE2:TIBStringField;
    IBQMailsMAIL:TIBStringField;
    IBQMailsWEB:TIBStringField;
    IBQMailsVILLE:TIBStringField;
    IBQMailsPAYS:TStringField;
    IBQMailsDEPT: TStringField;
    IBQMailsREGION: TStringField;
    DBGridMails:TExtDBGrid;
    Panel3:TPanel;
    Image1:TIATitle;
    Panel2:TPanel;
    SaveDialog:TSaveDialog;
    
    Label1:TLabel;
    fpBoutons:TPanel;
    GoodBtn7:TFWClose;
    btnPrint:TFWPrintGrid;
    XAEMail1: TXAEMail;
    procedure dxDBGridUnionsDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure btnPrintClick(Sender:TObject);
    procedure DoSelect;
    procedure mSupprimerTrisClick(Sender:TObject);
    procedure dxDBGridUnionsDBTableView1CellDblClick(
      Sender: TObject;
      ACellViewInfo: Longint; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure XAEMail1Click(Sender: TObject);
  private
    fCleFicheSelected:integer;

  protected
    procedure DoClose(var Action: TCloseAction); override;
    procedure DoShow; override;
  public
    procedure Loaded; override;
    destructor Destroy; override;
    property CleFicheSelected:integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm,u_common_const,
     u_common_functions,
     u_common_resources,
     u_common_ancestro,
     u_genealogy_context,
     fonctions_components,
     fonctions_ini,
     rxdbgrid,
     u_form_main,
     fonctions_string;

{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.lfm}{$ENDIF}

procedure TFListeMails.Loaded;
begin
  f_GetMemIniFile();
  Color:=gci_context.ColorLight;
  DBGridMails.Hint:=rs_Hint_You_can_Resize_the_columns_preview_resizing_your_grid_columns;

  SaveDialog.InitialDir:=gci_context.PathDocs;

  inherited;
end;

destructor TFListeMails.Destroy;
begin
  inherited Destroy;
  FMain.aFListeMails:=nil;
end;

procedure TFListeMails.dxDBGridUnionsDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  Value:Variant;
  DBGrid : TExtDBGrid;
begin
  DBGrid:=sender as TExtDBGrid;
  with DBGrid do
    Begin
      Value:=DataSource.DataSet.FieldByName('SOSA').Value;
      if not VarIsNull(Value) then
      begin
        if (Value>0) then
        begin
          Canvas.Font.Color:=_COLOR_SOSA;
        end
        else
        begin
          Canvas.Font.Color:=gci_context.ColorHomme;
        end;
      end;
    if column = SelectedColumn then
     if Canvas.Brush.Color=Color then
       Canvas.Brush.Color:=gci_context.ColorMedium;
    end;
end;

procedure TFListeMails.DoClose(
  var Action:TCloseAction);
begin
  inherited;
  IBQMails.Close;
  // Matthieu ?
//dxDBGridUnionsDBTableView1.StoreToRegistry(gci_context.KeyRegistry+DirectorySeparator+'W_LISTE_UNIONS');

  Action:=caFree;
end;

procedure TFListeMails.DoSelect;
begin
  DefaultCloseAction:=caNone;
  dm.individu_clef:=fCleFicheSelected;
  FMain.Ouvre_Et_Selecte_Individu;
end;

procedure TFListeMails.btnPrintClick(Sender:TObject);
begin
  // Matthieu
  btnPrint.DBTitle:=Caption;
end;

procedure TFListeMails.DoShow;
begin
  inherited;
  IBQMails.Params[0].AsInteger:=dm.NumDossier;
  IBQMails.Open;

end;

procedure TFListeMails.mSupprimerTrisClick(Sender:TObject);
var
  i:integer;
begin
  for i:=0 to DBGridMails.Columns.Count-1 do
    DBGridMails.Columns[i].SortOrder:=smNone;
  if IBQMails.Active then
  begin
    IBQMails.Close;
    IBQMails.Open;
  end;
end;

procedure TFListeMails.dxDBGridUnionsDBTableView1CellDblClick(Sender: TObject;
  ACellViewInfo: Longint; AButton: TMouseButton; AShift: TShiftState;
  var AHandled: Boolean);
begin
  fCleFicheSelected:=IBQMailsINDI_CLE.AsInteger;
end;

procedure TFListeMails.XAEMail1Click(Sender: TObject);
var
  SavePlace:TBookmark;
begin
  SavePlace:=nil;
  SaveDialog.FileName:='Liste des Mails.csv';
  if SaveDialog.Execute then
   begin
    IBQMails.DisableControls;
    try
      SavePlace:=IBQMails.GetBookmark;
      ExportGridToCSV(SaveDialog.FileName,DBGridMails,True,True);
    finally
      IBQMails.GotoBookmark(SavePlace);
      IBQMails.FreeBookmark(SavePlace);
      IBQMails.EnableControls;
    end;
   end;
end;

end.

